import type { RouteLocationRaw } from 'vue-router';
import type { Size } from '../../composables/size';
import type { TransitionProps, Component, ComputedOptions, MethodOptions, DefineComponent, Prop, VNode, RendererNode, RendererElement, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, ComponentInternalInstance, VNodeChild, Slot, ComponentPublicInstance, ComponentOptionsBase, DebuggerEvent, nextTick, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties, PropType } from 'vue';
import type { MakeSlots } from '../../utils';
export declare const alertTypes: readonly ["success", "info", "warning", "error"];
export declare type AlertType = typeof alertTypes[number];
export declare type AlertSlots = MakeSlots<{
    prepend: [];
    default: [];
    append: [];
}>;
export declare const makeAlertProps: <Defaults extends {
    elevation?: unknown;
    shape?: unknown;
    border?: unknown;
    density?: unknown;
    size?: unknown;
    height?: unknown;
    maxHeight?: unknown;
    maxWidth?: unknown;
    minHeight?: unknown;
    minWidth?: unknown;
    width?: unknown;
    absolute?: unknown;
    bottom?: unknown;
    fixed?: unknown;
    left?: unknown;
    position?: unknown;
    right?: unknown;
    top?: unknown;
    color?: unknown;
    textColor?: unknown;
    variant?: unknown;
    theme?: unknown;
    tag?: unknown;
    disabled?: unknown;
    loading?: unknown;
    href?: unknown;
    replace?: unknown;
    to?: unknown;
    link?: unknown;
    hover?: unknown;
    image?: unknown;
    prependAvatar?: unknown;
    prependIcon?: unknown;
    appendAvatar?: unknown;
    appendIcon?: unknown;
    title?: unknown;
    subtitle?: unknown;
    divided?: unknown;
    text?: unknown;
    ripple?: unknown;
    transition?: unknown;
    modelValue?: unknown;
    type?: unknown;
    icon?: unknown;
    closable?: unknown;
    closeIcon?: unknown;
    closeText?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    elevation: unknown extends Defaults["elevation"] ? {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    } : Omit<{
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["elevation"] ? string | number : string | number | Defaults["elevation"]>;
        default: unknown extends Defaults["elevation"] ? string | number : string | number | Defaults["elevation"];
    };
    shape: unknown extends Defaults["shape"] ? Omit<Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    } : Omit<Omit<Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["shape"] ? "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" : "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" | Defaults["shape"]>;
        default: unknown extends Defaults["shape"] ? "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" : "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" | Defaults["shape"];
    };
    border: unknown extends Defaults["border"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["border"] ? string | number | boolean : string | number | boolean | Defaults["border"]>;
        default: unknown extends Defaults["border"] ? string | number | boolean : string | number | boolean | Defaults["border"];
    };
    density: unknown extends Defaults["density"] ? {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    } : Omit<{
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["density"] ? "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined : "medium" | "ultra-low" | "low" | "high" | "ultra-high" | Defaults["density"]>;
        default: unknown extends Defaults["density"] ? "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined : "medium" | "ultra-low" | "low" | "high" | "ultra-high" | Defaults["density"];
    };
    size: unknown extends Defaults["size"] ? {
        type: PropType<Size | undefined>;
        default: string;
    } : Omit<{
        type: PropType<Size | undefined>;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["size"] ? Size | undefined : Size | Defaults["size"]>;
        default: unknown extends Defaults["size"] ? Size | undefined : Size | Defaults["size"];
    };
    height: unknown extends Defaults["height"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["height"] ? string | number : string | number | Defaults["height"]>;
        default: unknown extends Defaults["height"] ? string | number : string | number | Defaults["height"];
    };
    maxHeight: unknown extends Defaults["maxHeight"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["maxHeight"] ? string | number : string | number | Defaults["maxHeight"]>;
        default: unknown extends Defaults["maxHeight"] ? string | number : string | number | Defaults["maxHeight"];
    };
    maxWidth: unknown extends Defaults["maxWidth"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["maxWidth"] ? string | number : string | number | Defaults["maxWidth"]>;
        default: unknown extends Defaults["maxWidth"] ? string | number : string | number | Defaults["maxWidth"];
    };
    minHeight: unknown extends Defaults["minHeight"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["minHeight"] ? string | number : string | number | Defaults["minHeight"]>;
        default: unknown extends Defaults["minHeight"] ? string | number : string | number | Defaults["minHeight"];
    };
    minWidth: unknown extends Defaults["minWidth"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["minWidth"] ? string | number : string | number | Defaults["minWidth"]>;
        default: unknown extends Defaults["minWidth"] ? string | number : string | number | Defaults["minWidth"];
    };
    width: unknown extends Defaults["width"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["width"] ? string | number : string | number | Defaults["width"]>;
        default: unknown extends Defaults["width"] ? string | number : string | number | Defaults["width"];
    };
    absolute: unknown extends Defaults["absolute"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["absolute"] ? boolean : boolean | Defaults["absolute"]>;
        default: unknown extends Defaults["absolute"] ? boolean : boolean | Defaults["absolute"];
    };
    bottom: unknown extends Defaults["bottom"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["bottom"] ? string | number | boolean : string | number | boolean | Defaults["bottom"]>;
        default: unknown extends Defaults["bottom"] ? string | number | boolean : string | number | boolean | Defaults["bottom"];
    };
    fixed: unknown extends Defaults["fixed"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["fixed"] ? boolean : boolean | Defaults["fixed"]>;
        default: unknown extends Defaults["fixed"] ? boolean : boolean | Defaults["fixed"];
    };
    left: unknown extends Defaults["left"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["left"] ? string | number | boolean : string | number | boolean | Defaults["left"]>;
        default: unknown extends Defaults["left"] ? string | number | boolean : string | number | boolean | Defaults["left"];
    };
    position: unknown extends Defaults["position"] ? {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    } : Omit<{
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["position"] ? "fixed" | "absolute" | "static" | "relative" | "sticky" : "fixed" | "absolute" | "static" | "relative" | "sticky" | Defaults["position"]>;
        default: unknown extends Defaults["position"] ? "fixed" | "absolute" | "static" | "relative" | "sticky" : "fixed" | "absolute" | "static" | "relative" | "sticky" | Defaults["position"];
    };
    right: unknown extends Defaults["right"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["right"] ? string | number | boolean : string | number | boolean | Defaults["right"]>;
        default: unknown extends Defaults["right"] ? string | number | boolean : string | number | boolean | Defaults["right"];
    };
    top: unknown extends Defaults["top"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["top"] ? string | number | boolean : string | number | boolean | Defaults["top"]>;
        default: unknown extends Defaults["top"] ? string | number | boolean : string | number | boolean | Defaults["top"];
    };
    color: unknown extends Defaults["color"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["color"] ? string : string | Defaults["color"]>;
        default: unknown extends Defaults["color"] ? string : string | Defaults["color"];
    };
    textColor: unknown extends Defaults["textColor"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"]>;
        default: unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"];
    };
    variant: unknown extends Defaults["variant"] ? Omit<Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    } : Omit<Omit<Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"]>;
        default: unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"];
    };
    theme: unknown extends Defaults["theme"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["theme"] ? string : string | Defaults["theme"]>;
        default: unknown extends Defaults["theme"] ? string : string | Defaults["theme"];
    };
    tag: unknown extends Defaults["tag"] ? {
        type: StringConstructor;
        default: string;
    } : Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["tag"] ? string : string | Defaults["tag"]>;
        default: unknown extends Defaults["tag"] ? string : string | Defaults["tag"];
    };
    disabled: unknown extends Defaults["disabled"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["disabled"] ? boolean : boolean | Defaults["disabled"]>;
        default: unknown extends Defaults["disabled"] ? boolean : boolean | Defaults["disabled"];
    };
    loading: unknown extends Defaults["loading"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["loading"] ? boolean : boolean | Defaults["loading"]>;
        default: unknown extends Defaults["loading"] ? boolean : boolean | Defaults["loading"];
    };
    href: unknown extends Defaults["href"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["href"] ? string : string | Defaults["href"]>;
        default: unknown extends Defaults["href"] ? string : string | Defaults["href"];
    };
    replace: unknown extends Defaults["replace"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["replace"] ? boolean : boolean | Defaults["replace"]>;
        default: unknown extends Defaults["replace"] ? boolean : boolean | Defaults["replace"];
    };
    to: unknown extends Defaults["to"] ? PropType<RouteLocationRaw> : {
        type: PropType<unknown extends Defaults["to"] ? (string & {}) | RouteLocationRaw : (string & {}) | RouteLocationRaw | Defaults["to"]>;
        default: unknown extends Defaults["to"] ? (string & {}) | RouteLocationRaw : (string & {}) | RouteLocationRaw | Defaults["to"];
    };
    link: unknown extends Defaults["link"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["link"] ? boolean : boolean | Defaults["link"]>;
        default: unknown extends Defaults["link"] ? boolean : boolean | Defaults["link"];
    };
    hover: unknown extends Defaults["hover"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["hover"] ? boolean : boolean | Defaults["hover"]>;
        default: unknown extends Defaults["hover"] ? boolean : boolean | Defaults["hover"];
    };
    image: unknown extends Defaults["image"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["image"] ? string : string | Defaults["image"]>;
        default: unknown extends Defaults["image"] ? string : string | Defaults["image"];
    };
    prependAvatar: unknown extends Defaults["prependAvatar"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["prependAvatar"] ? string : string | Defaults["prependAvatar"]>;
        default: unknown extends Defaults["prependAvatar"] ? string : string | Defaults["prependAvatar"];
    };
    prependIcon: unknown extends Defaults["prependIcon"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["prependIcon"] ? string : string | Defaults["prependIcon"]>;
        default: unknown extends Defaults["prependIcon"] ? string : string | Defaults["prependIcon"];
    };
    appendAvatar: unknown extends Defaults["appendAvatar"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["appendAvatar"] ? string : string | Defaults["appendAvatar"]>;
        default: unknown extends Defaults["appendAvatar"] ? string : string | Defaults["appendAvatar"];
    };
    appendIcon: unknown extends Defaults["appendIcon"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["appendIcon"] ? string : string | Defaults["appendIcon"]>;
        default: unknown extends Defaults["appendIcon"] ? string : string | Defaults["appendIcon"];
    };
    title: unknown extends Defaults["title"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["title"] ? string : string | Defaults["title"]>;
        default: unknown extends Defaults["title"] ? string : string | Defaults["title"];
    };
    subtitle: unknown extends Defaults["subtitle"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["subtitle"] ? string : string | Defaults["subtitle"]>;
        default: unknown extends Defaults["subtitle"] ? string : string | Defaults["subtitle"];
    };
    divided: unknown extends Defaults["divided"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["divided"] ? boolean : boolean | Defaults["divided"]>;
        default: unknown extends Defaults["divided"] ? boolean : boolean | Defaults["divided"];
    };
    text: unknown extends Defaults["text"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["text"] ? string : string | Defaults["text"]>;
        default: unknown extends Defaults["text"] ? string : string | Defaults["text"];
    };
    ripple: unknown extends Defaults["ripple"] ? {
        type: BooleanConstructor;
        default: boolean;
    } : Omit<{
        type: BooleanConstructor;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["ripple"] ? boolean : boolean | Defaults["ripple"]>;
        default: unknown extends Defaults["ripple"] ? boolean : boolean | Defaults["ripple"];
    };
    transition: unknown extends Defaults["transition"] ? Omit<{
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        })>;
        default: string;
        validator: (val: unknown) => boolean;
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        };
    } : Omit<Omit<{
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        })>;
        default: string;
        validator: (val: unknown) => boolean;
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        };
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["transition"] ? string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        } : string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        } | Defaults["transition"]>;
        default: unknown extends Defaults["transition"] ? string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        } : string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        } | Defaults["transition"];
    };
    modelValue: unknown extends Defaults["modelValue"] ? {
        type: BooleanConstructor;
        default: boolean;
    } : Omit<{
        type: BooleanConstructor;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["modelValue"] ? boolean : boolean | Defaults["modelValue"]>;
        default: unknown extends Defaults["modelValue"] ? boolean : boolean | Defaults["modelValue"];
    };
    type: unknown extends Defaults["type"] ? {
        type: PropType<"success" | "info" | "warning" | "error">;
        default: string;
        validator: (val: AlertType) => boolean;
    } : Omit<{
        type: PropType<"success" | "info" | "warning" | "error">;
        default: string;
        validator: (val: AlertType) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["type"] ? "success" | "info" | "warning" | "error" : "success" | "info" | "warning" | "error" | Defaults["type"]>;
        default: unknown extends Defaults["type"] ? "success" | "info" | "warning" | "error" : "success" | "info" | "warning" | "error" | Defaults["type"];
    };
    icon: unknown extends Defaults["icon"] ? {
        type: PropType<string | false>;
        default: boolean;
    } : Omit<{
        type: PropType<string | false>;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["icon"] ? string | false : string | false | Defaults["icon"]>;
        default: unknown extends Defaults["icon"] ? string | false : string | false | Defaults["icon"];
    };
    closable: unknown extends Defaults["closable"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["closable"] ? boolean : boolean | Defaults["closable"]>;
        default: unknown extends Defaults["closable"] ? boolean : boolean | Defaults["closable"];
    };
    closeIcon: unknown extends Defaults["closeIcon"] ? {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    } : Omit<{
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["closeIcon"] ? string : string | Defaults["closeIcon"]>;
        default: unknown extends Defaults["closeIcon"] ? string : string | Defaults["closeIcon"];
    };
    closeText: unknown extends Defaults["closeText"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["closeText"] ? string : string | Defaults["closeText"]>;
        default: unknown extends Defaults["closeText"] ? string : string | Defaults["closeText"];
    };
};
export declare const Alert: {
    new (...args: any[]): {
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            type: "success" | "info" | "warning" | "error";
            modelValue: boolean;
            icon: string | false;
            closable: boolean;
            closeIcon: string | Record<string, any>;
            transition: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                }>;
            };
            replace: boolean;
            fixed: boolean;
            link: boolean;
            loading: boolean;
            hover: boolean;
            divided: boolean;
            ripple: boolean;
            disabled: boolean;
            tag: string;
            variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            absolute: boolean;
            size: Size | undefined;
            density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
            shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
        }> & Omit<Readonly<ExtractPropTypes<{
            elevation: {
                type: (StringConstructor | NumberConstructor)[];
                validator(v: any): boolean;
            };
            shape: Omit<Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            density: {
                type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                default: string;
                validator: (v: any) => boolean;
            };
            size: {
                type: PropType<Size | undefined>;
                default: string;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: (StringConstructor | NumberConstructor)[];
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: (StringConstructor | NumberConstructor)[];
            width: (StringConstructor | NumberConstructor)[];
            absolute: BooleanConstructor;
            bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            fixed: BooleanConstructor;
            left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            position: {
                type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
                validator: (v: any) => boolean;
            };
            right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            theme: StringConstructor;
            tag: {
                type: StringConstructor;
                default: string;
            };
            disabled: BooleanConstructor;
            loading: BooleanConstructor;
            href: StringConstructor;
            replace: BooleanConstructor;
            to: PropType<RouteLocationRaw>;
            link: BooleanConstructor;
            hover: BooleanConstructor;
            image: StringConstructor;
            prependAvatar: StringConstructor;
            prependIcon: StringConstructor;
            appendAvatar: StringConstructor;
            appendIcon: StringConstructor;
            title: StringConstructor;
            subtitle: StringConstructor;
            divided: BooleanConstructor;
            text: StringConstructor;
            ripple: {
                type: BooleanConstructor;
                default: boolean;
            };
            transition: Omit<{
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                })>;
                default: string;
                validator: (val: unknown) => boolean;
            }, "default" | "type"> & {
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                    }>;
                }>;
                default: string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                    }>;
                };
            };
            modelValue: {
                type: BooleanConstructor;
                default: boolean;
            };
            type: {
                type: PropType<"success" | "info" | "warning" | "error">;
                default: string;
                validator: (val: AlertType) => boolean;
            };
            icon: {
                type: PropType<string | false>;
                default: boolean;
            };
            closable: BooleanConstructor;
            closeIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            closeText: StringConstructor;
        } & {
            $children: () => (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild | {
                prepend?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
                default?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
                append?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
            };
            'v-slots': new () => {
                prepend?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                append?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_: boolean) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "type" | "modelValue" | "icon" | "closable" | "closeIcon" | "transition" | "replace" | "fixed" | "link" | "loading" | "hover" | "divided" | "ripple" | "disabled" | "tag" | "variant" | "absolute" | "size" | "density" | "shape">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: (event: "update:modelValue", _: boolean) => void;
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            elevation: {
                type: (StringConstructor | NumberConstructor)[];
                validator(v: any): boolean;
            };
            shape: Omit<Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            density: {
                type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                default: string;
                validator: (v: any) => boolean;
            };
            size: {
                type: PropType<Size | undefined>;
                default: string;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: (StringConstructor | NumberConstructor)[];
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: (StringConstructor | NumberConstructor)[];
            width: (StringConstructor | NumberConstructor)[];
            absolute: BooleanConstructor;
            bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            fixed: BooleanConstructor;
            left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            position: {
                type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
                validator: (v: any) => boolean;
            };
            right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            theme: StringConstructor;
            tag: {
                type: StringConstructor;
                default: string;
            };
            disabled: BooleanConstructor;
            loading: BooleanConstructor;
            href: StringConstructor;
            replace: BooleanConstructor;
            to: PropType<RouteLocationRaw>;
            link: BooleanConstructor;
            hover: BooleanConstructor;
            image: StringConstructor;
            prependAvatar: StringConstructor;
            prependIcon: StringConstructor;
            appendAvatar: StringConstructor;
            appendIcon: StringConstructor;
            title: StringConstructor;
            subtitle: StringConstructor;
            divided: BooleanConstructor;
            text: StringConstructor;
            ripple: {
                type: BooleanConstructor;
                default: boolean;
            };
            transition: Omit<{
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                })>;
                default: string;
                validator: (val: unknown) => boolean;
            }, "default" | "type"> & {
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                    }>;
                }>;
                default: string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                    }>;
                };
            };
            modelValue: {
                type: BooleanConstructor;
                default: boolean;
            };
            type: {
                type: PropType<"success" | "info" | "warning" | "error">;
                default: string;
                validator: (val: AlertType) => boolean;
            };
            icon: {
                type: PropType<string | false>;
                default: boolean;
            };
            closable: BooleanConstructor;
            closeIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            closeText: StringConstructor;
        } & {
            $children: () => (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild | {
                prepend?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
                default?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
                append?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
            };
            'v-slots': new () => {
                prepend?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                append?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_: boolean) => any) | undefined;
        }, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            'update:modelValue': (_: boolean) => boolean;
        }, string, {
            type: "success" | "info" | "warning" | "error";
            modelValue: boolean;
            icon: string | false;
            closable: boolean;
            closeIcon: string | Record<string, any>;
            transition: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                }>;
            };
            replace: boolean;
            fixed: boolean;
            link: boolean;
            loading: boolean;
            hover: boolean;
            divided: boolean;
            ripple: boolean;
            disabled: boolean;
            tag: string;
            variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            absolute: boolean;
            size: Size | undefined;
            density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
            shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        elevation: {
            type: (StringConstructor | NumberConstructor)[];
            validator(v: any): boolean;
        };
        shape: Omit<Omit<{
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: string;
        }, "default" | "type"> & {
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
        }, "default" | "type"> & {
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
        };
        border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
        density: {
            type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
            default: string;
            validator: (v: any) => boolean;
        };
        size: {
            type: PropType<Size | undefined>;
            default: string;
        };
        height: (StringConstructor | NumberConstructor)[];
        maxHeight: (StringConstructor | NumberConstructor)[];
        maxWidth: (StringConstructor | NumberConstructor)[];
        minHeight: (StringConstructor | NumberConstructor)[];
        minWidth: (StringConstructor | NumberConstructor)[];
        width: (StringConstructor | NumberConstructor)[];
        absolute: BooleanConstructor;
        bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
        fixed: BooleanConstructor;
        left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
        position: {
            type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
            validator: (v: any) => boolean;
        };
        right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
        top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
        color: StringConstructor;
        textColor: StringConstructor;
        variant: Omit<Omit<{
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: string;
            validator: (v: any) => boolean;
        }, "default" | "type"> & {
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
        }, "default" | "type"> & {
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
        };
        theme: StringConstructor;
        tag: {
            type: StringConstructor;
            default: string;
        };
        disabled: BooleanConstructor;
        loading: BooleanConstructor;
        href: StringConstructor;
        replace: BooleanConstructor;
        to: PropType<RouteLocationRaw>;
        link: BooleanConstructor;
        hover: BooleanConstructor;
        image: StringConstructor;
        prependAvatar: StringConstructor;
        prependIcon: StringConstructor;
        appendAvatar: StringConstructor;
        appendIcon: StringConstructor;
        title: StringConstructor;
        subtitle: StringConstructor;
        divided: BooleanConstructor;
        text: StringConstructor;
        ripple: {
            type: BooleanConstructor;
            default: boolean;
        };
        transition: Omit<{
            type: PropType<string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            })>;
            default: string;
            validator: (val: unknown) => boolean;
        }, "default" | "type"> & {
            type: PropType<string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                }>;
            }>;
            default: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                }>;
            };
        };
        modelValue: {
            type: BooleanConstructor;
            default: boolean;
        };
        type: {
            type: PropType<"success" | "info" | "warning" | "error">;
            default: string;
            validator: (val: AlertType) => boolean;
        };
        icon: {
            type: PropType<string | false>;
            default: boolean;
        };
        closable: BooleanConstructor;
        closeIcon: {
            type: (StringConstructor | ObjectConstructor)[];
            default: string;
        };
        closeText: StringConstructor;
    } & {
        $children: () => (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild | {
            prepend?: (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild;
            default?: (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild;
            append?: (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild;
        };
        'v-slots': new () => {
            prepend?: false | (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            default?: false | (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            append?: false | (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_: boolean) => any) | undefined;
    } & ShallowUnwrapRef<() => JSX.Element> & {} & {} & ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & ComponentOptionsBase<Readonly<ExtractPropTypes<{
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: {
        type: StringConstructor;
        default: string;
    };
    disabled: BooleanConstructor;
    loading: BooleanConstructor;
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    link: BooleanConstructor;
    hover: BooleanConstructor;
    image: StringConstructor;
    prependAvatar: StringConstructor;
    prependIcon: StringConstructor;
    appendAvatar: StringConstructor;
    appendIcon: StringConstructor;
    title: StringConstructor;
    subtitle: StringConstructor;
    divided: BooleanConstructor;
    text: StringConstructor;
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    transition: Omit<{
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        })>;
        default: string;
        validator: (val: unknown) => boolean;
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        };
    };
    modelValue: {
        type: BooleanConstructor;
        default: boolean;
    };
    type: {
        type: PropType<"success" | "info" | "warning" | "error">;
        default: string;
        validator: (val: AlertType) => boolean;
    };
    icon: {
        type: PropType<string | false>;
        default: boolean;
    };
    closable: BooleanConstructor;
    closeIcon: {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    };
    closeText: StringConstructor;
} & {
    $children: () => (() => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]) | VNodeChild | {
        prepend?: (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild;
        default?: (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild;
        append?: (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild;
    };
    'v-slots': new () => {
        prepend?: false | (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        default?: false | (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        append?: false | (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
    };
}>> & {
    "onUpdate:modelValue"?: ((_: boolean) => any) | undefined;
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_: boolean) => boolean;
}, string, {
    type: "success" | "info" | "warning" | "error";
    modelValue: boolean;
    icon: string | false;
    closable: boolean;
    closeIcon: string | Record<string, any>;
    transition: string | false | (TransitionProps & {
        component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
    }) | {
        readonly component: DefineComponent<{
            group: BooleanConstructor;
            mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }, () => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
            group: BooleanConstructor;
            mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }>>, {
            group: boolean;
        }>;
    };
    replace: boolean;
    fixed: boolean;
    link: boolean;
    loading: boolean;
    hover: boolean;
    divided: boolean;
    ripple: boolean;
    disabled: boolean;
    tag: string;
    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    absolute: boolean;
    size: Size | undefined;
    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
}> & VNodeProps & AllowedComponentProps & ComponentCustomProps & (new () => {
    $slots: AlertSlots;
});
export declare function filterAlertProps(props: Record<string, unknown>): [yes: Partial<Pick<Record<string, unknown>, string>>, no: Omit<Record<string, unknown>, string>];
export declare type Alert = InstanceType<typeof Alert>;
//# sourceMappingURL=alert.d.ts.map