var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { createVNode } from "vue";
import "./styles/anchor-item.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { Link } from "../link/link.mjs";
import { makeNamedAnchorItem, useNamedAnchorItem } from "../../composables/named-anchor/index.mjs";
const AnchorItem = defineComponent({
  name: "VeAnchorItem",
  props: __spreadValues({
    activeColor: {
      type: String,
      default: "primary"
    },
    text: String
  }, makeNamedAnchorItem()),
  setup(props, {
    slots
  }) {
    const {
      to,
      activate,
      isActive
    } = useNamedAnchorItem(props);
    return () => {
      return createVNode("li", {
        "class": ["ve-anchor-item", {
          "ve-anchor-item--active": isActive.value
        }]
      }, [createVNode(Link, {
        "to": to.value,
        "underline": false,
        "color": isActive.value ? props.activeColor : void 0,
        "onClick": (e) => {
          e.preventDefault();
          e.stopPropagation();
          activate(props.value);
        }
      }, __spreadProps(__spreadValues({}, slots), {
        default: () => {
          var _a, _b;
          return (_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text;
        }
      }))]);
    };
  }
});
export { AnchorItem };
//# sourceMappingURL=anchor-item.mjs.map
