var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { toRef, createVNode, mergeProps } from "vue";
import "./styles/anchor.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { provideDefaults } from "../../composables/defaults/index.mjs";
import { makeNamedAnchor, useNamedAnchor } from "../../composables/named-anchor/index.mjs";
import { AnchorItem } from "./anchor-item.mjs";
const Anchor = defineComponent({
  name: "VeAnchor",
  props: __spreadValues({
    activeColor: {
      type: String,
      default: "primary"
    },
    items: Array
  }, makeNamedAnchor()),
  setup(props, {
    slots
  }) {
    useNamedAnchor(props);
    provideDefaults({
      VeAnchorItem: {
        activeColor: toRef(props, "activeColor")
      }
    });
    return () => {
      var _a, _b;
      return createVNode("ul", {
        "class": "ve-anchor"
      }, [(_a = slots.default) == null ? void 0 : _a.call(slots), (_b = props.items) == null ? void 0 : _b.map((item) => createVNode(AnchorItem, mergeProps({
        "key": item.value
      }, item), null))]);
    };
  }
});
export { Anchor };
//# sourceMappingURL=anchor.mjs.map
