var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode } from "vue";
import "./styles/app.scss";
import { useRender } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeThemeProps, provideTheme } from "../../composables/theme/index.mjs";
import { makeLayoutProps, provideLayout } from "../../composables/layout/layout.mjs";
import { useProviders } from "../../composables/providers/index.mjs";
const App = defineComponent({
  name: "VeApp",
  props: __spreadValues(__spreadValues({}, makeThemeProps()), makeLayoutProps({
    fullHeight: true
  })),
  setup(props, {
    slots
  }) {
    const theme = provideTheme(props);
    const {
      getLayoutItem,
      items,
      layoutClasses
    } = provideLayout(props);
    const {
      createRootProvider
    } = useProviders();
    useRender(() => {
      const RootProvider = createRootProvider();
      return createVNode("div", {
        "class": ["ve-app", theme.themeClasses.value, layoutClasses.value],
        "data-app": "true"
      }, [createVNode("div", {
        "class": "ve-app__wrapper"
      }, [createVNode(RootProvider, null, {
        default: () => {
          var _a;
          return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
        }
      })])]);
    });
    return {
      theme,
      getLayoutItem,
      items
    };
  }
});
export { App };
//# sourceMappingURL=app.mjs.map
