var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode, Fragment } from "vue";
import { genericComponent } from "../../utils/define-component.mjs";
import { makeButtonProps, Button } from "../button/button.mjs";
import { Icon } from "../icon/icon.mjs";
import "../icon/icon-class.mjs";
import "../icon/icon-component.mjs";
import "../icon/icon-ligature.mjs";
import "../icon/icon-svg.mjs";
import { makeGroupItemProps, useGroupItem } from "../../composables/group/index.mjs";
import { BreadcrumbKey } from "./breadcrumb.mjs";
const BreadcrumbItem = genericComponent()({
  name: "VeBreadcrumbItem",
  props: __spreadValues(__spreadValues({}, makeButtonProps({
    variant: "text"
  })), makeGroupItemProps()),
  setup(props, {
    slots
  }) {
    const {
      id,
      group
    } = useGroupItem(props, BreadcrumbKey);
    const hasNext = computed(() => {
      if (!group.items.value.length)
        return false;
      return group.items.value[group.items.value.length - 1].id !== id;
    });
    return () => {
      var _a, _b, _c, _d, _e, _f;
      return createVNode(Fragment, null, [createVNode("li", {
        "class": ["ve-breadcrumb-item", {
          "ve-breadcrumb-item--has-next": hasNext.value
        }]
      }, [createVNode(Button, props, slots)]), hasNext.value && createVNode("li", {
        "class": "ve-breadcrumb-separator",
        "aria-hidden": "true"
      }, [(_f = (_e = (_a = slots.separator) == null ? void 0 : _a.call(slots)) != null ? _e : (_d = (_b = group.vm) == null ? void 0 : (_c = _b.slots).separator) == null ? void 0 : _d.call(_c)) != null ? _f : createVNode(Icon, {
        "icon": "$separator"
      }, null)])]);
    };
  }
});
export { BreadcrumbItem };
//# sourceMappingURL=breadcrumb-item.mjs.map
