var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode } from "vue";
import "./styles/breadcrumb.scss";
import { genericComponent } from "../../utils/define-component.mjs";
import { createSymbol } from "../../utils/symbol.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { useGroup } from "../../composables/group/index.mjs";
const BreadcrumbKey = createSymbol("breadcrumb");
const Breadcrumb = genericComponent()({
  name: "VeBreadcrumb",
  props: __spreadValues({}, makeTagProps({
    tag: "nav"
  })),
  emits: {
    "update:modelValue": (_value) => true
  },
  setup(props, {
    slots
  }) {
    useGroup(props, BreadcrumbKey);
    return () => {
      return createVNode(props.tag, {
        "aria-label": "breadcrumb",
        "class": "ve-breadcrumb"
      }, {
        default: () => {
          var _a;
          return [createVNode("ol", null, [(_a = slots.default) == null ? void 0 : _a.call(slots)])];
        }
      });
    };
  }
});
export { Breadcrumb, BreadcrumbKey };
//# sourceMappingURL=breadcrumb.mjs.map
