var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { reactive, toRef, createVNode } from "vue";
import "./styles/button-group.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeDisabledProps } from "../../composables/disabled/index.mjs";
import { makePaperProps, usePaper } from "../../composables/paper/index.mjs";
import { provideDefaults } from "../../composables/defaults/index.mjs";
const ButtonGroup = defineComponent({
  name: "VeButtonGroup",
  props: __spreadValues(__spreadValues({
    divided: Boolean
  }, makeDisabledProps()), makePaperProps({
    shape: "rounded-sm"
  })),
  setup(props, {
    slots
  }) {
    const {
      paperClasses,
      paperStyles
    } = usePaper(props);
    provideDefaults(reactive({
      VeButton: {
        disabled: toRef(props, "disabled"),
        height: "auto",
        color: toRef(props, "color"),
        variant: toRef(props, "variant")
      }
    }));
    return () => {
      return createVNode(props.tag, {
        "class": ["ve-button-group", {
          "ve-button-group--divided": props.divided
        }, paperClasses.value],
        "style": [paperStyles.value]
      }, slots);
    };
  }
});
export { ButtonGroup };
//# sourceMappingURL=button-group.mjs.map
