var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode } from "vue";
import { useRender } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeGroupProps, useGroup } from "../../composables/group/index.mjs";
import { ButtonGroup } from "../button-group/button-group.mjs";
const ButtonToggleKey = Symbol.for("veno-ui:button-toggle");
const ButtonToggle = defineComponent({
  name: "VeButtonToggle",
  props: __spreadValues({}, makeGroupProps({
    selectedClass: "ve-button--selected"
  })),
  emits: {
    "update:modelValue": (_value) => true
  },
  setup(props, {
    slots
  }) {
    const {
      isSelected,
      next,
      prev,
      select,
      selected
    } = useGroup(props, ButtonToggleKey);
    useRender(() => {
      return createVNode(ButtonGroup, {
        "class": "ve-button-toggle"
      }, {
        default: () => {
          var _a;
          return [(_a = slots.default) == null ? void 0 : _a.call(slots, {
            isSelected,
            next,
            prev,
            select,
            selected
          })];
        }
      });
    });
    return {
      next,
      prev,
      select
    };
  }
});
export { ButtonToggle, ButtonToggleKey };
//# sourceMappingURL=button-toggle.mjs.map
