import type { RouteLocationRaw } from 'vue-router';
import type { Size } from '../../composables/size';
import type { PropType, DefineComponent, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
export declare const makeButtonProps: <Defaults extends {
    elevation?: unknown;
    shape?: unknown;
    border?: unknown;
    density?: unknown;
    size?: unknown;
    height?: unknown;
    maxHeight?: unknown;
    maxWidth?: unknown;
    minHeight?: unknown;
    minWidth?: unknown;
    width?: unknown;
    absolute?: unknown;
    bottom?: unknown;
    fixed?: unknown;
    left?: unknown;
    position?: unknown;
    right?: unknown;
    top?: unknown;
    color?: unknown;
    textColor?: unknown;
    variant?: unknown;
    theme?: unknown;
    tag?: unknown;
    value?: unknown;
    disabled?: unknown;
    selectedClass?: unknown;
    href?: unknown;
    replace?: unknown;
    to?: unknown;
    loading?: unknown;
    type?: unknown;
    icon?: unknown;
    prependIcon?: unknown;
    appendIcon?: unknown;
    stacked?: unknown;
    block?: unknown;
    text?: unknown;
    ripple?: unknown;
    overlay?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    elevation: unknown extends Defaults["elevation"] ? {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    } : Omit<{
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["elevation"] ? string | number : string | number | Defaults["elevation"]>;
        default: unknown extends Defaults["elevation"] ? string | number : string | number | Defaults["elevation"];
    };
    shape: unknown extends Defaults["shape"] ? Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    } : Omit<Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["shape"] ? "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" : "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" | Defaults["shape"]>;
        default: unknown extends Defaults["shape"] ? "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" : "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" | Defaults["shape"];
    };
    border: unknown extends Defaults["border"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["border"] ? string | number | boolean : string | number | boolean | Defaults["border"]>;
        default: unknown extends Defaults["border"] ? string | number | boolean : string | number | boolean | Defaults["border"];
    };
    density: unknown extends Defaults["density"] ? {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    } : Omit<{
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["density"] ? "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined : "medium" | "ultra-low" | "low" | "high" | "ultra-high" | Defaults["density"]>;
        default: unknown extends Defaults["density"] ? "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined : "medium" | "ultra-low" | "low" | "high" | "ultra-high" | Defaults["density"];
    };
    size: unknown extends Defaults["size"] ? {
        type: PropType<Size | undefined>;
        default: string;
    } : Omit<{
        type: PropType<Size | undefined>;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["size"] ? Size | undefined : Size | Defaults["size"]>;
        default: unknown extends Defaults["size"] ? Size | undefined : Size | Defaults["size"];
    };
    height: unknown extends Defaults["height"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["height"] ? string | number : string | number | Defaults["height"]>;
        default: unknown extends Defaults["height"] ? string | number : string | number | Defaults["height"];
    };
    maxHeight: unknown extends Defaults["maxHeight"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["maxHeight"] ? string | number : string | number | Defaults["maxHeight"]>;
        default: unknown extends Defaults["maxHeight"] ? string | number : string | number | Defaults["maxHeight"];
    };
    maxWidth: unknown extends Defaults["maxWidth"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["maxWidth"] ? string | number : string | number | Defaults["maxWidth"]>;
        default: unknown extends Defaults["maxWidth"] ? string | number : string | number | Defaults["maxWidth"];
    };
    minHeight: unknown extends Defaults["minHeight"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["minHeight"] ? string | number : string | number | Defaults["minHeight"]>;
        default: unknown extends Defaults["minHeight"] ? string | number : string | number | Defaults["minHeight"];
    };
    minWidth: unknown extends Defaults["minWidth"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["minWidth"] ? string | number : string | number | Defaults["minWidth"]>;
        default: unknown extends Defaults["minWidth"] ? string | number : string | number | Defaults["minWidth"];
    };
    width: unknown extends Defaults["width"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["width"] ? string | number : string | number | Defaults["width"]>;
        default: unknown extends Defaults["width"] ? string | number : string | number | Defaults["width"];
    };
    absolute: unknown extends Defaults["absolute"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["absolute"] ? boolean : boolean | Defaults["absolute"]>;
        default: unknown extends Defaults["absolute"] ? boolean : boolean | Defaults["absolute"];
    };
    bottom: unknown extends Defaults["bottom"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["bottom"] ? string | number | boolean : string | number | boolean | Defaults["bottom"]>;
        default: unknown extends Defaults["bottom"] ? string | number | boolean : string | number | boolean | Defaults["bottom"];
    };
    fixed: unknown extends Defaults["fixed"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["fixed"] ? boolean : boolean | Defaults["fixed"]>;
        default: unknown extends Defaults["fixed"] ? boolean : boolean | Defaults["fixed"];
    };
    left: unknown extends Defaults["left"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["left"] ? string | number | boolean : string | number | boolean | Defaults["left"]>;
        default: unknown extends Defaults["left"] ? string | number | boolean : string | number | boolean | Defaults["left"];
    };
    position: unknown extends Defaults["position"] ? {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    } : Omit<{
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["position"] ? "fixed" | "absolute" | "static" | "relative" | "sticky" : "fixed" | "absolute" | "static" | "relative" | "sticky" | Defaults["position"]>;
        default: unknown extends Defaults["position"] ? "fixed" | "absolute" | "static" | "relative" | "sticky" : "fixed" | "absolute" | "static" | "relative" | "sticky" | Defaults["position"];
    };
    right: unknown extends Defaults["right"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["right"] ? string | number | boolean : string | number | boolean | Defaults["right"]>;
        default: unknown extends Defaults["right"] ? string | number | boolean : string | number | boolean | Defaults["right"];
    };
    top: unknown extends Defaults["top"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["top"] ? string | number | boolean : string | number | boolean | Defaults["top"]>;
        default: unknown extends Defaults["top"] ? string | number | boolean : string | number | boolean | Defaults["top"];
    };
    color: unknown extends Defaults["color"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["color"] ? string : string | Defaults["color"]>;
        default: unknown extends Defaults["color"] ? string : string | Defaults["color"];
    };
    textColor: unknown extends Defaults["textColor"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"]>;
        default: unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"];
    };
    variant: unknown extends Defaults["variant"] ? Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    } : Omit<Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"]>;
        default: unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"];
    };
    theme: unknown extends Defaults["theme"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["theme"] ? string : string | Defaults["theme"]>;
        default: unknown extends Defaults["theme"] ? string : string | Defaults["theme"];
    };
    tag: unknown extends Defaults["tag"] ? Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    } : Omit<Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["tag"] ? string : string | Defaults["tag"]>;
        default: unknown extends Defaults["tag"] ? string : string | Defaults["tag"];
    };
    value: unknown extends Defaults["value"] ? null : {
        type: PropType<unknown extends Defaults["value"] ? any : any>;
        default: unknown extends Defaults["value"] ? any : any;
    };
    disabled: unknown extends Defaults["disabled"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["disabled"] ? boolean : boolean | Defaults["disabled"]>;
        default: unknown extends Defaults["disabled"] ? boolean : boolean | Defaults["disabled"];
    };
    selectedClass: unknown extends Defaults["selectedClass"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["selectedClass"] ? string : string | Defaults["selectedClass"]>;
        default: unknown extends Defaults["selectedClass"] ? string : string | Defaults["selectedClass"];
    };
    href: unknown extends Defaults["href"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["href"] ? string : string | Defaults["href"]>;
        default: unknown extends Defaults["href"] ? string : string | Defaults["href"];
    };
    replace: unknown extends Defaults["replace"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["replace"] ? boolean : boolean | Defaults["replace"]>;
        default: unknown extends Defaults["replace"] ? boolean : boolean | Defaults["replace"];
    };
    to: unknown extends Defaults["to"] ? PropType<RouteLocationRaw> : {
        type: PropType<unknown extends Defaults["to"] ? (string & {}) | RouteLocationRaw : (string & {}) | RouteLocationRaw | Defaults["to"]>;
        default: unknown extends Defaults["to"] ? (string & {}) | RouteLocationRaw : (string & {}) | RouteLocationRaw | Defaults["to"];
    };
    loading: unknown extends Defaults["loading"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["loading"] ? boolean : boolean | Defaults["loading"]>;
        default: unknown extends Defaults["loading"] ? boolean : boolean | Defaults["loading"];
    };
    type: unknown extends Defaults["type"] ? {
        type: StringConstructor;
        default: string;
    } : Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["type"] ? string : string | Defaults["type"]>;
        default: unknown extends Defaults["type"] ? string : string | Defaults["type"];
    };
    icon: unknown extends Defaults["icon"] ? (BooleanConstructor | StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["icon"] ? unknown : unknown>;
        default: unknown extends Defaults["icon"] ? unknown : unknown;
    };
    prependIcon: unknown extends Defaults["prependIcon"] ? (StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["prependIcon"] ? unknown : unknown>;
        default: unknown extends Defaults["prependIcon"] ? unknown : unknown;
    };
    appendIcon: unknown extends Defaults["appendIcon"] ? (StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["appendIcon"] ? unknown : unknown>;
        default: unknown extends Defaults["appendIcon"] ? unknown : unknown;
    };
    stacked: unknown extends Defaults["stacked"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["stacked"] ? boolean : boolean | Defaults["stacked"]>;
        default: unknown extends Defaults["stacked"] ? boolean : boolean | Defaults["stacked"];
    };
    block: unknown extends Defaults["block"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["block"] ? boolean : boolean | Defaults["block"]>;
        default: unknown extends Defaults["block"] ? boolean : boolean | Defaults["block"];
    };
    text: unknown extends Defaults["text"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["text"] ? string | number : string | number | Defaults["text"]>;
        default: unknown extends Defaults["text"] ? string | number : string | number | Defaults["text"];
    };
    ripple: unknown extends Defaults["ripple"] ? {
        type: BooleanConstructor;
        default: boolean;
    } : Omit<{
        type: BooleanConstructor;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["ripple"] ? boolean : boolean | Defaults["ripple"]>;
        default: unknown extends Defaults["ripple"] ? boolean : boolean | Defaults["ripple"];
    };
    overlay: unknown extends Defaults["overlay"] ? {
        type: BooleanConstructor;
        default: boolean;
    } : Omit<{
        type: BooleanConstructor;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["overlay"] ? boolean : boolean | Defaults["overlay"]>;
        default: unknown extends Defaults["overlay"] ? boolean : boolean | Defaults["overlay"];
    };
};
export declare const Button: DefineComponent<{
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    value: null;
    disabled: BooleanConstructor;
    selectedClass: StringConstructor;
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    loading: BooleanConstructor;
    type: {
        type: StringConstructor;
        default: string;
    };
    icon: (BooleanConstructor | StringConstructor | ObjectConstructor)[];
    prependIcon: (StringConstructor | ObjectConstructor)[];
    appendIcon: (StringConstructor | ObjectConstructor)[];
    stacked: BooleanConstructor;
    block: BooleanConstructor;
    text: (StringConstructor | NumberConstructor)[];
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    overlay: {
        type: BooleanConstructor;
        default: boolean;
    };
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    click: (_event: MouseEvent) => true;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    value: null;
    disabled: BooleanConstructor;
    selectedClass: StringConstructor;
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    loading: BooleanConstructor;
    type: {
        type: StringConstructor;
        default: string;
    };
    icon: (BooleanConstructor | StringConstructor | ObjectConstructor)[];
    prependIcon: (StringConstructor | ObjectConstructor)[];
    appendIcon: (StringConstructor | ObjectConstructor)[];
    stacked: BooleanConstructor;
    block: BooleanConstructor;
    text: (StringConstructor | NumberConstructor)[];
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    overlay: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & {
    onClick?: ((_event: MouseEvent) => any) | undefined;
}, {
    type: string;
    replace: boolean;
    fixed: boolean;
    loading: boolean;
    ripple: boolean;
    disabled: boolean;
    tag: string;
    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    absolute: boolean;
    size: Size | undefined;
    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    stacked: boolean;
    block: boolean;
    overlay: boolean;
}>;
export declare type Button = InstanceType<typeof Button>;
//# sourceMappingURL=button.d.ts.map