var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { ref, watch, createVNode, Transition, withDirectives, vShow } from "vue";
import "./styles/carousel-item.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeGroupItemProps, useGroupItem } from "../../composables/group/index.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { CarouselKey } from "./carousel.mjs";
const CarouselItem = defineComponent({
  name: "VeCarouselItem",
  props: __spreadValues(__spreadValues({}, makeGroupItemProps()), makeTagProps()),
  setup(props, {
    slots
  }) {
    const {
      isSelected,
      group
    } = useGroupItem(props, CarouselKey);
    const {
      items,
      selected
    } = group;
    const transition = ref();
    watch(() => items.value.findIndex(({
      id
    }) => selected.value.includes(id)), (val, oldVal) => {
      transition.value = oldVal > val ? "ve-carousel-item-x-reverse-transition" : "ve-carousel-item-x-transition";
    });
    return () => createVNode(Transition, {
      "name": transition.value
    }, {
      default: () => [withDirectives(createVNode(props.tag, {
        "class": "ve-carousel-item"
      }, {
        default: () => {
          var _a;
          return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
        }
      }), [[vShow, isSelected.value]])]
    });
  }
});
export { CarouselItem };
//# sourceMappingURL=carousel-item.mjs.map
