import type { Size } from '../../composables/size';
import type { DefineComponent, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, PropType } from 'vue';
export interface CheckboxGroupItemProps {
    value: any;
    [key: string]: any;
}
export declare const CheckboxGroup: DefineComponent<{
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    id: StringConstructor;
    inline: BooleanConstructor;
    name: StringConstructor;
    falseIcon: {
        type: PropType<string>;
        default: string;
    };
    trueIcon: {
        type: PropType<string>;
        default: string;
    };
    multiple: Omit<{
        type: PropType<boolean | null>;
        default: null;
    }, "default" | "type"> & {
        type: PropType<boolean>;
        default: boolean;
    };
    disabled: BooleanConstructor;
    readonly: BooleanConstructor;
    type: {
        type: PropType<string>;
        default: string;
    };
    modelValue: null;
    /**
     * @zh 复选框的所有可选项
     */
    items: PropType<(string | CheckboxGroupItemProps)[]>;
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_val: any) => true;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    id: StringConstructor;
    inline: BooleanConstructor;
    name: StringConstructor;
    falseIcon: {
        type: PropType<string>;
        default: string;
    };
    trueIcon: {
        type: PropType<string>;
        default: string;
    };
    multiple: Omit<{
        type: PropType<boolean | null>;
        default: null;
    }, "default" | "type"> & {
        type: PropType<boolean>;
        default: boolean;
    };
    disabled: BooleanConstructor;
    readonly: BooleanConstructor;
    type: {
        type: PropType<string>;
        default: string;
    };
    modelValue: null;
    /**
     * @zh 复选框的所有可选项
     */
    items: PropType<(string | CheckboxGroupItemProps)[]>;
}>> & {
    "onUpdate:modelValue"?: ((_val: any) => any) | undefined;
}, {
    type: string;
    disabled: boolean;
    size: Size | undefined;
    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
    inline: boolean;
    multiple: boolean;
    falseIcon: string;
    trueIcon: string;
    readonly: boolean;
}>;
//# sourceMappingURL=checkbox-group.d.ts.map