var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode, mergeProps, isVNode } from "vue";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeSelectionControlProps, filterSelectionControlProps, SelectionControl } from "../selection-control/selection-control.mjs";
import { useProxiedModel } from "../../composables/proxied-model/index.mjs";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
const Checkbox = defineComponent({
  name: "VeCheckbox",
  props: __spreadValues({
    indeterminate: Boolean,
    indeterminateIcon: {
      type: String,
      default: "$checkboxIndeterminate"
    }
  }, makeSelectionControlProps({
    type: "checkbox",
    falseIcon: "$checkboxOff",
    trueIcon: "$checkboxOn",
    color: "primary"
  })),
  emits: {
    "update:modelValue": (_val) => true,
    "update:indeterminate": (_val) => true
  },
  setup(props, {
    emit,
    slots
  }) {
    const indeterminate = useProxiedModel(props, "indeterminate");
    const falseIcon = computed(() => {
      return indeterminate.value ? props.indeterminateIcon : props.falseIcon;
    });
    const trueIcon = computed(() => {
      return indeterminate.value ? props.indeterminateIcon : props.trueIcon;
    });
    function onChange(val) {
      if (indeterminate.value) {
        indeterminate.value = false;
      } else {
        emit("update:modelValue", val);
      }
    }
    return () => {
      const [controlProps] = filterSelectionControlProps(props);
      return createVNode(SelectionControl, mergeProps(controlProps, {
        "class": "ve-checkbox",
        "onUpdate:modelValue": onChange,
        "falseIcon": falseIcon.value,
        "trueIcon": trueIcon.value,
        "aria-checked": indeterminate.value ? "mixed" : void 0
      }), _isSlot(slots) ? slots : {
        default: () => [slots]
      });
    };
  }
});
export { Checkbox };
//# sourceMappingURL=checkbox.mjs.map
