var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode, withDirectives, vShow } from "vue";
import "./styles/counter.scss";
import { genericComponent } from "../../utils/define-component.mjs";
import { makeTransitionProps, MaybeTransition } from "../../composables/transition/index.mjs";
import { FadeTransition } from "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import "../transition/expand-transition.mjs";
import "../transition/dialog-transition.mjs";
import "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import "../transition/slide-right-fade-in-expand-transition.mjs";
const Counter = genericComponent()({
  name: "VeCounter",
  props: __spreadValues({
    active: Boolean,
    max: [Number, String],
    value: {
      type: [Number, String],
      default: 0
    }
  }, makeTransitionProps({
    transition: {
      component: FadeTransition
    }
  })),
  setup(props, {
    slots
  }) {
    const counter = computed(() => {
      return props.max ? `${props.value} / ${props.max}` : String(props.value);
    });
    return () => {
      return createVNode(MaybeTransition, {
        "transition": props.transition
      }, {
        default: () => {
          var _a, _b;
          return [withDirectives(createVNode("div", {
            "class": "ve-counter"
          }, [(_b = (_a = slots.default) == null ? void 0 : _a.call(slots, {
            counter: counter.value,
            max: Number(props.max),
            value: Number(props.value)
          })) != null ? _b : counter.value]), [[vShow, props.active]])];
        }
      });
    };
  }
});
export { Counter };
//# sourceMappingURL=counter.mjs.map
