import type { DefineComponent, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, ComputedRef,  InjectionKey,  PropType,  Ref } from 'vue';
import type { DateInstance } from '../../composables/date';
interface DateRangeInstance {
    selected: ComputedRef<DateInstance[]>;
    select: (value: string) => void;
    inRange: (value: number) => boolean;
    preview: (value: boolean) => void;
    isPreview: Ref<boolean>;
}
export declare const DateRangeKey: InjectionKey<DateRangeInstance>;
export declare const DateRangePickerPanel: DefineComponent<{
    /**
     * @zh 时间格式化
     */
    format: {
        type: PropType<string[] | ((dates: DateInstance[]) => string[])>;
        default: () => string[];
    };
    /**
     * @zh 时间值
     */
    modelValue: {
        type: PropType<string[]>;
        default: () => never[];
    };
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_value: string[]) => true;
    preview: (_value: boolean) => true;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    /**
     * @zh 时间格式化
     */
    format: {
        type: PropType<string[] | ((dates: DateInstance[]) => string[])>;
        default: () => string[];
    };
    /**
     * @zh 时间值
     */
    modelValue: {
        type: PropType<string[]>;
        default: () => never[];
    };
}>> & {
    "onUpdate:modelValue"?: ((_value: string[]) => any) | undefined;
    onPreview?: ((_value: boolean) => any) | undefined;
}, {
    modelValue: string[];
    format: string[] | ((dates: DateInstance[]) => string[]);
}>;
export {};
//# sourceMappingURL=date-range-picker-panel.d.ts.map