import { defineComponent, toRefs } from "vue";
import { provideDefaults } from "../../composables/defaults/index.mjs";
const DefaultsProvider = defineComponent({
  name: "VeDefaultsProvider",
  props: {
    defaults: Object,
    reset: [Number, String],
    root: Boolean,
    scoped: Boolean
  },
  setup(props, {
    slots
  }) {
    const {
      defaults,
      reset,
      root,
      scoped
    } = toRefs(props);
    provideDefaults(defaults, {
      reset,
      root,
      scoped
    });
    return () => {
      var _a;
      return (_a = slots.default) == null ? void 0 : _a.call(slots);
    };
  }
});
export { DefaultsProvider };
//# sourceMappingURL=defaults-provider.mjs.map
