var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode, createTextVNode } from "vue";
import "./styles/device.scss";
import { convertToUnit } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { makeVariantProps, useVariant } from "../../composables/variant/index.mjs";
import { makeDeviceProps, useDevice } from "../../composables/device/index.mjs";
import { DeviceStatusBar } from "./device-status-bar.mjs";
const Device = defineComponent({
  name: "VeDevice",
  props: __spreadValues(__spreadValues(__spreadValues({
    battery: {
      type: Number,
      default: 100
    },
    operator: {
      type: String,
      default: "Z+"
    },
    headerColor: String
  }, makeDeviceProps()), makeTagProps()), makeVariantProps()),
  setup(props, {
    slots
  }) {
    const {
      colorClasses,
      colorStyles,
      variantClasses
    } = useVariant(props);
    const {
      deviceModel,
      deviceStyles
    } = useDevice(props);
    return () => {
      return createVNode(props.tag, {
        "class": ["ve-device", variantClasses.value, colorClasses.value],
        "style": [deviceStyles.value, colorStyles.value]
      }, {
        default: () => {
          var _a, _b;
          return [createVNode("div", {
            "class": "ve-device__app-header",
            "style": {
              backgroundColor: props.headerColor
            }
          }, [deviceModel.value.statusBarHeight > 0 && createVNode(DeviceStatusBar, {
            "height": deviceModel.value.statusBarHeight,
            "battery": props.battery,
            "operator": props.operator
          }, null), slots.header && createVNode("div", {
            "class": "ve-device__app-bar"
          }, [(_a = slots.header) == null ? void 0 : _a.call(slots)])]), createVNode("div", {
            "class": "ve-device__app-main"
          }, [(_b = slots.default) == null ? void 0 : _b.call(slots)]), props.autoHeight && typeof deviceModel.value.height === "number" && createVNode("div", {
            "class": "ve-device__height-tip",
            "style": {
              top: convertToUnit(deviceModel.value.height - 21)
            }
          }, [props.model, createTextVNode("\u9AD8\u5EA6")])];
        }
      });
    };
  }
});
export { Device };
//# sourceMappingURL=device.mjs.map
