var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { computed, createVNode } from "vue";
import "./styles/dialog.scss";
import { getUid } from "../../utils/dist/index.mjs";
import { genericComponent } from "../../utils/define-component.mjs";
import { useProxiedModel } from "../../composables/proxied-model/index.mjs";
import { makeTransitionProps } from "../../composables/transition/index.mjs";
import "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import "../transition/expand-transition.mjs";
import { DialogTransition } from "../transition/dialog-transition.mjs";
import "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import "../transition/slide-right-fade-in-expand-transition.mjs";
import { Overlay } from "../overlay/overlay.mjs";
const Dialog = genericComponent()({
  name: "VeDialog",
  props: __spreadValues({
    fullscreen: Boolean,
    id: String,
    modelValue: Boolean,
    scrollable: Boolean,
    draggable: Boolean
  }, makeTransitionProps({
    transition: {
      component: DialogTransition
    }
  })),
  emits: {
    "update:modelValue": (_) => true
  },
  setup(props, {
    slots
  }) {
    const isActive = useProxiedModel(props, "modelValue");
    const id = computed(() => props.id || `ve-dialog-${getUid()}`);
    return () => createVNode(Overlay, {
      "aria-role": "dialog",
      "aria-modal": "true",
      "activator-props": {
        "aria-haspopup": "dialog",
        "aria-expanded": String(isActive.value),
        "aria-describedby": id.value
      },
      "class": ["ve-dialog", {
        "ve-dialog--fullscreen": props.fullscreen,
        "ve-dialog--scrollable": props.scrollable
      }],
      "contentClass": "ve-dialog__wrapper",
      "id": id.value,
      "transition": props.transition,
      "modelValue": isActive.value,
      "onUpdate:modelValue": ($event) => isActive.value = $event
    }, __spreadProps(__spreadValues({}, slots), {
      default: slots.default
    }));
  }
});
export { Dialog };
//# sourceMappingURL=dialog.mjs.map
