import type { ComponentInternalInstance, ExtractPropTypes, VNodeProps, AllowedComponentProps, ComponentCustomProps, Slot, ComponentPublicInstance, ComponentOptionsBase, ComponentOptionsMixin, DebuggerEvent, nextTick, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties, VNode, RendererNode, RendererElement, PropType } from 'vue';
declare const VeDividerTextAligns: readonly ["left", "center", "right"];
declare type VeDividerTextAlign = typeof VeDividerTextAligns[number];
export declare type Divider = InstanceType<typeof Divider>;
export declare const Divider: {
    new (...args: any[]): {
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            tag: string;
            dashed: boolean;
            vertical: boolean;
            textAlign: "left" | "right" | "center";
        }> & Omit<Readonly<ExtractPropTypes<{
            tag: Omit<{
                type: StringConstructor;
                default: string;
            }, "default" | "type"> & {
                type: PropType<string>;
                default: string;
            };
            textAlign: {
                type: PropType<"left" | "right" | "center">;
                default: string;
                validator: (val: VeDividerTextAlign) => boolean;
            };
            length: (StringConstructor | NumberConstructor)[];
            dashed: BooleanConstructor;
            vertical: BooleanConstructor;
        }>> & VNodeProps & AllowedComponentProps & ComponentCustomProps, "tag" | "dashed" | "vertical" | "textAlign">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            tag: Omit<{
                type: StringConstructor;
                default: string;
            }, "default" | "type"> & {
                type: PropType<string>;
                default: string;
            };
            textAlign: {
                type: PropType<"left" | "right" | "center">;
                default: string;
                validator: (val: VeDividerTextAlign) => boolean;
            };
            length: (StringConstructor | NumberConstructor)[];
            dashed: BooleanConstructor;
            vertical: BooleanConstructor;
        }>>, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, {
            tag: string;
            dashed: boolean;
            vertical: boolean;
            textAlign: "left" | "right" | "center";
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        tag: Omit<{
            type: StringConstructor;
            default: string;
        }, "default" | "type"> & {
            type: PropType<string>;
            default: string;
        };
        textAlign: {
            type: PropType<"left" | "right" | "center">;
            default: string;
            validator: (val: VeDividerTextAlign) => boolean;
        };
        length: (StringConstructor | NumberConstructor)[];
        dashed: BooleanConstructor;
        vertical: BooleanConstructor;
    }>> & ShallowUnwrapRef<() => JSX.Element> & {} & {} & ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & ComponentOptionsBase<Readonly<ExtractPropTypes<{
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    textAlign: {
        type: PropType<"left" | "right" | "center">;
        default: string;
        validator: (val: VeDividerTextAlign) => boolean;
    };
    length: (StringConstructor | NumberConstructor)[];
    dashed: BooleanConstructor;
    vertical: BooleanConstructor;
}>>, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, {
    tag: string;
    dashed: boolean;
    vertical: boolean;
    textAlign: "left" | "right" | "center";
}> & VNodeProps & AllowedComponentProps & ComponentCustomProps & (new () => {
    $slots?: Record<string, (...args: any[]) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]> | undefined;
});
export {};
//# sourceMappingURL=divider.d.ts.map