var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { mergeProps, toHandlers } from "vue";
import { defineComponent } from "../../utils/define-component.mjs";
import { useProxiedModel } from "../../composables/proxied-model/index.mjs";
import { makeDraggableProps, useDraggable } from "../../composables/draggable/index.mjs";
const Draggable = defineComponent({
  name: "VeDraggable",
  inheritAttrs: false,
  props: __spreadValues({
    modelValue: {
      type: Object,
      default: () => ({
        left: 0,
        top: 0
      })
    }
  }, makeDraggableProps()),
  emits: {
    "update:modelValue": (_value) => true
  },
  setup(props, {
    slots
  }) {
    const model = useProxiedModel(props, "modelValue", props.modelValue, (v) => ({
      left: parseFloat((v == null ? void 0 : v.left) || 0),
      top: parseFloat((v == null ? void 0 : v.top) || 0)
    }));
    const {
      draggableEvents,
      draggableStyles,
      contentStyles
    } = useDraggable(props, model);
    return () => {
      var _a;
      const draggable = mergeProps(toHandlers(draggableEvents.value), {
        style: draggableStyles.value
      });
      return (_a = slots.default) == null ? void 0 : _a.call(slots, {
        value: model.value,
        draggable,
        contentStyle: contentStyles.value,
        props: mergeProps(draggable, {
          style: contentStyles.value
        })
      });
    };
  }
});
export { Draggable };
//# sourceMappingURL=draggable.mjs.map
