import type { DefineComponent, PropType, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
export declare const Drawer: DefineComponent<{
    modelValue: Omit<{
        type: PropType<boolean | undefined>;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<boolean | null>;
        default: boolean | null;
    };
    name: StringConstructor;
    position: Omit<{
        type: PropType<"fixed" | "absolute">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"fixed" | "absolute">;
        default: "fixed" | "absolute";
    };
    anchor: Omit<{
        type: PropType<"bottom" | "left" | "right" | "top">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"bottom" | "left" | "right" | "top">;
        default: "bottom" | "left" | "right" | "top";
    };
    priority: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    theme: StringConstructor;
    beautifyScrollbar: {
        type: BooleanConstructor;
        default: boolean;
    };
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    /**
     * @zh 禁用大小调整监听
     */
    disableResizeWatcher: BooleanConstructor;
    /**
     * @zh 禁用路由监听
     */
    disableRouteWatcher: BooleanConstructor;
    /**
     * @zh 背景颜色
     */
    color: StringConstructor;
    /**
     * @zh 悬停时展开
     */
    expandOnHover: BooleanConstructor;
    /**
     * @zh 持续激活
     */
    permanent: BooleanConstructor;
    /**
     * @zh 最小化
     */
    rail: BooleanConstructor;
    /**
     * @zh 最小化宽度
     */
    railWidth: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
    /**
     * @zh 显示激活/隐藏按钮
     */
    showToggler: BooleanConstructor;
    /**
     * @zh 临时抽屉
     */
    temporary: BooleanConstructor;
    /**
     * @zh 可触摸
     */
    touchless: BooleanConstructor;
    /**
     * @zh 宽度
     */
    width: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_modelValue: boolean) => true;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    modelValue: Omit<{
        type: PropType<boolean | undefined>;
        default: boolean;
    }, "default" | "type"> & {
        type: PropType<boolean | null>;
        default: boolean | null;
    };
    name: StringConstructor;
    position: Omit<{
        type: PropType<"fixed" | "absolute">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"fixed" | "absolute">;
        default: "fixed" | "absolute";
    };
    anchor: Omit<{
        type: PropType<"bottom" | "left" | "right" | "top">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"bottom" | "left" | "right" | "top">;
        default: "bottom" | "left" | "right" | "top";
    };
    priority: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    theme: StringConstructor;
    beautifyScrollbar: {
        type: BooleanConstructor;
        default: boolean;
    };
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    /**
     * @zh 禁用大小调整监听
     */
    disableResizeWatcher: BooleanConstructor;
    /**
     * @zh 禁用路由监听
     */
    disableRouteWatcher: BooleanConstructor;
    /**
     * @zh 背景颜色
     */
    color: StringConstructor;
    /**
     * @zh 悬停时展开
     */
    expandOnHover: BooleanConstructor;
    /**
     * @zh 持续激活
     */
    permanent: BooleanConstructor;
    /**
     * @zh 最小化
     */
    rail: BooleanConstructor;
    /**
     * @zh 最小化宽度
     */
    railWidth: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
    /**
     * @zh 显示激活/隐藏按钮
     */
    showToggler: BooleanConstructor;
    /**
     * @zh 临时抽屉
     */
    temporary: BooleanConstructor;
    /**
     * @zh 可触摸
     */
    touchless: BooleanConstructor;
    /**
     * @zh 宽度
     */
    width: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
}>> & {
    "onUpdate:modelValue"?: ((_modelValue: boolean) => any) | undefined;
}, {
    modelValue: boolean | null;
    anchor: "bottom" | "left" | "right" | "top";
    tag: string;
    position: "fixed" | "absolute";
    width: string | number;
    priority: string | number;
    beautifyScrollbar: boolean;
    disableResizeWatcher: boolean;
    disableRouteWatcher: boolean;
    expandOnHover: boolean;
    permanent: boolean;
    rail: boolean;
    railWidth: string | number;
    showToggler: boolean;
    temporary: boolean;
    touchless: boolean;
}>;
export declare type Drawer = InstanceType<typeof Drawer>;
//# sourceMappingURL=drawer.d.ts.map