var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { computed, toRef, createVNode } from "vue";
import "./styles/form.scss";
import { useRender } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeSizeProps } from "../../composables/size/index.mjs";
import { makeDensityProps } from "../../composables/density/index.mjs";
import { makeFormProps, provideForm } from "../../composables/form/index.mjs";
import { makeVariantProps } from "../../composables/variant/index.mjs";
import { provideDefaults } from "../../composables/defaults/index.mjs";
import { FormChildren } from "./form-children.mjs";
const Form = defineComponent({
  name: "VeForm",
  props: __spreadValues(__spreadValues(__spreadValues(__spreadValues({
    direction: {
      type: String,
      default: "horizontal",
      validator: (v) => ["horizontal", "vertical"].includes(v)
    },
    hideDetails: [Boolean, String],
    inline: Boolean,
    items: Array,
    labelWidth: [Number, String]
  }, makeSizeProps()), makeDensityProps()), makeFormProps()), makeVariantProps()),
  emits: {
    "update:valid": (_valid) => true,
    "update:modelValue": (_modelValue) => true,
    "resetValidation": () => true,
    "reset": (_event) => true,
    "submit": (_value, _event) => true
  },
  setup(props, {
    slots
  }) {
    const form = provideForm(props);
    const items = computed(() => {
      var _a;
      return (_a = props.items) == null ? void 0 : _a.map((item) => {
        const _a2 = item, {
          $type: type
        } = _a2, props2 = __objRest(_a2, [
          "$type"
        ]);
        return {
          type,
          props: props2
        };
      });
    });
    const defaults = {
      variant: toRef(props, "variant"),
      size: toRef(props, "size"),
      density: toRef(props, "density"),
      direction: toRef(props, "direction"),
      inline: toRef(props, "inline"),
      labelWidth: toRef(props, "labelWidth"),
      hideDetails: toRef(props, "hideDetails"),
      readonly: toRef(props, "readonly"),
      disabled: toRef(props, "disabled")
    };
    provideDefaults({
      VeInput: defaults,
      VeSelect: defaults,
      VeRadioGroup: defaults,
      VeCheckboxGroup: defaults,
      VeSwitch: defaults,
      VeFormControl: defaults,
      VeButton: {
        density: defaults.density,
        disabled: defaults.disabled
      }
    });
    useRender(() => {
      var _a;
      return createVNode("form", {
        "class": ["ve-form", {
          [`ve-form--${props.direction}`]: !!props.direction,
          "ve-form--inline": props.inline
        }],
        "novalidate": true,
        "onReset": form.reset,
        "onSubmit": form.submit
      }, [createVNode(FormChildren, {
        "items": items.value
      }, null), (_a = slots.default) == null ? void 0 : _a.call(slots, form)]);
    });
    return form;
  }
});
export { Form };
//# sourceMappingURL=form.mjs.map
