var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode, mergeProps, isVNode } from "vue";
import "./styles/header.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeLayoutItemProps, useLayoutItem } from "../../composables/layout/layout-item.mjs";
import { makeToolbarProps, filterToolbarProps, Toolbar } from "../toolbar/toolbar.mjs";
import "../toolbar/toolbar-items.mjs";
import "../toolbar/toolbar-title.mjs";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
const Header = defineComponent({
  name: "VeHeader",
  props: __spreadValues(__spreadValues({}, makeToolbarProps()), makeLayoutItemProps({
    position: "fixed",
    anchor: "top"
  })),
  setup(props, {
    slots
  }) {
    const {
      layoutItemStyles
    } = useLayoutItem(computed(() => ({
      position: props.position,
      anchor: props.anchor,
      size: props.height,
      active: props.modelValue,
      priority: props.priority
    })));
    return () => {
      const [toolbarProps] = filterToolbarProps(props);
      return createVNode(Toolbar, mergeProps(toolbarProps, {
        "class": ["ve-header"],
        "style": layoutItemStyles.value
      }), _isSlot(slots) ? slots : {
        default: () => [slots]
      });
    };
  }
});
export { Header };
//# sourceMappingURL=header.mjs.map
