import { createVNode } from "vue";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeIconSetProps } from "../../composables/icon/make-icon-props.mjs";
const IconComponent = defineComponent({
  name: "VeIconComponent",
  props: makeIconSetProps(),
  setup(props) {
    return () => {
      return createVNode(props.tag, null, {
        default: () => [createVNode(props.icon, {
          "role": "img",
          "aria-hidden": "true"
        }, null)]
      });
    };
  }
});
export { IconComponent };
//# sourceMappingURL=icon-component.mjs.map
