var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode } from "vue";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeIconSetProps } from "../../composables/icon/make-icon-props.mjs";
const IconSvg = defineComponent({
  name: "VeIconSvg",
  props: __spreadValues({
    viewBox: {
      type: String,
      default: "0 0 24 24"
    }
  }, makeIconSetProps()),
  setup(props) {
    return () => {
      const isString = typeof props.icon === "string";
      return createVNode(props.tag, null, {
        default: () => [isString ? createVNode("svg", {
          "xmlns": "http://www.w3.org/2000/svg",
          "viewBox": props.viewBox,
          "role": "img",
          "aria-hidden": "true"
        }, [createVNode("path", {
          "d": props.icon
        }, null)]) : createVNode(props.icon, {
          "role": "img",
          "aria-hidden": "true"
        }, null)]
      });
    };
  }
});
export { IconSvg };
//# sourceMappingURL=icon-svg.mjs.map
