var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { defineComponent, computed, toRef, createVNode } from "vue";
import "./styles/icon.scss";
import { flattenFragments, convertToUnit } from "../../utils/dist/index.mjs";
import { makeSizeProps, useSize } from "../../composables/size/index.mjs";
import { makeIconProps } from "../../composables/icon/make-icon-props.mjs";
import { useIcon } from "../../composables/icon/use-icon.mjs";
import { useTextColor } from "../../composables/color/index.mjs";
const Icon = defineComponent({
  name: "VeIcon",
  props: __spreadValues(__spreadValues({
    color: String,
    start: Boolean,
    end: Boolean
  }, makeSizeProps()), makeIconProps()),
  setup(props, {
    slots
  }) {
    const {
      iconData
    } = useIcon(computed(() => {
      var _a, _b;
      if (!slots.default)
        return props;
      const slot = (_a = slots.default) == null ? void 0 : _a.call(slots);
      if (!slot)
        return props;
      const nodes = flattenFragments(slot);
      if (typeof ((_b = nodes == null ? void 0 : nodes[0]) == null ? void 0 : _b.children) === "string") {
        return {
          tag: props.tag,
          icon: nodes[0].children
        };
      }
      return {
        tag: props.tag,
        icon: () => slot
      };
    }));
    const {
      sizeClasses
    } = useSize(props);
    const {
      textColorClasses,
      textColorStyles
    } = useTextColor(toRef(props, "color"));
    return () => {
      if (!iconData.value)
        return;
      return createVNode(iconData.value.component, {
        "tag": props.tag,
        "icon": iconData.value.icon,
        "class": ["ve-icon", "notranslate", sizeClasses.value, textColorClasses.value, {
          "ve-icon--start": props.start,
          "ve-icon--end": props.end
        }],
        "style": [!sizeClasses.value ? {
          fontSize: convertToUnit(props.size),
          width: convertToUnit(props.size),
          height: convertToUnit(props.size)
        } : void 0, textColorStyles.value],
        "aria-hidden": "true"
      }, null);
    };
  }
});
export { Icon };
//# sourceMappingURL=icon.mjs.map
