import type { ValidationRule } from '../../composables/validation';
import type { Size } from '../../composables/size';
import type { ComponentInternalInstance, ExtractPropTypes, VNodeChild, VNode, RendererNode, RendererElement, VNodeProps, AllowedComponentProps, ComponentCustomProps, Slot, ComponentPublicInstance, ComponentOptionsBase, Ref, ComputedRef, ComponentOptionsMixin, DebuggerEvent, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties, nextTick } from 'vue';
import type { PropType } from 'vue';
import type { FormControlSlot, FormControlSlots } from '../form-control/form-control';
import type { InputControlSlot, InputControlDefaultSlot,  InputControlSlots } from '../input-control/input-control';
import type { CounterSlot } from '../counter/counter';
import type { MakeSlots } from '../../utils';
export declare type InputSlots = FormControlSlots & InputControlSlots & MakeSlots<{
    counter: [CounterSlot];
    default: [InputControlDefaultSlot];
}>;
export declare const makeInputProps: <Defaults extends {
    shape?: unknown;
    color?: unknown;
    textColor?: unknown;
    variant?: unknown;
    appendInnerIcon?: unknown;
    clearable?: unknown;
    clearIcon?: unknown;
    disabled?: unknown;
    prependInnerIcon?: unknown;
    prefix?: unknown;
    prefixIcon?: unknown;
    suffix?: unknown;
    suffixIcon?: unknown;
    autofocus?: unknown;
    autoResize?: unknown;
    counter?: unknown;
    counterValue?: unknown;
    id?: unknown;
    inputAttach?: unknown;
    maxRows?: unknown;
    modelValue?: unknown;
    name?: unknown;
    noResize?: unknown;
    persistentCounter?: unknown;
    placeholder?: unknown;
    rows?: unknown;
    type?: unknown;
    width?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    shape: unknown extends Defaults["shape"] ? Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    } : Omit<Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["shape"] ? "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" : "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" | Defaults["shape"]>;
        default: unknown extends Defaults["shape"] ? "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" : "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle" | Defaults["shape"];
    };
    color: unknown extends Defaults["color"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["color"] ? string : string | Defaults["color"]>;
        default: unknown extends Defaults["color"] ? string : string | Defaults["color"];
    };
    textColor: unknown extends Defaults["textColor"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"]>;
        default: unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"];
    };
    variant: unknown extends Defaults["variant"] ? Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    } : Omit<Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"]>;
        default: unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"];
    };
    appendInnerIcon: unknown extends Defaults["appendInnerIcon"] ? (StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["appendInnerIcon"] ? unknown : unknown>;
        default: unknown extends Defaults["appendInnerIcon"] ? unknown : unknown;
    };
    clearable: unknown extends Defaults["clearable"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["clearable"] ? boolean : boolean | Defaults["clearable"]>;
        default: unknown extends Defaults["clearable"] ? boolean : boolean | Defaults["clearable"];
    };
    clearIcon: unknown extends Defaults["clearIcon"] ? {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    } : Omit<{
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["clearIcon"] ? string : string | Defaults["clearIcon"]>;
        default: unknown extends Defaults["clearIcon"] ? string : string | Defaults["clearIcon"];
    };
    disabled: unknown extends Defaults["disabled"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["disabled"] ? boolean : boolean | Defaults["disabled"]>;
        default: unknown extends Defaults["disabled"] ? boolean : boolean | Defaults["disabled"];
    };
    prependInnerIcon: unknown extends Defaults["prependInnerIcon"] ? (StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["prependInnerIcon"] ? unknown : unknown>;
        default: unknown extends Defaults["prependInnerIcon"] ? unknown : unknown;
    };
    prefix: unknown extends Defaults["prefix"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["prefix"] ? string : string | Defaults["prefix"]>;
        default: unknown extends Defaults["prefix"] ? string : string | Defaults["prefix"];
    };
    prefixIcon: unknown extends Defaults["prefixIcon"] ? (StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["prefixIcon"] ? unknown : unknown>;
        default: unknown extends Defaults["prefixIcon"] ? unknown : unknown;
    };
    suffix: unknown extends Defaults["suffix"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["suffix"] ? string : string | Defaults["suffix"]>;
        default: unknown extends Defaults["suffix"] ? string : string | Defaults["suffix"];
    };
    suffixIcon: unknown extends Defaults["suffixIcon"] ? (StringConstructor | ObjectConstructor)[] : {
        type: PropType<unknown extends Defaults["suffixIcon"] ? unknown : unknown>;
        default: unknown extends Defaults["suffixIcon"] ? unknown : unknown;
    };
    autofocus: unknown extends Defaults["autofocus"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["autofocus"] ? boolean : boolean | Defaults["autofocus"]>;
        default: unknown extends Defaults["autofocus"] ? boolean : boolean | Defaults["autofocus"];
    };
    autoResize: unknown extends Defaults["autoResize"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["autoResize"] ? boolean : boolean | Defaults["autoResize"]>;
        default: unknown extends Defaults["autoResize"] ? boolean : boolean | Defaults["autoResize"];
    };
    counter: unknown extends Defaults["counter"] ? PropType<string | number | true> : {
        type: PropType<unknown extends Defaults["counter"] ? string | number | true | ((string | number | true) & {}) : string | number | true | ((string | number | true) & {}) | Defaults["counter"]>;
        default: unknown extends Defaults["counter"] ? string | number | true | ((string | number | true) & {}) : string | number | true | ((string | number | true) & {}) | Defaults["counter"];
    };
    counterValue: unknown extends Defaults["counterValue"] ? PropType<(value: any) => number> : {
        type: PropType<unknown extends Defaults["counterValue"] ? (value: any) => number : ((value: any) => number) | Defaults["counterValue"]>;
        default: unknown extends Defaults["counterValue"] ? (value: any) => number : ((value: any) => number) | Defaults["counterValue"];
    };
    id: unknown extends Defaults["id"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["id"] ? string : string | Defaults["id"]>;
        default: unknown extends Defaults["id"] ? string : string | Defaults["id"];
    };
    inputAttach: unknown extends Defaults["inputAttach"] ? PropType<string | boolean | Element> : {
        type: PropType<unknown extends Defaults["inputAttach"] ? string | boolean | ((string | boolean | Element) & {}) : string | boolean | ((string | boolean | Element) & {}) | Defaults["inputAttach"]>;
        default: unknown extends Defaults["inputAttach"] ? string | boolean | ((string | boolean | Element) & {}) : string | boolean | ((string | boolean | Element) & {}) | Defaults["inputAttach"];
    };
    maxRows: unknown extends Defaults["maxRows"] ? {
        type: (StringConstructor | NumberConstructor)[];
        validator: (v: any) => boolean;
    } : Omit<{
        type: (StringConstructor | NumberConstructor)[];
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["maxRows"] ? string | number : string | number | Defaults["maxRows"]>;
        default: unknown extends Defaults["maxRows"] ? string | number : string | number | Defaults["maxRows"];
    };
    modelValue: unknown extends Defaults["modelValue"] ? null : {
        type: PropType<unknown extends Defaults["modelValue"] ? any : any>;
        default: unknown extends Defaults["modelValue"] ? any : any;
    };
    name: unknown extends Defaults["name"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["name"] ? string : string | Defaults["name"]>;
        default: unknown extends Defaults["name"] ? string : string | Defaults["name"];
    };
    noResize: unknown extends Defaults["noResize"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["noResize"] ? boolean : boolean | Defaults["noResize"]>;
        default: unknown extends Defaults["noResize"] ? boolean : boolean | Defaults["noResize"];
    };
    persistentCounter: unknown extends Defaults["persistentCounter"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["persistentCounter"] ? boolean : boolean | Defaults["persistentCounter"]>;
        default: unknown extends Defaults["persistentCounter"] ? boolean : boolean | Defaults["persistentCounter"];
    };
    placeholder: unknown extends Defaults["placeholder"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["placeholder"] ? string : string | Defaults["placeholder"]>;
        default: unknown extends Defaults["placeholder"] ? string : string | Defaults["placeholder"];
    };
    rows: unknown extends Defaults["rows"] ? {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (v: any) => boolean;
    } : Omit<{
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["rows"] ? string | number : string | number | Defaults["rows"]>;
        default: unknown extends Defaults["rows"] ? string | number : string | number | Defaults["rows"];
    };
    type: unknown extends Defaults["type"] ? {
        type: StringConstructor;
        default: string;
    } : Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["type"] ? string : string | Defaults["type"]>;
        default: unknown extends Defaults["type"] ? string : string | Defaults["type"];
    };
    width: unknown extends Defaults["width"] ? (StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["width"] ? string | number : string | number | Defaults["width"]>;
        default: unknown extends Defaults["width"] ? string | number : string | number | Defaults["width"];
    };
};
export declare const InputEmits: {
    'update:modelValue': (_: string) => boolean;
    /**
     * @zh 输入框 name
     */
    'click:clear': (_event: MouseEvent) => boolean;
    /**
     * @zh textarea 独有不允许重置大小
     */
    'click:prepend-inner': (_event: MouseEvent) => boolean;
    'click:prefix': (_event: MouseEvent) => boolean;
    'click:suffix': (_event: MouseEvent) => boolean;
    'click:append-inner': (_event: MouseEvent) => boolean;
    'click:control': (_event: MouseEvent) => boolean;
    'update:active': (_active: boolean) => boolean;
    'click:prepend': (_event: MouseEvent) => boolean;
    'click:label': (_event: MouseEvent) => boolean;
    'click:append': (_event: MouseEvent) => boolean;
};
export declare const Input: {
    new (...args: any[]): {
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            type: string;
            disabled: boolean;
            variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            autofocus: boolean;
            autoResize: boolean;
            noResize: boolean;
            persistentCounter: boolean;
            rows: string | number;
            clearable: boolean;
            clearIcon: string | Record<string, any>;
        }> & Omit<Readonly<ExtractPropTypes<{
            shape: Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            appendInnerIcon: (StringConstructor | ObjectConstructor)[];
            clearable: BooleanConstructor;
            clearIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            disabled: BooleanConstructor;
            prependInnerIcon: (StringConstructor | ObjectConstructor)[];
            prefix: StringConstructor;
            prefixIcon: (StringConstructor | ObjectConstructor)[];
            suffix: StringConstructor;
            suffixIcon: (StringConstructor | ObjectConstructor)[];
            autofocus: BooleanConstructor;
            autoResize: BooleanConstructor;
            counter: PropType<string | number | true>;
            counterValue: PropType<(value: any) => number>;
            id: StringConstructor;
            inputAttach: PropType<string | boolean | Element>;
            maxRows: {
                type: (StringConstructor | NumberConstructor)[];
                validator: (v: any) => boolean;
            };
            modelValue: null;
            name: StringConstructor;
            noResize: BooleanConstructor;
            persistentCounter: BooleanConstructor;
            placeholder: StringConstructor;
            rows: {
                type: (StringConstructor | NumberConstructor)[];
                default: number;
                validator: (v: any) => boolean;
            };
            type: {
                type: StringConstructor;
                default: string;
            };
            width: (StringConstructor | NumberConstructor)[];
        } & {
            $children: () => VNodeChild | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[])) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]));
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[])) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_: string) => any) | undefined;
            "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:active"?: ((_active: boolean) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "type" | "disabled" | "variant" | "shape" | "autofocus" | "autoResize" | "noResize" | "persistentCounter" | "rows" | "clearable" | "clearIcon">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: ((event: "update:modelValue", _: string) => void) & ((event: "click:prepend", _event: MouseEvent) => void) & ((event: "click:label", _event: MouseEvent) => void) & ((event: "click:append", _event: MouseEvent) => void) & ((event: "click:clear", _event: MouseEvent) => void) & ((event: "click:prepend-inner", _event: MouseEvent) => void) & ((event: "click:prefix", _event: MouseEvent) => void) & ((event: "click:suffix", _event: MouseEvent) => void) & ((event: "click:append-inner", _event: MouseEvent) => void) & ((event: "click:control", _event: MouseEvent) => void) & ((event: "update:active", _active: boolean) => void);
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            shape: Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            appendInnerIcon: (StringConstructor | ObjectConstructor)[];
            clearable: BooleanConstructor;
            clearIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            disabled: BooleanConstructor;
            prependInnerIcon: (StringConstructor | ObjectConstructor)[];
            prefix: StringConstructor;
            prefixIcon: (StringConstructor | ObjectConstructor)[];
            suffix: StringConstructor;
            suffixIcon: (StringConstructor | ObjectConstructor)[];
            autofocus: BooleanConstructor;
            autoResize: BooleanConstructor;
            counter: PropType<string | number | true>;
            counterValue: PropType<(value: any) => number>;
            id: StringConstructor;
            inputAttach: PropType<string | boolean | Element>;
            maxRows: {
                type: (StringConstructor | NumberConstructor)[];
                validator: (v: any) => boolean;
            };
            modelValue: null;
            name: StringConstructor;
            noResize: BooleanConstructor;
            persistentCounter: BooleanConstructor;
            placeholder: StringConstructor;
            rows: {
                type: (StringConstructor | NumberConstructor)[];
                default: number;
                validator: (v: any) => boolean;
            };
            type: {
                type: StringConstructor;
                default: string;
            };
            width: (StringConstructor | NumberConstructor)[];
        } & {
            $children: () => VNodeChild | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[])) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]));
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[])) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_: string) => any) | undefined;
            "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:active"?: ((_active: boolean) => any) | undefined;
        }, {
            formControlRef: Ref<({
                $: ComponentInternalInstance;
                $data: {};
                $props: Partial<{
                    error: boolean;
                    disabled: boolean;
                    size: Size | undefined;
                    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
                    inline: boolean;
                    readonly: boolean;
                    direction: "vertical" | "horizontal";
                    errorMessages: string | string[];
                    focused: boolean;
                    persistentHint: boolean;
                    messages: string | unknown[];
                    maxErrors: string | number;
                    rules: ValidationRule[];
                }> & Omit<Readonly<ExtractPropTypes<{
                    disabled: BooleanConstructor;
                    error: BooleanConstructor;
                    errorMessages: {
                        type: PropType<string | string[]>;
                        default: () => never[];
                    };
                    maxErrors: {
                        type: (StringConstructor | NumberConstructor)[];
                        default: number;
                    };
                    readonly: BooleanConstructor;
                    rules: {
                        type: PropType<ValidationRule[]>;
                        default: () => never[];
                    };
                    modelValue: null;
                    density: {
                        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                        default: string;
                        validator: (v: any) => boolean;
                    };
                    size: {
                        type: PropType<Size | undefined>;
                        default: string;
                    };
                    height: (StringConstructor | NumberConstructor)[];
                    maxHeight: (StringConstructor | NumberConstructor)[];
                    maxWidth: (StringConstructor | NumberConstructor)[];
                    minHeight: (StringConstructor | NumberConstructor)[];
                    minWidth: (StringConstructor | NumberConstructor)[];
                    width: (StringConstructor | NumberConstructor)[];
                    appendIcon: (StringConstructor | ObjectConstructor)[];
                    direction: {
                        type: PropType<"vertical" | "horizontal">;
                        default: string;
                        validator: (v: any) => boolean;
                    };
                    focused: BooleanConstructor;
                    hideDetails: PropType<boolean | "auto">;
                    hint: StringConstructor;
                    inline: BooleanConstructor;
                    label: (BooleanConstructor | StringConstructor)[];
                    labelId: StringConstructor;
                    labelWidth: (StringConstructor | NumberConstructor)[];
                    messages: {
                        type: (StringConstructor | ArrayConstructor)[];
                        default: () => never[];
                    };
                    name: StringConstructor;
                    prependIcon: StringConstructor;
                    persistentHint: BooleanConstructor;
                } & {
                    $children: () => VNodeChild | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | {
                        prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        default?: VNodeChild | ((args_0: FormControlSlot & {
                            props: Record<string, unknown>;
                        }) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                    };
                    'v-slots': new () => {
                        prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        default?: false | ((args_0: FormControlSlot & {
                            props: Record<string, unknown>;
                        }) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                    };
                }>> & {
                    "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                    "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
                } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "error" | "disabled" | "size" | "density" | "inline" | "readonly" | "direction" | "errorMessages" | "focused" | "persistentHint" | "messages" | "maxErrors" | "rules">;
                $attrs: {
                    [x: string]: unknown;
                };
                $refs: {
                    [x: string]: unknown;
                };
                $slots: Readonly<{
                    [name: string]: Slot | undefined;
                }>;
                $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
                $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
                $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:prepend", _event: MouseEvent) => void) & ((event: "click:label", _event: MouseEvent) => void) & ((event: "click:append", _event: MouseEvent) => void);
                $el: any;
                $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
                    disabled: BooleanConstructor;
                    error: BooleanConstructor;
                    errorMessages: {
                        type: PropType<string | string[]>;
                        default: () => never[];
                    };
                    maxErrors: {
                        type: (StringConstructor | NumberConstructor)[];
                        default: number;
                    };
                    readonly: BooleanConstructor;
                    rules: {
                        type: PropType<ValidationRule[]>;
                        default: () => never[];
                    };
                    modelValue: null;
                    density: {
                        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                        default: string;
                        validator: (v: any) => boolean;
                    };
                    size: {
                        type: PropType<Size | undefined>;
                        default: string;
                    };
                    height: (StringConstructor | NumberConstructor)[];
                    maxHeight: (StringConstructor | NumberConstructor)[];
                    maxWidth: (StringConstructor | NumberConstructor)[];
                    minHeight: (StringConstructor | NumberConstructor)[];
                    minWidth: (StringConstructor | NumberConstructor)[];
                    width: (StringConstructor | NumberConstructor)[];
                    appendIcon: (StringConstructor | ObjectConstructor)[];
                    direction: {
                        type: PropType<"vertical" | "horizontal">;
                        default: string;
                        validator: (v: any) => boolean;
                    };
                    focused: BooleanConstructor;
                    hideDetails: PropType<boolean | "auto">;
                    hint: StringConstructor;
                    inline: BooleanConstructor;
                    label: (BooleanConstructor | StringConstructor)[];
                    labelId: StringConstructor;
                    labelWidth: (StringConstructor | NumberConstructor)[];
                    messages: {
                        type: (StringConstructor | ArrayConstructor)[];
                        default: () => never[];
                    };
                    name: StringConstructor;
                    prependIcon: StringConstructor;
                    persistentHint: BooleanConstructor;
                } & {
                    $children: () => VNodeChild | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | {
                        prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        default?: VNodeChild | ((args_0: FormControlSlot & {
                            props: Record<string, unknown>;
                        }) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                    };
                    'v-slots': new () => {
                        prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        default?: false | ((args_0: FormControlSlot & {
                            props: Record<string, unknown>;
                        }) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                    };
                }>> & {
                    "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                    "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
                }, {
                    isDisabled: ComputedRef<boolean>;
                    isReadonly: ComputedRef<boolean>;
                    isPristine: Ref<boolean>;
                    isValid: ComputedRef<boolean | null>;
                    isValidating: Ref<boolean>;
                    reset: () => void;
                    resetValidation: () => void;
                    validate: () => Promise<string[]>;
                }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
                    'click:prepend': (_event: MouseEvent) => boolean;
                    'click:label': (_event: MouseEvent) => boolean;
                    'click:append': (_event: MouseEvent) => boolean;
                    'update:modelValue': (_modelValue: any) => boolean;
                }, string, {
                    error: boolean;
                    disabled: boolean;
                    size: Size | undefined;
                    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
                    inline: boolean;
                    readonly: boolean;
                    direction: "vertical" | "horizontal";
                    errorMessages: string | string[];
                    focused: boolean;
                    persistentHint: boolean;
                    messages: string | unknown[];
                    maxErrors: string | number;
                    rules: ValidationRule[];
                }> & {
                    beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                    created?: ((() => void) | (() => void)[]) | undefined;
                    beforeMount?: ((() => void) | (() => void)[]) | undefined;
                    mounted?: ((() => void) | (() => void)[]) | undefined;
                    beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                    updated?: ((() => void) | (() => void)[]) | undefined;
                    activated?: ((() => void) | (() => void)[]) | undefined;
                    deactivated?: ((() => void) | (() => void)[]) | undefined;
                    beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                    beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                    destroyed?: ((() => void) | (() => void)[]) | undefined;
                    unmounted?: ((() => void) | (() => void)[]) | undefined;
                    renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                    renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                    errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
                };
                $forceUpdate: () => void;
                $nextTick: typeof nextTick;
                $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
            } & Readonly<ExtractPropTypes<{
                disabled: BooleanConstructor;
                error: BooleanConstructor;
                errorMessages: {
                    type: PropType<string | string[]>;
                    default: () => never[];
                };
                maxErrors: {
                    type: (StringConstructor | NumberConstructor)[];
                    default: number;
                };
                readonly: BooleanConstructor;
                rules: {
                    type: PropType<ValidationRule[]>;
                    default: () => never[];
                };
                modelValue: null;
                density: {
                    type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                    default: string;
                    validator: (v: any) => boolean;
                };
                size: {
                    type: PropType<Size | undefined>;
                    default: string;
                };
                height: (StringConstructor | NumberConstructor)[];
                maxHeight: (StringConstructor | NumberConstructor)[];
                maxWidth: (StringConstructor | NumberConstructor)[];
                minHeight: (StringConstructor | NumberConstructor)[];
                minWidth: (StringConstructor | NumberConstructor)[];
                width: (StringConstructor | NumberConstructor)[];
                appendIcon: (StringConstructor | ObjectConstructor)[];
                direction: {
                    type: PropType<"vertical" | "horizontal">;
                    default: string;
                    validator: (v: any) => boolean;
                };
                focused: BooleanConstructor;
                hideDetails: PropType<boolean | "auto">;
                hint: StringConstructor;
                inline: BooleanConstructor;
                label: (BooleanConstructor | StringConstructor)[];
                labelId: StringConstructor;
                labelWidth: (StringConstructor | NumberConstructor)[];
                messages: {
                    type: (StringConstructor | ArrayConstructor)[];
                    default: () => never[];
                };
                name: StringConstructor;
                prependIcon: StringConstructor;
                persistentHint: BooleanConstructor;
            } & {
                $children: () => VNodeChild | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | {
                    prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    default?: VNodeChild | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                };
                'v-slots': new () => {
                    prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    default?: false | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                };
            }>> & {
                "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
            } & ShallowUnwrapRef<{
                isDisabled: ComputedRef<boolean>;
                isReadonly: ComputedRef<boolean>;
                isPristine: Ref<boolean>;
                isValid: ComputedRef<boolean | null>;
                isValidating: Ref<boolean>;
                reset: () => void;
                resetValidation: () => void;
                validate: () => Promise<string[]>;
            }> & {} & {} & ComponentCustomProperties & {
                $slots: MakeSlots<{
                    prepend: [FormControlSlot];
                    label: [FormControlSlot];
                    default: [FormControlSlot & {
                        props: Record<string, unknown>;
                    }];
                    append: [FormControlSlot];
                    details: [FormControlSlot];
                }>;
            }) | undefined>;
            inputControlRef: Ref<({
                $: ComponentInternalInstance;
                $data: {};
                $props: Partial<{
                    disabled: boolean;
                    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                    active: boolean;
                    clearable: boolean;
                    clearIcon: string | Record<string, any>;
                    dirty: boolean;
                }> & Omit<Readonly<ExtractPropTypes<{
                    shape: Omit<{
                        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                        default: string;
                    }, "default" | "type"> & {
                        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                    };
                    color: StringConstructor;
                    textColor: StringConstructor;
                    variant: Omit<{
                        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                        default: string;
                        validator: (v: any) => boolean;
                    }, "default" | "type"> & {
                        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                    };
                    appendInnerIcon: (StringConstructor | ObjectConstructor)[];
                    clearable: BooleanConstructor;
                    clearIcon: {
                        type: (StringConstructor | ObjectConstructor)[];
                        default: string;
                    };
                    disabled: BooleanConstructor;
                    prependInnerIcon: (StringConstructor | ObjectConstructor)[];
                    prefix: StringConstructor;
                    prefixIcon: (StringConstructor | ObjectConstructor)[];
                    suffix: StringConstructor;
                    suffixIcon: (StringConstructor | ObjectConstructor)[];
                    active: BooleanConstructor;
                    dirty: BooleanConstructor;
                } & {
                    $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | {
                        'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                    };
                    'v-slots': new () => {
                        'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                    };
                }>> & {
                    "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                    "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
                    "onUpdate:active"?: ((_active: boolean) => any) | undefined;
                } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "disabled" | "variant" | "shape" | "active" | "clearable" | "clearIcon" | "dirty">;
                $attrs: {
                    [x: string]: unknown;
                };
                $refs: {
                    [x: string]: unknown;
                };
                $slots: Readonly<{
                    [name: string]: Slot | undefined;
                }>;
                $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
                $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
                $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:clear", _event: MouseEvent) => void) & ((event: "click:prepend-inner", _event: MouseEvent) => void) & ((event: "click:prefix", _event: MouseEvent) => void) & ((event: "click:suffix", _event: MouseEvent) => void) & ((event: "click:append-inner", _event: MouseEvent) => void) & ((event: "click:control", _event: MouseEvent) => void) & ((event: "update:active", _active: boolean) => void);
                $el: any;
                $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
                    shape: Omit<{
                        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                        default: string;
                    }, "default" | "type"> & {
                        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                    };
                    color: StringConstructor;
                    textColor: StringConstructor;
                    variant: Omit<{
                        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                        default: string;
                        validator: (v: any) => boolean;
                    }, "default" | "type"> & {
                        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                    };
                    appendInnerIcon: (StringConstructor | ObjectConstructor)[];
                    clearable: BooleanConstructor;
                    clearIcon: {
                        type: (StringConstructor | ObjectConstructor)[];
                        default: string;
                    };
                    disabled: BooleanConstructor;
                    prependInnerIcon: (StringConstructor | ObjectConstructor)[];
                    prefix: StringConstructor;
                    prefixIcon: (StringConstructor | ObjectConstructor)[];
                    suffix: StringConstructor;
                    suffixIcon: (StringConstructor | ObjectConstructor)[];
                    active: BooleanConstructor;
                    dirty: BooleanConstructor;
                } & {
                    $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | {
                        'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                        clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]);
                    };
                    'v-slots': new () => {
                        'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                        clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }> | VNode<RendererNode, RendererElement, {
                            [key: string]: any;
                        }>[]) | undefined;
                    };
                }>> & {
                    "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                    "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
                    "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
                    "onUpdate:active"?: ((_active: boolean) => any) | undefined;
                }, {
                    inputRef: Ref<HTMLInputElement | undefined>;
                    controlRef: Ref<HTMLElement | undefined>;
                }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
                    /**
                     * @zh 输入框 name
                     */
                    'click:clear': (_event: MouseEvent) => boolean;
                    /**
                     * @zh textarea 独有不允许重置大小
                     */
                    'click:prepend-inner': (_event: MouseEvent) => boolean;
                    'click:prefix': (_event: MouseEvent) => boolean;
                    'click:suffix': (_event: MouseEvent) => boolean;
                    'click:append-inner': (_event: MouseEvent) => boolean;
                    'click:control': (_event: MouseEvent) => boolean;
                    'update:active': (_active: boolean) => boolean;
                    'update:modelValue': (_modelValue: any) => boolean;
                }, string, {
                    disabled: boolean;
                    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                    active: boolean;
                    clearable: boolean;
                    clearIcon: string | Record<string, any>;
                    dirty: boolean;
                }> & {
                    beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                    created?: ((() => void) | (() => void)[]) | undefined;
                    beforeMount?: ((() => void) | (() => void)[]) | undefined;
                    mounted?: ((() => void) | (() => void)[]) | undefined;
                    beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                    updated?: ((() => void) | (() => void)[]) | undefined;
                    activated?: ((() => void) | (() => void)[]) | undefined;
                    deactivated?: ((() => void) | (() => void)[]) | undefined;
                    beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                    beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                    destroyed?: ((() => void) | (() => void)[]) | undefined;
                    unmounted?: ((() => void) | (() => void)[]) | undefined;
                    renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                    renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                    errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
                };
                $forceUpdate: () => void;
                $nextTick: typeof nextTick;
                $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
            } & Readonly<ExtractPropTypes<{
                shape: Omit<{
                    type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                    default: string;
                }, "default" | "type"> & {
                    type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                    default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                };
                color: StringConstructor;
                textColor: StringConstructor;
                variant: Omit<{
                    type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                    default: string;
                    validator: (v: any) => boolean;
                }, "default" | "type"> & {
                    type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                    default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                };
                appendInnerIcon: (StringConstructor | ObjectConstructor)[];
                clearable: BooleanConstructor;
                clearIcon: {
                    type: (StringConstructor | ObjectConstructor)[];
                    default: string;
                };
                disabled: BooleanConstructor;
                prependInnerIcon: (StringConstructor | ObjectConstructor)[];
                prefix: StringConstructor;
                prefixIcon: (StringConstructor | ObjectConstructor)[];
                suffix: StringConstructor;
                suffixIcon: (StringConstructor | ObjectConstructor)[];
                active: BooleanConstructor;
                dirty: BooleanConstructor;
            } & {
                $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | {
                    'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                };
                'v-slots': new () => {
                    'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                };
            }>> & {
                "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
                "onUpdate:active"?: ((_active: boolean) => any) | undefined;
            } & ShallowUnwrapRef<{
                inputRef: Ref<HTMLInputElement | undefined>;
                controlRef: Ref<HTMLElement | undefined>;
            }> & {} & {} & ComponentCustomProperties & {
                $slots: MakeSlots<{
                    'prepend-inner': [InputControlSlot];
                    prefix: [InputControlSlot];
                    default: [InputControlDefaultSlot];
                    suffix: [InputControlSlot];
                    'append-inner': [InputControlSlot];
                    clear: [InputControlSlot];
                }>;
            }) | undefined>;
            blur: () => void;
            focus: () => void;
        }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            'update:modelValue': (_: string) => boolean;
            /**
             * @zh 输入框 name
             */
            'click:clear': (_event: MouseEvent) => boolean;
            /**
             * @zh textarea 独有不允许重置大小
             */
            'click:prepend-inner': (_event: MouseEvent) => boolean;
            'click:prefix': (_event: MouseEvent) => boolean;
            'click:suffix': (_event: MouseEvent) => boolean;
            'click:append-inner': (_event: MouseEvent) => boolean;
            'click:control': (_event: MouseEvent) => boolean;
            'update:active': (_active: boolean) => boolean;
            'click:prepend': (_event: MouseEvent) => boolean;
            'click:label': (_event: MouseEvent) => boolean;
            'click:append': (_event: MouseEvent) => boolean;
        }, string, {
            type: string;
            disabled: boolean;
            variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            autofocus: boolean;
            autoResize: boolean;
            noResize: boolean;
            persistentCounter: boolean;
            rows: string | number;
            clearable: boolean;
            clearIcon: string | Record<string, any>;
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        shape: Omit<{
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: string;
        }, "default" | "type"> & {
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
        };
        color: StringConstructor;
        textColor: StringConstructor;
        variant: Omit<{
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: string;
            validator: (v: any) => boolean;
        }, "default" | "type"> & {
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
        };
        appendInnerIcon: (StringConstructor | ObjectConstructor)[];
        clearable: BooleanConstructor;
        clearIcon: {
            type: (StringConstructor | ObjectConstructor)[];
            default: string;
        };
        disabled: BooleanConstructor;
        prependInnerIcon: (StringConstructor | ObjectConstructor)[];
        prefix: StringConstructor;
        prefixIcon: (StringConstructor | ObjectConstructor)[];
        suffix: StringConstructor;
        suffixIcon: (StringConstructor | ObjectConstructor)[];
        autofocus: BooleanConstructor;
        autoResize: BooleanConstructor;
        counter: PropType<string | number | true>;
        counterValue: PropType<(value: any) => number>;
        id: StringConstructor;
        inputAttach: PropType<string | boolean | Element>;
        maxRows: {
            type: (StringConstructor | NumberConstructor)[];
            validator: (v: any) => boolean;
        };
        modelValue: null;
        name: StringConstructor;
        noResize: BooleanConstructor;
        persistentCounter: BooleanConstructor;
        placeholder: StringConstructor;
        rows: {
            type: (StringConstructor | NumberConstructor)[];
            default: number;
            validator: (v: any) => boolean;
        };
        type: {
            type: StringConstructor;
            default: string;
        };
        width: (StringConstructor | NumberConstructor)[];
    } & {
        $children: () => VNodeChild | (((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[])) | {
            prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            default?: VNodeChild | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]));
            append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
        };
        'v-slots': new () => {
            prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            default?: false | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[])) | undefined;
            append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_: string) => any) | undefined;
        "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
        "onUpdate:active"?: ((_active: boolean) => any) | undefined;
    } & ShallowUnwrapRef<{
        formControlRef: Ref<({
            $: ComponentInternalInstance;
            $data: {};
            $props: Partial<{
                error: boolean;
                disabled: boolean;
                size: Size | undefined;
                density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
                inline: boolean;
                readonly: boolean;
                direction: "vertical" | "horizontal";
                errorMessages: string | string[];
                focused: boolean;
                persistentHint: boolean;
                messages: string | unknown[];
                maxErrors: string | number;
                rules: ValidationRule[];
            }> & Omit<Readonly<ExtractPropTypes<{
                disabled: BooleanConstructor;
                error: BooleanConstructor;
                errorMessages: {
                    type: PropType<string | string[]>;
                    default: () => never[];
                };
                maxErrors: {
                    type: (StringConstructor | NumberConstructor)[];
                    default: number;
                };
                readonly: BooleanConstructor;
                rules: {
                    type: PropType<ValidationRule[]>;
                    default: () => never[];
                };
                modelValue: null;
                density: {
                    type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                    default: string;
                    validator: (v: any) => boolean;
                };
                size: {
                    type: PropType<Size | undefined>;
                    default: string;
                };
                height: (StringConstructor | NumberConstructor)[];
                maxHeight: (StringConstructor | NumberConstructor)[];
                maxWidth: (StringConstructor | NumberConstructor)[];
                minHeight: (StringConstructor | NumberConstructor)[];
                minWidth: (StringConstructor | NumberConstructor)[];
                width: (StringConstructor | NumberConstructor)[];
                appendIcon: (StringConstructor | ObjectConstructor)[];
                direction: {
                    type: PropType<"vertical" | "horizontal">;
                    default: string;
                    validator: (v: any) => boolean;
                };
                focused: BooleanConstructor;
                hideDetails: PropType<boolean | "auto">;
                hint: StringConstructor;
                inline: BooleanConstructor;
                label: (BooleanConstructor | StringConstructor)[];
                labelId: StringConstructor;
                labelWidth: (StringConstructor | NumberConstructor)[];
                messages: {
                    type: (StringConstructor | ArrayConstructor)[];
                    default: () => never[];
                };
                name: StringConstructor;
                prependIcon: StringConstructor;
                persistentHint: BooleanConstructor;
            } & {
                $children: () => VNodeChild | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | {
                    prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    default?: VNodeChild | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                };
                'v-slots': new () => {
                    prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    default?: false | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                };
            }>> & {
                "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
            } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "error" | "disabled" | "size" | "density" | "inline" | "readonly" | "direction" | "errorMessages" | "focused" | "persistentHint" | "messages" | "maxErrors" | "rules">;
            $attrs: {
                [x: string]: unknown;
            };
            $refs: {
                [x: string]: unknown;
            };
            $slots: Readonly<{
                [name: string]: Slot | undefined;
            }>;
            $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
            $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
            $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:prepend", _event: MouseEvent) => void) & ((event: "click:label", _event: MouseEvent) => void) & ((event: "click:append", _event: MouseEvent) => void);
            $el: any;
            $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
                disabled: BooleanConstructor;
                error: BooleanConstructor;
                errorMessages: {
                    type: PropType<string | string[]>;
                    default: () => never[];
                };
                maxErrors: {
                    type: (StringConstructor | NumberConstructor)[];
                    default: number;
                };
                readonly: BooleanConstructor;
                rules: {
                    type: PropType<ValidationRule[]>;
                    default: () => never[];
                };
                modelValue: null;
                density: {
                    type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                    default: string;
                    validator: (v: any) => boolean;
                };
                size: {
                    type: PropType<Size | undefined>;
                    default: string;
                };
                height: (StringConstructor | NumberConstructor)[];
                maxHeight: (StringConstructor | NumberConstructor)[];
                maxWidth: (StringConstructor | NumberConstructor)[];
                minHeight: (StringConstructor | NumberConstructor)[];
                minWidth: (StringConstructor | NumberConstructor)[];
                width: (StringConstructor | NumberConstructor)[];
                appendIcon: (StringConstructor | ObjectConstructor)[];
                direction: {
                    type: PropType<"vertical" | "horizontal">;
                    default: string;
                    validator: (v: any) => boolean;
                };
                focused: BooleanConstructor;
                hideDetails: PropType<boolean | "auto">;
                hint: StringConstructor;
                inline: BooleanConstructor;
                label: (BooleanConstructor | StringConstructor)[];
                labelId: StringConstructor;
                labelWidth: (StringConstructor | NumberConstructor)[];
                messages: {
                    type: (StringConstructor | ArrayConstructor)[];
                    default: () => never[];
                };
                name: StringConstructor;
                prependIcon: StringConstructor;
                persistentHint: BooleanConstructor;
            } & {
                $children: () => VNodeChild | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | {
                    prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    default?: VNodeChild | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                };
                'v-slots': new () => {
                    prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    default?: false | ((args_0: FormControlSlot & {
                        props: Record<string, unknown>;
                    }) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                };
            }>> & {
                "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
            }, {
                isDisabled: ComputedRef<boolean>;
                isReadonly: ComputedRef<boolean>;
                isPristine: Ref<boolean>;
                isValid: ComputedRef<boolean | null>;
                isValidating: Ref<boolean>;
                reset: () => void;
                resetValidation: () => void;
                validate: () => Promise<string[]>;
            }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
                'click:prepend': (_event: MouseEvent) => boolean;
                'click:label': (_event: MouseEvent) => boolean;
                'click:append': (_event: MouseEvent) => boolean;
                'update:modelValue': (_modelValue: any) => boolean;
            }, string, {
                error: boolean;
                disabled: boolean;
                size: Size | undefined;
                density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
                inline: boolean;
                readonly: boolean;
                direction: "vertical" | "horizontal";
                errorMessages: string | string[];
                focused: boolean;
                persistentHint: boolean;
                messages: string | unknown[];
                maxErrors: string | number;
                rules: ValidationRule[];
            }> & {
                beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                created?: ((() => void) | (() => void)[]) | undefined;
                beforeMount?: ((() => void) | (() => void)[]) | undefined;
                mounted?: ((() => void) | (() => void)[]) | undefined;
                beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                updated?: ((() => void) | (() => void)[]) | undefined;
                activated?: ((() => void) | (() => void)[]) | undefined;
                deactivated?: ((() => void) | (() => void)[]) | undefined;
                beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                destroyed?: ((() => void) | (() => void)[]) | undefined;
                unmounted?: ((() => void) | (() => void)[]) | undefined;
                renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
            };
            $forceUpdate: () => void;
            $nextTick: typeof nextTick;
            $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
        } & Readonly<ExtractPropTypes<{
            disabled: BooleanConstructor;
            error: BooleanConstructor;
            errorMessages: {
                type: PropType<string | string[]>;
                default: () => never[];
            };
            maxErrors: {
                type: (StringConstructor | NumberConstructor)[];
                default: number;
            };
            readonly: BooleanConstructor;
            rules: {
                type: PropType<ValidationRule[]>;
                default: () => never[];
            };
            modelValue: null;
            density: {
                type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                default: string;
                validator: (v: any) => boolean;
            };
            size: {
                type: PropType<Size | undefined>;
                default: string;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: (StringConstructor | NumberConstructor)[];
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: (StringConstructor | NumberConstructor)[];
            width: (StringConstructor | NumberConstructor)[];
            appendIcon: (StringConstructor | ObjectConstructor)[];
            direction: {
                type: PropType<"vertical" | "horizontal">;
                default: string;
                validator: (v: any) => boolean;
            };
            focused: BooleanConstructor;
            hideDetails: PropType<boolean | "auto">;
            hint: StringConstructor;
            inline: BooleanConstructor;
            label: (BooleanConstructor | StringConstructor)[];
            labelId: StringConstructor;
            labelWidth: (StringConstructor | NumberConstructor)[];
            messages: {
                type: (StringConstructor | ArrayConstructor)[];
                default: () => never[];
            };
            name: StringConstructor;
            prependIcon: StringConstructor;
            persistentHint: BooleanConstructor;
        } & {
            $children: () => VNodeChild | ((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
        } & ShallowUnwrapRef<{
            isDisabled: ComputedRef<boolean>;
            isReadonly: ComputedRef<boolean>;
            isPristine: Ref<boolean>;
            isValid: ComputedRef<boolean | null>;
            isValidating: Ref<boolean>;
            reset: () => void;
            resetValidation: () => void;
            validate: () => Promise<string[]>;
        }> & {} & {} & ComponentCustomProperties & {
            $slots: MakeSlots<{
                prepend: [FormControlSlot];
                label: [FormControlSlot];
                default: [FormControlSlot & {
                    props: Record<string, unknown>;
                }];
                append: [FormControlSlot];
                details: [FormControlSlot];
            }>;
        }) | undefined>;
        inputControlRef: Ref<({
            $: ComponentInternalInstance;
            $data: {};
            $props: Partial<{
                disabled: boolean;
                variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                active: boolean;
                clearable: boolean;
                clearIcon: string | Record<string, any>;
                dirty: boolean;
            }> & Omit<Readonly<ExtractPropTypes<{
                shape: Omit<{
                    type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                    default: string;
                }, "default" | "type"> & {
                    type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                    default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                };
                color: StringConstructor;
                textColor: StringConstructor;
                variant: Omit<{
                    type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                    default: string;
                    validator: (v: any) => boolean;
                }, "default" | "type"> & {
                    type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                    default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                };
                appendInnerIcon: (StringConstructor | ObjectConstructor)[];
                clearable: BooleanConstructor;
                clearIcon: {
                    type: (StringConstructor | ObjectConstructor)[];
                    default: string;
                };
                disabled: BooleanConstructor;
                prependInnerIcon: (StringConstructor | ObjectConstructor)[];
                prefix: StringConstructor;
                prefixIcon: (StringConstructor | ObjectConstructor)[];
                suffix: StringConstructor;
                suffixIcon: (StringConstructor | ObjectConstructor)[];
                active: BooleanConstructor;
                dirty: BooleanConstructor;
            } & {
                $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | {
                    'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                };
                'v-slots': new () => {
                    'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                };
            }>> & {
                "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
                "onUpdate:active"?: ((_active: boolean) => any) | undefined;
            } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "disabled" | "variant" | "shape" | "active" | "clearable" | "clearIcon" | "dirty">;
            $attrs: {
                [x: string]: unknown;
            };
            $refs: {
                [x: string]: unknown;
            };
            $slots: Readonly<{
                [name: string]: Slot | undefined;
            }>;
            $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
            $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
            $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:clear", _event: MouseEvent) => void) & ((event: "click:prepend-inner", _event: MouseEvent) => void) & ((event: "click:prefix", _event: MouseEvent) => void) & ((event: "click:suffix", _event: MouseEvent) => void) & ((event: "click:append-inner", _event: MouseEvent) => void) & ((event: "click:control", _event: MouseEvent) => void) & ((event: "update:active", _active: boolean) => void);
            $el: any;
            $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
                shape: Omit<{
                    type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                    default: string;
                }, "default" | "type"> & {
                    type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                    default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                };
                color: StringConstructor;
                textColor: StringConstructor;
                variant: Omit<{
                    type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                    default: string;
                    validator: (v: any) => boolean;
                }, "default" | "type"> & {
                    type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                    default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                };
                appendInnerIcon: (StringConstructor | ObjectConstructor)[];
                clearable: BooleanConstructor;
                clearIcon: {
                    type: (StringConstructor | ObjectConstructor)[];
                    default: string;
                };
                disabled: BooleanConstructor;
                prependInnerIcon: (StringConstructor | ObjectConstructor)[];
                prefix: StringConstructor;
                prefixIcon: (StringConstructor | ObjectConstructor)[];
                suffix: StringConstructor;
                suffixIcon: (StringConstructor | ObjectConstructor)[];
                active: BooleanConstructor;
                dirty: BooleanConstructor;
            } & {
                $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | {
                    'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                    clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]);
                };
                'v-slots': new () => {
                    'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                    clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }> | VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>[]) | undefined;
                };
            }>> & {
                "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
                "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
                "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
                "onUpdate:active"?: ((_active: boolean) => any) | undefined;
            }, {
                inputRef: Ref<HTMLInputElement | undefined>;
                controlRef: Ref<HTMLElement | undefined>;
            }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
                /**
                 * @zh 输入框 name
                 */
                'click:clear': (_event: MouseEvent) => boolean;
                /**
                 * @zh textarea 独有不允许重置大小
                 */
                'click:prepend-inner': (_event: MouseEvent) => boolean;
                'click:prefix': (_event: MouseEvent) => boolean;
                'click:suffix': (_event: MouseEvent) => boolean;
                'click:append-inner': (_event: MouseEvent) => boolean;
                'click:control': (_event: MouseEvent) => boolean;
                'update:active': (_active: boolean) => boolean;
                'update:modelValue': (_modelValue: any) => boolean;
            }, string, {
                disabled: boolean;
                variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
                shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
                active: boolean;
                clearable: boolean;
                clearIcon: string | Record<string, any>;
                dirty: boolean;
            }> & {
                beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                created?: ((() => void) | (() => void)[]) | undefined;
                beforeMount?: ((() => void) | (() => void)[]) | undefined;
                mounted?: ((() => void) | (() => void)[]) | undefined;
                beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                updated?: ((() => void) | (() => void)[]) | undefined;
                activated?: ((() => void) | (() => void)[]) | undefined;
                deactivated?: ((() => void) | (() => void)[]) | undefined;
                beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                destroyed?: ((() => void) | (() => void)[]) | undefined;
                unmounted?: ((() => void) | (() => void)[]) | undefined;
                renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
                errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
            };
            $forceUpdate: () => void;
            $nextTick: typeof nextTick;
            $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
        } & Readonly<ExtractPropTypes<{
            shape: Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            appendInnerIcon: (StringConstructor | ObjectConstructor)[];
            clearable: BooleanConstructor;
            clearIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            disabled: BooleanConstructor;
            prependInnerIcon: (StringConstructor | ObjectConstructor)[];
            prefix: StringConstructor;
            prefixIcon: (StringConstructor | ObjectConstructor)[];
            suffix: StringConstructor;
            suffixIcon: (StringConstructor | ObjectConstructor)[];
            active: BooleanConstructor;
            dirty: BooleanConstructor;
        } & {
            $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:active"?: ((_active: boolean) => any) | undefined;
        } & ShallowUnwrapRef<{
            inputRef: Ref<HTMLInputElement | undefined>;
            controlRef: Ref<HTMLElement | undefined>;
        }> & {} & {} & ComponentCustomProperties & {
            $slots: MakeSlots<{
                'prepend-inner': [InputControlSlot];
                prefix: [InputControlSlot];
                default: [InputControlDefaultSlot];
                suffix: [InputControlSlot];
                'append-inner': [InputControlSlot];
                clear: [InputControlSlot];
            }>;
        }) | undefined>;
        blur: () => void;
        focus: () => void;
    }> & {} & {} & ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & ComponentOptionsBase<Readonly<ExtractPropTypes<{
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    appendInnerIcon: (StringConstructor | ObjectConstructor)[];
    clearable: BooleanConstructor;
    clearIcon: {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    };
    disabled: BooleanConstructor;
    prependInnerIcon: (StringConstructor | ObjectConstructor)[];
    prefix: StringConstructor;
    prefixIcon: (StringConstructor | ObjectConstructor)[];
    suffix: StringConstructor;
    suffixIcon: (StringConstructor | ObjectConstructor)[];
    autofocus: BooleanConstructor;
    autoResize: BooleanConstructor;
    counter: PropType<string | number | true>;
    counterValue: PropType<(value: any) => number>;
    id: StringConstructor;
    inputAttach: PropType<string | boolean | Element>;
    maxRows: {
        type: (StringConstructor | NumberConstructor)[];
        validator: (v: any) => boolean;
    };
    modelValue: null;
    name: StringConstructor;
    noResize: BooleanConstructor;
    persistentCounter: BooleanConstructor;
    placeholder: StringConstructor;
    rows: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (v: any) => boolean;
    };
    type: {
        type: StringConstructor;
        default: string;
    };
    width: (StringConstructor | NumberConstructor)[];
} & {
    $children: () => VNodeChild | (((args_0: FormControlSlot & {
        props: Record<string, unknown>;
    }) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[])) | {
        prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        default?: VNodeChild | (((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]));
        append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
    };
    'v-slots': new () => {
        prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        default?: false | (((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[])) | undefined;
        append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
    };
}>> & {
    "onUpdate:modelValue"?: ((_: string) => any) | undefined;
    "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
    "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
    "onUpdate:active"?: ((_active: boolean) => any) | undefined;
}, {
    formControlRef: Ref<({
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            error: boolean;
            disabled: boolean;
            size: Size | undefined;
            density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
            inline: boolean;
            readonly: boolean;
            direction: "vertical" | "horizontal";
            errorMessages: string | string[];
            focused: boolean;
            persistentHint: boolean;
            messages: string | unknown[];
            maxErrors: string | number;
            rules: ValidationRule[];
        }> & Omit<Readonly<ExtractPropTypes<{
            disabled: BooleanConstructor;
            error: BooleanConstructor;
            errorMessages: {
                type: PropType<string | string[]>;
                default: () => never[];
            };
            maxErrors: {
                type: (StringConstructor | NumberConstructor)[];
                default: number;
            };
            readonly: BooleanConstructor;
            rules: {
                type: PropType<ValidationRule[]>;
                default: () => never[];
            };
            modelValue: null;
            density: {
                type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                default: string;
                validator: (v: any) => boolean;
            };
            size: {
                type: PropType<Size | undefined>;
                default: string;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: (StringConstructor | NumberConstructor)[];
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: (StringConstructor | NumberConstructor)[];
            width: (StringConstructor | NumberConstructor)[];
            appendIcon: (StringConstructor | ObjectConstructor)[];
            direction: {
                type: PropType<"vertical" | "horizontal">;
                default: string;
                validator: (v: any) => boolean;
            };
            focused: BooleanConstructor;
            hideDetails: PropType<boolean | "auto">;
            hint: StringConstructor;
            inline: BooleanConstructor;
            label: (BooleanConstructor | StringConstructor)[];
            labelId: StringConstructor;
            labelWidth: (StringConstructor | NumberConstructor)[];
            messages: {
                type: (StringConstructor | ArrayConstructor)[];
                default: () => never[];
            };
            name: StringConstructor;
            prependIcon: StringConstructor;
            persistentHint: BooleanConstructor;
        } & {
            $children: () => VNodeChild | ((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "error" | "disabled" | "size" | "density" | "inline" | "readonly" | "direction" | "errorMessages" | "focused" | "persistentHint" | "messages" | "maxErrors" | "rules">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:prepend", _event: MouseEvent) => void) & ((event: "click:label", _event: MouseEvent) => void) & ((event: "click:append", _event: MouseEvent) => void);
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            disabled: BooleanConstructor;
            error: BooleanConstructor;
            errorMessages: {
                type: PropType<string | string[]>;
                default: () => never[];
            };
            maxErrors: {
                type: (StringConstructor | NumberConstructor)[];
                default: number;
            };
            readonly: BooleanConstructor;
            rules: {
                type: PropType<ValidationRule[]>;
                default: () => never[];
            };
            modelValue: null;
            density: {
                type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
                default: string;
                validator: (v: any) => boolean;
            };
            size: {
                type: PropType<Size | undefined>;
                default: string;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: (StringConstructor | NumberConstructor)[];
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: (StringConstructor | NumberConstructor)[];
            width: (StringConstructor | NumberConstructor)[];
            appendIcon: (StringConstructor | ObjectConstructor)[];
            direction: {
                type: PropType<"vertical" | "horizontal">;
                default: string;
                validator: (v: any) => boolean;
            };
            focused: BooleanConstructor;
            hideDetails: PropType<boolean | "auto">;
            hint: StringConstructor;
            inline: BooleanConstructor;
            label: (BooleanConstructor | StringConstructor)[];
            labelId: StringConstructor;
            labelWidth: (StringConstructor | NumberConstructor)[];
            messages: {
                type: (StringConstructor | ArrayConstructor)[];
                default: () => never[];
            };
            name: StringConstructor;
            prependIcon: StringConstructor;
            persistentHint: BooleanConstructor;
        } & {
            $children: () => VNodeChild | ((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | ((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
        }, {
            isDisabled: ComputedRef<boolean>;
            isReadonly: ComputedRef<boolean>;
            isPristine: Ref<boolean>;
            isValid: ComputedRef<boolean | null>;
            isValidating: Ref<boolean>;
            reset: () => void;
            resetValidation: () => void;
            validate: () => Promise<string[]>;
        }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            'click:prepend': (_event: MouseEvent) => boolean;
            'click:label': (_event: MouseEvent) => boolean;
            'click:append': (_event: MouseEvent) => boolean;
            'update:modelValue': (_modelValue: any) => boolean;
        }, string, {
            error: boolean;
            disabled: boolean;
            size: Size | undefined;
            density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
            inline: boolean;
            readonly: boolean;
            direction: "vertical" | "horizontal";
            errorMessages: string | string[];
            focused: boolean;
            persistentHint: boolean;
            messages: string | unknown[];
            maxErrors: string | number;
            rules: ValidationRule[];
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        disabled: BooleanConstructor;
        error: BooleanConstructor;
        errorMessages: {
            type: PropType<string | string[]>;
            default: () => never[];
        };
        maxErrors: {
            type: (StringConstructor | NumberConstructor)[];
            default: number;
        };
        readonly: BooleanConstructor;
        rules: {
            type: PropType<ValidationRule[]>;
            default: () => never[];
        };
        modelValue: null;
        density: {
            type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
            default: string;
            validator: (v: any) => boolean;
        };
        size: {
            type: PropType<Size | undefined>;
            default: string;
        };
        height: (StringConstructor | NumberConstructor)[];
        maxHeight: (StringConstructor | NumberConstructor)[];
        maxWidth: (StringConstructor | NumberConstructor)[];
        minHeight: (StringConstructor | NumberConstructor)[];
        minWidth: (StringConstructor | NumberConstructor)[];
        width: (StringConstructor | NumberConstructor)[];
        appendIcon: (StringConstructor | ObjectConstructor)[];
        direction: {
            type: PropType<"vertical" | "horizontal">;
            default: string;
            validator: (v: any) => boolean;
        };
        focused: BooleanConstructor;
        hideDetails: PropType<boolean | "auto">;
        hint: StringConstructor;
        inline: BooleanConstructor;
        label: (BooleanConstructor | StringConstructor)[];
        labelId: StringConstructor;
        labelWidth: (StringConstructor | NumberConstructor)[];
        messages: {
            type: (StringConstructor | ArrayConstructor)[];
            default: () => never[];
        };
        name: StringConstructor;
        prependIcon: StringConstructor;
        persistentHint: BooleanConstructor;
    } & {
        $children: () => VNodeChild | ((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | {
            prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            default?: VNodeChild | ((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
        };
        'v-slots': new () => {
            prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            default?: false | ((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
        "onClick:prepend"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:label"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:append"?: ((_event: MouseEvent) => any) | undefined;
    } & ShallowUnwrapRef<{
        isDisabled: ComputedRef<boolean>;
        isReadonly: ComputedRef<boolean>;
        isPristine: Ref<boolean>;
        isValid: ComputedRef<boolean | null>;
        isValidating: Ref<boolean>;
        reset: () => void;
        resetValidation: () => void;
        validate: () => Promise<string[]>;
    }> & {} & {} & ComponentCustomProperties & {
        $slots: MakeSlots<{
            prepend: [FormControlSlot];
            label: [FormControlSlot];
            default: [FormControlSlot & {
                props: Record<string, unknown>;
            }];
            append: [FormControlSlot];
            details: [FormControlSlot];
        }>;
    }) | undefined>;
    inputControlRef: Ref<({
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            disabled: boolean;
            variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            active: boolean;
            clearable: boolean;
            clearIcon: string | Record<string, any>;
            dirty: boolean;
        }> & Omit<Readonly<ExtractPropTypes<{
            shape: Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            appendInnerIcon: (StringConstructor | ObjectConstructor)[];
            clearable: BooleanConstructor;
            clearIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            disabled: BooleanConstructor;
            prependInnerIcon: (StringConstructor | ObjectConstructor)[];
            prefix: StringConstructor;
            prefixIcon: (StringConstructor | ObjectConstructor)[];
            suffix: StringConstructor;
            suffixIcon: (StringConstructor | ObjectConstructor)[];
            active: BooleanConstructor;
            dirty: BooleanConstructor;
        } & {
            $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:active"?: ((_active: boolean) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "disabled" | "variant" | "shape" | "active" | "clearable" | "clearIcon" | "dirty">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:clear", _event: MouseEvent) => void) & ((event: "click:prepend-inner", _event: MouseEvent) => void) & ((event: "click:prefix", _event: MouseEvent) => void) & ((event: "click:suffix", _event: MouseEvent) => void) & ((event: "click:append-inner", _event: MouseEvent) => void) & ((event: "click:control", _event: MouseEvent) => void) & ((event: "update:active", _active: boolean) => void);
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            shape: Omit<{
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: string;
            }, "default" | "type"> & {
                type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
                default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            };
            color: StringConstructor;
            textColor: StringConstructor;
            variant: Omit<{
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: string;
                validator: (v: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
                default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            };
            appendInnerIcon: (StringConstructor | ObjectConstructor)[];
            clearable: BooleanConstructor;
            clearIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            disabled: BooleanConstructor;
            prependInnerIcon: (StringConstructor | ObjectConstructor)[];
            prefix: StringConstructor;
            prefixIcon: (StringConstructor | ObjectConstructor)[];
            suffix: StringConstructor;
            suffixIcon: (StringConstructor | ObjectConstructor)[];
            active: BooleanConstructor;
            dirty: BooleanConstructor;
        } & {
            $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
            "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:active"?: ((_active: boolean) => any) | undefined;
        }, {
            inputRef: Ref<HTMLInputElement | undefined>;
            controlRef: Ref<HTMLElement | undefined>;
        }, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            /**
             * @zh 输入框 name
             */
            'click:clear': (_event: MouseEvent) => boolean;
            /**
             * @zh textarea 独有不允许重置大小
             */
            'click:prepend-inner': (_event: MouseEvent) => boolean;
            'click:prefix': (_event: MouseEvent) => boolean;
            'click:suffix': (_event: MouseEvent) => boolean;
            'click:append-inner': (_event: MouseEvent) => boolean;
            'click:control': (_event: MouseEvent) => boolean;
            'update:active': (_active: boolean) => boolean;
            'update:modelValue': (_modelValue: any) => boolean;
        }, string, {
            disabled: boolean;
            variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
            shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
            active: boolean;
            clearable: boolean;
            clearIcon: string | Record<string, any>;
            dirty: boolean;
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        shape: Omit<{
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: string;
        }, "default" | "type"> & {
            type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
            default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
        };
        color: StringConstructor;
        textColor: StringConstructor;
        variant: Omit<{
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: string;
            validator: (v: any) => boolean;
        }, "default" | "type"> & {
            type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
            default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
        };
        appendInnerIcon: (StringConstructor | ObjectConstructor)[];
        clearable: BooleanConstructor;
        clearIcon: {
            type: (StringConstructor | ObjectConstructor)[];
            default: string;
        };
        disabled: BooleanConstructor;
        prependInnerIcon: (StringConstructor | ObjectConstructor)[];
        prefix: StringConstructor;
        prefixIcon: (StringConstructor | ObjectConstructor)[];
        suffix: StringConstructor;
        suffixIcon: (StringConstructor | ObjectConstructor)[];
        active: BooleanConstructor;
        dirty: BooleanConstructor;
    } & {
        $children: () => VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | {
            'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            default?: VNodeChild | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
        };
        'v-slots': new () => {
            'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            default?: false | ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
        "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:prepend-inner"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:prefix"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:suffix"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:append-inner"?: ((_event: MouseEvent) => any) | undefined;
        "onClick:control"?: ((_event: MouseEvent) => any) | undefined;
        "onUpdate:active"?: ((_active: boolean) => any) | undefined;
    } & ShallowUnwrapRef<{
        inputRef: Ref<HTMLInputElement | undefined>;
        controlRef: Ref<HTMLElement | undefined>;
    }> & {} & {} & ComponentCustomProperties & {
        $slots: MakeSlots<{
            'prepend-inner': [InputControlSlot];
            prefix: [InputControlSlot];
            default: [InputControlDefaultSlot];
            suffix: [InputControlSlot];
            'append-inner': [InputControlSlot];
            clear: [InputControlSlot];
        }>;
    }) | undefined>;
    blur: () => void;
    focus: () => void;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_: string) => boolean;
    /**
     * @zh 输入框 name
     */
    'click:clear': (_event: MouseEvent) => boolean;
    /**
     * @zh textarea 独有不允许重置大小
     */
    'click:prepend-inner': (_event: MouseEvent) => boolean;
    'click:prefix': (_event: MouseEvent) => boolean;
    'click:suffix': (_event: MouseEvent) => boolean;
    'click:append-inner': (_event: MouseEvent) => boolean;
    'click:control': (_event: MouseEvent) => boolean;
    'update:active': (_active: boolean) => boolean;
    'click:prepend': (_event: MouseEvent) => boolean;
    'click:label': (_event: MouseEvent) => boolean;
    'click:append': (_event: MouseEvent) => boolean;
}, string, {
    type: string;
    disabled: boolean;
    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    autofocus: boolean;
    autoResize: boolean;
    noResize: boolean;
    persistentCounter: boolean;
    rows: string | number;
    clearable: boolean;
    clearIcon: string | Record<string, any>;
}> & VNodeProps & AllowedComponentProps & ComponentCustomProps & (new () => {
    $slots: InputSlots;
});
export declare type Input = InstanceType<typeof Input>;
//# sourceMappingURL=input.d.ts.map