var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode, isVNode } from "vue";
import "./styles/layout.scss";
import { useRender } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { makeLayoutProps, provideLayout } from "../../composables/layout/layout.mjs";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
const Layout = defineComponent({
  name: "VeLayout",
  props: __spreadValues(__spreadValues({}, makeTagProps()), makeLayoutProps()),
  setup(props, {
    slots
  }) {
    const {
      layoutClasses,
      getLayoutItem,
      items
    } = provideLayout(props);
    useRender(() => createVNode(props.tag, {
      "class": ["ve-layout", layoutClasses.value]
    }, _isSlot(slots) ? slots : {
      default: () => [slots]
    }));
    return {
      getLayoutItem,
      items
    };
  }
});
export { Layout };
//# sourceMappingURL=layout.mjs.map
