var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { withDirectives, createVNode, resolveDirective } from "vue";
import { genericComponent } from "../../utils/define-component.mjs";
import { makeDimensionProps, useDimension } from "../../composables/dimension/index.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { makeTransitionProps, MaybeTransition } from "../../composables/transition/index.mjs";
import { useProxiedModel } from "../../composables/proxied-model/index.mjs";
import { FadeTransition } from "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import "../transition/expand-transition.mjs";
import "../transition/dialog-transition.mjs";
import "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import "../transition/slide-right-fade-in-expand-transition.mjs";
import { Intersect } from "../../directives/intersect/index.mjs";
const Lazy = genericComponent()({
  name: "VeLazy",
  directives: {
    Intersect
  },
  props: __spreadValues(__spreadValues(__spreadValues({
    modelValue: Boolean,
    options: {
      type: Object,
      default: () => ({
        root: void 0,
        rootMargin: void 0,
        threshold: void 0
      })
    }
  }, makeDimensionProps()), makeTagProps()), makeTransitionProps({
    transition: {
      component: FadeTransition
    }
  })),
  emits: {
    "update:modelValue": (_modelValue) => true
  },
  setup(props, {
    slots
  }) {
    const {
      dimensionStyles
    } = useDimension(props);
    const isActive = useProxiedModel(props, "modelValue");
    function onIntersect(isIntersecting) {
      if (isActive.value)
        return;
      isActive.value = isIntersecting;
    }
    return () => withDirectives(createVNode(props.tag, {
      "class": "ve-lazy",
      "style": dimensionStyles.value
    }, {
      default: () => [isActive.value && createVNode(MaybeTransition, {
        "transition": props.transition
      }, {
        default: () => {
          var _a;
          return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
        }
      })]
    }), [[resolveDirective("intersect"), onIntersect, props.options]]);
  }
});
export { Lazy };
//# sourceMappingURL=lazy.mjs.map
