import { inject, ref, provide } from "vue";
const ListKey = Symbol.for("veno-ui:list");
function provideList() {
  const parent = inject(ListKey, { hasPrepend: ref(false), updateHasPrepend: () => null });
  const data = {
    hasPrepend: ref(false),
    updateHasPrepend: (value) => {
      if (value)
        data.hasPrepend.value = value;
    }
  };
  provide(ListKey, data);
  return parent;
}
function useList() {
  return inject(ListKey, null);
}
export { ListKey, provideList, useList };
//# sourceMappingURL=list.mjs.map
