import type { ComponentInternalInstance, ExtractPropTypes, VNode, RendererNode, RendererElement, VNodeChild, VNodeProps, AllowedComponentProps, ComponentCustomProps, Slot, ComponentPublicInstance, ComponentOptionsBase, ComponentOptionsMixin, DebuggerEvent, nextTick, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties } from 'vue';
import type { MakeSlots } from '../../utils';
export declare type ListGroupActivatorSlot = {
    props: {
        onClick: (e: Event) => void;
        appendIcon: string;
        class: string;
        value?: string;
    };
};
export declare const ListGroup: {
    new (...args: any[]): {
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            tag: string;
            collapseIcon: string | Record<string, any>;
            expandIcon: string | Record<string, any>;
        }> & Omit<Readonly<ExtractPropTypes<{
            tag: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 列表组收起时的图标
             */
            collapseIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            /**
             * @zh 列表组展开时的图标
             */
            expandIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            /**
             * @zh 列表组的值
             */
            value: null;
        } & {
            $children: () => (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild | {
                activator?: VNodeChild | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
            };
            'v-slots': new () => {
                activator?: false | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & VNodeProps & AllowedComponentProps & ComponentCustomProps, "tag" | "collapseIcon" | "expandIcon">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            tag: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 列表组收起时的图标
             */
            collapseIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            /**
             * @zh 列表组展开时的图标
             */
            expandIcon: {
                type: (StringConstructor | ObjectConstructor)[];
                default: string;
            };
            /**
             * @zh 列表组的值
             */
            value: null;
        } & {
            $children: () => (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild | {
                activator?: VNodeChild | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
            };
            'v-slots': new () => {
                activator?: false | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>>, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, {
            tag: string;
            collapseIcon: string | Record<string, any>;
            expandIcon: string | Record<string, any>;
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        tag: {
            type: StringConstructor;
            default: string;
        };
        /**
         * @zh 列表组收起时的图标
         */
        collapseIcon: {
            type: (StringConstructor | ObjectConstructor)[];
            default: string;
        };
        /**
         * @zh 列表组展开时的图标
         */
        expandIcon: {
            type: (StringConstructor | ObjectConstructor)[];
            default: string;
        };
        /**
         * @zh 列表组的值
         */
        value: null;
    } & {
        $children: () => (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild | {
            activator?: VNodeChild | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            default?: (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild;
        };
        'v-slots': new () => {
            activator?: false | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            default?: false | (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & ShallowUnwrapRef<() => JSX.Element> & {} & {} & ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & ComponentOptionsBase<Readonly<ExtractPropTypes<{
    tag: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 列表组收起时的图标
     */
    collapseIcon: {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    };
    /**
     * @zh 列表组展开时的图标
     */
    expandIcon: {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    };
    /**
     * @zh 列表组的值
     */
    value: null;
} & {
    $children: () => (() => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]) | VNodeChild | {
        activator?: VNodeChild | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        default?: (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild;
    };
    'v-slots': new () => {
        activator?: false | ((args_0: ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        default?: false | (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
    };
}>>, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, {
    tag: string;
    collapseIcon: string | Record<string, any>;
    expandIcon: string | Record<string, any>;
}> & VNodeProps & AllowedComponentProps & ComponentCustomProps & (new () => {
    $slots: MakeSlots<{
        activator: [ListGroupActivatorSlot];
        default: [];
    }>;
});
export declare type ListGroup = InstanceType<typeof ListGroup>;
//# sourceMappingURL=list-group.d.ts.map