var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode, withDirectives, vShow } from "vue";
import "./styles/list-group.scss";
import { genericComponent } from "../../utils/define-component.mjs";
import { useNestedGroup } from "../../composables/nested/index.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import { ExpandTransition } from "../transition/expand-transition.mjs";
import "../transition/dialog-transition.mjs";
import "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import "../transition/slide-right-fade-in-expand-transition.mjs";
import { useList } from "./composables/list.mjs";
const ListGroup = genericComponent()({
  name: "VeListGroup",
  props: __spreadValues({
    collapseIcon: {
      type: [String, Object],
      default: "$collapse"
    },
    expandIcon: {
      type: [String, Object],
      default: "$expand"
    },
    value: null
  }, makeTagProps()),
  setup(props, {
    slots
  }) {
    const {
      isOpen,
      open
    } = useNestedGroup(props);
    const list = useList();
    const onClick = (e) => {
      open(!isOpen.value, e);
    };
    const activatorProps = computed(() => ({
      onClick,
      appendIcon: isOpen.value ? props.collapseIcon : props.expandIcon,
      class: "ve-list-group__header",
      value: props.value ? `${props.value}_header` : void 0
    }));
    return () => {
      return createVNode(props.tag, {
        "class": ["ve-list-group", {
          "ve-list-group--prepend": list == null ? void 0 : list.hasPrepend.value
        }]
      }, {
        default: () => {
          var _a;
          return [(_a = slots.activator) == null ? void 0 : _a.call(slots, {
            props: activatorProps.value
          }), createVNode(ExpandTransition, null, {
            default: () => {
              var _a2;
              return [withDirectives(createVNode("div", {
                "class": "ve-list-group__items"
              }, [(_a2 = slots.default) == null ? void 0 : _a2.call(slots)]), [[vShow, isOpen.value]])];
            }
          })];
        }
      });
    };
  }
});
export { ListGroup };
//# sourceMappingURL=list-group.mjs.map
