import { createVNode, mergeProps } from "vue";
import "./styles/list-item-avatar.scss";
import { makeAvatarProps, Avatar } from "../avatar/avatar.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
const ListItemAvatar = defineComponent({
  name: "VeListItemAvatar",
  props: makeAvatarProps(),
  setup(props, {
    slots
  }) {
    return () => {
      return createVNode(Avatar, mergeProps({
        "class": ["ve-list-item-avatar", {
          "ve-list-item-avatar--start": props.start,
          "ve-list-item-avatar--end": props.end
        }]
      }, props), slots);
    };
  }
});
export { ListItemAvatar };
//# sourceMappingURL=list-item-avatar.mjs.map
