var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { toRef, createVNode } from "vue";
import "./styles/list-subheader.scss";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { useTextColor } from "../../composables/color/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
const ListSubheader = defineComponent({
  name: "VeListSubheader",
  props: __spreadValues({
    color: String,
    inset: Boolean
  }, makeTagProps()),
  setup(props, {
    slots
  }) {
    const {
      textColorClasses,
      textColorStyles
    } = useTextColor(toRef(props, "color"));
    return () => createVNode(props.tag, {
      "class": ["ve-list-subheader", {
        "ve-list-subheader--inset": props.inset
      }, textColorClasses.value],
      "style": {
        textColorStyles
      }
    }, {
      default: () => [slots.default && createVNode("div", {
        "class": "ve-list-subheader__text"
      }, [slots.default()])]
    });
  }
});
export { ListSubheader };
//# sourceMappingURL=list-subheader.mjs.map
