var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { computed, toRef, createVNode, isVNode } from "vue";
import "./styles/list.scss";
import { useRender } from "../../utils/dist/index.mjs";
import { genericComponent } from "../../utils/define-component.mjs";
import { makePaperProps, usePaper } from "../../composables/paper/index.mjs";
import { makeDisabledProps, useDisabled } from "../../composables/disabled/index.mjs";
import { makeNestedProps, useNested } from "../../composables/nested/index.mjs";
import { provideDefaults } from "../../composables/defaults/index.mjs";
import { provideList } from "./composables/list.mjs";
import { ListChildren } from "./list-children.mjs";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
function parseItems(items) {
  if (!items)
    return void 0;
  return items.map((item) => {
    if (typeof item === "string")
      return {
        type: "item",
        props: {
          value: item,
          title: item
        }
      };
    const _a = item, {
      $type,
      $children
    } = _a, props = __objRest(_a, [
      "$type",
      "$children"
    ]);
    if ($type === "subheader")
      return {
        type: "subheader",
        props
      };
    if ($type === "divider")
      return {
        type: "divider",
        props
      };
    return {
      type: "item",
      props,
      children: parseItems($children)
    };
  });
}
const List = genericComponent()({
  name: "VeList",
  props: __spreadValues(__spreadValues(__spreadValues({
    nav: Boolean,
    items: Array
  }, makeNestedProps({
    selectStrategy: "leaf",
    openStrategy: "multiple",
    activeStrategy: "single"
  })), makePaperProps({
    size: void 0
  })), makeDisabledProps()),
  emits: {
    "update:selected": (_selected) => true,
    "update:opened": (_opened) => true,
    "update:active": (_active) => true
  },
  setup(props, {
    slots
  }) {
    const items = computed(() => parseItems(props.items));
    const {
      paperClasses,
      paperStyles
    } = usePaper(props);
    const {
      disabledClasses
    } = useDisabled(props);
    const {
      open,
      select,
      activate
    } = useNested(props);
    provideList();
    provideDefaults({
      VeListItem: {
        density: toRef(props, "density")
      }
    });
    useRender(() => {
      return createVNode(props.tag, {
        "class": ["ve-list", {
          "ve-list--nav": props.nav
        }, paperClasses.value, disabledClasses.value],
        "style": paperStyles.value
      }, {
        default: () => {
          var _a, _b;
          return [(_a = slots.prepend) == null ? void 0 : _a.call(slots), createVNode(ListChildren, {
            "items": items.value
          }, _isSlot(slots) ? slots : {
            default: () => [slots]
          }), (_b = slots.append) == null ? void 0 : _b.call(slots)];
        }
      });
    });
    return {
      open,
      select,
      activate
    };
  }
});
export { List };
//# sourceMappingURL=list.mjs.map
