var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, unref, createVNode } from "vue";
import "./styles/main.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeTagProps } from "../../composables/tag/index.mjs";
import { useLayoutMain } from "../../composables/layout/layout-main.mjs";
import { makeColorProps, useColor } from "../../composables/color/index.mjs";
const Main = defineComponent({
  name: "VeMain",
  props: __spreadValues(__spreadValues({}, makeTagProps({
    tag: "main"
  })), makeColorProps()),
  setup(props, {
    slots
  }) {
    const {
      mainStyles
    } = useLayoutMain();
    const {
      colorClasses,
      colorStyles
    } = useColor(computed(() => {
      const {
        textColor,
        color
      } = unref(props);
      return {
        background: color,
        text: textColor
      };
    }));
    return () => createVNode(props.tag, {
      "class": ["ve-main", colorClasses.value],
      "style": [mainStyles.value, colorStyles.value]
    }, {
      default: () => {
        var _a;
        return [createVNode("div", {
          "class": "ve-main__wrap"
        }, [(_a = slots.default) == null ? void 0 : _a.call(slots)])];
      }
    });
  }
});
export { Main };
//# sourceMappingURL=main.mjs.map
