var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { ref, computed, createVNode, isVNode } from "vue";
import "./styles/menu.scss";
import { getUid, useRender } from "../../utils/dist/index.mjs";
import { genericComponent } from "../../utils/define-component.mjs";
import { useProxiedModel } from "../../composables/proxied-model/index.mjs";
import { makeTransitionProps } from "../../composables/transition/index.mjs";
import { Overlay } from "../overlay/overlay.mjs";
import "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import "../transition/expand-transition.mjs";
import "../transition/dialog-transition.mjs";
import { MenuTransition } from "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import "../transition/slide-right-fade-in-expand-transition.mjs";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
const Menu = genericComponent()({
  name: "VeMenu",
  props: __spreadValues({
    modelValue: Boolean,
    id: String
  }, makeTransitionProps({
    transition: {
      component: MenuTransition
    }
  })),
  emits: {
    "update:modelValue": (_modelValue) => true
  },
  setup(props, {
    slots
  }) {
    const isActive = useProxiedModel(props, "modelValue");
    const overlayRef = ref();
    const id = computed(() => props.id || `ve-menu-${getUid()}`);
    useRender(() => {
      return createVNode(Overlay, {
        "ref": overlayRef,
        "modelValue": isActive.value,
        "onUpdate:modelValue": ($event) => isActive.value = $event,
        "class": "ve-menu",
        "transition": props.transition,
        "absolute": true,
        "positionStrategy": "connected",
        "scrollStrategy": "reposition",
        "closeDelay": 100,
        "minWidth": 0,
        "offset": 4,
        "scrim": false,
        "activatorProps": {
          "aria-haspopup": "menu",
          "aria-expanded": String(isActive.value),
          "aria-owns": id.value
        }
      }, _isSlot(slots) ? slots : {
        default: () => [slots]
      });
    });
    return {
      overlayRef
    };
  }
});
export { Menu };
//# sourceMappingURL=menu.mjs.map
