var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode } from "vue";
import "./styles/messages.scss";
import { wrapInArray } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { FadeTransition } from "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import "../transition/expand-transition.mjs";
import "../transition/dialog-transition.mjs";
import "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import "../transition/slide-right-fade-in-expand-transition.mjs";
import { makeTransitionProps, MaybeTransition } from "../../composables/transition/index.mjs";
const Messages = defineComponent({
  name: "VeMessages",
  props: __spreadValues({
    active: Boolean,
    value: {
      type: [Array, String],
      default: () => []
    }
  }, makeTransitionProps({
    transition: {
      component: FadeTransition,
      group: true
    }
  })),
  setup(props, {
    slots
  }) {
    const messages = computed(() => wrapInArray(props.value));
    return () => {
      const hasMessages = messages.value.length > 0 && props.active;
      return createVNode(MaybeTransition, {
        "transition": props.transition,
        "tag": "div",
        "class": "ve-messages"
      }, {
        default: () => {
          var _a;
          return [hasMessages && messages.value.map((message, i) => createVNode("div", {
            "class": "ve-messages__message",
            "key": i
          }, [message])), (_a = slots == null ? void 0 : slots.default) == null ? void 0 : _a.call(slots)];
        }
      });
    };
  }
});
export { Messages };
//# sourceMappingURL=messages.mjs.map
