var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { createVNode, Fragment, mergeProps } from "vue";
import "./styles/notification-provider.scss";
import { useRender } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { Overlay } from "../overlay/overlay.mjs";
import { filterAlertProps, Alert } from "../alert/alert.mjs";
import { NotificationKey, notification, useNotification, provideNotification } from "../../composables/message/index.mjs";
import "../transition/fade-transition.mjs";
import "../transition/scale-transition.mjs";
import "../transition/expand-transition.mjs";
import "../transition/dialog-transition.mjs";
import "../transition/menu-transition.mjs";
import "../transition/fade-in-expand-transition.mjs";
import { SlideRightFadeInExpandTransition } from "../transition/slide-right-fade-in-expand-transition.mjs";
const NotificationProvider = defineComponent({
  name: "VeNotificationProvider",
  register(app) {
    app.provide(NotificationKey, notification);
  },
  props: {
    registered: Boolean
  },
  setup(props, {
    slots
  }) {
    const notification2 = props.registered ? useNotification() : provideNotification();
    const {
      items,
      remove
    } = notification2;
    useRender(() => {
      var _a;
      return createVNode(Fragment, null, [(_a = slots.default) == null ? void 0 : _a.call(slots), createVNode(Overlay, {
        "modelValue": items.value.length > 0,
        "scrim": false,
        "scrollStrategy": "none",
        "class": ["ve-notification-provider"]
      }, __spreadProps(__spreadValues({}, slots), {
        default: () => createVNode("ul", null, [items.value.map((item) => {
          const [alertProps] = filterAlertProps(item);
          return createVNode(Alert, mergeProps({
            "key": item.id,
            "tag": "li",
            "appear": true,
            "modelValue": item.modelValue,
            "onUpdate:modelValue": ($event) => item.modelValue = $event,
            "on-after-leave": () => remove(item.id),
            "min-width": "300",
            "transition": {
              component: SlideRightFadeInExpandTransition
            }
          }, alertProps), null);
        })])
      }))]);
    });
    return notification2;
  }
});
export { NotificationProvider };
//# sourceMappingURL=notification-provider.mjs.map
