import type { Size } from '../../composables/size';
import type { DefineComponent, PropType, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
export declare const Pagination: DefineComponent<{
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">; /**
         * @zh 是否禁用
         */
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    /**
     * @zh 激活时的颜色
     */
    activeColor: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 导航的无障碍标签值
     */
    ariaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 当前页的无障碍标签值
     */
    currentPageAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 是否禁用
     */
    disabled: BooleanConstructor;
    /**
     * @zh 省略值
     */
    ellipsis: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 第一页的无障碍标签值
     */
    firstAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 第一页初始值
     */
    firstPage: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
    /**
     * @zh 第一页的按钮图标
     */
    firstIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 最后一页的无障碍标签值
     */
    lastAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 最后一页的按钮图标
     */
    lastIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 当前页
     */
    modelValue: {
        type: (StringConstructor | NumberConstructor)[];
        default: (props: any) => any;
        validator: (val: number) => boolean;
    };
    /**
     * @zh 下一页的无障碍标签值
     */
    nextAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 下一页的按钮图标
     */
    nextIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 上一页的按钮图标
     */
    prevIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 页面的无障碍标签值
     */
    pageAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 每页条数
     */
    perPage: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (val: number) => boolean;
    };
    /**
     * @zh 每页条数可选项
     */
    perPageOptions: {
        type: ArrayConstructor;
        default: () => number[];
    };
    /**
     * @zh 上一页的无障碍标签值
     */
    previousAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 显示首页和最后一页
     */
    showFirstLastPage: BooleanConstructor;
    /**
     * @zh 显示快速跳跃
     */
    showQuickJumper: BooleanConstructor;
    /**
     * @zh 显示每页条数选择器
     */
    showPerPageSelect: BooleanConstructor;
    /**
     * @zh 总条数
     */
    total: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (val: number) => boolean;
    };
    /**
     * @zh 总显示页数
     */
    totalVisible: {
        type: (StringConstructor | NumberConstructor)[];
        validator: (val: number) => boolean;
    };
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_modelValue: number) => true;
    'update:perPage': (_perPage: number) => true;
    first: (_value: number) => true;
    prev: (_value: number) => true;
    next: (_value: number) => true;
    last: (_value: number) => true;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">; /**
         * @zh 是否禁用
         */
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    /**
     * @zh 激活时的颜色
     */
    activeColor: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 导航的无障碍标签值
     */
    ariaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 当前页的无障碍标签值
     */
    currentPageAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 是否禁用
     */
    disabled: BooleanConstructor;
    /**
     * @zh 省略值
     */
    ellipsis: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 第一页的无障碍标签值
     */
    firstAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 第一页初始值
     */
    firstPage: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
    };
    /**
     * @zh 第一页的按钮图标
     */
    firstIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 最后一页的无障碍标签值
     */
    lastAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 最后一页的按钮图标
     */
    lastIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 当前页
     */
    modelValue: {
        type: (StringConstructor | NumberConstructor)[];
        default: (props: any) => any;
        validator: (val: number) => boolean;
    };
    /**
     * @zh 下一页的无障碍标签值
     */
    nextAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 下一页的按钮图标
     */
    nextIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 上一页的按钮图标
     */
    prevIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 页面的无障碍标签值
     */
    pageAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 每页条数
     */
    perPage: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (val: number) => boolean;
    };
    /**
     * @zh 每页条数可选项
     */
    perPageOptions: {
        type: ArrayConstructor;
        default: () => number[];
    };
    /**
     * @zh 上一页的无障碍标签值
     */
    previousAriaLabel: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 显示首页和最后一页
     */
    showFirstLastPage: BooleanConstructor;
    /**
     * @zh 显示快速跳跃
     */
    showQuickJumper: BooleanConstructor;
    /**
     * @zh 显示每页条数选择器
     */
    showPerPageSelect: BooleanConstructor;
    /**
     * @zh 总条数
     */
    total: {
        type: (StringConstructor | NumberConstructor)[];
        default: number;
        validator: (val: number) => boolean;
    };
    /**
     * @zh 总显示页数
     */
    totalVisible: {
        type: (StringConstructor | NumberConstructor)[];
        validator: (val: number) => boolean;
    };
}>> & {
    "onUpdate:modelValue"?: ((_modelValue: number) => any) | undefined;
    onNext?: ((_value: number) => any) | undefined;
    onPrev?: ((_value: number) => any) | undefined;
    "onUpdate:perPage"?: ((_perPage: number) => any) | undefined;
    onFirst?: ((_value: number) => any) | undefined;
    onLast?: ((_value: number) => any) | undefined;
}, {
    modelValue: string | number;
    fixed: boolean;
    disabled: boolean;
    tag: string;
    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    absolute: boolean;
    size: Size | undefined;
    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    activeColor: string;
    prevIcon: string;
    nextIcon: string;
    ariaLabel: string;
    currentPageAriaLabel: string;
    ellipsis: string;
    firstAriaLabel: string;
    firstPage: string | number;
    firstIcon: string;
    lastAriaLabel: string;
    lastIcon: string;
    nextAriaLabel: string;
    pageAriaLabel: string;
    perPage: string | number;
    perPageOptions: unknown[];
    previousAriaLabel: string;
    showFirstLastPage: boolean;
    showQuickJumper: boolean;
    showPerPageSelect: boolean;
    total: string | number;
}>;
export declare type Pagination = InstanceType<typeof Pagination>;
//# sourceMappingURL=pagination.d.ts.map