import { createVNode } from "vue";
import "./styles/paper.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { makePaperProps, usePaper } from "../../composables/paper/index.mjs";
const Paper = defineComponent({
  name: "VePaper",
  props: makePaperProps(),
  setup(props, {
    slots
  }) {
    const {
      paperClasses,
      paperStyles
    } = usePaper(props);
    return () => createVNode(props.tag, {
      "class": ["ve-paper", paperClasses.value],
      "style": paperStyles.value
    }, slots);
  }
});
export { Paper };
//# sourceMappingURL=paper.mjs.map
