var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { computed, toRef, createVNode, mergeProps } from "vue";
import { getUid } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import { FormControl } from "../form-control/form-control.mjs";
import { makeSelectionGroupControlProps, SelectionGroupControl } from "../selection-group-control/selection-group-control.mjs";
import { Radio } from "../radio/radio.mjs";
import { makeSizeProps } from "../../composables/size/index.mjs";
import { makeDensityProps } from "../../composables/density/index.mjs";
import { provideDefaults } from "../../composables/defaults/index.mjs";
import { useProxiedModel } from "../../composables/proxied-model/index.mjs";
const RadioGroup = defineComponent({
  name: "VeRadioGroup",
  props: __spreadValues(__spreadValues(__spreadValues({
    items: Array
  }, makeSelectionGroupControlProps({
    type: "radio",
    trueIcon: "$radioOn",
    falseIcon: "$radioOff"
  })), makeSizeProps()), makeDensityProps()),
  emits: {
    "update:modelValue": (_modelValue) => true
  },
  setup(props, {
    slots
  }) {
    const id = computed(() => props.id || `ve-radio-group-${getUid()}`);
    const model = useProxiedModel(props, "modelValue");
    const items = computed(() => {
      var _a;
      return (_a = props.items) == null ? void 0 : _a.map((itemProps) => typeof itemProps === "string" ? {
        value: itemProps
      } : itemProps);
    });
    provideDefaults({
      VeRadio: {
        size: toRef(props, "size"),
        density: toRef(props, "density"),
        readonly: toRef(props, "readonly"),
        disabled: toRef(props, "disabled")
      }
    });
    return () => {
      const _a = props, {
        density,
        size
      } = _a, restProps = __objRest(_a, [
        "density",
        "size"
      ]);
      return createVNode(FormControl, {
        "class": "ve-radio-group",
        "density": density,
        "name": props.name,
        "size": size,
        "modelValue": model.value,
        "onUpdate:modelValue": ($event) => model.value = $event
      }, __spreadProps(__spreadValues({}, slots), {
        default: ({
          isDisabled,
          isReadonly,
          props: controlProps
        }) => createVNode(SelectionGroupControl, mergeProps(restProps, controlProps, {
          "id": id.value,
          "disabled": isDisabled.value,
          "readonly": isReadonly.value,
          "modelValue": model.value,
          "onUpdate:modelValue": ($event) => model.value = $event
        }), {
          default: () => {
            var _a2, _b;
            return [(_a2 = items.value) == null ? void 0 : _a2.map((itemProps) => createVNode(Radio, itemProps, null)), (_b = slots.default) == null ? void 0 : _b.call(slots)];
          }
        })
      }));
    };
  }
});
export { RadioGroup };
//# sourceMappingURL=radio-group.mjs.map
