var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, createVNode } from "vue";
import "./styles/responsive.scss";
import { genericComponent } from "../../utils/define-component.mjs";
import { makeDimensionProps, useDimension } from "../../composables/dimension/index.mjs";
function useAspectStyles(props) {
  return {
    aspectStyles: computed(() => {
      const ratio = Number(props.aspectRatio);
      return ratio ? {
        paddingBottom: `${String(1 / ratio * 100)}%`
      } : void 0;
    })
  };
}
const Responsive = genericComponent()({
  name: "VeResponsive",
  props: __spreadValues({
    aspectRatio: [String, Number],
    contentClass: String
  }, makeDimensionProps()),
  setup(props, {
    slots
  }) {
    const {
      dimensionStyles
    } = useDimension(props);
    const {
      aspectStyles
    } = useAspectStyles(props);
    return () => {
      var _a;
      return createVNode("div", {
        "class": "ve-responsive",
        "style": dimensionStyles.value
      }, [createVNode("div", {
        "class": "ve-responsive__sizer",
        "style": aspectStyles.value
      }, null), (_a = slots.additional) == null ? void 0 : _a.call(slots), slots.default && createVNode("div", {
        "class": ["ve-responsive__content", props.contentClass]
      }, [slots.default()])]);
    };
  }
});
export { Responsive, useAspectStyles };
//# sourceMappingURL=responsive.mjs.map
