import type { ListItemTitleSlot, ListItemSubtitleSlot } from '../list/list-item';
import type { ListGroupActivatorSlot } from '../list/list-group';
import type { CounterSlot } from '../counter/counter';
import type { InputControlDefaultSlot, InputControlSlot } from '../input-control/input-control';
import type { FormControlSlot } from '../form-control/form-control';
import type { ComponentInternalInstance, ExtractPropTypes, VNodeChild, VNode, RendererNode, RendererElement, VNodeProps, AllowedComponentProps, ComponentCustomProps, Slot, ComponentPublicInstance, ComponentOptionsBase, ComponentOptionsMixin, DebuggerEvent, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties, nextTick } from 'vue';
import type { PropType } from 'vue';
import type { MakeSlots } from '../../utils';
import type { InputSlots } from '../input/input';
import type { ListItemProps } from '../list/list';
import type { ListChildrenSlots } from '../list/list-children';
export declare type SelectItemProps = string | Record<string, any>;
export declare type InternalSelectItemProps = ListItemProps & {
    text: string;
    value: string | number;
    filtered?: boolean;
};
export declare type SelectSlots = InputSlots & ListChildrenSlots<InternalSelectItemProps> & MakeSlots<{
    'tag': [
        {
            item: InternalSelectItemProps;
            close: () => void;
        }
    ];
    'no-data': [];
}>;
export declare const Select: {
    new (...args: any[]): {
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            modelValue: any;
            loading: boolean;
            multiple: boolean;
            readonly: boolean;
            beautifyScrollbar: boolean;
            openOnClear: boolean;
            appendInnerIcon: string;
            deleteAfterUnmount: boolean;
            filterable: boolean;
            tags: boolean;
            returnObject: boolean;
            itemText: string;
            itemValue: string;
            noDataText: string;
        }> & Omit<Readonly<ExtractPropTypes<{
            beautifyScrollbar: {
                type: BooleanConstructor;
                default: boolean;
            };
            /**
             * @zh 追加的内联图标
             */
            appendInnerIcon: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 可选项卸载后是否从已选项中移除
             */
            deleteAfterUnmount: {
                type: BooleanConstructor;
                default: boolean;
            };
            /**
             * @zh 可过滤的
             */
            filterable: BooleanConstructor;
            /**
             * @zh ID
             */
            id: StringConstructor;
            /**
             * @zh 选择框可选项
             */
            items: PropType<SelectItemProps[]>;
            /**
             * @zh 可选项文本字段
             */
            itemText: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 可选项值字段
             */
            itemValue: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 加载中
             */
            loading: BooleanConstructor;
            /**
             * @zh 当前值
             */
            modelValue: {
                type: null;
                default: () => never[];
            };
            /**
             * @zh 是否多选
             */
            multiple: BooleanConstructor;
            /**
             * @zh 无数据时显示的文本
             */
            noDataText: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 是否在清除时打开可选菜单
             */
            openOnClear: BooleanConstructor;
            /**
             * @zh 输入框占位符
             */
            placeholder: StringConstructor;
            /**
             * @zh 查询字符串
             */
            query: StringConstructor;
            /**
             * @zh 标签
             */
            tags: BooleanConstructor;
            /**
             * @zh 只读
             */
            readonly: BooleanConstructor;
            /**
             * @zh 返回对象值
             */
            returnObject: BooleanConstructor;
        } & {
            $children: () => VNodeChild | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[])) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]));
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                header?: VNodeChild | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                item?: VNodeChild | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                title?: VNodeChild | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                subtitle?: VNodeChild | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                tag?: VNodeChild | ((args_0: {
                    item: InternalSelectItemProps;
                    close: () => void;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'no-data'?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[])) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                header?: false | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                item?: false | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                title?: false | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                subtitle?: false | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                tag?: false | ((args_0: {
                    item: InternalSelectItemProps;
                    close: () => void;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'no-data'?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:query"?: ((_query: string) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "modelValue" | "loading" | "multiple" | "readonly" | "beautifyScrollbar" | "openOnClear" | "appendInnerIcon" | "deleteAfterUnmount" | "filterable" | "tags" | "returnObject" | "itemText" | "itemValue" | "noDataText">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: ((event: "update:modelValue", _modelValue: any) => void) & ((event: "click:clear", _event: MouseEvent) => void) & ((event: "update:query", _query: string) => void);
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            beautifyScrollbar: {
                type: BooleanConstructor;
                default: boolean;
            };
            /**
             * @zh 追加的内联图标
             */
            appendInnerIcon: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 可选项卸载后是否从已选项中移除
             */
            deleteAfterUnmount: {
                type: BooleanConstructor;
                default: boolean;
            };
            /**
             * @zh 可过滤的
             */
            filterable: BooleanConstructor;
            /**
             * @zh ID
             */
            id: StringConstructor;
            /**
             * @zh 选择框可选项
             */
            items: PropType<SelectItemProps[]>;
            /**
             * @zh 可选项文本字段
             */
            itemText: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 可选项值字段
             */
            itemValue: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 加载中
             */
            loading: BooleanConstructor;
            /**
             * @zh 当前值
             */
            modelValue: {
                type: null;
                default: () => never[];
            };
            /**
             * @zh 是否多选
             */
            multiple: BooleanConstructor;
            /**
             * @zh 无数据时显示的文本
             */
            noDataText: {
                type: StringConstructor;
                default: string;
            };
            /**
             * @zh 是否在清除时打开可选菜单
             */
            openOnClear: BooleanConstructor;
            /**
             * @zh 输入框占位符
             */
            placeholder: StringConstructor;
            /**
             * @zh 查询字符串
             */
            query: StringConstructor;
            /**
             * @zh 标签
             */
            tags: BooleanConstructor;
            /**
             * @zh 只读
             */
            readonly: BooleanConstructor;
            /**
             * @zh 返回对象值
             */
            returnObject: BooleanConstructor;
        } & {
            $children: () => VNodeChild | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[])) | {
                prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                default?: VNodeChild | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]));
                append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                header?: VNodeChild | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                item?: VNodeChild | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                title?: VNodeChild | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                subtitle?: VNodeChild | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                tag?: VNodeChild | ((args_0: {
                    item: InternalSelectItemProps;
                    close: () => void;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                'no-data'?: (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | VNodeChild;
            };
            'v-slots': new () => {
                prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                default?: false | (((args_0: FormControlSlot & {
                    props: Record<string, unknown>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) & (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[])) | undefined;
                append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                header?: false | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                item?: false | ((args_0: {
                    item: InternalSelectItemProps;
                    index: number;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                title?: false | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                subtitle?: false | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                tag?: false | ((args_0: {
                    item: InternalSelectItemProps;
                    close: () => void;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                'no-data'?: false | (() => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
            "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
            "onUpdate:query"?: ((_query: string) => any) | undefined;
        }, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            'click:clear': (_event: MouseEvent) => boolean;
            'update:modelValue': (_modelValue: any) => boolean;
            'update:query': (_query: string) => boolean;
        }, string, {
            modelValue: any;
            loading: boolean;
            multiple: boolean;
            readonly: boolean;
            beautifyScrollbar: boolean;
            openOnClear: boolean;
            appendInnerIcon: string;
            deleteAfterUnmount: boolean;
            filterable: boolean;
            tags: boolean;
            returnObject: boolean;
            itemText: string;
            itemValue: string;
            noDataText: string;
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        beautifyScrollbar: {
            type: BooleanConstructor;
            default: boolean;
        };
        /**
         * @zh 追加的内联图标
         */
        appendInnerIcon: {
            type: StringConstructor;
            default: string;
        };
        /**
         * @zh 可选项卸载后是否从已选项中移除
         */
        deleteAfterUnmount: {
            type: BooleanConstructor;
            default: boolean;
        };
        /**
         * @zh 可过滤的
         */
        filterable: BooleanConstructor;
        /**
         * @zh ID
         */
        id: StringConstructor;
        /**
         * @zh 选择框可选项
         */
        items: PropType<SelectItemProps[]>;
        /**
         * @zh 可选项文本字段
         */
        itemText: {
            type: StringConstructor;
            default: string;
        };
        /**
         * @zh 可选项值字段
         */
        itemValue: {
            type: StringConstructor;
            default: string;
        };
        /**
         * @zh 加载中
         */
        loading: BooleanConstructor;
        /**
         * @zh 当前值
         */
        modelValue: {
            type: null;
            default: () => never[];
        };
        /**
         * @zh 是否多选
         */
        multiple: BooleanConstructor;
        /**
         * @zh 无数据时显示的文本
         */
        noDataText: {
            type: StringConstructor;
            default: string;
        };
        /**
         * @zh 是否在清除时打开可选菜单
         */
        openOnClear: BooleanConstructor;
        /**
         * @zh 输入框占位符
         */
        placeholder: StringConstructor;
        /**
         * @zh 查询字符串
         */
        query: StringConstructor;
        /**
         * @zh 标签
         */
        tags: BooleanConstructor;
        /**
         * @zh 只读
         */
        readonly: BooleanConstructor;
        /**
         * @zh 返回对象值
         */
        returnObject: BooleanConstructor;
    } & {
        $children: () => VNodeChild | (((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[])) | {
            prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            default?: VNodeChild | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]));
            append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            header?: VNodeChild | ((args_0: {
                item: InternalSelectItemProps;
                index: number;
            } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            item?: VNodeChild | ((args_0: {
                item: InternalSelectItemProps;
                index: number;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            title?: VNodeChild | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            subtitle?: VNodeChild | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            tag?: VNodeChild | ((args_0: {
                item: InternalSelectItemProps;
                close: () => void;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            'no-data'?: (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | VNodeChild;
        };
        'v-slots': new () => {
            prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            default?: false | (((args_0: FormControlSlot & {
                props: Record<string, unknown>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) & (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[])) | undefined;
            append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            header?: false | ((args_0: {
                item: InternalSelectItemProps;
                index: number;
            } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            item?: false | ((args_0: {
                item: InternalSelectItemProps;
                index: number;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            title?: false | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            subtitle?: false | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            tag?: false | ((args_0: {
                item: InternalSelectItemProps;
                close: () => void;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            'no-data'?: false | (() => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
        "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
        "onUpdate:query"?: ((_query: string) => any) | undefined;
    } & ShallowUnwrapRef<() => JSX.Element> & {} & {} & ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & ComponentOptionsBase<Readonly<ExtractPropTypes<{
    beautifyScrollbar: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @zh 追加的内联图标
     */
    appendInnerIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 可选项卸载后是否从已选项中移除
     */
    deleteAfterUnmount: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @zh 可过滤的
     */
    filterable: BooleanConstructor;
    /**
     * @zh ID
     */
    id: StringConstructor;
    /**
     * @zh 选择框可选项
     */
    items: PropType<SelectItemProps[]>;
    /**
     * @zh 可选项文本字段
     */
    itemText: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 可选项值字段
     */
    itemValue: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 加载中
     */
    loading: BooleanConstructor;
    /**
     * @zh 当前值
     */
    modelValue: {
        type: null;
        default: () => never[];
    };
    /**
     * @zh 是否多选
     */
    multiple: BooleanConstructor;
    /**
     * @zh 无数据时显示的文本
     */
    noDataText: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 是否在清除时打开可选菜单
     */
    openOnClear: BooleanConstructor;
    /**
     * @zh 输入框占位符
     */
    placeholder: StringConstructor;
    /**
     * @zh 查询字符串
     */
    query: StringConstructor;
    /**
     * @zh 标签
     */
    tags: BooleanConstructor;
    /**
     * @zh 只读
     */
    readonly: BooleanConstructor;
    /**
     * @zh 返回对象值
     */
    returnObject: BooleanConstructor;
} & {
    $children: () => VNodeChild | (((args_0: FormControlSlot & {
        props: Record<string, unknown>;
    }) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]) & (() => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[])) | {
        prepend?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        label?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        default?: VNodeChild | (((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]));
        append?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        details?: VNodeChild | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        'prepend-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        prefix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        suffix?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        'append-inner'?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        clear?: VNodeChild | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        counter?: VNodeChild | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        header?: VNodeChild | ((args_0: {
            item: InternalSelectItemProps;
            index: number;
        } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        item?: VNodeChild | ((args_0: {
            item: InternalSelectItemProps;
            index: number;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        title?: VNodeChild | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        subtitle?: VNodeChild | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        tag?: VNodeChild | ((args_0: {
            item: InternalSelectItemProps;
            close: () => void;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        'no-data'?: (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | VNodeChild;
    };
    'v-slots': new () => {
        prepend?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        label?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        default?: false | (((args_0: FormControlSlot & {
            props: Record<string, unknown>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & ((args_0: InputControlDefaultSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) & (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[])) | undefined;
        append?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        details?: false | ((args_0: FormControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        'prepend-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        prefix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        suffix?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        'append-inner'?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        clear?: false | ((args_0: InputControlSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        counter?: false | ((args_0: CounterSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        header?: false | ((args_0: {
            item: InternalSelectItemProps;
            index: number;
        } & ListGroupActivatorSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        item?: false | ((args_0: {
            item: InternalSelectItemProps;
            index: number;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        title?: false | ((args_0: ListItemTitleSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        subtitle?: false | ((args_0: ListItemSubtitleSlot) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        tag?: false | ((args_0: {
            item: InternalSelectItemProps;
            close: () => void;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        'no-data'?: false | (() => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
    };
}>> & {
    "onUpdate:modelValue"?: ((_modelValue: any) => any) | undefined;
    "onClick:clear"?: ((_event: MouseEvent) => any) | undefined;
    "onUpdate:query"?: ((_query: string) => any) | undefined;
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'click:clear': (_event: MouseEvent) => boolean;
    'update:modelValue': (_modelValue: any) => boolean;
    'update:query': (_query: string) => boolean;
}, string, {
    modelValue: any;
    loading: boolean;
    multiple: boolean;
    readonly: boolean;
    beautifyScrollbar: boolean;
    openOnClear: boolean;
    appendInnerIcon: string;
    deleteAfterUnmount: boolean;
    filterable: boolean;
    tags: boolean;
    returnObject: boolean;
    itemText: string;
    itemValue: string;
    noDataText: string;
}> & VNodeProps & AllowedComponentProps & ComponentCustomProps & (new () => {
    $slots: SelectSlots;
});
export declare type Select = InstanceType<typeof Select>;
//# sourceMappingURL=select.d.ts.map