var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { createVNode, mergeProps, isVNode } from "vue";
import "./styles/spacer.scss";
import { flattenFragments, pick } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
import "../grid/container.mjs";
import { makeColProps, Col } from "../grid/col.mjs";
import { makeRowProps, Row } from "../grid/row.mjs";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !isVNode(s);
}
const Spacer = defineComponent({
  name: "VeSpacer",
  props: __spreadValues(__spreadValues({}, makeRowProps()), makeColProps({
    cols: "auto"
  })),
  setup(props, {
    slots
  }) {
    return () => {
      var _a, _b;
      let _slot;
      const children = flattenFragments((_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : []);
      if (!children.length) {
        return createVNode("div", {
          "class": "ve-spacer"
        }, null);
      }
      const [rowProps] = pick(props, Object.keys(Row.props));
      const [colProps] = pick(props, Object.keys(Col.props));
      return createVNode(Row, mergeProps(rowProps, {
        "class": "ve-spacer"
      }), _isSlot(_slot = children.map((child, index) => createVNode(Col, mergeProps(colProps, {
        "key": index
      }), _isSlot(child) ? child : {
        default: () => [child]
      }))) ? _slot : {
        default: () => [_slot]
      });
    };
  }
});
export { Spacer };
//# sourceMappingURL=spacer.mjs.map
