var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { ref, createVNode, mergeProps } from "vue";
import "./styles/switch.scss";
import { defineComponent } from "../../utils/define-component.mjs";
import { makeSelectionControlProps, SelectionControl } from "../selection-control/selection-control.mjs";
const Switch = defineComponent({
  name: "VeSwitch",
  props: makeSelectionControlProps({
    type: "checkbox",
    color: "primary"
  }),
  emits: {
    "update:modelValue": (_modelValue) => true
  },
  setup(props, {
    emit,
    slots
  }) {
    const control = ref();
    function onClick() {
      var _a, _b;
      (_b = (_a = control.value) == null ? void 0 : _a.inputRef) == null ? void 0 : _b.click();
    }
    return () => {
      return createVNode(SelectionControl, mergeProps({
        "ref": control,
        "class": "ve-switch"
      }, props, {
        "onUpdate:modelValue": (val) => emit("update:modelValue", val)
      }), __spreadProps(__spreadValues({}, slots), {
        default: ({
          textColorClasses,
          textColorStyles
        }) => createVNode("div", {
          "class": ["ve-switch__track", textColorClasses.value],
          "style": [textColorStyles.value],
          "onClick": onClick
        }, null),
        input: () => {
          return createVNode("div", {
            "class": "ve-switch__thumb"
          }, null);
        }
      }));
    };
  }
});
export { Switch };
//# sourceMappingURL=switch.mjs.map
