import type { DefineComponent, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, PropType } from 'vue';
export declare const TableTh: DefineComponent<{
    /**
     * @zh 可排序
     */
    sortable: BooleanConstructor;
    /**
     * @zh 倒序是否倒序
     */
    sortDesc: PropType<boolean | undefined>;
    /**
     * @zh 排序的图标
     */
    sortIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 排序激活时的颜色
     */
    sortActiveColor: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 过滤器的图标
     */
    filterIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 过滤器
     */
    filters: {
        type: ArrayConstructor;
        default: () => never[];
    };
    /**
     * @zh 固定方式
     */
    fixed: PropType<false | "start" | "end">;
    /**
     * @zh 对齐方式
     */
    align: {
        type: PropType<boolean | "start" | "end" | "center">;
        default: string;
    };
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    /**
     * @zh 可排序
     */
    sortable: BooleanConstructor;
    /**
     * @zh 倒序是否倒序
     */
    sortDesc: PropType<boolean | undefined>;
    /**
     * @zh 排序的图标
     */
    sortIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 排序激活时的颜色
     */
    sortActiveColor: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 过滤器的图标
     */
    filterIcon: {
        type: StringConstructor;
        default: string;
    };
    /**
     * @zh 过滤器
     */
    filters: {
        type: ArrayConstructor;
        default: () => never[];
    };
    /**
     * @zh 固定方式
     */
    fixed: PropType<false | "start" | "end">;
    /**
     * @zh 对齐方式
     */
    align: {
        type: PropType<boolean | "start" | "end" | "center">;
        default: string;
    };
}>>, {
    align: boolean | "start" | "end" | "center";
    sortIcon: string;
    sortActiveColor: string;
    filters: unknown[];
    sortable: boolean;
    filterIcon: string;
}>;
export declare function filterTableThProps(attrs: Record<string, unknown>): [yes: Partial<Pick<Record<string, unknown>, string>>, no: Omit<Record<string, unknown>, string>];
export declare type TableTh = InstanceType<typeof TableTh>;
//# sourceMappingURL=table-th.d.ts.map