import type { RouteLocationRaw } from 'vue-router';
import type { DefineComponent, Ref, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, PropType } from 'vue';
export declare const Tab: DefineComponent<{
    theme: StringConstructor;
    value: null;
    disabled: BooleanConstructor;
    selectedClass: {
        type: PropType<string>;
        default: string;
    };
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    tag: {
        type: StringConstructor;
        default: string;
    };
    fixed: BooleanConstructor;
    icon: (BooleanConstructor | StringConstructor)[];
    prependIcon: StringConstructor;
    appendIcon: StringConstructor;
    stacked: BooleanConstructor;
    title: StringConstructor;
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    color: StringConstructor;
    sliderColor: StringConstructor;
    hideSlider: BooleanConstructor;
    direction: {
        type: PropType<"vertical" | "horizontal">;
        default: string;
    };
}, {
    isSelected: Ref<boolean>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    theme: StringConstructor;
    value: null;
    disabled: BooleanConstructor;
    selectedClass: {
        type: PropType<string>;
        default: string;
    };
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    tag: {
        type: StringConstructor;
        default: string;
    };
    fixed: BooleanConstructor;
    icon: (BooleanConstructor | StringConstructor)[];
    prependIcon: StringConstructor;
    appendIcon: StringConstructor;
    stacked: BooleanConstructor;
    title: StringConstructor;
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    color: StringConstructor;
    sliderColor: StringConstructor;
    hideSlider: BooleanConstructor;
    direction: {
        type: PropType<"vertical" | "horizontal">;
        default: string;
    };
}>>, {
    replace: boolean;
    fixed: boolean;
    ripple: boolean;
    disabled: boolean;
    tag: string;
    stacked: boolean;
    selectedClass: string;
    direction: "vertical" | "horizontal";
    hideSlider: boolean;
}>;
export declare type Tab = InstanceType<typeof Tab>;
//# sourceMappingURL=tab.d.ts.map