var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { toRef, createVNode } from "vue";
import "./styles/tag-group.scss";
import { makePaperProps, usePaper } from "../../composables/paper/index.mjs";
import { makeGroupProps, useGroup } from "../../composables/group/index.mjs";
import { provideDefaults } from "../../composables/defaults/index.mjs";
import { deepEqual } from "../../utils/dist/index.mjs";
import { defineComponent } from "../../utils/define-component.mjs";
const TagGroupKey = Symbol.for("veno-ui:chip-group");
const TagGroup = defineComponent({
  name: "VeTagGroup",
  props: __spreadValues(__spreadValues({
    column: Boolean,
    valueComparator: {
      type: Function,
      default: deepEqual
    }
  }, makeGroupProps({
    selectedClass: "ve-tag--active"
  })), makePaperProps({
    variant: "contained-text"
  })),
  emits: {
    "update:modelValue": (_modelValue) => true
  },
  setup(props, {
    slots
  }) {
    const {
      paperClasses,
      paperStyles
    } = usePaper(props);
    const {
      isSelected,
      select,
      next,
      prev,
      selected
    } = useGroup(props, TagGroupKey);
    provideDefaults({
      VeTag: {
        color: toRef(props, "color"),
        size: toRef(props, "size"),
        variant: toRef(props, "variant")
      }
    });
    return () => createVNode(props.tag, {
      "class": ["ve-tag-group", {
        "ve-tag-group--column": props.column
      }, paperClasses.value],
      "style": paperStyles.value
    }, {
      default: () => {
        var _a;
        return [(_a = slots.default) == null ? void 0 : _a.call(slots, {
          isSelected,
          select,
          next,
          prev,
          selected: selected.value
        })];
      }
    });
  }
});
export { TagGroup, TagGroupKey };
//# sourceMappingURL=tag-group.mjs.map
