import type { Size } from '../../composables/size';
import type { RouteLocationRaw } from 'vue-router';
import type { DefineComponent, PropType, TransitionProps, Component, ComputedOptions, MethodOptions, Prop, VNode, RendererNode, RendererElement, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes } from 'vue';
export declare const Tag: DefineComponent<{
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    value: null;
    disabled: BooleanConstructor;
    selectedClass: StringConstructor;
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        /**
         * @zh 追加的头像图片
         */
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    transition: Omit<{
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        })>;
        default: string;
        validator: (val: unknown) => boolean;
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        };
    };
    loading: BooleanConstructor;
    /**
     * @zh 激活时的 class
     */
    activeClass: StringConstructor;
    /**
     * @zh 追加的头像图片
     */
    appendAvatar: StringConstructor;
    /**
     * @zh 追加的图标
     */
    appendIcon: (StringConstructor | ObjectConstructor)[];
    /**
     * @zh 可关闭
     */
    closable: BooleanConstructor;
    /**
     * @zh 关闭图标
     */
    closeIcon: {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    };
    /**
     * @zh 是否显示
     */
    modelValue: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @zh 前置的头像图片
     */
    prependAvatar: StringConstructor;
    /**
     * @zh 前置的图标
     */
    prependIcon: (StringConstructor | ObjectConstructor)[];
    /**
     * @zh 涟漪动画
     */
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @zh 标签文字
     */
    text: StringConstructor;
    /**
     * @zh 是否为链接
     */
    link: BooleanConstructor;
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'click:close': (_event: MouseEvent) => true;
    'update:modelValue': (_modelValue: boolean) => true;
}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    href: StringConstructor;
    replace: BooleanConstructor;
    to: PropType<RouteLocationRaw>;
    value: null;
    disabled: BooleanConstructor;
    selectedClass: StringConstructor;
    elevation: {
        type: (StringConstructor | NumberConstructor)[];
        validator(v: any): boolean;
    };
    shape: Omit<{
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: string;
    }, "default" | "type"> & {
        type: PropType<"tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle">;
        default: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
    };
    border: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    density: {
        type: PropType<"medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined>;
        default: string;
        validator: (v: any) => boolean;
    };
    size: {
        type: PropType<Size | undefined>;
        default: string;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: (StringConstructor | NumberConstructor)[];
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: (StringConstructor | NumberConstructor)[];
    width: (StringConstructor | NumberConstructor)[];
    absolute: BooleanConstructor;
    bottom: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    fixed: BooleanConstructor;
    left: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    position: {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    };
    right: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    top: (BooleanConstructor | StringConstructor | NumberConstructor)[];
    color: StringConstructor;
    textColor: StringConstructor;
    variant: Omit<{
        /**
         * @zh 追加的头像图片
         */
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    };
    theme: StringConstructor;
    tag: Omit<{
        type: StringConstructor;
        default: string;
    }, "default" | "type"> & {
        type: PropType<string>;
        default: string;
    };
    transition: Omit<{
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        })>;
        default: string;
        validator: (val: unknown) => boolean;
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
            }>;
        };
    };
    loading: BooleanConstructor;
    /**
     * @zh 激活时的 class
     */
    activeClass: StringConstructor;
    /**
     * @zh 追加的头像图片
     */
    appendAvatar: StringConstructor;
    /**
     * @zh 追加的图标
     */
    appendIcon: (StringConstructor | ObjectConstructor)[];
    /**
     * @zh 可关闭
     */
    closable: BooleanConstructor;
    /**
     * @zh 关闭图标
     */
    closeIcon: {
        type: (StringConstructor | ObjectConstructor)[];
        default: string;
    };
    /**
     * @zh 是否显示
     */
    modelValue: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @zh 前置的头像图片
     */
    prependAvatar: StringConstructor;
    /**
     * @zh 前置的图标
     */
    prependIcon: (StringConstructor | ObjectConstructor)[];
    /**
     * @zh 涟漪动画
     */
    ripple: {
        type: BooleanConstructor;
        default: boolean;
    };
    /**
     * @zh 标签文字
     */
    text: StringConstructor;
    /**
     * @zh 是否为链接
     */
    link: BooleanConstructor;
}>> & {
    "onUpdate:modelValue"?: ((_modelValue: boolean) => any) | undefined;
    "onClick:close"?: ((_event: MouseEvent) => any) | undefined;
}, {
    modelValue: boolean;
    closable: boolean;
    closeIcon: string | Record<string, any>;
    transition: string | false | (TransitionProps & {
        component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
    }) | {
        readonly component: DefineComponent<{
            group: BooleanConstructor;
            mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }, () => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
            group: BooleanConstructor;
            mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }>>, {
            group: boolean;
        }>;
    };
    replace: boolean;
    fixed: boolean;
    link: boolean;
    loading: boolean;
    ripple: boolean;
    disabled: boolean;
    tag: string;
    variant: "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined";
    absolute: boolean;
    size: Size | undefined;
    density: "medium" | "ultra-low" | "low" | "high" | "ultra-high" | undefined;
    shape: "tile" | "rounded-sm" | "rounded" | "rounded-lg" | "pill" | "circle";
}>;
export declare type Tag = InstanceType<typeof Tag>;
//# sourceMappingURL=tag.d.ts.map