import type { Selector } from '@veno-ui/utils';
import type { ScrollStrategyData } from '../../composables/scroll-strategy';
import type { ComponentInternalInstance, TransitionProps, Component, ComputedOptions, MethodOptions, DefineComponent, VNode, RendererNode, RendererElement, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, PropType, VNodeChild, Ref, Slot, ComponentPublicInstance, ComponentOptionsBase, DebuggerEvent, nextTick, WatchOptions, WatchStopHandle, ShallowUnwrapRef, ComponentCustomProperties } from 'vue';
import type { OverlaySlots } from '../overlay/overlay';
import type { PositionStrategy, Origin } from '../../composables/position-strategy';
import type { Anchor } from '../../utils';
export declare const Tooltip: {
    new (...args: any[]): {
        $: ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            modelValue: boolean;
            transition: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            } | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            };
            anchor: Anchor;
            contained: boolean;
            absolute: boolean;
            maxWidth: string | number;
            minWidth: string | number;
            offset: string | number;
            origin: Origin;
            eager: boolean;
            noClickAnimation: boolean;
            persistent: boolean;
            scrim: string | boolean;
            activatorProps: Record<string, any>;
            openOnClick: boolean;
            openOnHover: boolean;
            openOnFocus: boolean;
            positionStrategy: PositionStrategy;
            scrollStrategy: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
            arrow: boolean;
        }> & Omit<Readonly<ExtractPropTypes<{
            eager: BooleanConstructor;
            transition: Omit<Omit<{
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                })>;
                default: string;
                validator: (val: unknown) => boolean;
            }, "default" | "type"> & {
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                }>;
                default: string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                };
            }, "default" | "type"> & {
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                } | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                }>;
                default: string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                } | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                };
            };
            theme: StringConstructor;
            scrollStrategy: Omit<{
                type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
                default: string;
                validator: (val: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
                default: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
            };
            positionStrategy: Omit<{
                type: PropType<PositionStrategy>;
                default: string;
                validator: (val: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<PositionStrategy>;
                default: PositionStrategy;
            };
            anchor: Omit<{
                type: PropType<Anchor>;
                default: string;
            }, "default" | "type"> & {
                type: PropType<Anchor>;
                default: Anchor;
            };
            origin: Omit<{
                type: PropType<Origin>;
                default: string;
            }, "default" | "type"> & {
                type: PropType<Origin>;
                default: Origin;
            };
            offset: {
                type: PropType<string | number>;
                default: string | number;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: {
                type: PropType<string | number>;
                default: string | number;
            };
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: {
                type: PropType<string | number>;
                default: string | number;
            };
            width: (StringConstructor | NumberConstructor)[];
            closeDelay: (StringConstructor | NumberConstructor)[];
            openDelay: (StringConstructor | NumberConstructor)[];
            activator: PropType<Selector>;
            activatorProps: {
                type: PropType<Record<string, any>>;
                default: () => {}; /**
                 * @zh 工具提示内容
                 */
            };
            openOnClick: Omit<{
                /**
                 * @zh 是否显示箭头
                 */
                type: BooleanConstructor;
                default: undefined;
            }, "default" | "type"> & {
                type: PropType<boolean>;
                default: boolean;
            };
            openOnHover: {
                type: PropType<boolean>;
                default: boolean;
            };
            openOnFocus: {
                type: BooleanConstructor;
                default: undefined;
            };
            modelValue: BooleanConstructor;
            absolute: BooleanConstructor;
            attach: PropType<string | boolean | Element>;
            contained: BooleanConstructor;
            contentStyle: null;
            contentClass: null;
            noClickAnimation: BooleanConstructor;
            persistent: BooleanConstructor;
            scrim: {
                type: (BooleanConstructor | StringConstructor)[];
                default: boolean;
            };
            /**
             * @zh DOM ID
             */
            id: StringConstructor;
            /**
             * @zh 工具提示内容
             */
            text: StringConstructor;
            /**
             * @zh 是否显示箭头
             */
            arrow: {
                type: BooleanConstructor;
                default: boolean;
            };
        } & {
            $children: () => VNodeChild | ((args_0: {
                close: () => void;
                isActive: Ref<boolean>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                default?: VNodeChild | ((args_0: {
                    close: () => void;
                    isActive: Ref<boolean>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                activator?: VNodeChild | ((args_0: {
                    close: () => void;
                    isActive: boolean;
                    props: Record<string, any>;
                    on: Record<string, any>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                default?: false | ((args_0: {
                    close: () => void;
                    isActive: Ref<boolean>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                activator?: false | ((args_0: {
                    close: () => void;
                    isActive: boolean;
                    props: Record<string, any>;
                    on: Record<string, any>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: boolean) => any) | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps, "modelValue" | "transition" | "anchor" | "contained" | "absolute" | "maxWidth" | "minWidth" | "offset" | "origin" | "eager" | "noClickAnimation" | "persistent" | "scrim" | "activatorProps" | "openOnClick" | "openOnHover" | "openOnFocus" | "positionStrategy" | "scrollStrategy" | "arrow">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: Slot | undefined;
        }>;
        $root: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $parent: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null;
        $emit: (event: "update:modelValue", _modelValue: boolean) => void;
        $el: any;
        $options: ComponentOptionsBase<Readonly<ExtractPropTypes<{
            eager: BooleanConstructor;
            transition: Omit<Omit<{
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                })>;
                default: string;
                validator: (val: unknown) => boolean;
            }, "default" | "type"> & {
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                }>;
                default: string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                };
            }, "default" | "type"> & {
                type: PropType<string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                } | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                }>;
                default: string | false | (TransitionProps & {
                    component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
                }) | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                } | {
                    readonly component: DefineComponent<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }, () => VNode<RendererNode, RendererElement, {
                        [key: string]: any;
                    }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                        group: BooleanConstructor;
                        hideOnLeave: BooleanConstructor;
                        leaveAbsolute: BooleanConstructor;
                        mode: {
                            type: StringConstructor;
                            default: string | undefined;
                        };
                        origin: {
                            type: StringConstructor;
                            default: string;
                        };
                        onBeforeEnter: FunctionConstructor;
                        onLeave: FunctionConstructor;
                        onAfterLeave: FunctionConstructor;
                    }>>, {
                        group: boolean;
                        mode: string;
                        hideOnLeave: boolean;
                        leaveAbsolute: boolean;
                        origin: string;
                    }>;
                };
            };
            theme: StringConstructor;
            scrollStrategy: Omit<{
                type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
                default: string;
                validator: (val: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
                default: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
            };
            positionStrategy: Omit<{
                type: PropType<PositionStrategy>;
                default: string;
                validator: (val: any) => boolean;
            }, "default" | "type"> & {
                type: PropType<PositionStrategy>;
                default: PositionStrategy;
            };
            anchor: Omit<{
                type: PropType<Anchor>;
                default: string;
            }, "default" | "type"> & {
                type: PropType<Anchor>;
                default: Anchor;
            };
            origin: Omit<{
                type: PropType<Origin>;
                default: string;
            }, "default" | "type"> & {
                type: PropType<Origin>;
                default: Origin;
            };
            offset: {
                type: PropType<string | number>;
                default: string | number;
            };
            height: (StringConstructor | NumberConstructor)[];
            maxHeight: (StringConstructor | NumberConstructor)[];
            maxWidth: {
                type: PropType<string | number>;
                default: string | number;
            };
            minHeight: (StringConstructor | NumberConstructor)[];
            minWidth: {
                type: PropType<string | number>;
                default: string | number;
            };
            width: (StringConstructor | NumberConstructor)[];
            closeDelay: (StringConstructor | NumberConstructor)[];
            openDelay: (StringConstructor | NumberConstructor)[];
            activator: PropType<Selector>;
            activatorProps: {
                type: PropType<Record<string, any>>;
                default: () => {}; /**
                 * @zh 工具提示内容
                 */
            };
            openOnClick: Omit<{
                /**
                 * @zh 是否显示箭头
                 */
                type: BooleanConstructor;
                default: undefined;
            }, "default" | "type"> & {
                type: PropType<boolean>;
                default: boolean;
            };
            openOnHover: {
                type: PropType<boolean>;
                default: boolean;
            };
            openOnFocus: {
                type: BooleanConstructor;
                default: undefined;
            };
            modelValue: BooleanConstructor;
            absolute: BooleanConstructor;
            attach: PropType<string | boolean | Element>;
            contained: BooleanConstructor;
            contentStyle: null;
            contentClass: null;
            noClickAnimation: BooleanConstructor;
            persistent: BooleanConstructor;
            scrim: {
                type: (BooleanConstructor | StringConstructor)[];
                default: boolean;
            };
            /**
             * @zh DOM ID
             */
            id: StringConstructor;
            /**
             * @zh 工具提示内容
             */
            text: StringConstructor;
            /**
             * @zh 是否显示箭头
             */
            arrow: {
                type: BooleanConstructor;
                default: boolean;
            };
        } & {
            $children: () => VNodeChild | ((args_0: {
                close: () => void;
                isActive: Ref<boolean>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | {
                default?: VNodeChild | ((args_0: {
                    close: () => void;
                    isActive: Ref<boolean>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
                activator?: VNodeChild | ((args_0: {
                    close: () => void;
                    isActive: boolean;
                    props: Record<string, any>;
                    on: Record<string, any>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]);
            };
            'v-slots': new () => {
                default?: false | ((args_0: {
                    close: () => void;
                    isActive: Ref<boolean>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
                activator?: false | ((args_0: {
                    close: () => void;
                    isActive: boolean;
                    props: Record<string, any>;
                    on: Record<string, any>;
                }) => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }> | VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>[]) | undefined;
            };
        }>> & {
            "onUpdate:modelValue"?: ((_modelValue: boolean) => any) | undefined;
        }, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
            'update:modelValue': (_modelValue: boolean) => boolean;
        }, string, {
            modelValue: boolean;
            transition: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            } | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            };
            anchor: Anchor;
            contained: boolean;
            absolute: boolean;
            maxWidth: string | number;
            minWidth: string | number;
            offset: string | number;
            origin: Origin;
            eager: boolean;
            noClickAnimation: boolean;
            persistent: boolean;
            scrim: string | boolean;
            activatorProps: Record<string, any>;
            openOnClick: boolean;
            openOnHover: boolean;
            openOnFocus: boolean;
            positionStrategy: PositionStrategy;
            scrollStrategy: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
            arrow: boolean;
        }> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: DebuggerEvent) => void) | ((e: DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void) | ((err: unknown, instance: ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof nextTick;
        $watch(source: string | Function, cb: Function, options?: WatchOptions<boolean> | undefined): WatchStopHandle;
    } & Readonly<ExtractPropTypes<{
        eager: BooleanConstructor;
        transition: Omit<Omit<{
            type: PropType<string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            })>;
            default: string;
            validator: (val: unknown) => boolean;
        }, "default" | "type"> & {
            type: PropType<string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            }>;
            default: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            };
        }, "default" | "type"> & {
            type: PropType<string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            } | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            }>;
            default: string | false | (TransitionProps & {
                component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
            }) | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            } | {
                readonly component: DefineComponent<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }, () => VNode<RendererNode, RendererElement, {
                    [key: string]: any;
                }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                    group: BooleanConstructor;
                    hideOnLeave: BooleanConstructor;
                    leaveAbsolute: BooleanConstructor;
                    mode: {
                        type: StringConstructor;
                        default: string | undefined;
                    };
                    origin: {
                        type: StringConstructor;
                        default: string;
                    };
                    onBeforeEnter: FunctionConstructor;
                    onLeave: FunctionConstructor;
                    onAfterLeave: FunctionConstructor;
                }>>, {
                    group: boolean;
                    mode: string;
                    hideOnLeave: boolean;
                    leaveAbsolute: boolean;
                    origin: string;
                }>;
            };
        };
        theme: StringConstructor;
        scrollStrategy: Omit<{
            type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
            default: string;
            validator: (val: any) => boolean;
        }, "default" | "type"> & {
            type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
            default: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
        };
        positionStrategy: Omit<{
            type: PropType<PositionStrategy>;
            default: string;
            validator: (val: any) => boolean;
        }, "default" | "type"> & {
            type: PropType<PositionStrategy>;
            default: PositionStrategy;
        };
        anchor: Omit<{
            type: PropType<Anchor>;
            default: string;
        }, "default" | "type"> & {
            type: PropType<Anchor>;
            default: Anchor;
        };
        origin: Omit<{
            type: PropType<Origin>;
            default: string;
        }, "default" | "type"> & {
            type: PropType<Origin>;
            default: Origin;
        };
        offset: {
            type: PropType<string | number>;
            default: string | number;
        };
        height: (StringConstructor | NumberConstructor)[];
        maxHeight: (StringConstructor | NumberConstructor)[];
        maxWidth: {
            type: PropType<string | number>;
            default: string | number;
        };
        minHeight: (StringConstructor | NumberConstructor)[];
        minWidth: {
            type: PropType<string | number>;
            default: string | number;
        };
        width: (StringConstructor | NumberConstructor)[];
        closeDelay: (StringConstructor | NumberConstructor)[];
        openDelay: (StringConstructor | NumberConstructor)[];
        activator: PropType<Selector>;
        activatorProps: {
            type: PropType<Record<string, any>>;
            default: () => {}; /**
             * @zh 工具提示内容
             */
        };
        openOnClick: Omit<{
            /**
             * @zh 是否显示箭头
             */
            type: BooleanConstructor;
            default: undefined;
        }, "default" | "type"> & {
            type: PropType<boolean>;
            default: boolean;
        };
        openOnHover: {
            type: PropType<boolean>;
            default: boolean;
        };
        openOnFocus: {
            type: BooleanConstructor;
            default: undefined;
        };
        modelValue: BooleanConstructor;
        absolute: BooleanConstructor;
        attach: PropType<string | boolean | Element>;
        contained: BooleanConstructor;
        contentStyle: null;
        contentClass: null;
        noClickAnimation: BooleanConstructor;
        persistent: BooleanConstructor;
        scrim: {
            type: (BooleanConstructor | StringConstructor)[];
            default: boolean;
        };
        /**
         * @zh DOM ID
         */
        id: StringConstructor;
        /**
         * @zh 工具提示内容
         */
        text: StringConstructor;
        /**
         * @zh 是否显示箭头
         */
        arrow: {
            type: BooleanConstructor;
            default: boolean;
        };
    } & {
        $children: () => VNodeChild | ((args_0: {
            close: () => void;
            isActive: Ref<boolean>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | {
            default?: VNodeChild | ((args_0: {
                close: () => void;
                isActive: Ref<boolean>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
            activator?: VNodeChild | ((args_0: {
                close: () => void;
                isActive: boolean;
                props: Record<string, any>;
                on: Record<string, any>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]);
        };
        'v-slots': new () => {
            default?: false | ((args_0: {
                close: () => void;
                isActive: Ref<boolean>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
            activator?: false | ((args_0: {
                close: () => void;
                isActive: boolean;
                props: Record<string, any>;
                on: Record<string, any>;
            }) => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }> | VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>[]) | undefined;
        };
    }>> & {
        "onUpdate:modelValue"?: ((_modelValue: boolean) => any) | undefined;
    } & ShallowUnwrapRef<() => JSX.Element> & {} & {} & ComponentCustomProperties;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & ComponentOptionsBase<Readonly<ExtractPropTypes<{
    eager: BooleanConstructor;
    transition: Omit<Omit<{
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        })>;
        default: string;
        validator: (val: unknown) => boolean;
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
                mode: string;
                hideOnLeave: boolean;
                leaveAbsolute: boolean;
                origin: string;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
                mode: string;
                hideOnLeave: boolean;
                leaveAbsolute: boolean;
                origin: string;
            }>;
        };
    }, "default" | "type"> & {
        type: PropType<string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
                mode: string;
                hideOnLeave: boolean;
                leaveAbsolute: boolean;
                origin: string;
            }>;
        } | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
                mode: string;
                hideOnLeave: boolean;
                leaveAbsolute: boolean;
                origin: string;
            }>;
        }>;
        default: string | false | (TransitionProps & {
            component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
        }) | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
                mode: string;
                hideOnLeave: boolean;
                leaveAbsolute: boolean;
                origin: string;
            }>;
        } | {
            readonly component: DefineComponent<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }, () => VNode<RendererNode, RendererElement, {
                [key: string]: any;
            }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
                group: BooleanConstructor;
                hideOnLeave: BooleanConstructor;
                leaveAbsolute: BooleanConstructor;
                mode: {
                    type: StringConstructor;
                    default: string | undefined;
                };
                origin: {
                    type: StringConstructor;
                    default: string;
                };
                onBeforeEnter: FunctionConstructor;
                onLeave: FunctionConstructor;
                onAfterLeave: FunctionConstructor;
            }>>, {
                group: boolean;
                mode: string;
                hideOnLeave: boolean;
                leaveAbsolute: boolean;
                origin: string;
            }>;
        };
    };
    theme: StringConstructor;
    scrollStrategy: Omit<{
        type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
        default: string;
        validator: (val: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void)>;
        default: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
    };
    positionStrategy: Omit<{
        type: PropType<PositionStrategy>;
        default: string;
        validator: (val: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<PositionStrategy>;
        default: PositionStrategy;
    };
    anchor: Omit<{
        type: PropType<Anchor>;
        default: string;
    }, "default" | "type"> & {
        type: PropType<Anchor>;
        default: Anchor;
    };
    origin: Omit<{
        type: PropType<Origin>;
        default: string;
    }, "default" | "type"> & {
        type: PropType<Origin>;
        default: Origin;
    };
    offset: {
        type: PropType<string | number>;
        default: string | number;
    };
    height: (StringConstructor | NumberConstructor)[];
    maxHeight: (StringConstructor | NumberConstructor)[];
    maxWidth: {
        type: PropType<string | number>;
        default: string | number;
    };
    minHeight: (StringConstructor | NumberConstructor)[];
    minWidth: {
        type: PropType<string | number>;
        default: string | number;
    };
    width: (StringConstructor | NumberConstructor)[];
    closeDelay: (StringConstructor | NumberConstructor)[];
    openDelay: (StringConstructor | NumberConstructor)[];
    activator: PropType<Selector>;
    activatorProps: {
        type: PropType<Record<string, any>>;
        default: () => {}; /**
         * @zh 工具提示内容
         */
    };
    openOnClick: Omit<{
        /**
         * @zh 是否显示箭头
         */
        type: BooleanConstructor;
        default: undefined;
    }, "default" | "type"> & {
        type: PropType<boolean>;
        default: boolean;
    };
    openOnHover: {
        type: PropType<boolean>;
        default: boolean;
    };
    openOnFocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    modelValue: BooleanConstructor;
    absolute: BooleanConstructor;
    attach: PropType<string | boolean | Element>;
    contained: BooleanConstructor;
    contentStyle: null;
    contentClass: null;
    noClickAnimation: BooleanConstructor;
    persistent: BooleanConstructor;
    scrim: {
        type: (BooleanConstructor | StringConstructor)[];
        default: boolean;
    };
    /**
     * @zh DOM ID
     */
    id: StringConstructor;
    /**
     * @zh 工具提示内容
     */
    text: StringConstructor;
    /**
     * @zh 是否显示箭头
     */
    arrow: {
        type: BooleanConstructor;
        default: boolean;
    };
} & {
    $children: () => VNodeChild | ((args_0: {
        close: () => void;
        isActive: Ref<boolean>;
    }) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }> | VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>[]) | {
        default?: VNodeChild | ((args_0: {
            close: () => void;
            isActive: Ref<boolean>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
        activator?: VNodeChild | ((args_0: {
            close: () => void;
            isActive: boolean;
            props: Record<string, any>;
            on: Record<string, any>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]);
    };
    'v-slots': new () => {
        default?: false | ((args_0: {
            close: () => void;
            isActive: Ref<boolean>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
        activator?: false | ((args_0: {
            close: () => void;
            isActive: boolean;
            props: Record<string, any>;
            on: Record<string, any>;
        }) => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }> | VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>[]) | undefined;
    };
}>> & {
    "onUpdate:modelValue"?: ((_modelValue: boolean) => any) | undefined;
}, () => JSX.Element, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    'update:modelValue': (_modelValue: boolean) => boolean;
}, string, {
    modelValue: boolean;
    transition: string | false | (TransitionProps & {
        component?: Component<any, any, any, ComputedOptions, MethodOptions> | undefined;
    }) | {
        readonly component: DefineComponent<{
            group: BooleanConstructor;
            hideOnLeave: BooleanConstructor;
            leaveAbsolute: BooleanConstructor;
            mode: {
                type: StringConstructor;
                default: string | undefined;
            };
            origin: {
                type: StringConstructor;
                default: string;
            };
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }, () => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
            group: BooleanConstructor;
            hideOnLeave: BooleanConstructor;
            leaveAbsolute: BooleanConstructor;
            mode: {
                type: StringConstructor;
                default: string | undefined;
            };
            origin: {
                type: StringConstructor;
                default: string;
            };
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }>>, {
            group: boolean;
            mode: string;
            hideOnLeave: boolean;
            leaveAbsolute: boolean;
            origin: string;
        }>;
    } | {
        readonly component: DefineComponent<{
            group: BooleanConstructor;
            hideOnLeave: BooleanConstructor;
            leaveAbsolute: BooleanConstructor;
            mode: {
                type: StringConstructor;
                default: string | undefined;
            };
            origin: {
                type: StringConstructor;
                default: string;
            };
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }, () => VNode<RendererNode, RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
            group: BooleanConstructor;
            hideOnLeave: BooleanConstructor;
            leaveAbsolute: BooleanConstructor;
            mode: {
                type: StringConstructor;
                default: string | undefined;
            };
            origin: {
                type: StringConstructor;
                default: string;
            };
            onBeforeEnter: FunctionConstructor;
            onLeave: FunctionConstructor;
            onAfterLeave: FunctionConstructor;
        }>>, {
            group: boolean;
            mode: string;
            hideOnLeave: boolean;
            leaveAbsolute: boolean;
            origin: string;
        }>;
    };
    anchor: Anchor;
    contained: boolean;
    absolute: boolean;
    maxWidth: string | number;
    minWidth: string | number;
    offset: string | number;
    origin: Origin;
    eager: boolean;
    noClickAnimation: boolean;
    persistent: boolean;
    scrim: string | boolean;
    activatorProps: Record<string, any>;
    openOnClick: boolean;
    openOnHover: boolean;
    openOnFocus: boolean;
    positionStrategy: PositionStrategy;
    scrollStrategy: boolean | "block" | "none" | "close" | "reposition" | ((data: ScrollStrategyData, name: string) => void);
    arrow: boolean;
}> & VNodeProps & AllowedComponentProps & ComponentCustomProps & (new () => {
    $slots: OverlaySlots;
});
export declare type Tooltip = InstanceType<typeof Tooltip>;
//# sourceMappingURL=tooltip.d.ts.map