import type { DefineComponent, VNode, RendererNode, RendererElement, ComponentOptionsMixin, VNodeProps, AllowedComponentProps, ComponentCustomProps, ExtractPropTypes, Prop } from 'vue';
export declare function createCssTransition(name: string, origin?: string, mode?: string): DefineComponent<{
    group: BooleanConstructor;
    hideOnLeave: BooleanConstructor;
    leaveAbsolute: BooleanConstructor;
    mode: {
        type: StringConstructor;
        default: string | undefined;
    };
    origin: {
        type: StringConstructor;
        default: string;
    };
    onBeforeEnter: FunctionConstructor;
    onLeave: FunctionConstructor;
    onAfterLeave: FunctionConstructor;
}, () => VNode<RendererNode, RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    group: BooleanConstructor;
    hideOnLeave: BooleanConstructor;
    leaveAbsolute: BooleanConstructor;
    mode: {
        type: StringConstructor;
        default: string | undefined;
    };
    origin: {
        type: StringConstructor;
        default: string;
    };
    onBeforeEnter: FunctionConstructor;
    onLeave: FunctionConstructor;
    onAfterLeave: FunctionConstructor;
}>>, {
    group: boolean;
    mode: string;
    hideOnLeave: boolean;
    leaveAbsolute: boolean;
    origin: string;
}>;
export declare function createJavascriptTransition(name: string, functions: Record<string, any>, mode?: string): DefineComponent<{
    group: BooleanConstructor;
    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
    onBeforeEnter: FunctionConstructor;
    onLeave: FunctionConstructor;
    onAfterLeave: FunctionConstructor;
}, () => VNode<RendererNode, RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, Record<string, any>, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    group: BooleanConstructor;
    mode: Prop<"default" | "in-out" | "out-in", "default" | "in-out" | "out-in">;
    onBeforeEnter: FunctionConstructor;
    onLeave: FunctionConstructor;
    onAfterLeave: FunctionConstructor;
}>>, {
    group: boolean;
}>;
//# sourceMappingURL=create-transition.d.ts.map