import { computed, unref } from "vue";
import { propsFactory, getCurrentInstanceName } from "../../utils/dist/index.mjs";
const makeBorderProps = propsFactory({
  border: [Boolean, Number, String]
}, "border");
function useBorder(props, name = getCurrentInstanceName()) {
  const borderClasses = computed(() => {
    const { border } = unref(props);
    const classes = [];
    if (border === true) {
      classes.push(`${name}--border`);
    } else if (typeof border === "string" && border !== "" || border === 0) {
      for (const value of String(border).split(" ")) {
        classes.push(`border-${value}`);
      }
    }
    return classes;
  });
  return {
    borderClasses
  };
}
export { makeBorderProps, useBorder };
//# sourceMappingURL=index.mjs.map
