var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { reactive, computed } from "vue";
import { propsFactory, sortItems, getCurrentInstance, wrapInArray, deepEqual } from "../../utils/dist/index.mjs";
import { useProxiedModel } from "../proxied-model/index.mjs";
const defaultPagination = {
  page: 1,
  perPage: 10,
  perPageOptions: [10, 20, 50, 100],
  total: 0,
  totalVisible: 7,
  showQuickJumper: false,
  showPerPageSelect: false
};
const makeDataIteratorProps = propsFactory({
  remote: Boolean,
  items: {
    type: Array,
    default: () => []
  },
  mustSort: Boolean,
  multiSort: Boolean,
  sortBy: {
    type: [String, Array],
    default: () => []
  },
  sortDesc: {
    type: [Boolean, Array],
    default: () => []
  },
  customSort: {
    type: Function,
    default: sortItems
  },
  locale: {
    type: String,
    default: "en-US"
  },
  pagination: {
    type: Object,
    defualt: () => __spreadValues({}, defaultPagination)
  }
}, "data-iterator");
function toggle(key, oldBy, oldDesc, page, mustSort, multiSort) {
  let by = oldBy.slice();
  let desc = oldDesc.slice();
  const byIndex = by.findIndex((k) => k === key);
  if (byIndex < 0) {
    if (!multiSort) {
      by = [];
      desc = [];
    }
    by.push(key);
    desc.push(false);
  } else if (byIndex >= 0 && !desc[byIndex]) {
    desc[byIndex] = true;
  } else if (!mustSort) {
    by.splice(byIndex, 1);
    desc.splice(byIndex, 1);
  } else {
    desc[byIndex] = false;
  }
  if (!deepEqual(by, oldBy) || !deepEqual(desc, oldDesc)) {
    page = 1;
  }
  return { by, desc, page };
}
function useDataIterator(props) {
  const vm = getCurrentInstance("useDataIterator");
  const pagination = useProxiedModel(props, "pagination", props.pagination, (val) => {
    var _a;
    const pagination2 = __spreadValues(__spreadValues({}, defaultPagination), val);
    return reactive(__spreadProps(__spreadValues({}, pagination2), {
      page: Number(pagination2.page),
      perPage: Number(pagination2.perPage),
      total: props.remote ? Number((_a = pagination2.total) != null ? _a : props.items.length) : props.items.length
    }));
  });
  const sortBy = useProxiedModel(props, "sortBy");
  const sortDesc = useProxiedModel(props, "sortDesc");
  function updateOptions() {
    vm.emit("update:options", {
      pagination: pagination.value,
      sortBy: sortBy.value,
      sortDesc: sortDesc.value
    });
  }
  function sortItems2(items2) {
    return props.customSort(items2, wrapInArray(sortBy.value), wrapInArray(sortDesc.value), props.locale);
  }
  function paginateItems(items2) {
    return items2.slice((pagination.value.page - 1) * pagination.value.perPage, Math.min(pagination.value.total, pagination.value.page * pagination.value.perPage));
  }
  const items = computed(() => {
    if (props.remote)
      return props.items;
    let items2 = props.items.slice();
    items2 = sortItems2(items2);
    items2 = paginateItems(items2);
    return items2;
  });
  function sort(key) {
    var _a, _b;
    if (Array.isArray(key)) {
      const options = {
        sortBy: key,
        sortDesc: key.map((s) => {
          const i = wrapInArray(sortBy.value).findIndex((k) => k === s);
          return i > -1 ? wrapInArray(sortDesc.value)[i] : false;
        }),
        pagination: __spreadValues({}, pagination.value)
      };
      sortBy.value = options.sortBy;
      sortDesc.value = options.sortDesc;
      vm.emit("update:options", options);
    } else {
      const { by, desc, page } = toggle(key, wrapInArray(sortBy.value), wrapInArray(sortDesc.value), pagination.value.page, props.mustSort, props.multiSort);
      const options = {
        sortBy: props.multiSort ? by : (_a = by[0]) != null ? _a : null,
        sortDesc: props.multiSort ? desc : (_b = desc[0]) != null ? _b : null,
        pagination: __spreadProps(__spreadValues({}, pagination.value), {
          page
        })
      };
      sortBy.value = options.sortBy;
      sortDesc.value = options.sortDesc;
      pagination.value.page = options.pagination.page;
      vm.emit("update:options", options);
    }
  }
  return {
    items,
    pagination,
    sortBy,
    sortDesc,
    sort,
    updateOptions
  };
}
export { makeDataIteratorProps, useDataIterator };
//# sourceMappingURL=index.mjs.map
