import type { PropType, ComputedRef } from 'vue';
export declare const deviceModels: Record<string, DeviceModel>;
export interface DeviceModel {
    width: number | string;
    height: number | string;
    statusBarHeight: number;
}
export interface DeviceProps {
    model?: string;
    autoHeight: boolean;
}
export declare const makeDeviceProps: <Defaults extends {
    model?: unknown;
    autoHeight?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    model: unknown extends Defaults["model"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["model"] ? string : string | Defaults["model"]>;
        default: unknown extends Defaults["model"] ? string : string | Defaults["model"];
    };
    autoHeight: unknown extends Defaults["autoHeight"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["autoHeight"] ? boolean : boolean | Defaults["autoHeight"]>;
        default: unknown extends Defaults["autoHeight"] ? boolean : boolean | Defaults["autoHeight"];
    };
};
export declare function useDevice(props: DeviceProps): {
    deviceModel: ComputedRef<DeviceModel>;
    deviceStyles: ComputedRef<{
        width: string | undefined;
        height: string | null | undefined;
        minHeight: string | null | undefined;
    }>;
};
//# sourceMappingURL=index.d.ts.map