const aliases = {
  sh: "bash",
  shell: "bash",
  vue: "markup",
  html: "markup",
  md: "markdown",
  ts: "typescript",
  js: "javascript"
};
async function prismjsHighlightCode(prismjs, code, language) {
  language = language.toLowerCase();
  if (language in aliases) {
    language = aliases[language];
  }
  if (!prismjs.languages[language]) {
    console.warn(`[VenoUi] Syntax highlight for language "${language}" is not supported. try "import 'prismjs/components/prism-${language}.js'" .`);
    return code;
  }
  return prismjs.highlight(code, prismjs.languages[language], language);
}
export { prismjsHighlightCode };
//# sourceMappingURL=prismjs.mjs.map
