const aliases = {
  template: "vue-html"
};
async function shikiHighlightCode(shiki, code, language) {
  language = language.toLowerCase();
  if (language in aliases) {
    language = aliases[language];
  }
  const highlighter = await shiki;
  try {
    await highlighter.loadLanguage(language);
    return highlighter.codeToHtml(code, language).replace(/[\s\S]*code>([\s\S]*)<\/code[\s\S]*/, "$1");
  } catch (e) {
    console.warn(`[VenoUi] Syntax highlight for language "${language}" error: ${e}" .`);
    return code;
  }
}
export { shikiHighlightCode };
//# sourceMappingURL=shiki.mjs.map
