import type { makeIconProps } from './make-icon-props';
import type { ComputedRef, ExtractPropTypes } from 'vue';
import type { IconSetComponent, IconValue } from '../icons';
import type { MaybeRef } from '../../utils';
/**
 * @zh 使用图标
 *
 * @example
 * useIcons({ icon: '$info' })
 * useIcons({ icon: 'mdi:info' })
 * useIcons({ icon: 'svg:xxx' })
 * useIcons({ icon: 'class:xxx' })
 *
 * @param props
 */
export declare const useIcon: (props: MaybeRef<ExtractPropTypes<ReturnType<typeof makeIconProps>>>) => {
    iconData: ComputedRef<{
        component: IconSetComponent;
        icon: IconValue;
    } | undefined>;
};
//# sourceMappingURL=use-icon.d.ts.map