import { inject } from "vue";
import { deepMerge } from "../../utils/dist/index.mjs";
import { createSymbol } from "../../utils/symbol.mjs";
import { mdi, aliases } from "../../iconsets/mdi.mjs";
import { IconClass } from "../../components/icon/icon-class.mjs";
import { IconSvg } from "../../components/icon/icon-svg.mjs";
import { IconLigature } from "../../components/icon/icon-ligature.mjs";
const IconsKey = createSymbol("icons");
function useIcons() {
  const icons = inject(IconsKey);
  if (!icons)
    throw new Error("[VenoUi] Could not find icons instance");
  return icons;
}
function createIcons(options) {
  return deepMerge({
    defaultSet: "mdi",
    sets: {
      mdi,
      svg: IconSvg,
      class: IconClass,
      ligature: IconLigature
    },
    aliases
  }, options || {});
}
export { IconsKey, createIcons, useIcons };
//# sourceMappingURL=icons.mjs.map
