var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { ref, computed, onDeactivated, onActivated, onBeforeUnmount } from "vue";
import { propsFactory, getUid, getCurrentInstance } from "../../utils/dist/index.mjs";
import { useLayout } from "./layout.mjs";
const makeLayoutItemProps = propsFactory({
  modelValue: {
    type: Boolean,
    default: true
  },
  name: String,
  position: {
    type: String,
    default: "absolute"
  },
  anchor: {
    type: String,
    default: "left"
  },
  priority: {
    type: [String, Number],
    default: 0
  }
}, "layout-item");
function useLayoutItem(props) {
  var _a;
  const layout = useLayout();
  const id = (_a = props.value.name) != null ? _a : `layout-item-${getUid()}`;
  const vm = getCurrentInstance("useLayoutItem");
  const isKeptAlive = ref(false);
  const {
    layoutItemStyles,
    layoutItemScrimStyles
  } = layout.register(vm, id, computed(() => __spreadProps(__spreadValues({}, props.value), {
    active: !isKeptAlive.value && props.value.active
  })));
  onDeactivated(() => isKeptAlive.value = true);
  onActivated(() => isKeptAlive.value = false);
  onBeforeUnmount(() => layout.unregister(id));
  return {
    layoutItemStyles,
    layoutRect: layout.layoutRect,
    layoutItemScrimStyles
  };
}
export { makeLayoutItemProps, useLayoutItem };
//# sourceMappingURL=layout-item.mjs.map
