var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed } from "vue";
import { propsFactory, getCurrentInstanceName } from "../../utils/dist/index.mjs";
import { makeTagProps } from "../tag/index.mjs";
import { makeThemeProps, provideTheme } from "../theme/index.mjs";
import { makeVariantProps, useVariant } from "../variant/index.mjs";
export { genOverlays } from "../variant/index.mjs";
import { makePositionProps, usePosition } from "../position/index.mjs";
import { makeDimensionProps, useDimension } from "../dimension/index.mjs";
import { makeSizeProps, useSize } from "../size/index.mjs";
import { makeDensityProps, useDensity } from "../density/index.mjs";
import { makeBorderProps, useBorder } from "../border/index.mjs";
import { makeShapeProps, useShape } from "../shape/index.mjs";
import { makeElevationProps, useElevation } from "../elevation/index.mjs";
const makePaperProps = propsFactory(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({}, makeTagProps()), makeThemeProps()), makeVariantProps()), makePositionProps()), makeDimensionProps()), makeSizeProps()), makeDensityProps()), makeBorderProps()), makeShapeProps()), makeElevationProps()), "paper");
function usePaper(props, name = getCurrentInstanceName()) {
  const { themeClasses } = provideTheme(props);
  const { colorClasses, variantClasses, colorStyles } = useVariant(props, name);
  const { positionClasses, positionStyles } = usePosition(props, name);
  const { dimensionStyles } = useDimension(props);
  const { sizeClasses, sizeStyles } = useSize(props, name);
  const { densityClasses } = useDensity(props, name);
  const { borderClasses } = useBorder(props, name);
  const { shapeClasses } = useShape(props, name);
  const { elevationClasses } = useElevation(props);
  const paperClasses = computed(() => [
    themeClasses.value,
    colorClasses.value,
    variantClasses.value,
    positionClasses.value,
    sizeClasses.value,
    densityClasses.value,
    borderClasses.value,
    shapeClasses.value,
    elevationClasses.value
  ]);
  const paperStyles = computed(() => [
    colorStyles.value,
    positionStyles.value,
    dimensionStyles.value,
    sizeStyles.value
  ]);
  return {
    paperClasses,
    paperStyles
  };
}
export { makePaperProps, usePaper };
//# sourceMappingURL=index.mjs.map
