import type { ComputedRef, ExtractPropTypes,  PropType } from 'vue';
import type { MaybeRef } from '../../utils';
export declare const POSITIONS: readonly ["static", "relative", "fixed", "absolute", "sticky"];
export declare type PositionProps = ExtractPropTypes<ReturnType<typeof makePositionProps>>;
export declare const makePositionProps: <Defaults extends {
    absolute?: unknown;
    bottom?: unknown;
    fixed?: unknown;
    left?: unknown;
    position?: unknown;
    right?: unknown;
    top?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    absolute: unknown extends Defaults["absolute"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["absolute"] ? boolean : boolean | Defaults["absolute"]>;
        default: unknown extends Defaults["absolute"] ? boolean : boolean | Defaults["absolute"];
    };
    bottom: unknown extends Defaults["bottom"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["bottom"] ? string | number | boolean : string | number | boolean | Defaults["bottom"]>;
        default: unknown extends Defaults["bottom"] ? string | number | boolean : string | number | boolean | Defaults["bottom"];
    };
    fixed: unknown extends Defaults["fixed"] ? BooleanConstructor : {
        type: PropType<unknown extends Defaults["fixed"] ? boolean : boolean | Defaults["fixed"]>;
        default: unknown extends Defaults["fixed"] ? boolean : boolean | Defaults["fixed"];
    };
    left: unknown extends Defaults["left"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["left"] ? string | number | boolean : string | number | boolean | Defaults["left"]>;
        default: unknown extends Defaults["left"] ? string | number | boolean : string | number | boolean | Defaults["left"];
    };
    position: unknown extends Defaults["position"] ? {
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    } : Omit<{
        type: PropType<"fixed" | "absolute" | "static" | "relative" | "sticky">;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["position"] ? "fixed" | "absolute" | "static" | "relative" | "sticky" : "fixed" | "absolute" | "static" | "relative" | "sticky" | Defaults["position"]>;
        default: unknown extends Defaults["position"] ? "fixed" | "absolute" | "static" | "relative" | "sticky" : "fixed" | "absolute" | "static" | "relative" | "sticky" | Defaults["position"];
    };
    right: unknown extends Defaults["right"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["right"] ? string | number | boolean : string | number | boolean | Defaults["right"]>;
        default: unknown extends Defaults["right"] ? string | number | boolean : string | number | boolean | Defaults["right"];
    };
    top: unknown extends Defaults["top"] ? (BooleanConstructor | StringConstructor | NumberConstructor)[] : {
        type: PropType<unknown extends Defaults["top"] ? string | number | boolean : string | number | boolean | Defaults["top"]>;
        default: unknown extends Defaults["top"] ? string | number | boolean : string | number | boolean | Defaults["top"];
    };
};
export declare function usePosition(props: MaybeRef<PositionProps>, name?: string): {
    positionClasses: ComputedRef<string | null>;
    positionStyles: ComputedRef<Partial<Record<"bottom" | "left" | "right" | "top", string>>>;
};
//# sourceMappingURL=index.d.ts.map