var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { inject, shallowRef, createVNode } from "vue";
const ProvidersKey = Symbol.for("veno-ui:providers");
function createProviders(app, options) {
  const providers = shallowRef(__spreadValues({}, options));
  Object.values(providers.value).forEach((provider) => {
    var _a;
    (_a = provider.register) == null ? void 0 : _a.call(provider, app);
  });
  function createRootProvider() {
    return Object.values(providers.value).reduce((Prev, Cur) => {
      return (props, {
        slots
      }) => createVNode(Prev, {
        "registered": true
      }, {
        default: () => [createVNode(Cur, {
          "registered": true
        }, {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
          }
        })]
      });
    }, (props, {
      slots
    }) => {
      var _a;
      return (_a = slots.default) == null ? void 0 : _a.call(slots);
    });
  }
  function get(key) {
    return providers.value[key];
  }
  function set(key, value) {
    providers.value[key] = value;
  }
  return {
    providers,
    get,
    set,
    createRootProvider
  };
}
function useProviders() {
  const providers = inject(ProvidersKey);
  if (!providers)
    throw new Error("Could not find Veno UI providers injection");
  return providers;
}
export { ProvidersKey, createProviders, useProviders };
//# sourceMappingURL=index.mjs.map
