import { computed, unref } from "vue";
import { propsFactory, getCurrentInstanceName } from "../../utils/dist/index.mjs";
const SHAPES = [
  "tile",
  "rounded-sm",
  "rounded",
  "rounded-lg",
  "pill",
  "circle"
];
const makeShapeProps = propsFactory({
  shape: {
    type: String,
    default: "tile"
  }
}, "shape");
function useShape(props, name = getCurrentInstanceName()) {
  const shapeClasses = computed(() => {
    const { shape } = unref(props);
    if (!shape || !SHAPES.includes(shape))
      return null;
    return `${name}--shape-${shape}`;
  });
  return {
    shapeClasses
  };
}
export { SHAPES, makeShapeProps, useShape };
//# sourceMappingURL=index.mjs.map
