import type { ComputedRef, ExtractPropTypes,  PropType } from 'vue';
import type { MaybeRef } from '../../utils';
export declare const SIZES: string[];
export declare type Size = string | number | typeof SIZES[number];
export declare type SizeProps = ExtractPropTypes<ReturnType<typeof makeSizeProps>>;
export declare const makeSizeProps: <Defaults extends {
    size?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    size: unknown extends Defaults["size"] ? {
        type: PropType<Size | undefined>;
        default: string;
    } : Omit<{
        type: PropType<Size | undefined>;
        default: string;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["size"] ? Size | undefined : Size | Defaults["size"]>;
        default: unknown extends Defaults["size"] ? Size | undefined : Size | Defaults["size"];
    };
};
export declare function useSize(props: MaybeRef<SizeProps>, name?: string): {
    sizeClasses: ComputedRef<string | null>;
    sizeStyles: ComputedRef<{
        width?: undefined;
        height?: undefined;
    } | {
        width: string | undefined;
        height: string | undefined;
    }>;
};
//# sourceMappingURL=index.d.ts.map