import type { ComputedRef, CSSProperties, ExtractPropTypes,  PropType } from 'vue';
import type { MaybeRef } from '../../utils';
export declare type VariantProps = ExtractPropTypes<ReturnType<typeof makeVariantProps>>;
export declare const VARIANTS: readonly ["contained", "outlined", "plain", "text", "contained-text", "contained-outlined"];
export declare function genOverlays(isClickable: boolean, name: string): JSX.Element;
export declare const makeVariantProps: <Defaults extends {
    color?: unknown;
    textColor?: unknown;
    variant?: unknown;
} = {}>(defaults?: Defaults | undefined) => {
    color: unknown extends Defaults["color"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["color"] ? string : string | Defaults["color"]>;
        default: unknown extends Defaults["color"] ? string : string | Defaults["color"];
    };
    textColor: unknown extends Defaults["textColor"] ? StringConstructor : {
        type: PropType<unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"]>;
        default: unknown extends Defaults["textColor"] ? string : string | Defaults["textColor"];
    };
    variant: unknown extends Defaults["variant"] ? {
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    } : Omit<{
        type: PropType<"text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined">;
        default: string;
        validator: (v: any) => boolean;
    }, "default" | "type"> & {
        type: PropType<unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"]>;
        default: unknown extends Defaults["variant"] ? "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" : "text" | "contained" | "outlined" | "plain" | "contained-text" | "contained-outlined" | Defaults["variant"];
    };
};
export declare function useVariant(props: MaybeRef<VariantProps>, name?: string): {
    colorClasses: ComputedRef<string[]>;
    colorStyles: ComputedRef<CSSProperties>;
    variantClasses: ComputedRef<string[]>;
};
//# sourceMappingURL=index.d.ts.map