function mounted(el, binding) {
  var _a, _b;
  const handler = binding.value;
  const options = {
    passive: !((_a = binding.modifiers) == null ? void 0 : _a.active)
  };
  window.addEventListener("resize", handler, options);
  el._onResize = {
    handler,
    options
  };
  if (!((_b = binding.modifiers) == null ? void 0 : _b.quiet)) {
    handler();
  }
}
function unmounted(el) {
  if (!el._onResize)
    return;
  const { handler, options } = el._onResize;
  window.removeEventListener("resize", handler, options);
  delete el._onResize;
}
const Resize = {
  mounted,
  unmounted
};
export { Resize, Resize as default };
//# sourceMappingURL=index.mjs.map
