import { toKebabCase, toPascalCase } from "./utils/dist/index.mjs";
import "vue";
function VenoUiResolver(options = {}) {
  const {
    prefix: rawPrefix = "ve"
  } = options;
  const prefix = rawPrefix ? `${toKebabCase(rawPrefix)}-` : "";
  return [
    {
      type: "component",
      resolve: (name) => {
        const kebab = toKebabCase(name);
        if (!kebab.startsWith(prefix))
          return;
        const slice = kebab.slice(prefix.length);
        return {
          name: toPascalCase(slice),
          from: "veno-ui/components"
        };
      }
    }
  ];
}
export { VenoUiResolver };
//# sourceMappingURL=resolver.mjs.map
