var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("vue")) : typeof define === "function" && define.amd ? define(["exports", "vue"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global.VenoUi = {}, global.Vue));
})(this, function(exports2, vue) {
  "use strict";
  var main$1 = "";
  var alert = "";
  function wrapInArray(val) {
    return val == null ? [] : Array.isArray(val) ? val : [val];
  }
  function arrayDiff(a, b) {
    const diff = [];
    for (let i = 0; i < b.length; i++) {
      if (!a.includes(b[i]))
        diff.push(b[i]);
    }
    return diff;
  }
  function fillArray(length, fillable) {
    return Array(length).fill(fillable);
  }
  function createRange(length, start = 0) {
    return Array.from({ length }, (v, k) => start + k);
  }
  function parseAnchor(anchor2) {
    let [side, align] = anchor2.split(" ");
    if (!align) {
      align = side === "top" || side === "bottom" ? "start" : side === "start" || side === "end" ? "top" : "center";
    }
    return {
      side,
      align
    };
  }
  function oppositeAnchor(anchor2) {
    return {
      side: {
        center: "center",
        top: "bottom",
        bottom: "top",
        start: "end",
        end: "start"
      }[anchor2.side],
      align: anchor2.align
    };
  }
  function physicalAnchor(anchor2, el) {
    var _a, _b;
    const { side, align } = anchor2;
    const { direction } = window.getComputedStyle(el);
    const map = direction === "ltr" ? { start: "left", end: "right" } : { start: "right", end: "left" };
    return `${(_a = map[side]) != null ? _a : side} ${(_b = map[align]) != null ? _b : align}`;
  }
  class Box {
    constructor({ x, y, width, height }) {
      this.x = x;
      this.y = y;
      this.width = width;
      this.height = height;
    }
    get top() {
      return this.y;
    }
    get bottom() {
      return this.y + this.height;
    }
    get left() {
      return this.x;
    }
    get right() {
      return this.x + this.width;
    }
  }
  function nullifyTransforms(el) {
    const rect = el.getBoundingClientRect();
    const style = getComputedStyle(el);
    const tx = style.transform;
    if (tx) {
      let ta, sx, sy, dx, dy;
      if (tx.startsWith("matrix3d(")) {
        ta = tx.slice(9, -1).split(/, /);
        sx = +ta[0];
        sy = +ta[5];
        dx = +ta[12];
        dy = +ta[13];
      } else if (tx.startsWith("matrix(")) {
        ta = tx.slice(7, -1).split(/, /);
        sx = +ta[0];
        sy = +ta[3];
        dx = +ta[4];
        dy = +ta[5];
      } else {
        return new Box(rect);
      }
      const to = style.transformOrigin;
      const x = rect.x - dx - (1 - sx) * parseFloat(to);
      const y = rect.y - dy - (1 - sy) * parseFloat(to.slice(to.indexOf(" ") + 1));
      const w = sx ? rect.width / sx : el.offsetWidth;
      const h = sy ? rect.height / sy : el.offsetHeight;
      return new Box({ x, y, width: w, height: h });
    } else {
      return new Box(rect);
    }
  }
  function isObject(objectable) {
    return objectable !== null && typeof objectable === "object" && !Array.isArray(objectable);
  }
  function keys(obj) {
    return Object.keys(obj);
  }
  function getNestedValue(obj, path, fallback) {
    const last = path.length - 1;
    if (last < 0)
      return obj === void 0 ? fallback : obj;
    for (let i = 0; i < last; i++) {
      if (obj == null) {
        return fallback;
      }
      obj = obj[path[i]];
    }
    if (obj == null)
      return fallback;
    return obj[path[last]] === void 0 ? fallback : obj[path[last]];
  }
  function setNestedValue(obj, path, value) {
    const last = path.length - 1;
    for (let i = 0; i < last; i++) {
      if (typeof obj[path[i]] !== "object")
        obj[path[i]] = {};
      obj = obj[path[i]];
    }
    obj[path[last]] = value;
  }
  function filterObjectOnKeys(obj, keys2) {
    const filtered = {};
    for (let i = 0; i < keys2.length; i++) {
      const key = keys2[i];
      if (typeof obj[key] !== "undefined") {
        filtered[key] = obj[key];
      }
    }
    return filtered;
  }
  function getObjectValueByPath(obj, path, fallback) {
    if (obj == null || !path || typeof path !== "string")
      return fallback;
    if (obj[path] !== void 0)
      return obj[path];
    path = path.replace(/\[(\w+)\]/g, ".$1");
    path = path.replace(/^\./, "");
    return getNestedValue(obj, path.split("."), fallback);
  }
  function setObjectValueByPath(obj, path, value) {
    if (typeof obj !== "object" || !path)
      return;
    path = path.replace(/\[(\w+)\]/g, ".$1");
    path = path.replace(/^\./, "");
    return setNestedValue(obj, path.split("."), value);
  }
  function getPropertyFromItem(item, property, fallback) {
    if (property == null)
      return item === void 0 ? fallback : item;
    if (item !== Object(item))
      return fallback === void 0 ? item : fallback;
    if (typeof property === "string")
      return getObjectValueByPath(item, property, fallback);
    if (Array.isArray(property))
      return getNestedValue(item, property, fallback);
    if (typeof property !== "function")
      return fallback;
    const value = property(item, fallback);
    return typeof value === "undefined" ? fallback : value;
  }
  function deepMerge(source = {}, target = {}, out = {}) {
    for (const key in source) {
      out[key] = source[key];
    }
    for (const key in target) {
      const sourceProperty = source[key];
      const targetProperty = target[key];
      if (isObject(sourceProperty) && isObject(targetProperty)) {
        out[key] = deepMerge(sourceProperty, targetProperty);
        continue;
      }
      out[key] = targetProperty;
    }
    return out;
  }
  var __accessCheck = (obj, member, msg) => {
    if (!member.has(obj))
      throw TypeError("Cannot " + msg);
  };
  var __privateGet = (obj, member, getter) => {
    __accessCheck(obj, member, "read from private field");
    return getter ? getter.call(obj) : member.get(obj);
  };
  var __privateAdd = (obj, member, value) => {
    if (member.has(obj))
      throw TypeError("Cannot add the same private member more than once");
    member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
  };
  var __privateSet = (obj, member, value, setter) => {
    __accessCheck(obj, member, "write to private field");
    setter ? setter.call(obj, value) : member.set(obj, value);
    return value;
  };
  var _arr, _pointer;
  function deepEqual(a, b) {
    if (a === b)
      return true;
    if (a instanceof Date && b instanceof Date && a.getTime() !== b.getTime()) {
      return false;
    }
    if (a !== Object(a) || b !== Object(b)) {
      return false;
    }
    const props = Object.keys(a);
    if (props.length !== Object.keys(b).length) {
      return false;
    }
    return props.every((p2) => deepEqual(a[p2], b[p2]));
  }
  function getZIndex(el) {
    if (!el || el.nodeType !== Node.ELEMENT_NODE)
      return 0;
    const index2 = +window.getComputedStyle(el).getPropertyValue("z-index");
    if (!index2)
      return getZIndex(el.parentNode);
    return index2;
  }
  function convertToUnit(str, unit = "px") {
    if (str == null || str === "") {
      return void 0;
    } else if (isNaN(+str)) {
      return String(str);
    } else if (!isFinite(+str)) {
      return void 0;
    } else {
      return `${Number(str)}${unit}`;
    }
  }
  function isComponentInstance(obj) {
    return obj == null ? void 0 : obj.$el;
  }
  function groupItems(items, groupBy, _groupDesc) {
    const key = groupBy[0];
    const groups = [];
    let current;
    for (let i = 0; i < items.length; i++) {
      const item = items[i];
      const val = getObjectValueByPath(item, key, null);
      if (current !== val) {
        current = val;
        groups.push({
          name: val != null ? val : "",
          items: []
        });
      }
      groups[groups.length - 1].items.push(item);
    }
    return groups;
  }
  function sortItems(items, sortBy, sortDesc, locale, customSorters) {
    if (sortBy === null || !sortBy.length)
      return items;
    const stringCollator = new Intl.Collator(locale, { sensitivity: "accent", usage: "sort" });
    return items.sort((a, b) => {
      for (let i = 0; i < sortBy.length; i++) {
        const sortKey = sortBy[i];
        let sortA = getObjectValueByPath(a, sortKey);
        let sortB = getObjectValueByPath(b, sortKey);
        if (sortDesc[i]) {
          [sortA, sortB] = [sortB, sortA];
        }
        if (customSorters == null ? void 0 : customSorters[sortKey]) {
          const customResult = customSorters[sortKey](sortA, sortB);
          if (!customResult)
            continue;
          return customResult;
        }
        if (sortA === null && sortB === null) {
          continue;
        }
        if (sortA instanceof Date && sortB instanceof Date) {
          return sortA.getTime() - sortB.getTime();
        }
        [sortA, sortB] = [sortA, sortB].map((s) => (s || "").toString().toLocaleLowerCase());
        if (sortA !== sortB) {
          if (!isNaN(sortA) && !isNaN(sortB))
            return Number(sortA) - Number(sortB);
          return stringCollator.compare(sortA, sortB);
        }
      }
      return 0;
    });
  }
  function defaultFilter$1(value, search, _item) {
    return value != null && search != null && typeof value !== "boolean" && value.toString().toLocaleLowerCase().includes(search.toLocaleLowerCase());
  }
  function searchItems(items, search) {
    if (!search)
      return items;
    search = search.toString().toLowerCase();
    if (search.trim() === "")
      return items;
    return items.filter((item) => Object.keys(item).some((key) => defaultFilter$1(getObjectValueByPath(item, key), search)));
  }
  function debounce(fn, delay) {
    let timeoutId = 0;
    return (...args) => {
      clearTimeout(timeoutId);
      timeoutId = setTimeout(() => fn(...args), delay);
    };
  }
  function throttle(fn, limit) {
    let throttling = false;
    return (...args) => {
      if (!throttling) {
        throttling = true;
        setTimeout(() => throttling = false, limit);
        return fn(...args);
      }
    };
  }
  function getPrefixedSlots(prefix, slots) {
    return Object.keys(slots).filter((k) => k.startsWith(prefix)).reduce((obj, k) => {
      obj[k.replace(prefix, "")] = slots[k];
      return obj;
    }, {});
  }
  function clamp(value, min = 0, max = 1) {
    return Math.max(min, Math.min(max, value));
  }
  function padEnd(str, length, char = "0") {
    return str + char.repeat(Math.max(0, length - str.length));
  }
  function chunk(str, size = 1) {
    const chunked = [];
    let index2 = 0;
    while (index2 < str.length) {
      chunked.push(str.substr(index2, size));
      index2 += size;
    }
    return chunked;
  }
  function humanReadableFileSize(bytes, base = 1e3) {
    if (bytes < base) {
      return `${bytes} B`;
    }
    const prefix = base === 1024 ? ["Ki", "Mi", "Gi"] : ["k", "M", "G"];
    let unit = -1;
    while (Math.abs(bytes) >= base && unit < prefix.length - 1) {
      bytes /= base;
      ++unit;
    }
    return `${bytes.toFixed(1)} ${prefix[unit]}B`;
  }
  function camelizeObjectKeys(obj) {
    if (!obj)
      return {};
    return Object.keys(obj).reduce((o, key) => {
      o[vue.camelize(key)] = obj[key];
      return o;
    }, {});
  }
  function getUid() {
    return getUid._uid++;
  }
  getUid._uid = 0;
  function flattenFragments(nodes) {
    return nodes.map((node) => {
      if (node.type === vue.Fragment) {
        return flattenFragments(node.children);
      } else {
        return node;
      }
    }).flat();
  }
  const randomHexColor = () => {
    const n = (Math.random() * 1048575 * 1e6).toString(16);
    return `#${n.slice(0, 6)}`;
  };
  class CircularBuffer {
    constructor(size) {
      this.size = size;
      __privateAdd(this, _arr, []);
      __privateAdd(this, _pointer, 0);
    }
    push(val) {
      __privateGet(this, _arr)[__privateGet(this, _pointer)] = val;
      __privateSet(this, _pointer, (__privateGet(this, _pointer) + 1) % this.size);
    }
    values() {
      return __privateGet(this, _arr).slice(__privateGet(this, _pointer)).concat(__privateGet(this, _arr).slice(0, __privateGet(this, _pointer)));
    }
  }
  _arr = /* @__PURE__ */ new WeakMap();
  _pointer = /* @__PURE__ */ new WeakMap();
  function padNumber(x, length) {
    let padded = String(x);
    if (padded.length > length) {
      padded.substring(padded.length - length);
    }
    while (padded.length < length) {
      padded = `0${padded}`;
    }
    return padded;
  }
  const mainTRC = 2.4;
  const Rco = 0.2126729;
  const Gco = 0.7151522;
  const Bco = 0.072175;
  const normBG = 0.55;
  const normTXT = 0.58;
  const revTXT = 0.57;
  const revBG = 0.62;
  const blkThrs = 0.03;
  const blkClmp = 1.45;
  const deltaYmin = 5e-4;
  const scaleBoW = 1.25;
  const scaleWoB = 1.25;
  const loConThresh = 0.078;
  const loConFactor = 12.82051282051282;
  const loConOffset = 0.06;
  const loClip = 1e-3;
  function APCAcontrast(text, background) {
    const Rtxt = ((text >> 16 & 255) / 255) ** mainTRC;
    const Gtxt = ((text >> 8 & 255) / 255) ** mainTRC;
    const Btxt = ((text >> 0 & 255) / 255) ** mainTRC;
    const Rbg = ((background >> 16 & 255) / 255) ** mainTRC;
    const Gbg = ((background >> 8 & 255) / 255) ** mainTRC;
    const Bbg = ((background >> 0 & 255) / 255) ** mainTRC;
    let Ytxt = Rtxt * Rco + Gtxt * Gco + Btxt * Bco;
    let Ybg = Rbg * Rco + Gbg * Gco + Bbg * Bco;
    if (Ytxt <= blkThrs)
      Ytxt += (blkThrs - Ytxt) ** blkClmp;
    if (Ybg <= blkThrs)
      Ybg += (blkThrs - Ybg) ** blkClmp;
    if (Math.abs(Ybg - Ytxt) < deltaYmin)
      return 0;
    let outputContrast;
    if (Ybg > Ytxt) {
      const SAPC = (Ybg ** normBG - Ytxt ** normTXT) * scaleBoW;
      outputContrast = SAPC < loClip ? 0 : SAPC < loConThresh ? SAPC - SAPC * loConFactor * loConOffset : SAPC - loConOffset;
    } else {
      const SAPC = (Ybg ** revBG - Ytxt ** revTXT) * scaleWoB;
      outputContrast = SAPC > -loClip ? 0 : SAPC > -loConThresh ? SAPC - SAPC * loConFactor * loConOffset : SAPC + loConOffset;
    }
    return outputContrast * 100;
  }
  const srgbForwardMatrix = [
    [3.2406, -1.5372, -0.4986],
    [-0.9689, 1.8758, 0.0415],
    [0.0557, -0.204, 1.057]
  ];
  const srgbForwardTransform = (C) => C <= 31308e-7 ? C * 12.92 : 1.055 * C ** (1 / 2.4) - 0.055;
  const srgbReverseMatrix = [
    [0.4124, 0.3576, 0.1805],
    [0.2126, 0.7152, 0.0722],
    [0.0193, 0.1192, 0.9505]
  ];
  const srgbReverseTransform = (C) => C <= 0.04045 ? C / 12.92 : ((C + 0.055) / 1.055) ** 2.4;
  function fromXYZ$1(xyz) {
    const rgb = Array(3);
    const transform2 = srgbForwardTransform;
    const matrix = srgbForwardMatrix;
    for (let i = 0; i < 3; ++i) {
      rgb[i] = Math.round(clamp(transform2(matrix[i][0] * xyz[0] + matrix[i][1] * xyz[1] + matrix[i][2] * xyz[2])) * 255);
    }
    return (rgb[0] << 16) + (rgb[1] << 8) + (rgb[2] << 0);
  }
  function toXYZ$1(rgb) {
    const xyz = [0, 0, 0];
    const transform2 = srgbReverseTransform;
    const matrix = srgbReverseMatrix;
    const r = transform2((rgb >> 16 & 255) / 255);
    const g = transform2((rgb >> 8 & 255) / 255);
    const b = transform2((rgb >> 0 & 255) / 255);
    for (let i = 0; i < 3; ++i) {
      xyz[i] = matrix[i][0] * r + matrix[i][1] * g + matrix[i][2] * b;
    }
    return xyz;
  }
  const delta = 0.20689655172413793;
  const cielabForwardTransform = (t) => t > delta ** 3 ? Math.cbrt(t) : t / (3 * delta ** 2) + 4 / 29;
  const cielabReverseTransform = (t) => t > delta ? t ** 3 : 3 * delta ** 2 * (t - 4 / 29);
  function fromXYZ(xyz) {
    const transform2 = cielabForwardTransform;
    const transformedY = transform2(xyz[1]);
    return [
      116 * transformedY - 16,
      500 * (transform2(xyz[0] / 0.95047) - transformedY),
      200 * (transformedY - transform2(xyz[2] / 1.08883))
    ];
  }
  function toXYZ(lab) {
    const transform2 = cielabReverseTransform;
    const Ln = (lab[0] + 16) / 116;
    return [
      transform2(Ln + lab[1] / 500) * 0.95047,
      transform2(Ln),
      transform2(Ln - lab[2] / 200) * 1.08883
    ];
  }
  function isDarkColor(int) {
    const blackContrast = Math.abs(APCAcontrast(0, int));
    const whiteContrast = Math.abs(APCAcontrast(16777215, int));
    return whiteContrast > Math.min(blackContrast, 50);
  }
  function colorToOnColorHex(color) {
    return isDarkColor(colorToInt(color)) ? "#FFF" : "#000";
  }
  function isCssColor(color) {
    return !!color && /^(#|inherit|var\(--|(rgb|hsl)a?\()/.test(color);
  }
  function colorToInt(color) {
    let rgb;
    if (typeof color === "number") {
      rgb = color;
    } else if (typeof color === "string") {
      let c = color.startsWith("#") ? color.substring(1) : color;
      if (c.length === 3) {
        c = c.split("").map((char) => char + char).join("");
      }
      if (c.length !== 6) {
        console.warn(`'${color}' is not a valid rgb color`);
      }
      rgb = parseInt(c, 16);
    } else {
      throw new TypeError(`Colors can only be numbers or strings, recieved ${color} instead`);
    }
    if (rgb < 0) {
      console.warn(`Colors cannot be negative: '${color}'`);
      rgb = 0;
    } else if (rgb > 16777215 || isNaN(rgb)) {
      console.warn(`'${color}' is not a valid rgb color`);
      rgb = 16777215;
    }
    return rgb;
  }
  function intToHex(color) {
    let hexColor = color.toString(16);
    if (hexColor.length < 6)
      hexColor = "0".repeat(6 - hexColor.length) + hexColor;
    return `#${hexColor}`;
  }
  function colorToHex(color) {
    return intToHex(colorToInt(color));
  }
  function HSVAtoRGBA(hsva) {
    const { h, s, v, a } = hsva;
    const f = (n) => {
      const k = (n + h / 60) % 6;
      return v - v * s * Math.max(Math.min(k, 4 - k, 1), 0);
    };
    const rgb = [f(5), f(3), f(1)].map((v2) => Math.round(v2 * 255));
    return { r: rgb[0], g: rgb[1], b: rgb[2], a };
  }
  function RGBAtoHSVA(rgba) {
    if (!rgba)
      return { h: 0, s: 1, v: 1, a: 1 };
    const r = rgba.r / 255;
    const g = rgba.g / 255;
    const b = rgba.b / 255;
    const max = Math.max(r, g, b);
    const min = Math.min(r, g, b);
    let h = 0;
    if (max !== min) {
      if (max === r) {
        h = 60 * (0 + (g - b) / (max - min));
      } else if (max === g) {
        h = 60 * (2 + (b - r) / (max - min));
      } else if (max === b) {
        h = 60 * (4 + (r - g) / (max - min));
      }
    }
    if (h < 0)
      h = h + 360;
    const s = max === 0 ? 0 : (max - min) / max;
    const hsv = [h, s, max];
    return { h: hsv[0], s: hsv[1], v: hsv[2], a: rgba.a };
  }
  function HSVAtoHSLA(hsva) {
    const { h, s, v, a } = hsva;
    const l = v - v * s / 2;
    const sprime = l === 1 || l === 0 ? 0 : (v - l) / Math.min(l, 1 - l);
    return { h, s: sprime, l, a };
  }
  function HSLAtoHSVA(hsl) {
    const { h, s, l, a } = hsl;
    const v = l + s * Math.min(l, 1 - l);
    const sprime = v === 0 ? 0 : 2 - 2 * l / v;
    return { h, s: sprime, v, a };
  }
  function RGBAtoCSS(rgba) {
    return `rgba(${rgba.r}, ${rgba.g}, ${rgba.b}, ${rgba.a})`;
  }
  function RGBtoCSS(rgba) {
    return RGBAtoCSS(__spreadProps(__spreadValues({}, rgba), { a: 1 }));
  }
  function RGBAtoHex(rgba) {
    const toHex = (v) => {
      const h = Math.round(v).toString(16);
      return ("00".substr(0, 2 - h.length) + h).toUpperCase();
    };
    return `#${[
      toHex(rgba.r),
      toHex(rgba.g),
      toHex(rgba.b),
      toHex(Math.round(rgba.a * 255))
    ].join("")}`;
  }
  function RGBtoHex(rgba) {
    const toHex = (v) => {
      const h = Math.round(v).toString(16);
      return ("00".substr(0, 2 - h.length) + h).toUpperCase();
    };
    return `#${[
      toHex(rgba.r),
      toHex(rgba.g),
      toHex(rgba.b)
    ].join("")}`;
  }
  function HexToRGBA(hex) {
    const rgba = chunk(hex.slice(1), 2).map((c) => parseInt(c, 16));
    return {
      r: rgba[0],
      g: rgba[1],
      b: rgba[2],
      a: rgba[3] === void 0 ? 1 : Math.round(rgba[3] / 255 * 100) / 100
    };
  }
  function HexToHSVA(hex) {
    const rgb = HexToRGBA(hex);
    return RGBAtoHSVA(rgb);
  }
  function HSVAtoHex(hsva) {
    return RGBAtoHex(HSVAtoRGBA(hsva));
  }
  function parseHex(hex) {
    if (hex.startsWith("#")) {
      hex = hex.slice(1);
    }
    hex = hex.replace(/([^0-9a-f])/gi, "F");
    if (hex.length === 3 || hex.length === 4) {
      hex = hex.split("").map((x) => x + x).join("");
    }
    if (hex.length === 6) {
      hex = padEnd(hex, 8, "F");
    } else {
      hex = padEnd(padEnd(hex, 6), 8, "F");
    }
    return `#${hex}`.toUpperCase().substr(0, 9);
  }
  function RGBtoInt(rgba) {
    return (rgba.r << 16) + (rgba.g << 8) + rgba.b;
  }
  function colorIntToRGBString(int) {
    const rgb = colorIntToRGB(int);
    return `${rgb.r},${rgb.g},${rgb.b}`;
  }
  function colorIntToRGB(int) {
    return {
      r: (int & 16711680) >> 16,
      g: (int & 65280) >> 8,
      b: int & 255
    };
  }
  function colorToRGB(color) {
    return colorIntToRGB(colorToInt(color));
  }
  function lighten(value, amount) {
    const lab = fromXYZ(toXYZ$1(value));
    lab[0] = lab[0] + amount * 10;
    return fromXYZ$1(toXYZ(lab));
  }
  function darken(value, amount) {
    return lighten(value, -amount);
  }
  function getLuma(color) {
    const rgb = colorToInt(color);
    return toXYZ$1(rgb)[1];
  }
  function getContrast(first, second) {
    const l1 = getLuma(first);
    const l2 = getLuma(second);
    const light = Math.max(l1, l2);
    const dark = Math.min(l1, l2);
    return (light + 0.05) / (dark + 0.05);
  }
  function createSharedComposable(composable) {
    let subscribers = 0;
    let scope;
    let state;
    return () => {
      subscribers++;
      if (state === void 0) {
        scope = vue.effectScope(true);
        state = scope.run(composable);
      }
      vue.onScopeDispose(() => {
        if (scope && --subscribers <= 0) {
          scope == null ? void 0 : scope.stop();
          state = scope = void 0;
        }
      });
      return state;
    };
  }
  function toKebabCase(str) {
    return str.replace(/[^a-z0-9]/gi, "-").replace(/\B([A-Z])/g, "-$1").toLowerCase();
  }
  function toSnakeCase(str) {
    return toKebabCase(str).replace(/-/g, "_");
  }
  function toCameCase(str) {
    return str.replace(/-(\w)/g, (match, part) => part.toLocaleUpperCase());
  }
  function toPascalCase(str) {
    return toCameCase(str.replace(/^[a-z]/, (match) => match.toLocaleUpperCase()));
  }
  function createSimpleFunctional(klass, tag2 = "div", name) {
    return vue.defineComponent({
      name: name != null ? name : toKebabCase(klass.replace(/__/g, "-")),
      props: {
        tag: {
          type: String,
          default: tag2
        }
      },
      setup(props, { slots }) {
        return () => {
          var _a;
          return vue.h(props.tag, { class: klass }, (_a = slots.default) == null ? void 0 : _a.call(slots));
        };
      }
    });
  }
  function downloadCSV(name, headers2, rows, charset = "utf-8") {
    const csv = [
      headers2.map((header2) => {
        var _a;
        return typeof header2 === "object" ? (_a = header2.text) != null ? _a : header2.value : header2;
      }).join(","),
      ...rows.map((row2) => {
        return headers2.map((header2) => typeof header2 === "object" ? row2[header2.value] : row2[header2]).join(",");
      })
    ];
    const blob = new Blob([
      `\uFEFF${csv.join("\n")}`
    ], {
      type: `text/csv;charset=${charset}`
    });
    const link2 = document.createElement("a");
    link2.setAttribute("href", window.URL.createObjectURL(blob));
    link2.setAttribute("download", `${name}.csv`);
    link2.click();
  }
  const classifyRE = /(?:^|[-_])(\w)/g;
  const classify = (str) => str.replace(classifyRE, (c) => c.toUpperCase()).replace(/[-_]/g, "");
  function formatComponentName(vm, includeFile) {
    if (vm.$root === vm) {
      return "<Root>";
    }
    const options = typeof vm === "function" && vm.cid != null ? vm.options : vm._isVue ? vm.$options || vm.constructor.options : vm || {};
    let name = options.name || options._componentTag;
    const file = options.__file;
    if (!name && file) {
      const match = file.match(/([^/\\]+)\.vue$/);
      name = match == null ? void 0 : match[1];
    }
    return (name ? `<${classify(name)}>` : "<Anonymous>") + (file && includeFile !== false ? ` at ${file}` : "");
  }
  function generateComponentTrace(vm) {
    if (vm._isVue && vm.$parent) {
      const tree = [];
      let currentRecursiveSequence = 0;
      while (vm) {
        if (tree.length > 0) {
          const last = tree[tree.length - 1];
          if (last.constructor === vm.constructor) {
            currentRecursiveSequence++;
            vm = vm.$parent;
            continue;
          } else if (currentRecursiveSequence > 0) {
            tree[tree.length - 1] = [last, currentRecursiveSequence];
            currentRecursiveSequence = 0;
          }
        }
        tree.push(vm);
        vm = vm.$parent;
      }
      return `

found in

${tree.map((vm2, i) => `${i === 0 ? "---> " : " ".repeat(5 + i * 2)}${Array.isArray(vm2) ? `${formatComponentName(vm2[0])}... (${vm2[1]} recursive calls)` : formatComponentName(vm2)}`).join("\n")}`;
    } else {
      return `

(found in ${formatComponentName(vm)})`;
    }
  }
  function attachedRoot(node) {
    if (typeof node.getRootNode !== "function") {
      while (node.parentNode)
        node = node.parentNode;
      if (node !== document)
        return null;
      return document;
    }
    const root = node.getRootNode();
    if (root !== document && root.getRootNode({ composed: true }) !== document)
      return null;
    return root;
  }
  const standardEasing = "cubic-bezier(0.4, 0, 0.2, 1)";
  const deceleratedEasing = "cubic-bezier(0.0, 0, 0.2, 1)";
  const acceleratedEasing = "cubic-bezier(0.4, 0, 1, 1)";
  function createFilter(include, exclude) {
    const getMatcher = (id) => id instanceof RegExp ? id : new RegExp(id);
    const includeMatchers = wrapInArray(include).map(getMatcher);
    const excludeMatchers = wrapInArray(exclude).map(getMatcher);
    return (id) => {
      if (typeof id !== "string")
        return false;
      return !includeMatchers.length || !excludeMatchers.some((v) => v.test(id)) && includeMatchers.some((v) => v.test(id));
    };
  }
  function pick(obj, paths) {
    const found = /* @__PURE__ */ Object.create({});
    const rest = /* @__PURE__ */ Object.create({});
    for (const key in obj) {
      if (paths.some((path) => path instanceof RegExp ? path.test(key) : path === key)) {
        found[key] = obj[key];
      } else {
        rest[key] = obj[key];
      }
    }
    return [found, rest];
  }
  function filterInputAttrs(attrs) {
    return pick(attrs, ["class", "style", "id", /^data-/]);
  }
  function getCurrentInstance(errorName, errorMessage) {
    const vm = vue.getCurrentInstance();
    if (!vm) {
      throw new Error(`${errorName} ${errorMessage || "must be called from inside a setup function"}`);
    }
    return vm;
  }
  function getCurrentInstanceName(errorName = "getCurrentInstanceName") {
    var _a, _b;
    return toKebabCase((_b = (_a = getCurrentInstance(errorName).type) == null ? void 0 : _a.name) != null ? _b : "");
  }
  const IS_NODE = typeof process !== "undefined";
  const IN_BROWSER = typeof window !== "undefined";
  const IS_DEBUG = IS_NODE && {}.DEBUG === "true";
  const IS_PROD = IS_NODE && true;
  const SUPPORTS_INTERSECTION_OBSERVER = IN_BROWSER && "IntersectionObserver" in window;
  const SUPPORTS_RESIZE_OBSERVER = IN_BROWSER && "ResizeObserver" in window;
  const SUPPORTS_TOUCH = IN_BROWSER && ("ontouchstart" in window || window.navigator.maxTouchPoints > 0);
  const SUPPORTS_FOCUS_VISIBLE = IN_BROWSER && CSS.supports("selector(:focus-visible)");
  const keyCodes = Object.freeze({
    enter: 13,
    tab: 9,
    delete: 46,
    esc: 27,
    space: 32,
    up: 38,
    down: 40,
    left: 37,
    right: 39,
    end: 35,
    home: 36,
    del: 46,
    backspace: 8,
    insert: 45,
    pageup: 33,
    pagedown: 34,
    shift: 16
  });
  const keyValues = Object.freeze({
    enter: "Enter",
    tab: "Tab",
    delete: "Delete",
    esc: "Escape",
    space: "Space",
    up: "ArrowUp",
    down: "ArrowDown",
    left: "ArrowLeft",
    right: "ArrowRight",
    end: "End",
    home: "Home",
    del: "Delete",
    backspace: "Backspace",
    insert: "Insert",
    pageup: "PageUp",
    pagedown: "PageDown",
    shift: "Shift"
  });
  const tagsToReplace = {
    "&": "&amp;",
    "<": "&lt;",
    ">": "&gt;"
  };
  function escapeHTML(str) {
    return str.replace(/[&<>]/g, (tag2) => tagsToReplace[tag2] || tag2);
  }
  function isFixedPosition(el) {
    while (el) {
      if (window.getComputedStyle(el).position === "fixed") {
        return true;
      }
      el = el.offsetParent;
    }
    return false;
  }
  function elementToViewport(point, offset) {
    return {
      x: point.x + offset.x,
      y: point.y + offset.y
    };
  }
  function viewportToElement(point, offset) {
    return {
      x: point.x - offset.x,
      y: point.y - offset.y
    };
  }
  function getOffset(a, b) {
    return {
      x: a.x - b.x,
      y: a.y - b.y
    };
  }
  function anchorToPoint(anchor2, box) {
    const { side, align } = anchor2;
    let x;
    let y = 0;
    if (side === "top" || side === "bottom") {
      switch (side) {
        case "top":
          y = 0;
          break;
        case "bottom":
          y = box.height;
          break;
      }
      switch (align) {
        case "start":
          x = 0;
          break;
        case "center":
          x = box.width / 2;
          break;
        case "end":
          x = box.width;
          break;
      }
    } else if (side === "start" || side === "end") {
      switch (side) {
        case "start":
          x = 0;
          break;
        case "end":
          x = box.width;
          break;
      }
      switch (align) {
        case "top":
          y = 0;
          break;
        case "center":
          y = box.height / 2;
          break;
        case "bottom":
          y = box.height;
          break;
      }
    } else {
      x = box.width / 2;
      y = box.height / 2;
    }
    return elementToViewport({ x, y }, box);
  }
  function propsFactory(props, source) {
    return (defaults) => {
      return Object.keys(props).reduce((obj, prop) => {
        const isObjectDefinition = typeof props[prop] === "object" && props[prop] != null && !Array.isArray(props[prop]);
        const definition = isObjectDefinition ? props[prop] : { type: props[prop] };
        if (defaults && prop in defaults) {
          obj[prop] = __spreadProps(__spreadValues({}, definition), {
            default: defaults[prop]
          });
        } else {
          obj[prop] = definition;
        }
        if (source) {
          obj[prop].source = source;
        }
        return obj;
      }, {});
    };
  }
  function querySelector(selector, vm) {
    var _a, _b;
    let el;
    if (selector === "parent") {
      el = (_b = (_a = vm == null ? void 0 : vm.proxy) == null ? void 0 : _a.$el) == null ? void 0 : _b.parentNode;
    } else if (typeof selector === "string") {
      el = document.querySelector(selector);
    } else if ("$el" in selector) {
      el = selector.$el;
    } else if (selector) {
      el = selector;
    }
    return (el == null ? void 0 : el.nodeType) === Node.ELEMENT_NODE ? el : void 0;
  }
  function wrapInRef(val) {
    return vue.isRef(val) ? val : vue.ref(val);
  }
  let clean = true;
  const frames = [];
  function requestNewFrame(cb) {
    if (!clean || frames.length) {
      frames.push(cb);
      run();
    } else {
      clean = false;
      cb();
      run();
    }
  }
  let raf = -1;
  function run() {
    cancelAnimationFrame(raf);
    raf = requestAnimationFrame(() => {
      const frame = frames.shift();
      if (frame)
        frame();
      if (frames.length)
        run();
      else
        clean = true;
    });
  }
  function getScrollParent(el) {
    while (el) {
      if (hasScrollbar(el))
        return el;
      el = el.parentElement;
    }
    return document.scrollingElement;
  }
  function getScrollParents(el) {
    const elements = [];
    while (el) {
      if (hasScrollbar(el))
        elements.push(el);
      el = el.parentElement;
    }
    return elements;
  }
  function hasScrollbar(el) {
    if (!el || el.nodeType !== Node.ELEMENT_NODE)
      return false;
    const style = window.getComputedStyle(el);
    return style.overflowY === "scroll" || (style.overflowY === "auto" || style.overflowY === "overlay") && el.scrollHeight > el.clientHeight;
  }
  function getScrollbarWidth(el) {
    if (!el || el.nodeType !== Node.ELEMENT_NODE)
      return 0;
    if (el.tagName === "HTML") {
      return window.innerWidth - document.documentElement.offsetWidth;
    }
    const style = window.getComputedStyle(el);
    return el.offsetWidth - el.clientWidth - parseFloat(style.borderLeftWidth) - parseFloat(style.borderRightWidth);
  }
  function useRender(render) {
    const vm = getCurrentInstance("useRender");
    vm.render = render;
  }
  function classToHex(color, colors, currentTheme) {
    const [colorName, colorModifier] = color.toString().trim().replace("-", "").split(" ", 2);
    let hexColor = "";
    if (colorName && colorName in colors) {
      if (colorModifier && colorModifier in colors[colorName]) {
        hexColor = colors[colorName][colorModifier];
      } else if ("base" in colors[colorName]) {
        hexColor = colors[colorName].base;
      }
    } else if (colorName && colorName in currentTheme) {
      hexColor = currentTheme[colorName];
    }
    return hexColor;
  }
  function parseGradient(gradient, colors, currentTheme) {
    return gradient.replace(/([a-z]+(\s[a-z]+-[1-5])?)(?=$|,)/gi, (x) => {
      return classToHex(x, colors, currentTheme) || x;
    }).replace(/(rgba\()#[0-9a-f]+(?=,)/gi, (x) => {
      return `rgba(${Object.values(HexToRGBA(parseHex(x.replace(/rgba\(/, "")))).slice(0, 3).join(",")}`;
    });
  }
  const UI_NAME = "veno-ui";
  const UI_VERSION = "0.4.21";
  function createMessage$1(message2, vm, parent) {
    if (parent) {
      vm = {
        _isVue: true,
        $parent: parent,
        $options: vm
      };
    }
    if (vm) {
      vm.$_alreadyWarned = vm.$_alreadyWarned || [];
      if (vm.$_alreadyWarned.includes(message2))
        return;
      vm.$_alreadyWarned.push(message2);
    }
    return `[${UI_NAME}] ${message2}${vm ? generateComponentTrace(vm) : ""}`;
  }
  function consoleInfo(message2, vm, parent) {
    const newMessage = createMessage$1(message2, vm, parent);
    newMessage != null && console.info(newMessage);
  }
  function consoleWarn(message2, vm, parent) {
    const newMessage = createMessage$1(message2, vm, parent);
    newMessage != null && console.warn(newMessage);
  }
  function consoleError(message2, vm, parent) {
    const newMessage = createMessage$1(message2, vm, parent);
    newMessage != null && console.error(newMessage);
  }
  const DefaultsKey = Symbol.for("veno-ui:defaults");
  function createDefaults(options) {
    return vue.ref(options != null ? options : {});
  }
  function useDefaults() {
    const defaults = vue.inject(DefaultsKey);
    if (!defaults)
      throw new Error("[VenoUi] Could not find defaults instance");
    return defaults;
  }
  function provideDefaults(defaults, options) {
    const injectedDefaults = useDefaults();
    const providedDefaults = vue.ref(defaults);
    const newDefaults = vue.computed(() => {
      const scoped = vue.unref(options == null ? void 0 : options.scoped);
      const reset = vue.unref(options == null ? void 0 : options.reset);
      const root = vue.unref(options == null ? void 0 : options.root);
      let properties = deepMerge(providedDefaults.value, {
        prev: injectedDefaults.value
      });
      if (scoped)
        return properties;
      if (reset || root) {
        const len = Number(reset || Infinity);
        for (let i = 0; i <= len; i++) {
          if (!properties.prev)
            break;
          properties = properties.prev;
        }
        return properties;
      }
      return deepMerge(properties.prev, properties);
    });
    vue.provide(DefaultsKey, newDefaults);
    return newDefaults;
  }
  function propIsDefined(vnode, prop) {
    var _a, _b;
    return ((_a = vnode.props) == null ? void 0 : _a.hasOwnProperty(prop)) || ((_b = vnode.props) == null ? void 0 : _b.hasOwnProperty(toKebabCase(prop)));
  }
  const defineComponent = function defineComponent2(options) {
    var _a;
    options._setup = (_a = options._setup) != null ? _a : options.setup;
    if (!options.name) {
      consoleWarn("The component is missing an explicit name, unable to generate default prop value");
      return options;
    }
    if (options._setup) {
      options.setup = function setup(props, ctx) {
        const vm = vue.getCurrentInstance();
        const defaults = useDefaults();
        const _props = vue.shallowReactive(__spreadValues({}, vue.toRaw(props)));
        vue.watchEffect(() => {
          var _a2, _b;
          const globalDefaults = defaults.value.global;
          const componentDefaults = defaults.value[options.name];
          for (const prop of Object.keys(props)) {
            let newVal;
            if (propIsDefined(vm.vnode, prop)) {
              newVal = props[prop];
            } else {
              newVal = (_b = (_a2 = componentDefaults == null ? void 0 : componentDefaults[prop]) != null ? _a2 : globalDefaults == null ? void 0 : globalDefaults[prop]) != null ? _b : props[prop];
            }
            if (_props[prop] !== newVal) {
              _props[prop] = newVal;
            }
          }
        });
        return options._setup(_props, ctx);
      };
    }
    return options;
  };
  function genericComponent(exposeDefaults = true) {
    return (options) => (exposeDefaults ? defineComponent : vue.defineComponent)(options);
  }
  function findChildren(vnode) {
    var _a;
    if (!vnode || typeof vnode !== "object") {
      return [];
    }
    if (Array.isArray(vnode)) {
      return vnode.map((child) => findChildren(child)).filter((v) => v).flat(1);
    } else if (Array.isArray(vnode.children)) {
      return vnode.children.map((child) => findChildren(child)).filter((v) => v).flat(1);
    } else if (vnode.component) {
      return [vnode.component, ...findChildren((_a = vnode.component) == null ? void 0 : _a.subTree)].filter((v) => v).flat(1);
    }
    return [];
  }
  function findChildrenWithProvide(provide, vnode) {
    return findChildren(vnode).slice(1).filter((cmp) => !!cmp.provides[provide]);
  }
  function createSymbol(key) {
    return Symbol.for(`${UI_NAME}:${key}`);
  }
  var index = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    classToHex,
    parseGradient,
    consoleInfo,
    consoleWarn,
    consoleError,
    propIsDefined,
    defineComponent,
    genericComponent,
    UI_NAME,
    UI_VERSION,
    findChildren,
    findChildrenWithProvide,
    createSymbol,
    Box,
    CircularBuffer,
    HSLAtoHSVA,
    HSVAtoHSLA,
    HSVAtoHex,
    HSVAtoRGBA,
    HexToHSVA,
    HexToRGBA,
    IN_BROWSER,
    IS_DEBUG,
    IS_NODE,
    IS_PROD,
    RGBAtoCSS,
    RGBAtoHSVA,
    RGBAtoHex,
    RGBtoCSS,
    RGBtoHex,
    RGBtoInt,
    SUPPORTS_FOCUS_VISIBLE,
    SUPPORTS_INTERSECTION_OBSERVER,
    SUPPORTS_RESIZE_OBSERVER,
    SUPPORTS_TOUCH,
    acceleratedEasing,
    anchorToPoint,
    arrayDiff,
    attachedRoot,
    camelizeObjectKeys,
    chunk,
    clamp,
    colorIntToRGB,
    colorIntToRGBString,
    colorToHex,
    colorToInt,
    colorToOnColorHex,
    colorToRGB,
    convertToUnit,
    createFilter,
    createRange,
    createSharedComposable,
    createSimpleFunctional,
    darken,
    debounce,
    deceleratedEasing,
    deepEqual,
    deepMerge,
    defaultFilter: defaultFilter$1,
    downloadCSV,
    elementToViewport,
    escapeHTML,
    fillArray,
    filterInputAttrs,
    filterObjectOnKeys,
    flattenFragments,
    generateComponentTrace,
    getContrast,
    getCurrentInstance,
    getCurrentInstanceName,
    getLuma,
    getNestedValue,
    getObjectValueByPath,
    getOffset,
    getPrefixedSlots,
    getPropertyFromItem,
    getScrollParent,
    getScrollParents,
    getScrollbarWidth,
    getUid,
    getZIndex,
    groupItems,
    hasScrollbar,
    humanReadableFileSize,
    intToHex,
    isComponentInstance,
    isCssColor,
    isDarkColor,
    isFixedPosition,
    isObject,
    keyCodes,
    keyValues,
    keys,
    lighten,
    nullifyTransforms,
    oppositeAnchor,
    padEnd,
    padNumber,
    parseAnchor,
    parseHex,
    physicalAnchor,
    pick,
    propsFactory,
    querySelector,
    randomHexColor,
    requestNewFrame,
    searchItems,
    setNestedValue,
    setObjectValueByPath,
    sortItems,
    standardEasing,
    throttle,
    toCameCase,
    toKebabCase,
    toPascalCase,
    toSnakeCase,
    useRender,
    viewportToElement,
    wrapInArray,
    wrapInRef
  }, Symbol.toStringTag, { value: "Module" }));
  function useProxiedModel(props, prop, defaultValue, transformIn = (v) => v, transformOut = (v) => v) {
    const vm = getCurrentInstance("useProxiedModel");
    const propIsDefined$1 = vue.computed(() => {
      return typeof props[prop] !== "undefined" && vm.vnode && propIsDefined(vm.vnode, prop);
    });
    const internal = vue.ref(typeof props[prop] === "undefined" ? defaultValue : props[prop]);
    return vue.computed({
      get() {
        if (propIsDefined$1.value) {
          return transformIn(props[prop]);
        } else {
          return transformIn(internal.value);
        }
      },
      set(newValue) {
        internal.value = transformOut(newValue);
        vm.emit(`update:${prop}`, internal.value);
      }
    });
  }
  const makeTransitionProps = propsFactory({
    transition: {
      type: [Boolean, String, Object],
      default: "ve-fade-transition",
      validator: (val) => val !== true
    }
  }, "transition");
  const MaybeTransition = (props, { slots }) => {
    var _b;
    const _a = props, { transition } = _a, rest = __objRest(_a, ["transition"]);
    if (!transition || typeof transition === "boolean")
      return (_b = slots.default) == null ? void 0 : _b.call(slots);
    const _c = typeof transition === "object" ? transition : {}, { component = vue.Transition } = _c, customProps = __objRest(_c, ["component"]);
    return vue.h(component, vue.mergeProps(typeof transition === "string" ? { name: transition } : customProps, rest), slots);
  };
  const makeLoadingProps = propsFactory({
    loading: Boolean
  }, "loading");
  function useLoading(props, name = getCurrentInstanceName()) {
    return {
      loadingClasses: vue.computed(() => ({
        [`${name}--loading`]: props.loading
      }))
    };
  }
  var card = "";
  function useRoute() {
    const vm = vue.getCurrentInstance();
    return vue.computed(() => {
      var _a;
      return (_a = vm == null ? void 0 : vm.proxy) == null ? void 0 : _a.$route;
    });
  }
  function useRouter() {
    var _a, _b;
    return (_b = (_a = vue.getCurrentInstance()) == null ? void 0 : _a.proxy) == null ? void 0 : _b.$router;
  }
  function useRouterHistory() {
    const router = useRouter();
    const isWebHashHistory = vue.computed(() => router && router.options.history.base.includes("#"));
    return {
      isWebHashHistory
    };
  }
  function useLink(props, attrs) {
    const RouterLink = vue.resolveDynamicComponent("RouterLink");
    const isLink = vue.computed(() => !!(props.href || props.to));
    const isClickable = vue.computed(() => {
      return (isLink == null ? void 0 : isLink.value) || !!(attrs.onClick || attrs.onClickOnce);
    });
    if (typeof RouterLink === "string") {
      return {
        isLink,
        isClickable,
        href: vue.toRef(props, "href")
      };
    }
    const link2 = props.to ? RouterLink.useLink(props) : void 0;
    return __spreadProps(__spreadValues({}, link2), {
      isLink,
      isClickable,
      href: vue.computed(() => props.to ? link2 == null ? void 0 : link2.route.value.href : props.href)
    });
  }
  const makeRouterProps = propsFactory({
    href: String,
    replace: Boolean,
    to: [String, Object]
  }, "router");
  function useBackButton(cb) {
    const router = useRouter();
    let popped = false;
    let removeGuard;
    vue.onMounted(() => {
      window.addEventListener("popstate", onPopstate);
      removeGuard = router == null ? void 0 : router.beforeEach((to, from, next) => {
        setTimeout(() => popped ? cb(next) : next());
      });
    });
    vue.onBeforeUnmount(() => {
      window.removeEventListener("popstate", onPopstate);
      removeGuard == null ? void 0 : removeGuard();
    });
    function onPopstate(e) {
      var _a;
      if ((_a = e.state) == null ? void 0 : _a.replaced)
        return;
      popped = true;
      setTimeout(() => popped = false);
    }
  }
  const makeDisabledProps = propsFactory({
    disabled: Boolean
  }, "disabled");
  function useDisabled(props, name = getCurrentInstanceName()) {
    return {
      disabledClasses: vue.computed(() => {
        const { disabled } = vue.unref(props);
        return {
          [`${name}--disabled`]: disabled
        };
      })
    };
  }
  const makeTagProps = propsFactory({
    tag: {
      type: String,
      default: "div"
    }
  }, "tag");
  var defaultOptions = {
    defaultTheme: "light",
    themes: {
      light: {
        dark: false,
        colors: {
          "background": "#FFF",
          "on-background": "#333333",
          "surface": "#FFF",
          "on-surface": "#333333",
          "surface-variant": "#424242",
          "on-surface-variant": "#EEE",
          "primary": "#0969DA",
          "secondary": "#F2F3F5",
          "on-secondary": "#1D2129",
          "error": "#F53F3F",
          "info": "#2080F0",
          "success": "#00B42A",
          "warning": "#FF7D00"
        },
        variables: {
          "border-color": "#000",
          "border-opacity": 0.12,
          "high-emphasis-opacity": 0.87,
          "medium-emphasis-opacity": 0.6,
          "disabled-opacity": 0.38,
          "idle-opacity": 0.04,
          "hover-opacity": 0.04,
          "focus-opacity": 0.12,
          "selected-opacity": 0.08,
          "activated-opacity": 0.12,
          "pressed-opacity": 0.12,
          "dragged-opacity": 0.08
        }
      },
      dark: {
        dark: true,
        colors: {
          "background": "#22272E",
          "surface": "#2D333B",
          "surface-variant": "#BDBDBD",
          "on-surface-variant": "#424242",
          "primary": "#539BF5",
          "secondary": "#444C56",
          "on-secondary": "#F2F3F5",
          "error": "#F53F3F",
          "info": "#2080F0",
          "success": "#00B42A",
          "warning": "#FF7D00"
        },
        variables: {
          "border-color": "#FFF",
          "border-opacity": 0.08,
          "high-emphasis-opacity": 0.87,
          "medium-emphasis-opacity": 0.6,
          "disabled-opacity": 0.38,
          "idle-opacity": 0.1,
          "hover-opacity": 0.04,
          "focus-opacity": 0.12,
          "selected-opacity": 0.08,
          "activated-opacity": 0.12,
          "pressed-opacity": 0.16,
          "dragged-opacity": 0.08
        }
      }
    }
  };
  const ThemeKey = Symbol.for("veno-ui:theme");
  const makeThemeProps = propsFactory({
    theme: String
  }, "theme");
  const parseThemeOptions = (options = defaultOptions) => {
    if (!options) {
      return __spreadProps(__spreadValues({}, defaultOptions), { isDisabled: true });
    }
    return deepMerge(defaultOptions, options);
  };
  function createCssClass(selector, content) {
    return [
      `${selector} {
`,
      ...content.map((line) => `  ${line};
`),
      "}\n"
    ];
  }
  function createTheme(app2, options) {
    const head = app2._context.provides.usehead;
    const parsedOptions = parseThemeOptions(options);
    const styleEl = vue.ref();
    const current = vue.ref(parsedOptions.defaultTheme);
    const themes = vue.ref(parsedOptions.themes);
    const computedThemes = vue.computed(() => {
      return Object.keys(themes.value).reduce((obj, key) => {
        const theme = themes.value[key];
        for (const color of Object.keys(theme.colors)) {
          if (/on-[a-z]/.test(color) || theme.colors[`on-${color}`])
            continue;
          theme.colors[`on-${color}`] = colorToOnColorHex(theme.colors[color]);
        }
        obj[key] = theme;
        return obj;
      }, {});
    });
    const styles = vue.computed(() => {
      const lines = [];
      for (const themeName of Object.keys(computedThemes.value)) {
        const theme = computedThemes.value[themeName];
        lines.push(...createCssClass(`.ve-theme--${themeName}`, [
          ...genCssVariables(themeName),
          ...Object.keys(theme.variables).map((key) => {
            const value = theme.variables[key];
            const color = typeof value === "string" && value.startsWith("#") ? colorToRGB(value) : void 0;
            const rgb = color ? `${color.r}, ${color.g}, ${color.b}` : void 0;
            return `--ve-${key}: ${rgb != null ? rgb : value}`;
          })
        ]));
        if (theme.dark) {
          for (const key of Object.keys(theme.colors)) {
            if (/on-[a-z]/.test(key)) {
              lines.push(...createCssClass(`.${key}`, [
                `color: rgb(var(--ve-theme-${key})) !important`
              ]));
            } else {
              lines.push(...createCssClass(`.bg-${key}`, [
                `--ve-theme-overlay-multiplier: var(--ve-theme-${key}-overlay-multiplier)`,
                `background: rgb(var(--ve-theme-${key})) !important`,
                `color: rgb(var(--ve-theme-on-${key})) !important`
              ]), ...createCssClass(`.text-${key}`, [
                `color: rgb(var(--ve-theme-${key})) !important`
              ]), ...createCssClass(`.border-${key}`, [
                `--ve-border-color: var(--ve-theme-${key})`
              ]));
            }
          }
        }
      }
      return lines.map((str, i) => i === 0 ? str : `    ${str}`).join("");
    });
    function genCssVariables(name) {
      const theme = computedThemes.value[name];
      if (!theme)
        throw new Error(`Could not find theme ${name}`);
      const lightOverlay = theme.dark ? 2 : 1;
      const darkOverlay = theme.dark ? 1 : 2;
      const variables = [];
      for (const [key, value] of Object.entries(theme.colors)) {
        const rgb = colorToRGB(value);
        variables.push(`--ve-theme-${key}: ${rgb.r},${rgb.g},${rgb.b}`);
        if (!key.startsWith("on-")) {
          variables.push(`--ve-theme-${key}-overlay-multiplier: ${getLuma(value) > 0.18 ? lightOverlay : darkOverlay}`);
        }
      }
      return variables;
    }
    if (head) {
      head.addHeadObjs(vue.computed(() => ({
        style: [{
          children: styles.value,
          type: "text/css",
          id: "veno-ui-theme-stylesheet"
        }]
      })));
      if (IN_BROWSER) {
        vue.watchEffect(() => head.updateDOM());
      }
    } else {
      let updateStyles = function() {
        if (parsedOptions.isDisabled)
          return;
        genStyleElement();
        if (styleEl.value)
          styleEl.value.innerHTML = styles.value;
      }, genStyleElement = function() {
        if (typeof document === "undefined" || styleEl.value)
          return;
        const el = document.createElement("style");
        el.type = "text/css";
        el.id = "veno-ui-theme-stylesheet";
        styleEl.value = el;
        document.head.appendChild(styleEl.value);
      };
      vue.watch(themes, updateStyles, { deep: true, immediate: true });
    }
    return {
      isDisabled: parsedOptions.isDisabled,
      themes: computedThemes,
      setTheme: (key, theme) => themes.value[key] = theme,
      getTheme: (key) => computedThemes.value[key],
      current,
      themeClasses: vue.computed(() => {
        return parsedOptions.isDisabled ? void 0 : `ve-theme--${current.value}`;
      })
    };
  }
  function provideTheme(props) {
    getCurrentInstance("provideTheme");
    const theme = vue.inject(ThemeKey, null);
    if (!theme)
      throw new Error("Could not find theme injection");
    const current = vue.computed(() => {
      const { theme: propTheme } = vue.unref(props);
      if (propTheme && propTheme.includes(":")) {
        const [theme1, theme2] = propTheme.split(":");
        return (theme == null ? void 0 : theme.current.value) === theme1 ? theme2 : theme1;
      }
      return propTheme != null ? propTheme : theme == null ? void 0 : theme.current.value;
    });
    const themeClasses = vue.computed(() => {
      return theme.isDisabled ? void 0 : `ve-theme--${current.value}`;
    });
    const newTheme = __spreadProps(__spreadValues({}, theme), {
      current,
      themeClasses
    });
    vue.provide(ThemeKey, newTheme);
    return newTheme;
  }
  function useTheme() {
    getCurrentInstance("useTheme");
    const provider = vue.inject(ThemeKey, null);
    if (!provider)
      throw new Error("Could not find theme injection");
    return provider;
  }
  const makeColorProps = propsFactory({
    color: String,
    textColor: String
  }, "color");
  function useColor(colors) {
    const backgroundIsCssColor = vue.computed(() => isCssColor(colors.value.background));
    const textIsCssColor = vue.computed(() => isCssColor(colors.value.text));
    const colorClasses = vue.computed(() => {
      const classes = [];
      if (colors.value.background && !backgroundIsCssColor.value) {
        classes.push(`bg-${colors.value.background}`);
      }
      if (colors.value.text && !textIsCssColor.value) {
        classes.push(`text-${colors.value.text}`);
      }
      return classes;
    });
    const colorStyles = vue.computed(() => {
      const styles = {};
      if (colors.value.background && backgroundIsCssColor.value) {
        styles.backgroundColor = colors.value.background;
        styles.color = colorToOnColorHex(styles.backgroundColor);
      }
      if (colors.value.text && textIsCssColor.value) {
        styles.color = colors.value.text;
        styles.caretColor = colors.value.text;
      }
      return styles;
    });
    return { colorClasses, colorStyles };
  }
  function useTextColor(props, name) {
    const colors = vue.computed(() => ({
      text: vue.isRef(props) ? props.value : name ? props[name] : null
    }));
    const {
      colorClasses: textColorClasses,
      colorStyles: textColorStyles
    } = useColor(colors);
    return { textColorClasses, textColorStyles };
  }
  function useBackgroundColor(props, name) {
    const colors = vue.computed(() => ({
      background: vue.isRef(props) ? props.value : name ? props[name] : null
    }));
    const {
      colorClasses: backgroundColorClasses,
      colorStyles: backgroundColorStyles
    } = useColor(colors);
    return { backgroundColorClasses, backgroundColorStyles };
  }
  const VARIANTS = ["contained", "outlined", "plain", "text", "contained-text", "contained-outlined"];
  function genOverlays(isClickable, name) {
    return vue.createVNode(vue.Fragment, null, [isClickable && vue.createVNode("div", {
      "aria-hidden": "true",
      "class": `${name}__overlay`
    }, null), vue.createVNode("div", {
      "aria-hidden": "true",
      "class": `${name}__underlay`
    }, null), vue.createVNode("div", {
      "aria-hidden": "true",
      "class": `${name}__border`
    }, null)]);
  }
  const makeVariantProps = propsFactory({
    color: String,
    textColor: String,
    variant: {
      type: String,
      default: "contained",
      validator: (v) => VARIANTS.includes(v)
    }
  }, "variant");
  function useVariant(props, name = getCurrentInstanceName()) {
    const variant = vue.computed(() => {
      const {
        variant: variant2
      } = vue.unref(props);
      return variant2;
    });
    const colors = vue.computed(() => {
      const {
        textColor,
        color,
        variant: variant2
      } = vue.unref(props);
      if (variant2 === "contained") {
        return {
          text: textColor,
          background: color
        };
      }
      return {
        text: color != null ? color : textColor
      };
    });
    const variantClasses = vue.computed(() => {
      return [`${name}--variant-${variant.value}`];
    });
    const {
      colorClasses,
      colorStyles
    } = useColor(colors);
    return {
      colorClasses,
      colorStyles,
      variantClasses
    };
  }
  const POSITIONS = ["static", "relative", "fixed", "absolute", "sticky"];
  const makePositionProps = propsFactory({
    absolute: Boolean,
    bottom: [Boolean, Number, String],
    fixed: Boolean,
    left: [Boolean, Number, String],
    position: {
      type: String,
      validator: (v) => POSITIONS.includes(v)
    },
    right: [Boolean, Number, String],
    top: [Boolean, Number, String]
  }, "position");
  function usePosition(props, name = getCurrentInstanceName()) {
    const targets = ["top", "right", "bottom", "left"];
    const positionClasses = vue.computed(() => {
      const { fixed, absolute, position } = vue.unref(props);
      if (fixed) {
        return `${name}--fixed`;
      } else if (absolute) {
        return `${name}--absolute`;
      } else if (position) {
        return `position-${position}`;
      }
      return null;
    });
    const positionStyles = vue.computed(() => {
      const unrefedProps = vue.unref(props);
      const styles = {};
      for (const target of targets) {
        const prop = unrefedProps[target];
        if (prop == null || prop === false)
          continue;
        styles[target] = convertToUnit(prop === true ? "0" : String(prop));
      }
      return styles;
    });
    return {
      positionClasses,
      positionStyles
    };
  }
  const makeDimensionProps = propsFactory({
    height: [Number, String],
    maxHeight: [Number, String],
    maxWidth: [Number, String],
    minHeight: [Number, String],
    minWidth: [Number, String],
    width: [Number, String]
  }, "dimension");
  function useDimension(props) {
    return {
      dimensionStyles: vue.computed(() => {
        const { height, maxHeight, maxWidth, minHeight, minWidth, width } = vue.unref(props);
        return {
          height: convertToUnit(height),
          maxHeight: convertToUnit(maxHeight),
          maxWidth: convertToUnit(maxWidth),
          minHeight: convertToUnit(minHeight),
          minWidth: convertToUnit(minWidth),
          width: convertToUnit(width)
        };
      })
    };
  }
  const aliases$3 = {
    xs: "x-small",
    sm: "small",
    md: "medium",
    lg: "large",
    xl: "x-large"
  };
  const SIZES = [
    ...Object.keys(aliases$3),
    ...new Set(Object.values(aliases$3))
  ];
  const makeSizeProps = propsFactory({
    size: {
      type: [String, Number],
      default: "medium"
    }
  }, "size");
  function useSize(props, name = getCurrentInstanceName()) {
    const sizeClasses = vue.computed(() => {
      let { size } = vue.unref(props);
      if (!name || !size || !SIZES.includes(size))
        return null;
      if (size in aliases$3)
        size = aliases$3[size];
      return `${name}--size-${size}`;
    });
    const sizeStyles = vue.computed(() => {
      const { size } = vue.unref(props);
      if (!size || SIZES.includes(size))
        return {};
      return {
        width: convertToUnit(size),
        height: convertToUnit(size)
      };
    });
    return {
      sizeClasses,
      sizeStyles
    };
  }
  const DENSITIES = ["ultra-low", "low", "medium", "high", "ultra-high"];
  const makeDensityProps = propsFactory({
    density: {
      type: String,
      default: "medium",
      validator: (v) => DENSITIES.includes(v)
    }
  }, "density");
  function useDensity(props, name = getCurrentInstanceName()) {
    const densityClasses = vue.computed(() => {
      const { density } = vue.unref(props);
      if (!name || !density || !DENSITIES.includes(density))
        return null;
      return `${name}--density-${density}`;
    });
    return {
      densityClasses
    };
  }
  const makeBorderProps = propsFactory({
    border: [Boolean, Number, String]
  }, "border");
  function useBorder(props, name = getCurrentInstanceName()) {
    const borderClasses = vue.computed(() => {
      const { border } = vue.unref(props);
      const classes = [];
      if (border === true) {
        classes.push(`${name}--border`);
      } else if (typeof border === "string" && border !== "" || border === 0) {
        for (const value of String(border).split(" ")) {
          classes.push(`border-${value}`);
        }
      }
      return classes;
    });
    return {
      borderClasses
    };
  }
  const SHAPES = [
    "tile",
    "rounded-sm",
    "rounded",
    "rounded-lg",
    "pill",
    "circle"
  ];
  const makeShapeProps = propsFactory({
    shape: {
      type: String,
      default: "tile"
    }
  }, "shape");
  function useShape(props, name = getCurrentInstanceName()) {
    const shapeClasses = vue.computed(() => {
      const { shape } = vue.unref(props);
      if (!shape || !SHAPES.includes(shape))
        return null;
      return `${name}--shape-${shape}`;
    });
    return {
      shapeClasses
    };
  }
  const makeElevationProps = propsFactory({
    elevation: {
      type: [Number, String],
      validator(v) {
        const value = parseInt(v);
        return !isNaN(value) && value >= 0 && value <= 24;
      }
    }
  }, "elevation");
  function useElevation(props) {
    const elevationClasses = vue.computed(() => {
      const { elevation } = vue.unref(props);
      const classes = [];
      if (elevation == null)
        return classes;
      classes.push(`elevation-${elevation}`);
      return classes;
    });
    return { elevationClasses };
  }
  const makePaperProps = propsFactory(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({}, makeTagProps()), makeThemeProps()), makeVariantProps()), makePositionProps()), makeDimensionProps()), makeSizeProps()), makeDensityProps()), makeBorderProps()), makeShapeProps()), makeElevationProps()), "paper");
  function usePaper(props, name = getCurrentInstanceName()) {
    const { themeClasses } = provideTheme(props);
    const { colorClasses, variantClasses, colorStyles } = useVariant(props, name);
    const { positionClasses, positionStyles } = usePosition(props, name);
    const { dimensionStyles } = useDimension(props);
    const { sizeClasses, sizeStyles } = useSize(props, name);
    const { densityClasses } = useDensity(props, name);
    const { borderClasses } = useBorder(props, name);
    const { shapeClasses } = useShape(props, name);
    const { elevationClasses } = useElevation(props);
    const paperClasses = vue.computed(() => [
      themeClasses.value,
      colorClasses.value,
      variantClasses.value,
      positionClasses.value,
      sizeClasses.value,
      densityClasses.value,
      borderClasses.value,
      shapeClasses.value,
      elevationClasses.value
    ]);
    const paperStyles = vue.computed(() => [
      colorStyles.value,
      positionStyles.value,
      dimensionStyles.value,
      sizeStyles.value
    ]);
    return {
      paperClasses,
      paperStyles
    };
  }
  function mounted$2(el, binding) {
    if (!SUPPORTS_INTERSECTION_OBSERVER)
      return;
    const modifiers = binding.modifiers || {};
    const value = binding.value;
    const { handler, options } = typeof value === "object" ? value : { handler: value, options: {} };
    const observer = new IntersectionObserver((entries = [], observer2) => {
      if (!el._intersect)
        return;
      const isIntersecting = entries.some((entry) => entry.isIntersecting);
      if (handler && (!modifiers.quiet || el._intersect.init) && (!modifiers.once || isIntersecting || !el._intersect.init)) {
        handler(isIntersecting, entries, observer2);
      }
      if (isIntersecting && modifiers.once) {
        unmounted$2(el);
      } else {
        el._intersect.init = true;
      }
    }, options);
    el._intersect = { init: false, observer };
    observer.observe(el);
  }
  function unmounted$2(el) {
    if (!el._intersect)
      return;
    el._intersect.observer.unobserve(el);
    delete el._intersect;
  }
  const Intersect = {
    mounted: mounted$2,
    unmounted: unmounted$2
  };
  function defaultConditional() {
    return true;
  }
  function checkEvent(e, el, binding) {
    if (!e || checkIsActive(e, binding) === false)
      return false;
    const root = attachedRoot(el);
    if (root instanceof ShadowRoot && root.host === e.target)
      return false;
    const elements = (typeof binding.value === "object" && binding.value.include || (() => []))();
    elements.push(el);
    return !elements.some((el2) => el2 == null ? void 0 : el2.contains(e.target));
  }
  function checkIsActive(e, binding) {
    const isActive = typeof binding.value === "object" && binding.value.closeConditional || defaultConditional;
    return isActive(e);
  }
  function directive(e, el, binding) {
    const handler = typeof binding.value === "function" ? binding.value : binding.value.handler;
    el._clickOutside.lastMousedownWasOutside && checkEvent(e, el, binding) && setTimeout(() => {
      checkIsActive(e, binding) && handler && handler(e);
    }, 0);
  }
  function handleShadow(el, callback) {
    const root = attachedRoot(el);
    callback(document.body);
    if (root instanceof ShadowRoot) {
      callback(root);
    }
  }
  const ClickOutside = {
    mounted(el, binding) {
      const onClick = (e) => directive(e, el, binding);
      const onMousedown = (e) => {
        el._clickOutside.lastMousedownWasOutside = checkEvent(e, el, binding);
      };
      handleShadow(el, (app2) => {
        app2.addEventListener("click", onClick, true);
        app2.addEventListener("mousedown", onMousedown, true);
      });
      el._clickOutside = {
        lastMousedownWasOutside: true,
        onClick,
        onMousedown
      };
    },
    unmounted(el) {
      if (!el._clickOutside)
        return;
      handleShadow(el, (app2) => {
        if (!app2 || !el._clickOutside)
          return;
        app2.removeEventListener("click", el._clickOutside.onClick, true);
        app2.removeEventListener("mousedown", el._clickOutside.onMousedown, true);
      });
      delete el._clickOutside;
    }
  };
  function mounted$1(el, binding) {
    var _a, _b;
    const handler = binding.value;
    const options = {
      passive: !((_a = binding.modifiers) == null ? void 0 : _a.active)
    };
    window.addEventListener("resize", handler, options);
    el._onResize = {
      handler,
      options
    };
    if (!((_b = binding.modifiers) == null ? void 0 : _b.quiet)) {
      handler();
    }
  }
  function unmounted$1(el) {
    if (!el._onResize)
      return;
    const { handler, options } = el._onResize;
    window.removeEventListener("resize", handler, options);
    delete el._onResize;
  }
  const Resize = {
    mounted: mounted$1,
    unmounted: unmounted$1
  };
  var ripple = "";
  const rippleStop = Symbol("rippleStop");
  const DELAY_RIPPLE = 80;
  function transform(el, value) {
    el.style.transform = value;
    el.style.webkitTransform = value;
  }
  function opacity(el, value) {
    el.style.opacity = `calc(${value} * var(--ve-theme-overlay-multiplier))`;
  }
  function isTouchEvent(e) {
    return e.constructor.name === "TouchEvent";
  }
  function isKeyboardEvent(e) {
    return e.constructor.name === "KeyboardEvent";
  }
  const calculate = (e, el, value = {}) => {
    var _a;
    let localX = 0;
    let localY = 0;
    if (!isKeyboardEvent(e)) {
      const offset = el.getBoundingClientRect();
      const target = isTouchEvent(e) ? e.touches[e.touches.length - 1] : e;
      localX = target.clientX - offset.left;
      localY = target.clientY - offset.top;
    }
    let radius = 0;
    let scale = 0.3;
    if ((_a = el._ripple) == null ? void 0 : _a.circle) {
      scale = 0.15;
      radius = el.clientWidth / 2;
      radius = value.center ? radius : radius + Math.sqrt((localX - radius) ** 2 + (localY - radius) ** 2) / 4;
    } else {
      radius = Math.sqrt(el.clientWidth ** 2 + el.clientHeight ** 2) / 2;
    }
    const centerX = `${(el.clientWidth - radius * 2) / 2}px`;
    const centerY = `${(el.clientHeight - radius * 2) / 2}px`;
    const x = value.center ? centerX : `${localX - radius}px`;
    const y = value.center ? centerY : `${localY - radius}px`;
    return { radius, scale, x, y, centerX, centerY };
  };
  const ripples = {
    show(e, el, value = {}) {
      var _a;
      if (!((_a = el == null ? void 0 : el._ripple) == null ? void 0 : _a.enabled)) {
        return;
      }
      const container2 = document.createElement("span");
      const animation = document.createElement("span");
      container2.appendChild(animation);
      container2.className = "ve-ripple__container";
      if (value.class) {
        container2.className += ` ${value.class}`;
      }
      const { radius, scale, x, y, centerX, centerY } = calculate(e, el, value);
      const size = `${radius * 2}px`;
      animation.className = "ve-ripple__animation";
      animation.style.width = size;
      animation.style.height = size;
      el.appendChild(container2);
      const computed = window.getComputedStyle(el);
      if (computed && computed.position === "static") {
        el.style.position = "relative";
        el.dataset.previousPosition = "static";
      }
      animation.classList.add("ve-ripple__animation--enter");
      animation.classList.add("ve-ripple__animation--visible");
      transform(animation, `translate(${x}, ${y}) scale3d(${scale},${scale},${scale})`);
      opacity(animation, 0);
      animation.dataset.activated = String(performance.now());
      setTimeout(() => {
        animation.classList.remove("ve-ripple__animation--enter");
        animation.classList.add("ve-ripple__animation--in");
        transform(animation, `translate(${centerX}, ${centerY}) scale3d(1,1,1)`);
        opacity(animation, 0.08);
      }, 0);
    },
    hide(el) {
      var _a;
      if (!((_a = el == null ? void 0 : el._ripple) == null ? void 0 : _a.enabled))
        return;
      const ripples2 = el.getElementsByClassName("ve-ripple__animation");
      if (ripples2.length === 0)
        return;
      const animation = ripples2[ripples2.length - 1];
      if (animation.dataset.isHiding)
        return;
      else
        animation.dataset.isHiding = "true";
      const diff = performance.now() - Number(animation.dataset.activated);
      const delay = Math.max(250 - diff, 0);
      setTimeout(() => {
        animation.classList.remove("ve-ripple__animation--in");
        animation.classList.add("ve-ripple__animation--out");
        opacity(animation, 0);
        setTimeout(() => {
          const ripples3 = el.getElementsByClassName("ve-ripple__animation");
          if (ripples3.length === 1 && el.dataset.previousPosition) {
            el.style.position = el.dataset.previousPosition;
            delete el.dataset.previousPosition;
          }
          animation.parentNode && el.removeChild(animation.parentNode);
        }, 300);
      }, delay);
    }
  };
  function isRippleEnabled(value) {
    return typeof value === "undefined" || !!value;
  }
  function rippleShow(e) {
    const value = {};
    const element = e.currentTarget;
    if (!(element == null ? void 0 : element._ripple) || element._ripple.touched || e[rippleStop])
      return;
    e[rippleStop] = true;
    if (isTouchEvent(e)) {
      element._ripple.touched = true;
      element._ripple.isTouch = true;
    } else {
      if (element._ripple.isTouch)
        return;
    }
    value.center = element._ripple.centered || isKeyboardEvent(e);
    if (element._ripple.class) {
      value.class = element._ripple.class;
    }
    if (isTouchEvent(e)) {
      if (element._ripple.showTimerCommit)
        return;
      element._ripple.showTimerCommit = () => {
        ripples.show(e, element, value);
      };
      element._ripple.showTimer = window.setTimeout(() => {
        var _a;
        if ((_a = element == null ? void 0 : element._ripple) == null ? void 0 : _a.showTimerCommit) {
          element._ripple.showTimerCommit();
          element._ripple.showTimerCommit = null;
        }
      }, DELAY_RIPPLE);
    } else {
      ripples.show(e, element, value);
    }
  }
  function rippleHide(e) {
    const element = e.currentTarget;
    if (!element || !element._ripple)
      return;
    window.clearTimeout(element._ripple.showTimer);
    if (e.type === "touchend" && element._ripple.showTimerCommit) {
      element._ripple.showTimerCommit();
      element._ripple.showTimerCommit = null;
      element._ripple.showTimer = window.setTimeout(() => {
        rippleHide(e);
      });
      return;
    }
    window.setTimeout(() => {
      if (element._ripple) {
        element._ripple.touched = false;
      }
    });
    ripples.hide(element);
  }
  function rippleCancelShow(e) {
    const element = e.currentTarget;
    if (!element || !element._ripple)
      return;
    if (element._ripple.showTimerCommit) {
      element._ripple.showTimerCommit = null;
    }
    window.clearTimeout(element._ripple.showTimer);
  }
  let keyboardRipple = false;
  function keyboardRippleShow(e) {
    if (!keyboardRipple && (e.keyCode === keyCodes.enter || e.keyCode === keyCodes.space)) {
      keyboardRipple = true;
      rippleShow(e);
    }
  }
  function keyboardRippleHide(e) {
    keyboardRipple = false;
    rippleHide(e);
  }
  function focusRippleHide(e) {
    if (keyboardRipple) {
      keyboardRipple = false;
      rippleHide(e);
    }
  }
  function updateRipple(el, binding, wasEnabled) {
    var _a;
    const { value, modifiers } = binding;
    const enabled = isRippleEnabled(value);
    if (!enabled) {
      ripples.hide(el);
    }
    el._ripple = (_a = el._ripple) != null ? _a : {};
    el._ripple.enabled = enabled;
    el._ripple.centered = modifiers.center;
    el._ripple.circle = modifiers.circle;
    if (isObject(value) && value.class) {
      el._ripple.class = value.class;
    }
    if (enabled && !wasEnabled) {
      el.addEventListener("touchstart", rippleShow, { passive: true });
      el.addEventListener("touchend", rippleHide, { passive: true });
      el.addEventListener("touchmove", rippleCancelShow, { passive: true });
      el.addEventListener("touchcancel", rippleHide);
      el.addEventListener("mousedown", rippleShow);
      el.addEventListener("mouseup", rippleHide);
      el.addEventListener("mouseleave", rippleHide);
      el.addEventListener("keydown", keyboardRippleShow);
      el.addEventListener("keyup", keyboardRippleHide);
      el.addEventListener("blur", focusRippleHide);
      el.addEventListener("dragstart", rippleHide, { passive: true });
    } else if (!enabled && wasEnabled) {
      removeListeners(el);
    }
  }
  function removeListeners(el) {
    el.removeEventListener("mousedown", rippleShow);
    el.removeEventListener("touchstart", rippleShow);
    el.removeEventListener("touchend", rippleHide);
    el.removeEventListener("touchmove", rippleCancelShow);
    el.removeEventListener("touchcancel", rippleHide);
    el.removeEventListener("mouseup", rippleHide);
    el.removeEventListener("mouseleave", rippleHide);
    el.removeEventListener("keydown", keyboardRippleShow);
    el.removeEventListener("keyup", keyboardRippleHide);
    el.removeEventListener("dragstart", rippleHide);
    el.removeEventListener("blur", focusRippleHide);
  }
  function mounted(el, binding) {
    updateRipple(el, binding, false);
  }
  function unmounted(el) {
    delete el._ripple;
    removeListeners(el);
  }
  function updated(el, binding) {
    if (binding.value === binding.oldValue) {
      return;
    }
    const wasEnabled = isRippleEnabled(binding.oldValue);
    updateRipple(el, binding, wasEnabled);
  }
  const Ripple = {
    mounted,
    unmounted,
    updated
  };
  var directives = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    Intersect,
    ClickOutside,
    Resize,
    Ripple
  }, Symbol.toStringTag, { value: "Module" }));
  var avatar = "";
  var image = "";
  var responsive = "";
  function useAspectStyles(props) {
    return {
      aspectStyles: vue.computed(() => {
        const ratio = Number(props.aspectRatio);
        return ratio ? {
          paddingBottom: `${String(1 / ratio * 100)}%`
        } : void 0;
      })
    };
  }
  const Responsive = genericComponent()({
    name: "VeResponsive",
    props: __spreadValues({
      aspectRatio: [String, Number],
      contentClass: String
    }, makeDimensionProps()),
    setup(props, {
      slots
    }) {
      const {
        dimensionStyles
      } = useDimension(props);
      const {
        aspectStyles
      } = useAspectStyles(props);
      return () => {
        var _a;
        return vue.createVNode("div", {
          "class": "ve-responsive",
          "style": dimensionStyles.value
        }, [vue.createVNode("div", {
          "class": "ve-responsive__sizer",
          "style": aspectStyles.value
        }, null), (_a = slots.additional) == null ? void 0 : _a.call(slots), slots.default && vue.createVNode("div", {
          "class": ["ve-responsive__content", props.contentClass]
        }, [slots.default()])]);
      };
    }
  });
  function _isSlot$c(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Image = vue.defineComponent({
    name: "VeImage",
    props: __spreadValues({
      aspectRatio: [String, Number],
      alt: String,
      cover: Boolean,
      eager: Boolean,
      gradient: String,
      lazySrc: String,
      options: {
        type: Object,
        default: () => ({
          root: void 0,
          rootMargin: void 0,
          threshold: void 0
        })
      },
      sizes: String,
      src: String,
      srcset: String,
      width: [String, Number]
    }, makeTransitionProps()),
    emits: {
      loadstart: (_src, _image) => true,
      load: (_src, _image) => true,
      error: (_src, _image) => true
    },
    setup(props, {
      emit,
      slots
    }) {
      const currentSrc = vue.ref("");
      const image2 = vue.ref();
      const state = vue.ref(props.eager ? "loading" : "idle");
      const naturalWidth = vue.ref();
      const naturalHeight = vue.ref();
      const aspectRatio = vue.computed(() => {
        return Number(props.aspectRatio || 0) || naturalWidth.value / naturalHeight.value || 0;
      });
      vue.watch(() => props.src, () => {
        init(state.value !== "idle");
      });
      vue.onBeforeMount(() => init());
      function init(isIntersecting) {
        if (props.eager && isIntersecting)
          return;
        if (SUPPORTS_INTERSECTION_OBSERVER && !isIntersecting && !props.eager)
          return;
        state.value = "loading";
        if (props.lazySrc && IN_BROWSER) {
          const lazyImg = new window.Image();
          lazyImg.src = props.lazySrc;
          pollForSize(lazyImg, null);
        }
        if (!props.src)
          return;
        vue.nextTick(() => {
          var _a, _b;
          emit("loadstart", ((_a = image2.value) == null ? void 0 : _a.currentSrc) || props.src, image2.value);
          if ((_b = image2.value) == null ? void 0 : _b.complete) {
            if (!image2.value.naturalWidth)
              onError();
            if (state.value === "error")
              return;
            if (!aspectRatio.value)
              pollForSize(image2.value, null);
            onLoad();
          } else {
            if (!aspectRatio.value)
              pollForSize(image2.value);
            getSrc();
          }
        });
      }
      function onLoad() {
        var _a;
        getSrc();
        state.value = "loaded";
        emit("load", ((_a = image2.value) == null ? void 0 : _a.currentSrc) || props.src, image2.value);
      }
      function onError() {
        var _a;
        state.value = "error";
        emit("error", ((_a = image2.value) == null ? void 0 : _a.currentSrc) || props.src, image2.value);
      }
      function getSrc() {
        const img = image2.value;
        if (img)
          currentSrc.value = img.currentSrc || img.src;
      }
      function pollForSize(img, timeout = 100) {
        const poll = () => {
          const {
            naturalHeight: imgHeight,
            naturalWidth: imgWidth
          } = img;
          if (imgHeight || imgWidth) {
            naturalWidth.value = imgWidth;
            naturalHeight.value = imgHeight;
          } else if (!img.complete && state.value === "loading" && timeout != null) {
            setTimeout(poll, timeout);
          } else if (img.currentSrc.endsWith(".svg") || img.currentSrc.startsWith("data:image/svg+xml")) {
            naturalWidth.value = 1;
            naturalHeight.value = 1;
          }
        };
        poll();
      }
      const containClasses = vue.computed(() => ({
        "ve-image__img--cover": props.cover,
        "ve-image__img--contain": !props.cover
      }));
      const __image = vue.computed(() => {
        var _a;
        let _slot;
        if (!props.src || state.value === "idle")
          return;
        const img = vue.h("img", {
          class: ["ve-image__img", containClasses.value],
          src: props.src,
          srcset: props.srcset,
          sizes: props.sizes,
          ref: image2,
          onLoad,
          onError
        });
        const sources = (_a = slots.sources) == null ? void 0 : _a.call(slots);
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition,
          "appear": true
        }, _isSlot$c(_slot = vue.withDirectives(sources ? vue.createVNode("picture", {
          "class": "ve-image__picture"
        }, [sources, img]) : img, [[vue.vShow, state.value === "loaded"]])) ? _slot : {
          default: () => [_slot]
        });
      });
      const __preloadImage = vue.computed(() => vue.createVNode(MaybeTransition, {
        "transition": props.transition
      }, {
        default: () => [props.lazySrc && state.value !== "loaded" && vue.createVNode("img", {
          "class": ["ve-image__img", "ve-image__img--preload", containClasses.value],
          "src": props.lazySrc,
          "alt": ""
        }, null)]
      }));
      const __placeholder = vue.computed(() => {
        if (!slots.placeholder)
          return;
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition,
          "appear": true
        }, {
          default: () => [(state.value === "loading" || state.value === "error" && !slots.error) && vue.createVNode("div", {
            "class": "ve-image__placeholder"
          }, [slots.placeholder()])]
        });
      });
      const __error = vue.computed(() => {
        if (!slots.error)
          return;
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition,
          "appear": true
        }, {
          default: () => [state.value === "error" && vue.createVNode("div", {
            "class": "ve-image__error"
          }, [slots.error()])]
        });
      });
      const __gradient = vue.computed(() => {
        if (!props.gradient)
          return;
        return vue.createVNode("div", {
          "class": "ve-image__gradient",
          "style": {
            backgroundImage: `linear-gradient(${props.gradient})`
          }
        }, null);
      });
      const isBooted = vue.ref(false);
      {
        const stop = vue.watch(aspectRatio, (val) => {
          if (val) {
            requestAnimationFrame(() => {
              requestAnimationFrame(() => {
                isBooted.value = true;
              });
            });
            stop();
          }
        });
      }
      useRender(() => vue.withDirectives(vue.createVNode(Responsive, {
        "class": ["ve-image", {
          "ve-image--booting": !isBooted.value
        }],
        "style": {
          width: convertToUnit(props.width === "auto" ? naturalWidth.value : props.width)
        },
        "aspectRatio": aspectRatio.value,
        "aria-label": props.alt,
        "role": props.alt ? "img" : void 0
      }, {
        additional: () => [__image.value, __preloadImage.value, __gradient.value, __placeholder.value, __error.value],
        default: slots.default
      }), [[vue.resolveDirective("intersect"), {
        handler: init,
        options: props.options
      }, null, {
        once: true
      }]]));
      return {
        currentSrc,
        image: image2,
        state,
        naturalWidth,
        naturalHeight
      };
    }
  });
  var icon = "";
  const makeIconProps = propsFactory({
    icon: [String, Object, Function],
    tag: {
      type: String,
      default: "i"
    }
  }, "icon");
  const makeIconSetProps = propsFactory({
    icon: {
      type: [String, Object, Function],
      required: true
    },
    tag: {
      type: String,
      required: true
    }
  }, "icon-set");
  const IconClass = defineComponent({
    name: "VeIconClass",
    props: makeIconSetProps(),
    setup(props) {
      return () => {
        return vue.createVNode(props.tag, {
          "class": props.icon
        }, null);
      };
    }
  });
  const mdi = (props) => vue.h(IconClass, __spreadProps(__spreadValues({}, props), { class: "mdi" }));
  const aliases$2 = {
    checkboxIndeterminate: "svg:M17,13H7V11H17M19,3H5C3.89,3 3,3.89 3,5V19C3,20.1 3.9,21 5,21H19C20.1,21 21,20.1 21,19V5C21,3.89 20.1,3 19,3Z",
    checkboxOn: "svg:M10,17L5,12L6.41,10.58L10,14.17L17.59,6.58L19,8M19,3H5C3.89,3 3,3.89 3,5V19C3,20.1 3.9,21 5,21H19C20.1,21 21,20.1 21,19V5C21,3.89 20.1,3 19,3Z",
    checkboxOff: "svg:M19,3H5C3.89,3 3,3.89 3,5V19C3,20.1 3.9,21 5,21H19C20.1,21 21,20.1 21,19V5C21,3.89 20.1,3 19,3M19,5V19H5V5H19Z",
    close: "svg:M19,6.41L17.59,5L12,10.59L6.41,5L5,6.41L10.59,12L5,17.59L6.41,19L12,13.41L17.59,19L19,17.59L13.41,12L19,6.41Z",
    clear: "svg:M12,2C17.53,2 22,6.47 22,12C22,17.53 17.53,22 12,22C6.47,22 2,17.53 2,12C2,6.47 6.47,2 12,2M15.59,7L12,10.59L8.41,7L7,8.41L10.59,12L7,15.59L8.41,17L12,13.41L15.59,17L17,15.59L13.41,12L17,8.41L15.59,7Z",
    collapse: "svg:M7.41,15.41L12,10.83L16.59,15.41L18,14L12,8L6,14L7.41,15.41Z",
    calendar: "svg:M19,4H18V2H16V4H8V2H6V4H5C3.89,4 3,4.9 3,6V20A2,2 0 0,0 5,22H19A2,2 0 0,0 21,20V6A2,2 0 0,0 19,4M19,20H5V10H19V20M19,8H5V6H19V8Z",
    dropdown: "svg:M7.41,8.58L12,13.17L16.59,8.58L18,10L12,16L6,10L7.41,8.58Z",
    error: "svg:M12 2c5.53 0 10 4.47 10 10s-4.47 10-10 10S2 17.53 2 12S6.47 2 12 2m3.59 5L12 10.59L8.41 7L7 8.41L10.59 12L7 15.59L8.41 17L12 13.41L15.59 17L17 15.59L13.41 12L17 8.41L15.59 7Z",
    expand: "svg:M7.41,8.58L12,13.17L16.59,8.58L18,10L12,16L6,10L7.41,8.58Z",
    filter: "svg:M6,13H18V11H6M3,6V8H21V6M10,18H14V16H10V18Z",
    first: "svg:M18.41,16.59L13.82,12L18.41,7.41L17,6L11,12L17,18L18.41,16.59M6,6H8V18H6V6Z",
    info: "svg:M13,9H11V7H13M13,17H11V11H13M12,2C6.48,2 2,6.48 2,12C2,17.52 6.48,22 12,22C17.52,22 22,17.52 22,12C22,6.48 17.52,2 12,2Z",
    last: "svg:M5.59,7.41L10.18,12L5.59,16.59L7,18L13,12L7,6L5.59,7.41M16,6H18V18H16V6Z",
    link: "svg:M3.9,12C3.9,10.29 5.29,8.9 7,8.9H11V7H7A5,5 0 0,0 2,12A5,5 0 0,0 7,17H11V15.1H7C5.29,15.1 3.9,13.71 3.9,12M8,13H16V11H8V13M17,7H13V8.9H17C18.71,8.9 20.1,10.29 20.1,12C20.1,13.71 18.71,15.1 17,15.1H13V17H17A5,5 0 0,0 22,12A5,5 0 0,0 17,7Z",
    menu: "svg:M3,6H21V8H3V6M3,11H21V13H3V11M3,16H21V18H3V16Z",
    next: "svg:M8.59,16.58L13.17,12L8.59,7.41L10,6L16,12L10,18L8.59,16.58Z",
    nextDouble: "svg:M5.59,7.41L7,6L13,12L7,18L5.59,16.59L10.17,12L5.59,7.41M11.59,7.41L13,6L19,12L13,18L11.59,16.59L16.17,12L11.59,7.41Z",
    nodata: "svg:M2.39 1.73L1.11 3L4.21 6.1C4.08 6.39 4 6.69 4 7V17C4 19.21 7.59 21 12 21C14.3 21 16.38 20.5 17.84 19.73L20.84 22.73L22.11 21.46L2.39 1.73M6 9.64C6.76 10.07 7.7 10.42 8.76 10.65L12.11 14C12.07 14 12.04 14 12 14C9.58 14 7.3 13.4 6 12.45V9.64M12 19C8.13 19 6 17.5 6 17V14.77C7.61 15.55 9.72 16 12 16C12.68 16 13.34 15.95 14 15.87L16.34 18.23C15.33 18.65 13.87 19 12 19M8.64 5.44L7.06 3.86C8.42 3.33 10.13 3 12 3C16.42 3 20 4.79 20 7V16.8L18 14.8V14.77L18 14.78L16.45 13.25C17.05 13.03 17.58 12.76 18 12.45V9.64C16.97 10.22 15.61 10.65 14.06 10.86L12.19 9C15.94 8.94 18 7.5 18 7C18 6.5 15.87 5 12 5C10.66 5 9.54 5.18 8.64 5.44Z",
    prev: "svg:M15.41,16.58L10.83,12L15.41,7.41L14,6L8,12L14,18L15.41,16.58Z",
    prevDouble: "svg:M18.41,7.41L17,6L11,12L17,18L18.41,16.59L13.83,12L18.41,7.41M12.41,7.41L11,6L5,12L11,18L12.41,16.59L7.83,12L12.41,7.41Z",
    radioOn: "svg:M12,20C7.58,20 4,16.42 4,12C4,7.58 7.58,4 12,4C16.42,4 20,7.58 20,12C20,16.42 16.42,20 12,20M12,2C6.48,2 2,6.48 2,12C2,17.52 6.48,22 12,22C17.52,22 22,17.52 22,12C22,6.48 17.52,2 12,2M12,7C9.24,7 7,9.24 7,12C7,14.76 9.24,17 12,17C14.76,17 17,14.76 17,12C17,9.24 14.76,7 12,7Z",
    radioOff: "svg:M12,20C7.58,20 4,16.42 4,12C4,7.58 7.58,4 12,4C16.42,4 20,7.58 20,12C20,16.42 16.42,20 12,20M12,2C6.48,2 2,6.48 2,12C2,17.52 6.48,22 12,22C17.52,22 22,17.52 22,12C22,6.48 17.52,2 12,2Z",
    separator: "svg:M7 21L14.9 3H17L9.1 21H7Z",
    sort: "svg:M13,20H11V8L5.5,13.5L4.08,12.08L12,4.16L19.92,12.08L18.5,13.5L13,8V20Z",
    success: "svg:M12,2C17.52,2 22,6.48 22,12C22,17.52 17.52,22 12,22C6.48,22 2,17.52 2,12C2,6.48 6.48,2 12,2M11,16.5L18,9.5L16.59,8.09L11,13.67L7.91,10.59L6.5,12L11,16.5Z",
    toggler: "svg:M8.59,16.58L13.17,12L8.59,7.41L10,6L16,12L10,18L8.59,16.58Z",
    warning: "svg:M13 13h-2V7h2m0 10h-2v-2h2M12 2A10 10 0 0 0 2 12a10 10 0 0 0 10 10a10 10 0 0 0 10-10A10 10 0 0 0 12 2Z"
  };
  const IconSvg = defineComponent({
    name: "VeIconSvg",
    props: __spreadValues({
      viewBox: {
        type: String,
        default: "0 0 24 24"
      }
    }, makeIconSetProps()),
    setup(props) {
      return () => {
        const isString = typeof props.icon === "string";
        return vue.createVNode(props.tag, null, {
          default: () => [isString ? vue.createVNode("svg", {
            "xmlns": "http://www.w3.org/2000/svg",
            "viewBox": props.viewBox,
            "role": "img",
            "aria-hidden": "true"
          }, [vue.createVNode("path", {
            "d": props.icon
          }, null)]) : vue.createVNode(props.icon, {
            "role": "img",
            "aria-hidden": "true"
          }, null)]
        });
      };
    }
  });
  const IconLigature = defineComponent({
    name: "VeIconLigature",
    props: makeIconSetProps(),
    setup(props) {
      return () => {
        return vue.createVNode(props.tag, null, {
          default: () => [props.icon]
        });
      };
    }
  });
  const IconsKey = createSymbol("icons");
  function useIcons() {
    const icons = vue.inject(IconsKey);
    if (!icons)
      throw new Error("[VenoUi] Could not find icons instance");
    return icons;
  }
  function createIcons(options) {
    return deepMerge({
      defaultSet: "mdi",
      sets: {
        mdi,
        svg: IconSvg,
        class: IconClass,
        ligature: IconLigature
      },
      aliases: aliases$2
    }, options || {});
  }
  const IconComponent = defineComponent({
    name: "VeIconComponent",
    props: makeIconSetProps(),
    setup(props) {
      return () => {
        return vue.createVNode(props.tag, null, {
          default: () => [vue.createVNode(props.icon, {
            "role": "img",
            "aria-hidden": "true"
          }, null)]
        });
      };
    }
  });
  const useIcon = (props) => {
    const icons = useIcons();
    const iconData = vue.computed(() => {
      var _a;
      const { icon: value } = vue.unref(props);
      if (!value) {
        consoleError("Icon value is undefined or null");
        return;
      }
      const icon2 = typeof value === "string" && value.includes("$") ? (_a = icons.aliases) == null ? void 0 : _a[value.slice(value.indexOf("$") + 1)] : value;
      if (!icon2) {
        consoleError(`Could not find aliased icon "${value}"`);
        return;
      }
      if (typeof icon2 !== "string")
        return { component: IconComponent, icon: icon2 };
      const setName = Object.keys(icons.sets).find((v) => icon2.startsWith(`${v}:`));
      return {
        component: icons.sets[setName != null ? setName : icons.defaultSet],
        icon: setName ? icon2.slice(setName.length + 1) : icon2
      };
    });
    return { iconData };
  };
  const Icon = vue.defineComponent({
    name: "VeIcon",
    props: __spreadValues(__spreadValues({
      color: String,
      start: Boolean,
      end: Boolean
    }, makeSizeProps()), makeIconProps()),
    setup(props, {
      slots
    }) {
      const {
        iconData
      } = useIcon(vue.computed(() => {
        var _a, _b;
        if (!slots.default)
          return props;
        const slot = (_a = slots.default) == null ? void 0 : _a.call(slots);
        if (!slot)
          return props;
        const nodes = flattenFragments(slot);
        if (typeof ((_b = nodes == null ? void 0 : nodes[0]) == null ? void 0 : _b.children) === "string") {
          return {
            tag: props.tag,
            icon: nodes[0].children
          };
        }
        return {
          tag: props.tag,
          icon: () => slot
        };
      }));
      const {
        sizeClasses
      } = useSize(props);
      const {
        textColorClasses,
        textColorStyles
      } = useTextColor(vue.toRef(props, "color"));
      return () => {
        if (!iconData.value)
          return;
        return vue.createVNode(iconData.value.component, {
          "tag": props.tag,
          "icon": iconData.value.icon,
          "class": ["ve-icon", "notranslate", sizeClasses.value, textColorClasses.value, {
            "ve-icon--start": props.start,
            "ve-icon--end": props.end
          }],
          "style": [!sizeClasses.value ? {
            fontSize: convertToUnit(props.size),
            width: convertToUnit(props.size),
            height: convertToUnit(props.size)
          } : void 0, textColorStyles.value],
          "aria-hidden": "true"
        }, null);
      };
    }
  });
  const RADIX = 0.8;
  const makeAvatarProps = propsFactory(__spreadValues({
    start: Boolean,
    end: Boolean,
    image: String,
    icon: [String, Object],
    text: String,
    link: Boolean
  }, makePaperProps({
    color: "secondary",
    shape: "circle"
  })), "avatar");
  const Avatar = defineComponent({
    name: "VeAvatar",
    directives: {
      Resize
    },
    props: makeAvatarProps(),
    setup(props, {
      slots,
      attrs
    }) {
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const rootRef = vue.ref();
      const contentRef = vue.ref();
      function onResize() {
        vue.nextTick(() => {
          if (!rootRef.value || !contentRef.value)
            return;
          const ratio = Math.min(rootRef.value.offsetWidth / contentRef.value.offsetWidth * RADIX, rootRef.value.offsetHeight / contentRef.value.offsetHeight * RADIX, 1);
          contentRef.value.style.transform = `translateX(-50%) translateY(-50%) scale(${ratio})`;
        });
      }
      vue.watch(vue.toRef(props, "text"), onResize);
      return () => {
        const hasImage = !!props.image;
        const hasIcon = !!props.icon;
        const hasText = !!props.text;
        const isClickable = props.link || !!(attrs.onClick || attrs.onClickOnce);
        return vue.withDirectives(vue.createVNode(props.tag, {
          "class": ["ve-avatar", {
            "ve-avatar--start": props.start,
            "ve-avatar--end": props.end,
            "ve-avatar--icon": props.icon,
            "ve-avatar--link": isClickable
          }, paperClasses.value],
          "style": paperStyles.value,
          "ref": rootRef
        }, {
          default: () => {
            var _a;
            return [hasImage && vue.createVNode(Image, {
              "src": props.image,
              "alt": ""
            }, null), hasIcon && !hasImage && vue.createVNode(Icon, {
              "icon": props.icon,
              "size": props.size
            }, null), hasText && !hasIcon && !hasImage && vue.createVNode("span", {
              "class": "ve-avatar__wrapper",
              "ref": contentRef
            }, [props.text]), (_a = slots.default) == null ? void 0 : _a.call(slots)];
          }
        }), [[vue.resolveDirective("resize"), onResize]]);
      };
    }
  });
  var divider = "";
  const VeDividerTextAligns = ["left", "center", "right"];
  const Divider = genericComponent()({
    name: "VeDivider",
    props: __spreadValues({
      textAlign: {
        type: String,
        default: "center",
        validator: (val) => VeDividerTextAligns.includes(val)
      },
      length: [Number, String],
      dashed: Boolean,
      vertical: Boolean
    }, makeTagProps({
      tag: "hr"
    })),
    setup(props, {
      attrs,
      slots
    }) {
      const dividerStyles = vue.computed(() => {
        const styles = {};
        if (props.length) {
          styles[props.vertical ? "maxHeight" : "maxWidth"] = convertToUnit(props.length);
        }
        return styles;
      });
      return () => {
        var _a;
        const hasDefaultSlot = !!slots.default;
        const Tag2 = hasDefaultSlot ? "div" : props.tag;
        const role = (_a = attrs.role) != null ? _a : "separator";
        return vue.createVNode(Tag2, {
          "class": ["ve-divider", {
            "ve-divider--dashed": props.dashed,
            "ve-divider--vertical": props.vertical,
            "ve-divider--text": hasDefaultSlot,
            "ve-divider--text-left": props.textAlign === "left",
            "ve-divider--text-right": props.textAlign === "right"
          }],
          "style": [dividerStyles.value],
          "aria-orientation": role === "separator" ? props.vertical ? "vertical" : "horizontal" : void 0,
          "role": role
        }, {
          default: hasDefaultSlot ? () => {
            var _a2;
            return [vue.createVNode(vue.Fragment, null, [vue.createVNode("div", {
              "class": "ve-divider__line"
            }, null), vue.createVNode("div", {
              "class": "ve-divider__wrap"
            }, [(_a2 = slots.default) == null ? void 0 : _a2.call(slots)]), vue.createVNode("div", {
              "class": "ve-divider__line"
            }, null)])];
          } : void 0
        });
      };
    }
  });
  var cardImage = "";
  const CardImage = createSimpleFunctional("ve-card-image");
  var cardAvatar = "";
  const CardAvatar = createSimpleFunctional("ve-card-avatar");
  var cardHeader = "";
  const CardHeader = createSimpleFunctional("ve-card-header");
  var cardHeaderText = "";
  const CardHeaderText = createSimpleFunctional("ve-card-header-text");
  var cardTitle = "";
  const CardTitle = createSimpleFunctional("ve-card-title");
  var cardSubtitle = "";
  const CardSubtitle = createSimpleFunctional("ve-card-subtitle");
  var cardText = "";
  const CardText = createSimpleFunctional("ve-card-text");
  var cardActions = "";
  const CardActions = createSimpleFunctional("ve-card-actions");
  function _isSlot$b(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const makeCardProps = propsFactory(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
    link: Boolean,
    hover: Boolean,
    image: String,
    prependAvatar: String,
    prependIcon: String,
    appendAvatar: String,
    appendIcon: String,
    title: String,
    subtitle: String,
    divided: Boolean,
    text: String,
    ripple: {
      type: Boolean,
      default: true
    }
  }, makeRouterProps()), makeLoadingProps()), makeDisabledProps()), makePaperProps({
    shape: "rounded-sm",
    variant: "contained"
  })), "card");
  const Card = defineComponent({
    name: "VeCard",
    directives: {
      Ripple
    },
    props: makeCardProps(),
    setup(props, {
      attrs,
      slots
    }) {
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const link2 = useLink(props, attrs);
      const {
        loadingClasses
      } = useLoading(props);
      const {
        disabledClasses
      } = useDisabled(props);
      return () => {
        let _slot;
        const Tag2 = link2.isLink.value ? "a" : props.tag;
        const hasImage = !!(slots.image || props.image);
        const hasTitle = !!(slots.title || props.title);
        const hasSubtitle = !!(slots.subtitle || props.subtitle);
        const hasHeaderText = !!slots.headerText || hasTitle || hasSubtitle;
        const hasPrepend = !!(slots.prepend || props.prependAvatar || props.prependIcon);
        const hasAppend = !!(slots.append || props.appendAvatar || props.appendIcon);
        const hasHeader = !!slots.header || hasHeaderText || hasPrepend || hasAppend;
        const hasText = !!(slots.text || props.text);
        const isClickable = !props.disabled && (link2.isClickable.value || props.link);
        return vue.withDirectives(vue.createVNode(Tag2, {
          "class": ["ve-card", {
            "ve-card--hover": props.hover && !props.disabled,
            "ve-card--link": isClickable
          }, paperClasses.value, loadingClasses.value, disabledClasses.value],
          "style": paperStyles.value,
          "href": link2.href.value,
          "onClick": isClickable && link2.navigate
        }, {
          default: () => {
            var _a, _b;
            return [genOverlays(isClickable, "ve-card"), hasImage && vue.createVNode(CardImage, null, {
              default: () => {
                var _a2, _b2;
                return [(_b2 = (_a2 = slots.image) == null ? void 0 : _a2.call(slots, {
                  src: props.image
                })) != null ? _b2 : vue.createVNode(Image, {
                  "src": props.image,
                  "cover": true
                }, null)];
              }
            }), (_a = slots.media) == null ? void 0 : _a.call(slots), hasHeader && vue.createVNode(CardHeader, null, {
              default: () => {
                var _a2, _b2;
                return [(_b2 = (_a2 = slots.header) == null ? void 0 : _a2.call(slots)) != null ? _b2 : vue.createVNode(vue.Fragment, null, [hasPrepend && vue.createVNode(CardAvatar, null, {
                  default: () => {
                    var _a3, _b3;
                    return [(_b3 = (_a3 = slots.prepend) == null ? void 0 : _a3.call(slots)) != null ? _b3 : vue.createVNode(Avatar, {
                      "density": props.density,
                      "icon": props.prependIcon,
                      "image": props.prependAvatar
                    }, null)];
                  }
                }), hasHeaderText && vue.createVNode(CardHeaderText, null, {
                  default: () => {
                    var _a3, _b3;
                    return [(_b3 = (_a3 = slots.headerText) == null ? void 0 : _a3.call(slots)) != null ? _b3 : vue.createVNode(vue.Fragment, null, [hasTitle && vue.createVNode(CardTitle, null, {
                      default: () => {
                        var _a4, _b4;
                        return [(_b4 = (_a4 = slots.title) == null ? void 0 : _a4.call(slots)) != null ? _b4 : props.title];
                      }
                    }), hasSubtitle && vue.createVNode(CardSubtitle, null, {
                      default: () => {
                        var _a4, _b4;
                        return [(_b4 = (_a4 = slots.subtitle) == null ? void 0 : _a4.call(slots)) != null ? _b4 : props.subtitle];
                      }
                    })])];
                  }
                }), hasAppend && vue.createVNode(CardAvatar, null, {
                  default: () => {
                    var _a3, _b3;
                    return [(_b3 = (_a3 = slots.append) == null ? void 0 : _a3.call(slots)) != null ? _b3 : vue.createVNode(Avatar, {
                      "density": props.density,
                      "icon": props.appendIcon,
                      "image": props.appendAvatar
                    }, null)];
                  }
                })])];
              }
            }), props.divided && vue.createVNode(Divider, null, null), hasText && vue.createVNode(CardText, null, {
              default: () => {
                var _a2, _b2;
                return [(_b2 = (_a2 = slots.text) == null ? void 0 : _a2.call(slots)) != null ? _b2 : props.text];
              }
            }), (_b = slots.default) == null ? void 0 : _b.call(slots), slots.actions && props.divided && vue.createVNode(Divider, null, null), slots.actions && vue.createVNode(CardActions, null, _isSlot$b(_slot = slots.actions()) ? _slot : {
              default: () => [_slot]
            })];
          }
        }), [[vue.resolveDirective("ripple"), isClickable && props.ripple]]);
      };
    }
  });
  function filterCardProps(props) {
    return pick(props, Object.keys(Card.props));
  }
  var button = "";
  const makeGroupProps = propsFactory({
    modelValue: {
      type: [Number, Boolean, String, Array, Object],
      default: void 0
    },
    multiple: Boolean,
    mandatory: [Boolean, String],
    max: Number,
    selectedClass: String,
    disabled: Boolean
  }, "group");
  const makeGroupItemProps = propsFactory({
    value: null,
    disabled: Boolean,
    selectedClass: String
  }, "group-item");
  function useGroupItem(props, injectKey, required = true) {
    const vm = vue.getCurrentInstance();
    if (!vm) {
      throw new Error("[VenoUi] useGroupItem composable must be used inside a component setup function");
    }
    const group = vue.inject(injectKey, null);
    if (!group) {
      if (!required)
        return group;
      throw new Error(`[VenoUi] Could not find useGroup injection with symbol ${injectKey.description}`);
    }
    const id = `ve-group-item-${getUid()}`;
    const value = vue.toRef(props, "value");
    const disabled = vue.computed(() => group.disabled.value || props.disabled);
    group.register({
      id,
      value,
      disabled
    }, vm);
    vue.onBeforeUnmount(() => group.unregister(id));
    const isSelected = vue.computed(() => group.isSelected(id));
    const selectedClass = vue.computed(() => {
      var _a;
      return isSelected.value && ((_a = group.selectedClass.value) != null ? _a : props.selectedClass);
    });
    return {
      id,
      isSelected,
      toggle: () => group.select(id, !isSelected.value),
      select: (value2) => group.select(id, value2),
      selectedClass,
      value,
      disabled,
      group
    };
  }
  function useGroup(props, injectKey) {
    let isUnmounted = false;
    const items = vue.ref([]);
    const selected = useProxiedModel(props, "modelValue", [], (v) => {
      if (v == null)
        return [];
      return getIds(items.value, wrapInArray(v));
    }, (v) => {
      const arr = getValues(items.value, v);
      return props.multiple ? arr : arr[0];
    });
    const groupVm = vue.getCurrentInstance();
    function register(item, vm) {
      const unwrapped = item;
      const index2 = findChildren(groupVm == null ? void 0 : groupVm.vnode).slice(1).filter((cmp) => !!cmp.provides[injectKey]).indexOf(vm);
      if (index2 > -1)
        items.value.splice(index2, 0, unwrapped);
      else
        items.value.push(unwrapped);
    }
    function unregister(id) {
      if (isUnmounted)
        return;
      selected.value = selected.value.filter((v) => v !== id);
      forceMandatoryValue();
      const index2 = items.value.findIndex((item) => item.id === id);
      items.value.splice(index2, 1);
    }
    function forceMandatoryValue() {
      const item = items.value.find((item2) => !item2.disabled);
      if (item && props.mandatory === "force" && !selected.value.length) {
        selected.value = [item.id];
      }
    }
    vue.onMounted(() => {
      forceMandatoryValue();
    });
    vue.onBeforeUnmount(() => {
      isUnmounted = true;
    });
    function select2(id, isSelected) {
      const item = items.value.find((item2) => item2.id === id);
      if (isSelected && (item == null ? void 0 : item.disabled))
        return;
      if (props.multiple) {
        const internalValue = selected.value.slice();
        const index2 = internalValue.findIndex((v) => v === id);
        if (props.mandatory && index2 > -1 && internalValue.length <= 1)
          return;
        if (props.max != null && index2 < 0 && internalValue.length + 1 > props.max)
          return;
        if (index2 < 0 && isSelected)
          internalValue.push(id);
        else if (index2 >= 0 && !isSelected)
          internalValue.splice(index2, 1);
        selected.value = internalValue;
      } else {
        if (props.mandatory && selected.value.includes(id))
          return;
        selected.value = isSelected ? [id] : [];
      }
    }
    function step(offset) {
      if (props.multiple)
        consoleWarn('This method is not supported when using "multiple" prop');
      if (!selected.value.length) {
        const item = items.value.find((item2) => !item2.disabled);
        item && (selected.value = [item.id]);
      } else {
        const currentId = selected.value[0];
        const currentIndex = items.value.findIndex((i) => i.id === currentId);
        let newIndex = (currentIndex + offset) % items.value.length;
        let newItem = items.value[newIndex];
        while (newItem.disabled && newIndex !== currentIndex) {
          newIndex = (newIndex + offset) % items.value.length;
          newItem = items.value[newIndex];
        }
        if (newItem.disabled)
          return;
        selected.value = [items.value[newIndex].id];
      }
    }
    const state = {
      vm: groupVm,
      register,
      unregister,
      selected,
      select: select2,
      disabled: vue.toRef(props, "disabled"),
      prev: () => step(items.value.length - 1),
      next: () => step(1),
      isSelected: (id) => selected.value.includes(id),
      selectedClass: vue.computed(() => props.selectedClass),
      items
    };
    vue.provide(injectKey, state);
    return state;
  }
  function getIds(items, modelValue) {
    const ids = [];
    for (const item of items) {
      if (item.value != null) {
        if (modelValue.find((value) => deepEqual(value, item.value)) != null) {
          ids.push(item.id);
        }
      } else if (modelValue.includes(item.id)) {
        ids.push(item.id);
      }
    }
    return ids;
  }
  function getValues(items, ids) {
    const values = [];
    for (const item of items) {
      if (ids.includes(item.id)) {
        values.push(item.value != null ? item.value : item.id);
      }
    }
    return values;
  }
  var progressCircular = "";
  var progressLinear = "";
  const makeProgressLinearProps = propsFactory({
    active: {
      type: Boolean,
      default: true
    },
    modelValue: {
      type: [Number, String],
      default: 0
    },
    strokeWidth: {
      type: [Number, String],
      default: 2
    },
    indeterminate: Boolean,
    underlay: {
      type: Boolean,
      default: true
    }
  }, "progress-linear");
  const ProgressLinear = defineComponent({
    name: "VeProgressLinear",
    props: makeProgressLinearProps(),
    setup(props) {
      const model = vue.computed(() => Math.max(0, Math.min(100, parseFloat(props.modelValue))));
      const height = vue.computed(() => Number(props.strokeWidth));
      return () => vue.createVNode("div", {
        "class": ["ve-progress-linear", {
          "ve-progress-linear--active": props.active,
          "ve-progress-linear--indeterminate": props.indeterminate
        }],
        "style": {
          height: props.active ? convertToUnit(height.value) : 0
        }
      }, [props.underlay && vue.createVNode("div", {
        "class": "ve-progress-linear__underlay"
      }, null), vue.createVNode("div", {
        "class": "ve-progress-linear__overlay",
        "style": {
          width: convertToUnit(model.value, "%")
        }
      }, null)]);
    }
  });
  function filterProgressLinearProps(attrs) {
    return pick(attrs, Object.keys(ProgressLinear.props));
  }
  const diameter = 24;
  const makeProgressCircularProps = propsFactory(__spreadValues({
    size: {
      type: [String, Number],
      default: diameter
    },
    rotate: {
      type: [Number, String],
      default: 0
    }
  }, makeProgressLinearProps()), "progress-circular");
  const ProgressCircular = defineComponent({
    name: "VeProgressCircular",
    props: makeProgressCircularProps(),
    setup(props) {
      const model = vue.computed(() => Math.max(0, Math.min(100, parseFloat(props.modelValue))));
      const radius = vue.computed(() => {
        const rate = Math.max(Number(props.strokeWidth) && Number(props.size) ? 1 - Number(props.strokeWidth) / Number(props.size) : 0.5, 0.5);
        return diameter * rate / 2;
      });
      const strokeWidth = vue.computed(() => diameter - radius.value * 2);
      const circumference = vue.computed(() => 2 * Math.PI * radius.value);
      const offset = vue.computed(() => convertToUnit((100 - model.value) / 100 * circumference.value));
      return () => vue.createVNode("svg", {
        "class": ["ve-progress-circular", {
          "ve-progress-circular--active": props.active,
          "ve-progress-circular--indeterminate": props.indeterminate
        }],
        "style": {
          transform: `rotate(calc(-90deg + ${Number(props.rotate)}deg))`
        },
        "xmlns": "http://www.w3.org/2000/svg",
        "viewBox": `0 0 ${diameter} ${diameter}`
      }, [props.underlay && vue.createVNode("circle", {
        "class": "ve-progress-circular__underlay",
        "fill": "transparent",
        "cx": "50%",
        "cy": "50%",
        "r": radius.value,
        "stroke-width": strokeWidth.value,
        "stroke-dasharray": circumference.value,
        "stroke-dashoffset": 0
      }, null), vue.createVNode("circle", {
        "class": "ve-progress-circular__overlay",
        "fill": "transparent",
        "cx": "50%",
        "cy": "50%",
        "r": radius.value,
        "stroke-width": strokeWidth.value,
        "stroke-dasharray": circumference.value,
        "stroke-dashoffset": offset.value
      }, null)]);
    }
  });
  function filterProgressCircularProps(attrs) {
    return pick(attrs, Object.keys(ProgressCircular.props));
  }
  var fadeTransition = "";
  function createCssTransition(name, origin = "top center 0", mode) {
    return vue.defineComponent({
      name,
      props: {
        group: Boolean,
        hideOnLeave: Boolean,
        leaveAbsolute: Boolean,
        mode: {
          type: String,
          default: mode
        },
        origin: {
          type: String,
          default: origin
        },
        onBeforeEnter: Function,
        onLeave: Function,
        onAfterLeave: Function
      },
      setup(props, { slots, attrs }) {
        return () => {
          const tag2 = props.group ? vue.TransitionGroup : vue.Transition;
          return vue.h(tag2, __spreadValues({
            name,
            mode: props.mode,
            onBeforeEnter(el) {
              var _a;
              el.style.transformOrigin = props.origin;
              (_a = props.onBeforeEnter) == null ? void 0 : _a.call(props, el);
            },
            onLeave(el) {
              var _a;
              if (props.leaveAbsolute) {
                const { offsetTop, offsetLeft, offsetWidth, offsetHeight } = el;
                el._transitionInitialStyles = {
                  position: el.style.position,
                  top: el.style.top,
                  left: el.style.left,
                  width: el.style.width,
                  height: el.style.height
                };
                el.style.position = "absolute";
                el.style.top = `${offsetTop}px`;
                el.style.left = `${offsetLeft}px`;
                el.style.width = `${offsetWidth}px`;
                el.style.height = `${offsetHeight}px`;
              }
              if (props.hideOnLeave) {
                el._initialDisplay = el.style.display;
                el.style.display = "none";
              }
              (_a = props.onLeave) == null ? void 0 : _a.call(props, el);
            },
            onAfterLeave(el) {
              var _a;
              if (props.leaveAbsolute && (el == null ? void 0 : el._transitionInitialStyles)) {
                const { position, top, left, width, height } = el._transitionInitialStyles;
                delete el._transitionInitialStyles;
                el.style.position = position || "";
                el.style.top = top || "";
                el.style.left = left || "";
                el.style.width = width || "";
                el.style.height = height || "";
              }
              if (props.hideOnLeave && el) {
                el.style.display = el._initialDisplay || "";
              }
              (_a = props.onAfterLeave) == null ? void 0 : _a.call(props, el);
            }
          }, attrs), slots.default);
        };
      }
    });
  }
  function createJavascriptTransition(name, functions, mode = "in-out") {
    return vue.defineComponent({
      name,
      props: {
        group: Boolean,
        mode: {
          type: String,
          default: mode
        },
        onBeforeEnter: Function,
        onLeave: Function,
        onAfterLeave: Function
      },
      setup(props, { slots }) {
        return () => {
          const tag2 = props.group ? vue.TransitionGroup : vue.Transition;
          return vue.h(tag2, __spreadProps(__spreadValues({
            name
          }, functions), {
            onBeforeEnter(el) {
              var _a, _b;
              (_a = functions.onBeforeEnter) == null ? void 0 : _a.call(functions, el);
              (_b = props.onBeforeEnter) == null ? void 0 : _b.call(props, el);
            },
            onLeave(el) {
              var _a, _b;
              (_a = functions.onLeave) == null ? void 0 : _a.call(functions, el);
              (_b = props.onLeave) == null ? void 0 : _b.call(props, el);
            },
            onAfterLeave(el) {
              var _a, _b;
              (_a = functions.onAfterLeave) == null ? void 0 : _a.call(functions, el);
              (_b = props.onAfterLeave) == null ? void 0 : _b.call(props, el);
            }
          }), slots.default);
        };
      }
    });
  }
  const FadeTransition = createCssTransition("ve-fade-transition");
  var scaleTransition = "";
  const ScaleTransition = createCssTransition("ve-scale-transition");
  var expandTransition = "";
  function expandTransitionGenerator(expandedParentClass = "", x = false) {
    const sizeProperty = x ? "width" : "height";
    const offsetProperty = vue.camelize(`offset-${sizeProperty}`);
    return {
      onBeforeEnter(el) {
        el._parent = el.parentNode;
        el._initialStyle = {
          transition: el.style.transition,
          overflow: el.style.overflow,
          [sizeProperty]: el.style[sizeProperty]
        };
      },
      onEnter(el) {
        const initialStyle = el._initialStyle;
        el.style.setProperty("transition", "none", "important");
        el.style.overflow = "hidden";
        const offset = `${el[offsetProperty]}px`;
        el.style[sizeProperty] = "0";
        void el.offsetHeight;
        el.style.transition = initialStyle.transition;
        if (expandedParentClass && el._parent) {
          el._parent.classList.add(expandedParentClass);
        }
        requestAnimationFrame(() => {
          el.style[sizeProperty] = offset;
        });
      },
      onAfterEnter: resetStyles,
      onEnterCancelled: resetStyles,
      onLeave(el) {
        el._initialStyle = {
          transition: "",
          overflow: el.style.overflow,
          [sizeProperty]: el.style[sizeProperty]
        };
        el.style.overflow = "hidden";
        el.style[sizeProperty] = `${el[offsetProperty]}px`;
        void el.offsetHeight;
        requestAnimationFrame(() => el.style[sizeProperty] = "0");
      },
      onAfterLeave,
      onLeaveCancelled: onAfterLeave
    };
    function onAfterLeave(el) {
      if (expandedParentClass && el._parent) {
        el._parent.classList.remove(expandedParentClass);
      }
      resetStyles(el);
    }
    function resetStyles(el) {
      const size = el._initialStyle[sizeProperty];
      el.style.overflow = el._initialStyle.overflow;
      if (size != null)
        el.style[sizeProperty] = size;
      delete el._initialStyle;
    }
  }
  function fadeInExpandTransitionGenerator(x = false, reverse = false) {
    return {
      onBeforeLeave: (el) => {
        if (x) {
          el.style.maxWidth = `${el.offsetWidth}px`;
        } else {
          el.style.maxHeight = `${el.offsetHeight}px`;
        }
        void el.offsetWidth;
      },
      onLeave: (el) => {
        if (x) {
          el.style.maxWidth = "0";
        } else {
          el.style.maxHeight = "0";
        }
        void el.offsetWidth;
      },
      onAfterLeave: (el) => {
        if (x) {
          el.style.maxWidth = "";
        } else {
          el.style.maxHeight = "";
        }
      },
      onEnter: (el) => {
        el.style.transition = "none";
        if (x) {
          const memorizedWidth = el.offsetWidth;
          el.style.maxWidth = "0";
          void el.offsetWidth;
          el.style.transition = "";
          el.style.maxWidth = `${memorizedWidth}px`;
        } else {
          if (reverse) {
            el.style.maxHeight = `${el.offsetHeight}px`;
            void el.offsetHeight;
            el.style.transition = "";
            el.style.maxHeight = "0";
          } else {
            const memorizedHeight = el.offsetHeight;
            el.style.maxHeight = "0";
            void el.offsetWidth;
            el.style.transition = "";
            el.style.maxHeight = `${memorizedHeight}px`;
          }
        }
        void el.offsetWidth;
      },
      onAfterEnter: (el) => {
        if (x) {
          el.style.maxWidth = "";
        } else {
          if (!reverse) {
            el.style.maxHeight = "";
          }
        }
      }
    };
  }
  const ExpandTransition = createJavascriptTransition("ve-expand-transition", expandTransitionGenerator());
  const ExpandXTransition = createJavascriptTransition("ve-expand-x-transition", expandTransitionGenerator("", true));
  const useSharedClick = createSharedComposable(() => {
    const clickedEl = vue.ref();
    const clickedPosition = vue.ref();
    const onClick = (e) => {
      clickedEl.value = e.target;
      clickedPosition.value = { left: e.clientX, top: e.clientY };
    };
    document.addEventListener("click", onClick);
    vue.onScopeDispose(() => {
      document.removeEventListener("click", onClick);
    });
    return {
      clickedEl,
      clickedPosition: vue.readonly(clickedPosition)
    };
  });
  const DialogTransition = defineComponent({
    name: "VeDialogTransition",
    props: {
      target: Object
    },
    setup(props, {
      slots
    }) {
      const {
        clickedEl
      } = useSharedClick();
      const targetEl = vue.ref();
      const getTransformOrigin = (el) => {
        if (targetEl.value && document.documentElement.contains(targetEl.value)) {
          const {
            x,
            y
          } = getDimensions(targetEl.value, el);
          return `${x}px ${y}px`;
        }
        return "center";
      };
      const functions = {
        onBeforeEnter(el) {
          el.style.pointerEvents = "none";
        },
        async onEnter(el, done) {
          var _a;
          await new Promise((resolve) => requestAnimationFrame(resolve));
          targetEl.value = (_a = props.target) != null ? _a : clickedEl.value;
          el.style.transformOrigin = getTransformOrigin(el);
          el.animate([{
            transform: "scale(0.5)",
            opacity: 0
          }, {
            transform: ""
          }], {
            duration: 225,
            easing: deceleratedEasing
          }).finished.then(() => done());
        },
        onAfterEnter(el) {
          el.style.removeProperty("pointer-events");
          el.style.removeProperty("transform-origin");
        },
        onBeforeLeave(el) {
          el.style.pointerEvents = "none";
        },
        async onLeave(el, done) {
          await new Promise((resolve) => requestAnimationFrame(resolve));
          el.style.transformOrigin = getTransformOrigin(el);
          el.animate([{
            transform: ""
          }, {
            transform: "scale(0.5)",
            opacity: 0
          }], {
            duration: 125,
            easing: acceleratedEasing
          }).finished.then(() => done());
        },
        onAfterLeave(el) {
          el.style.removeProperty("pointer-events");
          el.style.removeProperty("transform-origin");
        }
      };
      return () => {
        return vue.createVNode(vue.Transition, vue.mergeProps({
          "name": "dialog-transition"
        }, functions, {
          "css": false
        }), slots);
      };
    }
  });
  function getDimensions(target, el) {
    const targetBox = target.getBoundingClientRect();
    const elBox = nullifyTransforms(el);
    const [anchorSide, anchorOffset] = getComputedStyle(el).getPropertyValue("--ve-overlay-anchor-origin").split(" ");
    let offsetX = targetBox.left + targetBox.width / 2;
    if (anchorSide === "left" || anchorOffset === "left") {
      offsetX -= targetBox.width / 2;
    } else if (anchorSide === "right" || anchorOffset === "right") {
      offsetX += targetBox.width / 2;
    }
    let offsetY = targetBox.top + targetBox.height / 2;
    if (anchorSide === "top" || anchorOffset === "top") {
      offsetY -= targetBox.height / 2;
    } else if (anchorSide === "bottom" || anchorOffset === "bottom") {
      offsetY += targetBox.height / 2;
    }
    return {
      x: offsetX - elBox.left,
      y: offsetY - elBox.top
    };
  }
  var menuTransition = "";
  const MenuTransition = createCssTransition("ve-menu-transition");
  var fadeInExpandTransition = "";
  const FadeInExpandTransition = createJavascriptTransition("ve-fade-in-expand-transition", fadeInExpandTransitionGenerator());
  var slideRightFadeInExpandTransition = "";
  const SlideRightFadeInExpandTransition = createJavascriptTransition("ve-slide-right-fade-in-expand-transition", fadeInExpandTransitionGenerator());
  var buttonGroup = "";
  const ButtonGroup = defineComponent({
    name: "VeButtonGroup",
    props: __spreadValues(__spreadValues({
      divided: Boolean
    }, makeDisabledProps()), makePaperProps({
      shape: "rounded-sm"
    })),
    setup(props, {
      slots
    }) {
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      provideDefaults(vue.reactive({
        VeButton: {
          disabled: vue.toRef(props, "disabled"),
          height: "auto",
          color: vue.toRef(props, "color"),
          variant: vue.toRef(props, "variant")
        }
      }));
      return () => {
        return vue.createVNode(props.tag, {
          "class": ["ve-button-group", {
            "ve-button-group--divided": props.divided
          }, paperClasses.value],
          "style": [paperStyles.value]
        }, slots);
      };
    }
  });
  const ButtonToggleKey = Symbol.for("veno-ui:button-toggle");
  const ButtonToggle = defineComponent({
    name: "VeButtonToggle",
    props: __spreadValues({}, makeGroupProps({
      selectedClass: "ve-button--selected"
    })),
    emits: {
      "update:modelValue": (_value) => true
    },
    setup(props, {
      slots
    }) {
      const {
        isSelected,
        next,
        prev,
        select: select2,
        selected
      } = useGroup(props, ButtonToggleKey);
      useRender(() => {
        return vue.createVNode(ButtonGroup, {
          "class": "ve-button-toggle"
        }, {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots, {
              isSelected,
              next,
              prev,
              select: select2,
              selected
            })];
          }
        });
      });
      return {
        next,
        prev,
        select: select2
      };
    }
  });
  const makeButtonProps = propsFactory(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
    type: {
      type: String,
      default: "button"
    },
    icon: [Boolean, String, Object],
    prependIcon: [String, Object],
    appendIcon: [String, Object],
    stacked: Boolean,
    block: Boolean,
    text: [String, Number],
    ripple: {
      type: Boolean,
      default: true
    },
    overlay: {
      type: Boolean,
      default: true
    }
  }, makeDisabledProps()), makeLoadingProps()), makeRouterProps()), makeGroupItemProps()), makePaperProps({
    tag: "button",
    shape: "rounded-sm",
    variant: "contained"
  })), "button");
  const Button = defineComponent({
    name: "VeButton",
    directives: {
      Ripple
    },
    props: makeButtonProps(),
    emits: {
      click: (_event) => true
    },
    setup(props, {
      attrs,
      slots,
      emit
    }) {
      const group = useGroupItem(props, ButtonToggleKey, false);
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const isDisabled = vue.computed(() => (group == null ? void 0 : group.disabled.value) || props.disabled || props.loading);
      const {
        loadingClasses
      } = useLoading(props);
      const {
        disabledClasses
      } = useDisabled(vue.computed(() => ({
        disabled: (group == null ? void 0 : group.disabled.value) || props.disabled
      })));
      const link2 = useLink(props, attrs);
      const handleClick = (e) => {
        if (isDisabled.value) {
          e.preventDefault();
          return;
        }
        link2.navigate ? link2.navigate() : group == null ? void 0 : group.toggle();
        emit("click", e);
      };
      return () => {
        var _a;
        const Tag2 = link2.isLink.value ? "a" : props.tag;
        const hasPrependIcon = !props.icon && props.prependIcon;
        const hasPrependLoading = !hasPrependIcon && props.loading && (slots.default || props.text);
        const hasIconOnly = props.icon && typeof props.icon !== "boolean";
        const hasDefault = !hasIconOnly && (slots.default || props.text);
        const hasAppendIcon = !props.icon && props.appendIcon;
        return vue.withDirectives(vue.createVNode(Tag2, {
          "role": link2.isLink.value ? void 0 : "button",
          "aria-disabled": props.disabled || void 0,
          "type": link2.isLink.value ? void 0 : props.type,
          "class": ["ve-button", group == null ? void 0 : group.selectedClass.value, paperClasses.value, disabledClasses.value, loadingClasses.value, {
            "ve-button--active": (_a = link2.isExactActive) == null ? void 0 : _a.value,
            "ve-button--block": props.block,
            "ve-button--stacked": props.stacked,
            "ve-button--icon": !hasIconOnly && !!props.icon,
            "ve-button--icon-only": hasIconOnly
          }],
          "style": paperStyles.value,
          "disabled": props.disabled || void 0,
          "href": link2.href.value,
          "onClick": handleClick
        }, {
          default: () => {
            var _a2, _b;
            return [genOverlays(props.overlay, "ve-button"), vue.createVNode(ExpandXTransition, null, {
              default: () => [hasPrependLoading && vue.createVNode(Icon, {
                "class": "ve-button__icon",
                "icon": vue.createVNode(ProgressCircular, {
                  "color": "currentColor",
                  "indeterminate": true
                }, null),
                "size": props.size,
                "start": true
              }, null)]
            }), hasPrependIcon && vue.createVNode(Icon, {
              "class": "ve-button__icon",
              "icon": props.loading ? vue.createVNode(ProgressCircular, {
                "color": "currentColor",
                "indeterminate": true
              }, null) : props.prependIcon,
              "size": props.size,
              "start": true
            }, null), hasDefault && vue.createVNode("span", {
              "class": "ve-button__wrapper"
            }, [(_b = (_a2 = slots.default) == null ? void 0 : _a2.call(slots)) != null ? _b : props.text]), hasIconOnly && vue.createVNode(Icon, {
              "class": "ve-button__icon",
              "icon": props.loading ? vue.createVNode(ProgressCircular, {
                "color": "currentColor",
                "indeterminate": true
              }, null) : props.icon,
              "size": props.size
            }, null), hasAppendIcon && vue.createVNode(Icon, {
              "class": "ve-button__icon",
              "icon": props.appendIcon,
              "size": props.size,
              "end": true
            }, null)];
          }
        }), [[vue.resolveDirective("ripple"), !isDisabled.value && props.ripple, null]]);
      };
    }
  });
  var progress = "";
  function useIntersectionObserver(callback) {
    const intersectionRef = vue.ref();
    const isIntersecting = vue.ref(false);
    if (SUPPORTS_INTERSECTION_OBSERVER) {
      const observer = new IntersectionObserver((entries) => {
        callback == null ? void 0 : callback(entries, observer);
        isIntersecting.value = !!entries.find((entry) => entry.isIntersecting);
      });
      vue.onBeforeUnmount(() => {
        observer.disconnect();
      });
      vue.watch(intersectionRef, (newValue, oldValue) => {
        if (oldValue) {
          observer.unobserve(oldValue);
          isIntersecting.value = false;
        }
        if (newValue)
          observer.observe(newValue);
      }, {
        flush: "post"
      });
    } else {
      isIntersecting.value = true;
    }
    return { intersectionRef, isIntersecting };
  }
  const progressVariants = [
    "linear",
    "circular"
  ];
  const Progress = defineComponent({
    name: "VeProgress",
    props: __spreadProps(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
      color: {
        type: [String, Boolean],
        default: "primary"
      },
      start: Boolean,
      end: Boolean
    }, makeProgressCircularProps()), makeProgressLinearProps()), makeThemeProps()), makeSizeProps()), makeTagProps()), {
      variant: {
        type: String,
        default: "linear",
        validator: (v) => progressVariants.includes(v)
      }
    }),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const {
        themeClasses
      } = provideTheme(props);
      const {
        variantClasses
      } = useVariant(props);
      const {
        sizeClasses,
        sizeStyles
      } = useSize(props);
      const {
        textColorClasses,
        textColorStyles
      } = useTextColor(vue.toRef(props, "color"));
      const {
        intersectionRef,
        isIntersecting
      } = useIntersectionObserver();
      const model = useProxiedModel(props, "modelValue", props.modelValue, (val) => Math.max(0, Math.min(100, parseFloat(val != null ? val : 0))));
      const strokeWidth = vue.computed(() => Number(props.strokeWidth));
      const size = vue.computed(() => {
        return sizeStyles.value.width ? Number(props.size) : intersectionRef.value ? intersectionRef.value.getBoundingClientRect().width : Math.max(strokeWidth.value, 32);
      });
      const transitionDuration = vue.ref();
      useRender(() => {
        return vue.createVNode(props.tag, {
          "role": "progressbar",
          "aria-valuenow": props.indeterminate ? void 0 : model.value,
          "aria-valuemin": "0",
          "aria-valuemax": "100",
          "ref": intersectionRef,
          "class": ["ve-progress", variantClasses.value, themeClasses.value, sizeClasses.value, textColorClasses.value, {
            "ve-progress--indeterminate": !!props.indeterminate,
            "ve-progress--visible": isIntersecting.value,
            "ve-progress--start": props.start,
            "ve-progress--end": props.end
          }],
          "style": [sizeStyles.value, textColorStyles.value, {
            transitionDuration: transitionDuration.value
          }]
        }, {
          default: () => [props.variant === "circular" && vue.createVNode(ProgressCircular, vue.mergeProps(filterProgressCircularProps(props)[0], {
            "modelValue": model.value,
            "size": size.value
          }), null), props.variant === "linear" && vue.createVNode(ProgressLinear, vue.mergeProps(filterProgressLinearProps(props)[0], {
            "modelValue": model.value
          }), null), slots.default && vue.createVNode("div", {
            "class": "ve-progress__wrapper"
          }, [slots.default({
            value: model.value
          })])]
        });
      });
      let timer;
      return {
        start: () => {
          if (timer)
            clearTimeout(timer);
          transitionDuration.value = "0s";
          model.value = 0;
          setTimeout(() => {
            transitionDuration.value = "4s";
            model.value = 80;
          }, 0);
          timer = setTimeout(() => {
            if (transitionDuration.value === "4s")
              transitionDuration.value = void 0;
            timer = void 0;
          }, 4e3);
        },
        finish: () => {
          return new Promise((resolve) => {
            transitionDuration.value = "0.2s";
            model.value = 100;
            setTimeout(() => {
              transitionDuration.value = void 0;
              if (model.value >= 100)
                resolve(model.value);
            }, 200);
          });
        }
      };
    }
  });
  const alertTypes = ["success", "info", "warning", "error"];
  const makeAlertProps = propsFactory(__spreadValues(__spreadValues(__spreadValues({
    modelValue: {
      type: Boolean,
      default: true
    },
    type: {
      type: String,
      default: "info",
      validator: (val) => alertTypes.includes(val)
    },
    icon: {
      type: [String, Boolean, Object],
      default: true
    },
    closable: Boolean,
    closeIcon: {
      type: [String, Object],
      default: "$close"
    },
    closeText: String
  }, makeTransitionProps({
    transition: {
      component: FadeInExpandTransition
    }
  })), makeLoadingProps()), makeCardProps({
    shape: "rounded-sm",
    variant: "contained-outlined"
  })), "alert");
  const Alert = genericComponent()({
    name: "VeAlert",
    props: makeAlertProps(),
    emits: {
      "update:modelValue": (_) => true
    },
    setup(props, {
      slots
    }) {
      const {
        loadingClasses
      } = useLoading(props);
      const computedProps = vue.computed(() => {
        var _a;
        return __spreadProps(__spreadValues({}, props), {
          text: void 0,
          textColor: (_a = props.type) != null ? _a : props.textColor
        });
      });
      const isActive = useProxiedModel(props, "modelValue");
      const icon2 = vue.computed(() => {
        if (props.icon === false)
          return void 0;
        if (typeof props.icon === "string")
          return props.icon;
        if (props.type)
          return `$${props.type}`;
        return void 0;
      });
      function onCloseClick(_) {
        isActive.value = false;
      }
      return () => {
        const [cardProps] = filterCardProps(computedProps.value);
        const hasLoading = props.loading;
        const hasIcon = !hasLoading && icon2.value;
        const hasPrepend = hasIcon || hasLoading || slots.prepend;
        const hasTitle = !!props.title;
        const hasClosable = props.closable && (props.closeText || props.closeIcon);
        const hasAppend = hasClosable || slots.append;
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition
        }, {
          default: () => [isActive.value && vue.createVNode(props.tag, {
            "role": "alert",
            "class": ["ve-alert", {
              "ve-alert--with-title": hasTitle
            }, loadingClasses.value]
          }, {
            default: () => [vue.createVNode(Card, vue.mergeProps(cardProps, {
              "tag": "div"
            }), {
              prepend: hasPrepend ? () => {
                var _a;
                return vue.createVNode(vue.Fragment, null, [hasIcon && vue.createVNode(Icon, {
                  "class": "ve-alert__icon",
                  "size": "21",
                  "icon": icon2.value
                }, null), hasLoading && vue.createVNode(Progress, {
                  "class": "ve-alert__icon",
                  "size": "21",
                  "variant": "circular",
                  "stroke-width": "2",
                  "indeterminate": true
                }, null), (_a = slots.prepend) == null ? void 0 : _a.call(slots)]);
              } : void 0,
              headerText: () => {
                var _a, _b;
                return vue.createVNode(vue.Fragment, null, [hasTitle && vue.createVNode("div", {
                  "class": "ve-alert__title"
                }, [props.title]), (_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text]);
              },
              append: hasAppend ? () => {
                var _a;
                return vue.createVNode(vue.Fragment, null, [(_a = slots.append) == null ? void 0 : _a.call(slots), hasClosable && vue.createVNode(Button, {
                  "class": "ve-alert__close",
                  "variant": "plain",
                  "ripple": false,
                  "icon": props.closeText ? false : props.closeIcon,
                  "text": props.closeText,
                  "onClick": onCloseClick
                }, null)]);
              } : void 0
            })]
          })]
        });
      };
    }
  });
  function filterAlertProps(props) {
    return pick(props, Object.keys(Alert.props));
  }
  var app = "";
  function useResizeObserver(callback) {
    const resizeRef = vue.ref();
    const contentRect = vue.ref();
    const contentBoxSize = vue.ref();
    const borderBoxSize = vue.ref();
    if (SUPPORTS_RESIZE_OBSERVER) {
      const observer = new ResizeObserver((entries) => {
        callback == null ? void 0 : callback(entries, observer);
        if (!entries.length)
          return;
        contentRect.value = entries[0].contentRect;
        contentBoxSize.value = entries[0].contentBoxSize[0];
        borderBoxSize.value = entries[0].borderBoxSize[0];
      });
      vue.onBeforeUnmount(() => {
        observer.disconnect();
      });
      vue.watch(resizeRef, (newValue, oldValue) => {
        if (oldValue) {
          observer.unobserve(oldValue);
          contentRect.value = void 0;
          contentBoxSize.value = void 0;
          borderBoxSize.value = void 0;
        }
        if (newValue)
          observer.observe(newValue);
      }, {
        flush: "post"
      });
    }
    return {
      resizeRef,
      contentRect: vue.readonly(contentRect),
      contentBoxSize: vue.readonly(contentBoxSize),
      borderBoxSize: vue.readonly(borderBoxSize)
    };
  }
  const LayoutKey = Symbol.for("veno-ui:layout");
  const ROOT_ZINDEX = 1e3;
  const makeLayoutProps = propsFactory({
    overlaps: {
      type: Array,
      default: () => []
    },
    fullHeight: Boolean
  }, "layout");
  function provideLayout(props, name = getCurrentInstanceName()) {
    const rootVm = getCurrentInstance("provideLayout");
    const parentLayout = vue.inject(LayoutKey, null);
    const rootZIndex = vue.computed(() => parentLayout ? parentLayout.rootZIndex.value - 100 : ROOT_ZINDEX);
    const itemIds = vue.reactive([]);
    const itemMap = /* @__PURE__ */ new Map();
    const { resizeRef, contentRect: layoutRect } = useResizeObserver();
    const overlays = vue.ref([]);
    function generate() {
      return itemIds.map((id) => {
        var _a, _b, _c, _d;
        const item = itemMap.get(id).value;
        return {
          id,
          size: Number(item.size),
          position: (_a = item.position) != null ? _a : "absolute",
          anchor: (_b = item.anchor) != null ? _b : "left",
          active: !!item.active,
          priority: Number((_c = item.priority) != null ? _c : 0),
          layoutSize: Number((_d = item.layoutSize) != null ? _d : item.size),
          disableTransition: Boolean(item.disableTransition)
        };
      }).sort((a, b) => b.priority - a.priority).reduce(({ items: items2, layer }, item) => ({
        items: [...items2, __spreadValues(__spreadValues({}, layer), item)],
        layer: __spreadProps(__spreadValues({}, layer), {
          [item.anchor]: layer[item.anchor] + (item.active ? item.layoutSize : 0)
        })
      }), {
        items: [],
        layer: { top: 0, right: 0, bottom: 0, left: 0 }
      });
    }
    const items = vue.computed(() => generate().items);
    const getLayoutItem = (id) => items.value.find((item) => item.id === id);
    const computedOverlaps = vue.computed(() => {
      var _a;
      const overlaps = (_a = props.overlaps) != null ? _a : [];
      const map = /* @__PURE__ */ new Map();
      for (const overlap of overlaps.filter((item) => item.includes(":"))) {
        const [top, bottom] = overlap.split(":");
        const topLayoutItem = getLayoutItem(top);
        const bottomLayoutItem = getLayoutItem(bottom);
        if (!topLayoutItem || !bottomLayoutItem)
          continue;
        const { anchor: topAlign, layoutSize: topAmount } = topLayoutItem;
        const { anchor: bottomAlign, layoutSize: bottomAmount } = bottomLayoutItem;
        if (!topAlign || !bottomAlign || !topAmount || !bottomAmount)
          continue;
        map.set(bottom, { anchor: topAlign, amount: topAmount });
        map.set(top, { anchor: bottomAlign, amount: -bottomAmount });
      }
      return map;
    });
    const transitionEnabled = vue.computed(() => !items.value.some((ref2) => ref2.disableTransition));
    vue.provide(LayoutKey, {
      register: (vm, id, itemProps) => {
        itemMap.set(id, itemProps);
        const instances = findChildrenWithProvide(LayoutKey, rootVm == null ? void 0 : rootVm.vnode);
        const instanceIndex = instances.indexOf(vm);
        if (instanceIndex > -1) {
          itemIds.splice(instanceIndex, 0, id);
        } else {
          itemIds.push(id);
        }
        const layoutItemStyles = vue.computed(() => {
          const { items: items2 } = generate();
          const index2 = items2.findIndex((i) => i.id === id);
          const item = items2[index2];
          if (!item)
            throw new Error(`Could not find layout item "${id}`);
          const overlap = computedOverlaps.value.get(id);
          if (overlap)
            item[overlap.anchor] += overlap.amount;
          const isHorizontal = item.anchor === "left" || item.anchor === "right";
          const isOppositeHorizontal = item.anchor === "right";
          const isOppositeVertical = item.anchor === "bottom";
          return __spreadValues({
            [item.anchor]: item.anchor === "right" ? "calc(0px + var(--ve-scrollbar-offset, 0px))" : "0px",
            height: isHorizontal ? `calc(100% - ${item.top}px - ${item.bottom}px)` : `${item.size}px`,
            marginLeft: isOppositeHorizontal ? void 0 : `${item.left}px`,
            marginRight: isOppositeHorizontal ? `${item.right}px` : void 0,
            marginTop: item.anchor !== "bottom" ? `${item.top}px` : void 0,
            marginBottom: item.anchor !== "top" ? `${item.bottom}px` : void 0,
            width: !isHorizontal ? `calc(100% - ${item.left}px - ${item.right}px)` : `${item.size}px`,
            zIndex: rootZIndex.value + items2.length * 2 - index2 * 2,
            transform: `translate${isHorizontal ? "X" : "Y"}(${(item.active ? 0 : -110) * (isOppositeHorizontal || isOppositeVertical ? -1 : 1)}%)`,
            position: item.position === "absolute" || rootZIndex.value !== ROOT_ZINDEX ? "absolute" : "fixed"
          }, transitionEnabled.value ? void 0 : { transition: "none" });
        });
        const layoutItemScrimStyles = vue.computed(() => ({
          zIndex: layoutItemStyles.value.zIndex - 1,
          position: rootZIndex.value === ROOT_ZINDEX ? "fixed" : "absolute"
        }));
        return {
          layoutItemStyles,
          layoutItemScrimStyles
        };
      },
      unregister: (id) => {
        itemIds.splice(itemIds.indexOf(id), 1);
        itemMap.delete(id);
      },
      mainStyles: vue.computed(() => {
        const { layer } = generate();
        return __spreadValues({
          position: "relative",
          paddingLeft: convertToUnit(layer.left),
          paddingRight: convertToUnit(layer.right),
          paddingTop: convertToUnit(layer.top),
          paddingBottom: convertToUnit(layer.bottom)
        }, transitionEnabled.value ? void 0 : { transition: "none" });
      }),
      getLayoutItem,
      items,
      layoutRect,
      rootZIndex,
      overlays
    });
    return {
      layoutClasses: vue.computed(() => ({
        [`${name}--full-height`]: props.fullHeight
      })),
      layoutStyles: vue.computed(() => ({
        zIndex: rootZIndex.value
      })),
      getLayoutItem,
      items,
      layoutRect,
      layoutRef: resizeRef
    };
  }
  function useLayout() {
    const layout2 = vue.inject(LayoutKey);
    if (!layout2)
      throw new Error("[VenoUi] Could not find layout instance");
    return layout2;
  }
  const makeLayoutItemProps = propsFactory({
    modelValue: {
      type: Boolean,
      default: true
    },
    name: String,
    position: {
      type: String,
      default: "absolute"
    },
    anchor: {
      type: String,
      default: "left"
    },
    priority: {
      type: [String, Number],
      default: 0
    }
  }, "layout-item");
  function useLayoutItem(props) {
    var _a;
    const layout2 = useLayout();
    const id = (_a = props.value.name) != null ? _a : `layout-item-${getUid()}`;
    const vm = getCurrentInstance("useLayoutItem");
    const isKeptAlive = vue.ref(false);
    const {
      layoutItemStyles,
      layoutItemScrimStyles
    } = layout2.register(vm, id, vue.computed(() => __spreadProps(__spreadValues({}, props.value), {
      active: !isKeptAlive.value && props.value.active
    })));
    vue.onDeactivated(() => isKeptAlive.value = true);
    vue.onActivated(() => isKeptAlive.value = false);
    vue.onBeforeUnmount(() => layout2.unregister(id));
    return {
      layoutItemStyles,
      layoutRect: layout2.layoutRect,
      layoutItemScrimStyles
    };
  }
  function useLayoutMain() {
    return useLayout();
  }
  const OFFSET_ZINDEX = 400;
  function useOverlay(isActive) {
    const layout2 = useLayout();
    const id = getUid();
    vue.watch(isActive, (value) => {
      if (value) {
        layout2.overlays.value.push(id);
      } else {
        layout2.overlays.value = layout2.overlays.value.filter((x) => x !== id);
      }
    }, {
      immediate: true
    });
    const overlayZIndex = vue.computed(() => ROOT_ZINDEX + OFFSET_ZINDEX + layout2.overlays.value.indexOf(id) + 1);
    return {
      overlayZIndex,
      layoutRect: layout2.layoutRect
    };
  }
  const ProvidersKey = Symbol.for("veno-ui:providers");
  function createProviders(app2, options) {
    const providers2 = vue.shallowRef(__spreadValues({}, options));
    Object.values(providers2.value).forEach((provider) => {
      var _a;
      (_a = provider.register) == null ? void 0 : _a.call(provider, app2);
    });
    function createRootProvider() {
      return Object.values(providers2.value).reduce((Prev, Cur) => {
        return (props, {
          slots
        }) => vue.createVNode(Prev, {
          "registered": true
        }, {
          default: () => [vue.createVNode(Cur, {
            "registered": true
          }, {
            default: () => {
              var _a;
              return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
            }
          })]
        });
      }, (props, {
        slots
      }) => {
        var _a;
        return (_a = slots.default) == null ? void 0 : _a.call(slots);
      });
    }
    function get(key) {
      return providers2.value[key];
    }
    function set(key, value) {
      providers2.value[key] = value;
    }
    return {
      providers: providers2,
      get,
      set,
      createRootProvider
    };
  }
  function useProviders() {
    const providers2 = vue.inject(ProvidersKey);
    if (!providers2)
      throw new Error("Could not find Veno UI providers injection");
    return providers2;
  }
  const App = defineComponent({
    name: "VeApp",
    props: __spreadValues(__spreadValues({}, makeThemeProps()), makeLayoutProps({
      fullHeight: true
    })),
    setup(props, {
      slots
    }) {
      const theme = provideTheme(props);
      const {
        getLayoutItem,
        items,
        layoutClasses
      } = provideLayout(props);
      const {
        createRootProvider
      } = useProviders();
      useRender(() => {
        const RootProvider = createRootProvider();
        return vue.createVNode("div", {
          "class": ["ve-app", theme.themeClasses.value, layoutClasses.value],
          "data-app": "true"
        }, [vue.createVNode("div", {
          "class": "ve-app__wrapper"
        }, [vue.createVNode(RootProvider, null, {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
          }
        })])]);
      });
      return {
        theme,
        getLayoutItem,
        items
      };
    }
  });
  var anchor = "";
  const NamedAnchorKey = Symbol.for("veno-ui:named-anchor");
  const makeNamedAnchor = propsFactory({
    offset: {
      type: [String, Number],
      default: 12
    },
    scrollTarget: {
      type: [String, Object]
    }
  }, "named-anchor");
  function useNamedAnchor(props) {
    const active = vue.ref();
    const names = vue.ref(/* @__PURE__ */ new Set());
    const offset = vue.computed(() => parseInt(props.offset, 10));
    const scrollTarget = vue.computed(() => typeof props.scrollTarget === "string" ? document.querySelector(props.scrollTarget) : props.scrollTarget);
    const scrolling = vue.ref(false);
    const { isWebHashHistory } = useRouterHistory();
    const route = useRoute();
    let timeout = 0;
    const activate = (name) => {
      var _a, _b, _c;
      const target = document.getElementById(name);
      if (target) {
        clearTimeout(timeout);
        scrolling.value = true;
        timeout = setTimeout(() => scrolling.value = false, 800);
        const container2 = (_a = scrollTarget.value) != null ? _a : window;
        const offsetTop = (_c = (_b = scrollTarget.value) == null ? void 0 : _b.scrollTop) != null ? _c : window.scrollY;
        container2.scrollTo({
          top: target.getBoundingClientRect().top + offsetTop - offset.value,
          behavior: "smooth"
        });
      }
      active.value = name;
    };
    const findActiveHash = () => {
      var _a, _b;
      if (scrolling.value || !names.value.size)
        return;
      const offsetTop = ((_a = scrollTarget.value) == null ? void 0 : _a.getBoundingClientRect().top) || 0;
      active.value = (_b = [...names.value].reduce((pos, name) => {
        const el = document.getElementById(name);
        if (el && document.documentElement.contains(el)) {
          const box = el.getBoundingClientRect();
          pos.push({
            name,
            top: box.top - offsetTop,
            height: box.height
          });
        }
        return pos;
      }, []).sort((a, b) => a.top - b.top).reduce((prev, item) => {
        if (item.top + item.height < 0) {
          return prev;
        }
        if (item.top <= props.offset) {
          if (prev === null) {
            return item;
          } else if (item.top === prev.top) {
            if (item.name === active.value) {
              return item;
            } else {
              return prev;
            }
          } else if (item.top > prev.top) {
            return item;
          } else {
            return prev;
          }
        }
        return prev;
      }, null)) == null ? void 0 : _b.name;
    };
    const onScroll = throttle(findActiveHash, 17);
    vue.onMounted(() => {
      var _a, _b;
      document.addEventListener("scroll", onScroll, true);
      if (isWebHashHistory.value && ((_b = (_a = route.value) == null ? void 0 : _a.query) == null ? void 0 : _b.anchor)) {
        activate(route.value.query.anchor);
      } else if (window.location.hash) {
        activate(decodeURIComponent(window.location.hash.substring(1)));
      } else {
        findActiveHash();
      }
    });
    vue.onBeforeUnmount(() => {
      document.removeEventListener("scroll", onScroll, true);
    });
    const namedAnchor = {
      names,
      active,
      activate,
      register: (name) => {
        names.value.add(name);
      },
      unregister: (name) => {
        names.value.delete(name);
        if (active.value === name) {
          active.value = void 0;
        }
      }
    };
    vue.provide(NamedAnchorKey, namedAnchor);
    return namedAnchor;
  }
  const makeNamedAnchorItem = propsFactory({
    value: {
      type: String,
      required: true
    }
  }, "named-anchor-item");
  function useNamedAnchorItem(props) {
    const parent = vue.inject(NamedAnchorKey);
    if (!parent)
      throw new Error("[VenoUi] Could not find namedAnchor instance");
    const { isWebHashHistory } = useRouterHistory();
    const item = __spreadProps(__spreadValues({}, parent), {
      isWebHashHistory,
      to: vue.computed(() => isWebHashHistory.value ? { query: { anchor: props.value }, replace: true } : { hash: `#${props.value}`, replace: true }),
      isActive: vue.computed(() => parent.active.value === props.value)
    });
    parent.register(props.value);
    vue.onBeforeUnmount(() => {
      parent.unregister(props.value);
    });
    return item;
  }
  var anchorItem = "";
  var link = "";
  function _isSlot$a(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Link = defineComponent({
    name: "VeLink",
    props: {
      underline: {
        type: [Boolean, String],
        default: "hover"
      },
      linkIcon: {
        type: String,
        default: "$link"
      },
      prependIcon: [Boolean, String, Object],
      appendIcon: [Boolean, String, Object]
    },
    setup(props, {
      slots
    }) {
      return () => {
        return vue.createVNode(Button, {
          "class": ["ve-link", {
            "ve-link--underline": props.underline === true,
            "ve-link--underline-hover": props.underline === "hover"
          }],
          "variant": "text",
          "ripple": false,
          "overlay": false,
          "prepend-icon": props.prependIcon === true ? props.linkIcon : typeof props.prependIcon === "boolean" ? void 0 : props.prependIcon,
          "append-icon": props.appendIcon === true ? props.linkIcon : typeof props.appendIcon === "boolean" ? void 0 : props.appendIcon
        }, _isSlot$a(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
  const AnchorItem = defineComponent({
    name: "VeAnchorItem",
    props: __spreadValues({
      activeColor: {
        type: String,
        default: "primary"
      },
      text: String
    }, makeNamedAnchorItem()),
    setup(props, {
      slots
    }) {
      const {
        to,
        activate,
        isActive
      } = useNamedAnchorItem(props);
      return () => {
        return vue.createVNode("li", {
          "class": ["ve-anchor-item", {
            "ve-anchor-item--active": isActive.value
          }]
        }, [vue.createVNode(Link, {
          "to": to.value,
          "underline": false,
          "color": isActive.value ? props.activeColor : void 0,
          "onClick": (e) => {
            e.preventDefault();
            e.stopPropagation();
            activate(props.value);
          }
        }, __spreadProps(__spreadValues({}, slots), {
          default: () => {
            var _a, _b;
            return (_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text;
          }
        }))]);
      };
    }
  });
  const Anchor = defineComponent({
    name: "VeAnchor",
    props: __spreadValues({
      activeColor: {
        type: String,
        default: "primary"
      },
      items: Array
    }, makeNamedAnchor()),
    setup(props, {
      slots
    }) {
      useNamedAnchor(props);
      provideDefaults({
        VeAnchorItem: {
          activeColor: vue.toRef(props, "activeColor")
        }
      });
      return () => {
        var _a, _b;
        return vue.createVNode("ul", {
          "class": "ve-anchor"
        }, [(_a = slots.default) == null ? void 0 : _a.call(slots), (_b = props.items) == null ? void 0 : _b.map((item) => vue.createVNode(AnchorItem, vue.mergeProps({
          "key": item.value
        }, item), null))]);
      };
    }
  });
  var badge = "";
  const Badge = defineComponent({
    name: "VeBadge",
    inheritAttrs: false,
    props: __spreadValues(__spreadValues(__spreadValues({
      bordered: {
        type: Boolean,
        default: true
      },
      color: String,
      content: [Number, String],
      dot: Boolean,
      floating: Boolean,
      icon: [String, Object],
      inline: Boolean,
      location: {
        type: String,
        default: "top-right",
        validator: (value) => {
          const [vertical, horizontal] = (value != null ? value : "").split("-");
          return ["top", "bottom"].includes(vertical) && ["left", "right"].includes(horizontal);
        }
      },
      max: [Number, String],
      modelValue: {
        type: Boolean,
        default: true
      },
      offsetX: [Number, String],
      offsetY: [Number, String],
      textColor: String
    }, makeShapeProps()), makeTagProps()), makeTransitionProps({
      transition: {
        component: FadeTransition
      }
    })),
    setup(props, {
      slots,
      attrs
    }) {
      const {
        backgroundColorClasses,
        backgroundColorStyles
      } = useBackgroundColor(vue.toRef(props, "color"));
      const {
        shapeClasses
      } = useShape(props);
      const {
        textColorClasses,
        textColorStyles
      } = useTextColor(vue.toRef(props, "textColor"));
      const position = vue.computed(() => props.floating ? props.dot ? 2 : 4 : props.dot ? 8 : 12);
      function calculatePosition(offset) {
        return `calc(100% - ${convertToUnit(position.value + Number(offset != null ? offset : 0))})`;
      }
      const locationStyles = vue.computed(() => {
        var _a;
        const [vertical, horizontal] = ((_a = props.location) != null ? _a : "").split("-");
        const styles = {
          bottom: "auto",
          left: "auto",
          right: "auto",
          top: "auto"
        };
        if (!props.inline) {
          styles[horizontal === "left" ? "right" : "left"] = calculatePosition(props.offsetX);
          styles[vertical === "top" ? "bottom" : "top"] = calculatePosition(props.offsetY);
        }
        return styles;
      });
      return () => {
        const value = Number(props.content);
        const content = !props.max || isNaN(value) ? props.content : value <= props.max ? value : `${props.max}+`;
        const [badgeAttrs, restAttrs] = pick(attrs, ["aria-atomic", "aria-label", "aria-live", "role", "title"]);
        return vue.createVNode(props.tag, vue.mergeProps({
          "class": ["ve-badge", {
            "ve-badge--bordered": props.bordered,
            "ve-badge--dot": props.dot,
            "ve-badge--floating": props.floating,
            "ve-badge--inline": props.inline
          }]
        }, restAttrs), {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots), vue.createVNode(MaybeTransition, {
              "transition": props.transition
            }, {
              default: () => {
                var _a2, _b;
                return [vue.withDirectives(vue.createVNode("span", vue.mergeProps({
                  "class": ["ve-badge__content", backgroundColorClasses.value, shapeClasses.value, textColorClasses.value],
                  "style": [backgroundColorStyles.value, locationStyles.value, textColorStyles.value],
                  "aria-atomic": "true",
                  "aria-label": "locale string here",
                  "aria-live": "polite",
                  "role": "status"
                }, badgeAttrs), [!props.dot && (((_b = (_a2 = slots.badge) == null ? void 0 : _a2.call(slots)) != null ? _b : props.icon) ? vue.createVNode(Icon, {
                  "icon": props.icon
                }, null) : content)]), [[vue.vShow, props.modelValue]])];
              }
            })];
          }
        });
      };
    }
  });
  var breadcrumb = "";
  const BreadcrumbKey = createSymbol("breadcrumb");
  const Breadcrumb = genericComponent()({
    name: "VeBreadcrumb",
    props: __spreadValues({}, makeTagProps({
      tag: "nav"
    })),
    emits: {
      "update:modelValue": (_value) => true
    },
    setup(props, {
      slots
    }) {
      useGroup(props, BreadcrumbKey);
      return () => {
        return vue.createVNode(props.tag, {
          "aria-label": "breadcrumb",
          "class": "ve-breadcrumb"
        }, {
          default: () => {
            var _a;
            return [vue.createVNode("ol", null, [(_a = slots.default) == null ? void 0 : _a.call(slots)])];
          }
        });
      };
    }
  });
  const BreadcrumbItem = genericComponent()({
    name: "VeBreadcrumbItem",
    props: __spreadValues(__spreadValues({}, makeButtonProps({
      variant: "text"
    })), makeGroupItemProps()),
    setup(props, {
      slots
    }) {
      const {
        id,
        group
      } = useGroupItem(props, BreadcrumbKey);
      const hasNext = vue.computed(() => {
        if (!group.items.value.length)
          return false;
        return group.items.value[group.items.value.length - 1].id !== id;
      });
      return () => {
        var _a, _b, _c, _d, _e, _f;
        return vue.createVNode(vue.Fragment, null, [vue.createVNode("li", {
          "class": ["ve-breadcrumb-item", {
            "ve-breadcrumb-item--has-next": hasNext.value
          }]
        }, [vue.createVNode(Button, props, slots)]), hasNext.value && vue.createVNode("li", {
          "class": "ve-breadcrumb-separator",
          "aria-hidden": "true"
        }, [(_f = (_e = (_a = slots.separator) == null ? void 0 : _a.call(slots)) != null ? _e : (_d = (_b = group.vm) == null ? void 0 : (_c = _b.slots).separator) == null ? void 0 : _d.call(_c)) != null ? _f : vue.createVNode(Icon, {
          "icon": "$separator"
        }, null)])]);
      };
    }
  });
  var carousel = "";
  var carouselActivator = "";
  const CarouselActivator = genericComponent()({
    name: "VeCarouselActivator",
    props: {
      active: Boolean
    },
    setup(props) {
      return () => vue.createVNode("div", {
        "class": ["ve-carousel-activator", {
          "ve-carousel-activator--active": props.active
        }]
      }, null);
    }
  });
  const CarouselKey = createSymbol("carousel");
  const Carousel = defineComponent({
    name: "VeCarousel",
    props: __spreadValues(__spreadValues({
      autoplay: Boolean,
      interval: {
        type: [Number, String],
        default: 6e3,
        validator: (value) => value > 0
      }
    }, makeGroupProps({
      mandatory: "force"
    })), makePaperProps({
      variant: "text",
      size: void 0,
      density: void 0
    })),
    emits: {
      "update:modelValue": (_value) => true
    },
    setup(props, {
      slots
    }) {
      const {
        paperStyles,
        paperClasses
      } = usePaper(props);
      const {
        isSelected,
        select: select2,
        selected,
        next,
        items
      } = useGroup(props, CarouselKey);
      let slideTimeout;
      const restartTimeout = () => {
        slideTimeout && clearTimeout(slideTimeout);
        slideTimeout = void 0;
        window.requestAnimationFrame(() => {
          if (!props.autoplay)
            return;
          slideTimeout = window.setTimeout(next, +props.interval > 0 ? +props.interval : 6e3);
        });
      };
      vue.watch([selected, vue.toRef(props, "autoplay"), vue.toRef(props, "interval")], restartTimeout);
      return () => vue.createVNode(props.tag, {
        "class": ["ve-carousel", paperClasses.value],
        "style": paperStyles.value
      }, {
        default: () => {
          var _a;
          return [(_a = slots.default) == null ? void 0 : _a.call(slots), vue.createVNode("div", {
            "class": "ve-carousel__controls"
          }, [items.value.map((v) => vue.createVNode(CarouselActivator, {
            "active": isSelected(v.id),
            "onClick": () => select2(v.id, true)
          }, null))])];
        }
      });
    }
  });
  var carouselItem = "";
  const CarouselItem = defineComponent({
    name: "VeCarouselItem",
    props: __spreadValues(__spreadValues({}, makeGroupItemProps()), makeTagProps()),
    setup(props, {
      slots
    }) {
      const {
        isSelected,
        group
      } = useGroupItem(props, CarouselKey);
      const {
        items,
        selected
      } = group;
      const transition = vue.ref();
      vue.watch(() => items.value.findIndex(({
        id
      }) => selected.value.includes(id)), (val, oldVal) => {
        transition.value = oldVal > val ? "ve-carousel-item-x-reverse-transition" : "ve-carousel-item-x-transition";
      });
      return () => vue.createVNode(vue.Transition, {
        "name": transition.value
      }, {
        default: () => [vue.withDirectives(vue.createVNode(props.tag, {
          "class": "ve-carousel-item"
        }, {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
          }
        }), [[vue.vShow, isSelected.value]])]
      });
    }
  });
  var selectionControl = "";
  var label = "";
  const Label = defineComponent({
    name: "VeLabel",
    props: __spreadValues({
      disabled: Boolean,
      error: Boolean,
      text: String
    }, makeThemeProps()),
    setup(props, {
      slots
    }) {
      return () => {
        var _a, _b;
        return vue.createVNode("label", {
          "class": ["ve-label", {
            "ve-label--disabled": props.disabled,
            "ve-label--error": props.error
          }]
        }, [(_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text]);
      };
    }
  });
  const FormKey = createSymbol("form");
  const makeFormProps = propsFactory({
    disabled: Boolean,
    fastFail: Boolean,
    lazyValidation: Boolean,
    readonly: Boolean,
    valid: {
      type: Boolean,
      default: null
    },
    modelValue: Object
  });
  function provideForm(props) {
    const vm = getCurrentInstance("provideForm");
    const valid = useProxiedModel(props, "valid");
    const model = useProxiedModel(props, "modelValue");
    const isDisabled = vue.computed(() => props.disabled);
    const isReadonly = vue.computed(() => props.readonly);
    const isValidating = vue.ref(false);
    const items = /* @__PURE__ */ new Map();
    const watchs = /* @__PURE__ */ new Map();
    const errorMessages = vue.ref([]);
    async function submit(e) {
      e.preventDefault();
      const results = [];
      let _valid = true;
      errorMessages.value = [];
      valid.value = null;
      isValidating.value = true;
      for (const [id, item] of items) {
        if (!item.validate)
          continue;
        const itemErrorMessages = await item.validate();
        if (itemErrorMessages.length > 0) {
          _valid = false;
          results.push({
            id,
            errorMessages: itemErrorMessages
          });
        }
        if (!_valid && props.fastFail)
          break;
      }
      errorMessages.value = results;
      valid.value = _valid;
      isValidating.value = false;
      vm == null ? void 0 : vm.emit("submit", model.value, e);
    }
    async function reset(e) {
      e.preventDefault();
      items.forEach((item) => {
        var _a;
        return (_a = item.reset) == null ? void 0 : _a.call(item);
      });
      valid.value = null;
      vm == null ? void 0 : vm.emit("reset", e);
    }
    async function resetValidation() {
      items.forEach((item) => {
        var _a;
        return (_a = item.resetValidation) == null ? void 0 : _a.call(item);
      });
      errorMessages.value = [];
      valid.value = null;
      vm == null ? void 0 : vm.emit("resetValidation");
    }
    vue.provide(FormKey, {
      isDisabled,
      isReadonly,
      isValidating,
      items,
      register: (id, item) => {
        items.set(id, item);
        watchs.set(id, [
          vue.watch(item.name, (name) => {
            if (!name)
              return;
            const val = getObjectValueByPath(model.value, name);
            if (val !== item.modelValue.value)
              item.modelValue.value = val;
          }, { immediate: true }),
          vue.watch(item.modelValue, (value) => {
            const name = item.name.value;
            if (!name)
              return;
            if (value !== getObjectValueByPath(model.value, name)) {
              setObjectValueByPath(model.value, name, value);
            }
          }, { immediate: true, deep: true })
        ]);
      },
      unregister: (id) => {
        var _a;
        items.delete(id);
        (_a = watchs.get(id)) == null ? void 0 : _a.forEach((v) => v());
        watchs.delete(id);
      }
    });
    return {
      errorMessages,
      isDisabled,
      isReadonly,
      isValidating,
      items,
      submit,
      reset,
      resetValidation
    };
  }
  function useForm() {
    return vue.inject(FormKey, null);
  }
  var selectionGroupControl = "";
  const SelectionGroupControlKey = createSymbol("selection-control-group");
  const makeSelectionGroupControlProps = propsFactory({
    id: String,
    inline: Boolean,
    name: String,
    falseIcon: String,
    trueIcon: String,
    multiple: {
      type: Boolean,
      default: null
    },
    disabled: Boolean,
    readonly: Boolean,
    type: String,
    modelValue: null
  }, "selection-control-group");
  const SelectionGroupControl = defineComponent({
    name: "VeSelectionGroupControl",
    props: makeSelectionGroupControlProps(),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const modelValue = useProxiedModel(props, "modelValue");
      const id = vue.computed(() => props.name || props.id || `ve-selection-control-group-${getUid()}`);
      const multiple = vue.computed(() => {
        return !!props.multiple || props.multiple == null && Array.isArray(modelValue.value);
      });
      const group = {
        disabled: vue.toRef(props, "disabled"),
        inline: vue.toRef(props, "inline"),
        modelValue,
        multiple,
        id,
        name: vue.toRef(props, "name"),
        falseIcon: vue.toRef(props, "falseIcon"),
        trueIcon: vue.toRef(props, "trueIcon"),
        readonly: vue.toRef(props, "readonly"),
        type: vue.toRef(props, "type")
      };
      vue.provide(SelectionGroupControlKey, group);
      useRender(() => {
        var _a;
        return vue.createVNode("div", {
          "class": "ve-selection-group-control",
          "aria-labelled-by": props.type === "radio" ? group.id.value : void 0,
          "role": props.type === "radio" ? "radiogroup" : void 0
        }, [(_a = slots.default) == null ? void 0 : _a.call(slots)]);
      });
      return group;
    }
  });
  function useSelectionGroupControl() {
    return vue.inject(SelectionGroupControlKey, null);
  }
  const makeSelectionControlProps = propsFactory(__spreadValues(__spreadValues(__spreadValues({
    color: String,
    disabled: Boolean,
    error: Boolean,
    id: String,
    inline: Boolean,
    label: String,
    falseIcon: String,
    trueIcon: String,
    multiple: {
      type: Boolean,
      default: null
    },
    name: String,
    readonly: Boolean,
    trueValue: null,
    falseValue: null,
    modelValue: null,
    type: String,
    value: null,
    valueComparator: {
      type: Function,
      default: deepEqual
    }
  }, makeThemeProps()), makeSizeProps()), makeDensityProps()), "selection-control");
  const SelectionControl = genericComponent()({
    name: "VeSelectionControl",
    inheritAttrs: false,
    props: makeSelectionControlProps(),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      attrs,
      slots
    }) {
      const group = useSelectionGroupControl();
      const {
        sizeClasses,
        sizeStyles
      } = useSize(props);
      const {
        densityClasses
      } = useDensity(props);
      const modelValue = useProxiedModel(props, "modelValue");
      const trueValue = vue.computed(() => props.trueValue !== void 0 ? props.trueValue : props.value !== void 0 ? props.value : true);
      const falseValue = vue.computed(() => props.falseValue !== void 0 ? props.falseValue : false);
      const isMultiple = vue.computed(() => (group == null ? void 0 : group.multiple.value) || !!props.multiple || props.multiple == null && Array.isArray(modelValue.value));
      const model = vue.computed({
        get() {
          const val = group ? group.modelValue.value : modelValue.value;
          if (isMultiple.value) {
            return (val || []).some((v) => props.valueComparator(v, trueValue.value));
          }
          return props.valueComparator(val, trueValue.value);
        },
        set(val) {
          const currentValue = val ? trueValue.value : falseValue.value;
          let newVal = currentValue;
          if (isMultiple.value) {
            const oldVal = group ? group.modelValue.value : modelValue.value;
            if (val) {
              newVal = [...wrapInArray(oldVal), currentValue];
            } else {
              newVal = wrapInArray(oldVal).filter((v) => !props.valueComparator(v, trueValue.value));
            }
          }
          if (group) {
            group.modelValue.value = newVal;
          } else {
            modelValue.value = newVal;
          }
        }
      });
      const {
        textColorClasses,
        textColorStyles
      } = useTextColor(vue.computed(() => {
        return model.value ? props.color : void 0;
      }));
      const icon2 = vue.computed(() => {
        var _a, _b;
        return model.value ? (_a = group == null ? void 0 : group.trueIcon.value) != null ? _a : props.trueIcon : (_b = group == null ? void 0 : group.falseIcon.value) != null ? _b : props.falseIcon;
      });
      const id = vue.computed(() => props.name || props.id || `ve-selection-control-${getUid()}`);
      const isFocused = vue.ref(false);
      const isFocusVisible = vue.ref(false);
      const inputRef = vue.ref();
      const form2 = useForm();
      vue.onBeforeMount(() => {
        form2 == null ? void 0 : form2.register(id.value, {
          name: vue.toRef(props, "name"),
          modelValue: model
        });
      });
      vue.onBeforeUnmount(() => {
        form2 == null ? void 0 : form2.unregister(id.value);
      });
      function onFocus(e) {
        isFocused.value = true;
        if (!SUPPORTS_FOCUS_VISIBLE || SUPPORTS_FOCUS_VISIBLE && e.target.matches(":focus-visible")) {
          isFocusVisible.value = true;
        }
      }
      function onBlur() {
        isFocused.value = false;
        isFocusVisible.value = false;
      }
      useRender(() => {
        var _a, _b, _c, _d;
        const slotProps = {
          label: props.label,
          model,
          textColorClasses,
          textColorStyles,
          props: {
            onFocus,
            onBlur,
            id: id.value
          }
        };
        const type = (_a = group == null ? void 0 : group.type.value) != null ? _a : props.type;
        const hasLabel = !!(slots.label || props.label || props.value);
        const [rootAttrs, restAttrs] = filterInputAttrs(attrs);
        return vue.createVNode("div", vue.mergeProps(rootAttrs, {
          "class": ["ve-selection-control", {
            "ve-selection-control--dirty": model.value,
            "ve-selection-control--disabled": props.disabled,
            "ve-selection-control--error": props.error,
            "ve-selection-control--focused": isFocused.value,
            "ve-selection-control--focus-visible": isFocusVisible.value,
            "ve-selection-control--inline": (group == null ? void 0 : group.inline.value) || props.inline
          }, sizeClasses.value, densityClasses.value, textColorClasses.value],
          "style": sizeStyles.value
        }), [vue.createVNode("div", {
          "class": "ve-selection-control__wrapper"
        }, [(_b = slots.default) == null ? void 0 : _b.call(slots, slotProps), vue.createVNode("div", {
          "class": "ve-selection-control__input",
          "style": textColorStyles.value
        }, [icon2.value && vue.createVNode(Icon, {
          "icon": icon2.value
        }, null), (_c = slots.input) == null ? void 0 : _c.call(slots, slotProps), vue.withDirectives(vue.createVNode("input", vue.mergeProps({
          "class": "ve-native-control",
          "ref": inputRef,
          "onUpdate:modelValue": ($event) => model.value = $event,
          "disabled": props.disabled,
          "id": id.value,
          "onBlur": onBlur,
          "onFocus": onFocus,
          "readonly": props.readonly,
          "type": type,
          "value": trueValue.value,
          "name": (_d = group == null ? void 0 : group.name.value) != null ? _d : props.name,
          "aria-checked": type === "checkbox" ? model.value : void 0
        }, restAttrs), null), [[vue.vModelDynamic, model.value]])])]), hasLabel && vue.createVNode(Label, {
          "for": id.value
        }, {
          default: () => {
            var _a2, _b2, _c2;
            return [(_c2 = (_b2 = (_a2 = slots.label) == null ? void 0 : _a2.call(slots, slotProps)) != null ? _b2 : props.label) != null ? _c2 : props.value];
          }
        })]);
      });
      return {
        isFocused,
        inputRef
      };
    }
  });
  function filterSelectionControlProps(props) {
    return pick(props, Object.keys(SelectionControl.props));
  }
  function _isSlot$9(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Checkbox = defineComponent({
    name: "VeCheckbox",
    props: __spreadValues({
      indeterminate: Boolean,
      indeterminateIcon: {
        type: String,
        default: "$checkboxIndeterminate"
      }
    }, makeSelectionControlProps({
      type: "checkbox",
      falseIcon: "$checkboxOff",
      trueIcon: "$checkboxOn",
      color: "primary"
    })),
    emits: {
      "update:modelValue": (_val) => true,
      "update:indeterminate": (_val) => true
    },
    setup(props, {
      emit,
      slots
    }) {
      const indeterminate = useProxiedModel(props, "indeterminate");
      const falseIcon = vue.computed(() => {
        return indeterminate.value ? props.indeterminateIcon : props.falseIcon;
      });
      const trueIcon = vue.computed(() => {
        return indeterminate.value ? props.indeterminateIcon : props.trueIcon;
      });
      function onChange(val) {
        if (indeterminate.value) {
          indeterminate.value = false;
        } else {
          emit("update:modelValue", val);
        }
      }
      return () => {
        const [controlProps] = filterSelectionControlProps(props);
        return vue.createVNode(SelectionControl, vue.mergeProps(controlProps, {
          "class": "ve-checkbox",
          "onUpdate:modelValue": onChange,
          "falseIcon": falseIcon.value,
          "trueIcon": trueIcon.value,
          "aria-checked": indeterminate.value ? "mixed" : void 0
        }), _isSlot$9(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
  var formControl = "";
  var messages = "";
  const Messages = defineComponent({
    name: "VeMessages",
    props: __spreadValues({
      active: Boolean,
      value: {
        type: [Array, String],
        default: () => []
      }
    }, makeTransitionProps({
      transition: {
        component: FadeTransition,
        group: true
      }
    })),
    setup(props, {
      slots
    }) {
      const messages2 = vue.computed(() => wrapInArray(props.value));
      return () => {
        const hasMessages = messages2.value.length > 0 && props.active;
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition,
          "tag": "div",
          "class": "ve-messages"
        }, {
          default: () => {
            var _a;
            return [hasMessages && messages2.value.map((message2, i) => vue.createVNode("div", {
              "class": "ve-messages__message",
              "key": i
            }, [message2])), (_a = slots == null ? void 0 : slots.default) == null ? void 0 : _a.call(slots)];
          }
        });
      };
    }
  });
  const makeValidationProps = propsFactory({
    disabled: Boolean,
    error: Boolean,
    errorMessages: {
      type: [Array, String],
      default: () => []
    },
    maxErrors: {
      type: [Number, String],
      default: 1
    },
    readonly: Boolean,
    rules: {
      type: Array,
      default: () => []
    },
    modelValue: null
  });
  function useValidation(props, name = getCurrentInstanceName()) {
    const errorMessages = vue.ref([]);
    const isPristine = vue.ref(true);
    const isDisabled = vue.computed(() => !!props.disabled);
    const isReadonly = vue.computed(() => !!props.readonly);
    const isValid = vue.computed(() => {
      var _a;
      if (props.error || ((_a = props.errorMessages) == null ? void 0 : _a.length) || errorMessages.value.length)
        return false;
      return isPristine.value ? null : true;
    });
    const isValidating = vue.ref(false);
    const validationClasses = vue.computed(() => {
      return {
        [`${name}--error`]: isValid.value === false,
        [`${name}--disabled`]: isDisabled.value,
        [`${name}--readonly`]: isReadonly.value
      };
    });
    const vm = getCurrentInstance("useValidation");
    function reset() {
      resetValidation();
      vm == null ? void 0 : vm.emit("update:modelValue", null);
    }
    function resetValidation() {
      isPristine.value = true;
      errorMessages.value = [];
    }
    async function validate() {
      var _a, _b;
      const results = [];
      errorMessages.value = [];
      isValidating.value = true;
      for (const rule of props.rules) {
        if (results.length >= (props.maxErrors || 1)) {
          break;
        }
        const handler = typeof rule === "function" ? rule : () => rule;
        const result = await handler((_b = (_a = props == null ? void 0 : props.modelValue) == null ? void 0 : _a.value) != null ? _b : props.modelValue);
        if (result === true)
          continue;
        if (typeof result !== "string") {
          console.warn(`${result} is not a valid value. Rule functions must return boolean true or a string.`);
          continue;
        }
        results.push(result);
      }
      errorMessages.value = results;
      isValidating.value = false;
      isPristine.value = false;
      return errorMessages.value;
    }
    return {
      errorMessages,
      isDisabled,
      isReadonly,
      isPristine,
      isValid,
      isValidating,
      reset,
      resetValidation,
      validate,
      validationClasses
    };
  }
  function filterFormControlSlots(slots) {
    return pick(slots, FormControlSlots);
  }
  const FormControlEmits = {
    "click:prepend": (_event) => true,
    "click:label": (_event) => true,
    "click:append": (_event) => true,
    "update:modelValue": (_modelValue) => true
  };
  const FormControlSlots = ["prepend", "label", "default", "append", "details"];
  const FormControl = genericComponent()({
    name: "VeFormControl",
    props: __spreadValues(__spreadValues(__spreadValues(__spreadValues({
      appendIcon: [String, Object],
      direction: {
        type: String,
        default: "horizontal",
        validator: (v) => ["horizontal", "vertical"].includes(v)
      },
      focused: Boolean,
      hideDetails: [Boolean, String],
      hint: String,
      inline: Boolean,
      label: [Boolean, String],
      labelId: String,
      labelWidth: [String, Number],
      messages: {
        type: [Array, String],
        default: () => []
      },
      name: String,
      prependIcon: String,
      persistentHint: Boolean
    }, makeDimensionProps()), makeSizeProps()), makeDensityProps()), makeValidationProps()),
    emits: FormControlEmits,
    setup(props, {
      slots,
      emit
    }) {
      const {
        dimensionStyles
      } = useDimension(props);
      const {
        sizeClasses,
        sizeStyles
      } = useSize(props);
      const model = useProxiedModel(props, "modelValue");
      const computedDimensionStyles = vue.computed(() => {
        var _a;
        return __spreadProps(__spreadValues({}, dimensionStyles.value), {
          minHeight: (_a = dimensionStyles.value.minHeight) != null ? _a : dimensionStyles.value.height
        });
      });
      const {
        densityClasses
      } = useDensity(props);
      const {
        errorMessages,
        isDisabled,
        isReadonly,
        isPristine,
        isValid,
        isValidating,
        reset,
        resetValidation,
        validate,
        validationClasses
      } = useValidation(props);
      const form2 = useForm();
      const id = vue.computed(() => {
        var _a;
        return (_a = props.name) != null ? _a : `ve-form-control-${getUid()}`;
      });
      vue.onBeforeMount(() => {
        form2 == null ? void 0 : form2.register(id.value, {
          name: vue.toRef(props, "name"),
          modelValue: model,
          validate,
          reset,
          resetValidation
        });
      });
      vue.onBeforeUnmount(() => {
        form2 == null ? void 0 : form2.unregister(id.value);
      });
      const slotProps = vue.computed(() => ({
        isDisabled,
        isReadonly,
        isPristine,
        isValid,
        isValidating,
        reset,
        resetValidation,
        validate
      }));
      useRender(() => {
        var _a, _b, _c, _d;
        const hasPrepend = !!(slots.prepend || props.prependIcon);
        const hasLabel = !!(slots.label || props.label);
        const hasAppend = !!(slots.append || props.appendIcon);
        const hasHint = !!(slots.hint || props.hint);
        const hasMessages = !!(slots.messages || ((_a = props.messages) == null ? void 0 : _a.length) || errorMessages.value.length);
        const hasDetails = !props.hideDetails || props.hideDetails === "auto" && (hasMessages || hasHint);
        const showMessages = hasMessages || hasHint && (props.persistentHint || props.focused);
        return vue.createVNode("div", {
          "class": ["ve-form-control", {
            [`ve-form-control--${props.direction}`]: !!props.direction,
            "ve-form-control--hide-details": props.hideDetails,
            "ve-form-control--inline": props.inline
          }, sizeClasses.value, densityClasses.value, validationClasses.value]
        }, [hasPrepend && vue.createVNode("div", {
          "class": "ve-form-control__prepend"
        }, [(_b = slots.prepend) == null ? void 0 : _b.call(slots, slotProps.value), props.prependIcon && vue.createVNode(Icon, {
          "onClick": (e) => emit("click:prepend", e),
          "icon": props.prependIcon
        }, null)]), hasLabel && vue.createVNode("div", {
          "class": "ve-form-control__label",
          "style": {
            width: convertToUnit(props.labelWidth)
          }
        }, [vue.createVNode(Label, {
          "disabled": isDisabled.value,
          "error": isValid.value === false,
          "onClick": (e) => emit("click:label", e),
          "for": props.labelId
        }, {
          default: () => {
            var _a2, _b2;
            return [(_b2 = (_a2 = slots.label) == null ? void 0 : _a2.call(slots, slotProps.value)) != null ? _b2 : props.label];
          }
        })]), slots.default && vue.createVNode("div", {
          "class": "ve-form-control__control",
          "style": [sizeStyles.value, computedDimensionStyles.value]
        }, [slots.default(slotProps.value)]), hasAppend && vue.createVNode("div", {
          "class": "ve-form-control__append"
        }, [props.appendIcon && vue.createVNode(Icon, {
          "onClick": (e) => emit("click:append", e),
          "icon": props.appendIcon
        }, null), (_c = slots == null ? void 0 : slots.append) == null ? void 0 : _c.call(slots, slotProps.value)]), hasDetails && vue.createVNode("div", {
          "class": "ve-form-control__details"
        }, [vue.createVNode(Messages, {
          "active": showMessages,
          "value": hasMessages ? props.messages : [props.hint]
        }, {
          default: slots.messages
        }), (_d = slots.details) == null ? void 0 : _d.call(slots, slotProps.value)])]);
      });
      return {
        isDisabled,
        isReadonly,
        isPristine,
        isValid,
        isValidating,
        reset,
        resetValidation,
        validate
      };
    }
  });
  const CheckboxGroup = defineComponent({
    name: "VeCheckboxGroup",
    props: __spreadValues(__spreadValues(__spreadValues({
      items: Array
    }, makeSelectionGroupControlProps({
      type: "checkbox",
      falseIcon: "$checkboxOff",
      trueIcon: "$checkboxOn",
      multiple: true
    })), makeSizeProps()), makeDensityProps()),
    emits: {
      "update:modelValue": (_val) => true
    },
    setup(props, {
      slots
    }) {
      const id = vue.computed(() => props.id || `ve-checkbox-group-${getUid()}`);
      const model = useProxiedModel(props, "modelValue");
      const items = vue.computed(() => {
        var _a;
        return (_a = props.items) == null ? void 0 : _a.map((itemProps) => typeof itemProps === "string" ? {
          value: itemProps
        } : itemProps);
      });
      provideDefaults({
        VeCheckbox: {
          size: vue.toRef(props, "size"),
          density: vue.toRef(props, "density"),
          readonly: vue.toRef(props, "readonly"),
          disabled: vue.toRef(props, "disabled")
        }
      });
      return () => {
        const _a = props, {
          density,
          size
        } = _a, restProps = __objRest(_a, [
          "density",
          "size"
        ]);
        return vue.createVNode(FormControl, {
          "class": "ve-checkbox-group",
          "density": density,
          "name": props.name,
          "size": size,
          "modelValue": model.value,
          "onUpdate:modelValue": ($event) => model.value = $event
        }, __spreadProps(__spreadValues({}, slots), {
          default: ({
            isDisabled,
            isReadonly,
            props: controlProps
          }) => {
            return vue.createVNode(SelectionGroupControl, vue.mergeProps(restProps, controlProps, {
              "id": id.value,
              "disabled": isDisabled.value,
              "readonly": isReadonly.value,
              "modelValue": model.value,
              "onUpdate:modelValue": ($event) => model.value = $event
            }), {
              default: () => {
                var _a2, _b;
                return [(_a2 = items.value) == null ? void 0 : _a2.map((itemProps) => vue.createVNode(Checkbox, itemProps, null)), (_b = slots.default) == null ? void 0 : _b.call(slots)];
              }
            });
          }
        }));
      };
    }
  });
  var code = "";
  const aliases$1 = {
    sh: "bash",
    shell: "bash",
    vue: "markup",
    html: "markup",
    md: "markdown",
    ts: "typescript",
    js: "javascript"
  };
  async function prismjsHighlightCode(prismjs, code2, language) {
    language = language.toLowerCase();
    if (language in aliases$1) {
      language = aliases$1[language];
    }
    if (!prismjs.languages[language]) {
      console.warn(`[VenoUi] Syntax highlight for language "${language}" is not supported. try "import 'prismjs/components/prism-${language}.js'" .`);
      return code2;
    }
    return prismjs.highlight(code2, prismjs.languages[language], language);
  }
  const aliases = {
    template: "vue-html"
  };
  async function shikiHighlightCode(shiki, code2, language) {
    language = language.toLowerCase();
    if (language in aliases) {
      language = aliases[language];
    }
    const highlighter = await shiki;
    try {
      await highlighter.loadLanguage(language);
      return highlighter.codeToHtml(code2, language).replace(/[\s\S]*code>([\s\S]*)<\/code[\s\S]*/, "$1");
    } catch (e) {
      console.warn(`[VenoUi] Syntax highlight for language "${language}" error: ${e}" .`);
      return code2;
    }
  }
  const HighlighterKey = createSymbol("highlighter");
  function createHighlighter(options) {
    return vue.ref({
      highlight: async (code2, language) => {
        var _a;
        const type = (_a = options == null ? void 0 : options.type) != null ? _a : "shiki";
        if (language === "text") {
          return code2;
        } else if (type === "shiki" && (options == null ? void 0 : options.shiki)) {
          return await shikiHighlightCode(options.shiki, code2, language);
        } else if (type === "prismjs" && (options == null ? void 0 : options.prismjs)) {
          return await prismjsHighlightCode(options.prismjs, code2, language);
        } else {
          return code2;
        }
      }
    });
  }
  function useHighlighter() {
    const highlighter = vue.inject(HighlighterKey);
    if (!highlighter)
      throw new Error("[VenoUi] Could not find highlighter instance");
    return highlighter;
  }
  const makeScrollbar = propsFactory({
    beautifyScrollbar: {
      type: Boolean,
      default: true
    }
  }, "scrollbar");
  function useScrollbar(props) {
    const scrollbarClasses = vue.computed(() => props.beautifyScrollbar ? "beautify-scrollbar" : null);
    return {
      scrollbarClasses
    };
  }
  const Code = defineComponent({
    name: "VeCode",
    props: __spreadValues(__spreadValues(__spreadValues({
      code: [String, Object],
      color: String,
      showLanguage: Boolean,
      showLineNumbers: Boolean,
      highlightedLineNumbers: Array,
      inline: Boolean,
      language: {
        type: String,
        default: "text"
      }
    }, makeThemeProps()), makeShapeProps()), makeScrollbar()),
    setup(props, {
      slots
    }) {
      const {
        themeClasses
      } = provideTheme(props);
      const {
        shapeClasses
      } = useShape(props);
      const highlighter = useHighlighter();
      const {
        scrollbarClasses
      } = useScrollbar(props);
      const code2 = vue.computed(() => {
        var _a, _b;
        let value = "";
        if (props.code) {
          value = typeof props.code === "object" ? JSON.stringify(props.code, null, 2) : (_a = props.code) != null ? _a : "";
        } else if (slots.default) {
          value = (_b = flattenFragments(slots.default()).filter((node) => node.children && typeof node.children === "string")[0]) == null ? void 0 : _b.children;
        }
        return decodeURIComponent(value).replace(/\n$/, "").replace(/^\n/, "");
      });
      const highlightedCode = vue.ref(code2.value);
      const {
        backgroundColorClasses,
        backgroundColorStyles
      } = useBackgroundColor(props, "color");
      const language = vue.computed(() => typeof props.code === "object" ? "json" : props.language);
      const lineNumbers = vue.computed(() => code2.value.split("\n").map((v, i) => i + 1));
      const highlightedLines = vue.computed(() => {
        return lineNumbers.value.filter((lineNumber) => {
          var _a;
          return (_a = props.highlightedLineNumbers) == null ? void 0 : _a.some((v) => {
            let start = v;
            let end;
            if (typeof v === "object") {
              [start, end] = v;
            }
            if (start && end) {
              return lineNumber >= start && lineNumber <= end;
            }
            return lineNumber === start;
          });
        });
      });
      const highlight = async () => {
        var _a;
        highlightedCode.value = await ((_a = highlighter.value) == null ? void 0 : _a.highlight(code2.value, language.value));
      };
      vue.onMounted(highlight);
      vue.watch([code2, language], highlight);
      return () => {
        var _a;
        if (props.inline) {
          return vue.createVNode("code", {
            "class": ["ve-code", "ve-code--inline", themeClasses.value, shapeClasses.value, backgroundColorClasses.value],
            "style": backgroundColorStyles.value,
            "innerHTML": highlightedCode.value
          }, null);
        }
        const showLines = props.showLineNumbers || !!((_a = props.highlightedLineNumbers) == null ? void 0 : _a.length);
        return vue.createVNode("div", {
          "class": ["ve-code", "ve-code--block", {
            "ve-code--show-line-numbers": !!props.showLineNumbers
          }, themeClasses.value, shapeClasses.value, backgroundColorClasses.value],
          "style": backgroundColorStyles.value
        }, [showLines && vue.createVNode("div", {
          "class": "ve-code__lines"
        }, [lineNumbers.value.map((number) => vue.createVNode("div", {
          "class": "ve-code__line"
        }, [highlightedLines.value.includes(number) && vue.createVNode("div", {
          "class": "ve-code__line-overlay",
          "innerHTML": "&nbsp;"
        }, null), props.showLineNumbers ? vue.createVNode("span", {
          "class": "ve-code__line-number"
        }, [number]) : vue.createVNode("br", null, null)]))]), vue.createVNode("pre", {
          "class": ["ve-code__preformatted", scrollbarClasses.value]
        }, [vue.createVNode("code", {
          "innerHTML": highlightedCode.value
        }, null)]), props.showLanguage && vue.createVNode("span", {
          "class": "ve-code__language"
        }, [language.value])]);
      };
    }
  });
  var counter = "";
  const Counter = genericComponent()({
    name: "VeCounter",
    props: __spreadValues({
      active: Boolean,
      max: [Number, String],
      value: {
        type: [Number, String],
        default: 0
      }
    }, makeTransitionProps({
      transition: {
        component: FadeTransition
      }
    })),
    setup(props, {
      slots
    }) {
      const counter2 = vue.computed(() => {
        return props.max ? `${props.value} / ${props.max}` : String(props.value);
      });
      return () => {
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition
        }, {
          default: () => {
            var _a, _b;
            return [vue.withDirectives(vue.createVNode("div", {
              "class": "ve-counter"
            }, [(_b = (_a = slots.default) == null ? void 0 : _a.call(slots, {
              counter: counter2.value,
              max: Number(props.max),
              value: Number(props.value)
            })) != null ? _b : counter2.value]), [[vue.vShow, props.active]])];
          }
        });
      };
    }
  });
  var datePicker = "";
  var input = "";
  var inputControl = "";
  const makeInputControlProps = propsFactory(__spreadValues(__spreadValues({
    appendInnerIcon: [String, Object],
    clearable: Boolean,
    clearIcon: {
      type: [String, Object],
      default: "$clear"
    },
    disabled: Boolean,
    prependInnerIcon: [String, Object],
    prefix: String,
    prefixIcon: [String, Object],
    suffix: String,
    suffixIcon: [String, Object]
  }, makeVariantProps({
    variant: "contained"
  })), makeShapeProps({
    shape: "rounded-sm"
  })), "input-control");
  function filterInputControlSlots(slots) {
    return pick(slots, InputControlSlots);
  }
  const InputControlEmits = {
    "click:clear": (_event) => true,
    "click:prepend-inner": (_event) => true,
    "click:prefix": (_event) => true,
    "click:suffix": (_event) => true,
    "click:append-inner": (_event) => true,
    "click:control": (_event) => true,
    "update:active": (_active) => true,
    "update:modelValue": (_modelValue) => true
  };
  const InputControlSlots = ["prepend-inner", "prefix", "default", "suffix", "append-inner", "clear"];
  const InputControl = genericComponent()({
    name: "VeInputControl",
    props: __spreadValues({
      active: Boolean,
      dirty: Boolean
    }, makeInputControlProps()),
    emits: InputControlEmits,
    setup(props, {
      slots,
      emit
    }) {
      const isActive = useProxiedModel(props, "active");
      const isFocused = vue.ref(false);
      const controlRef = vue.ref();
      const inputRef = vue.ref();
      const {
        variantClasses,
        colorClasses,
        colorStyles
      } = useVariant(props);
      const {
        shapeClasses
      } = useShape(props);
      vue.watchEffect(() => isActive.value = isFocused.value || props.dirty);
      function focus() {
        isFocused.value = true;
      }
      function blur() {
        isFocused.value = false;
      }
      const slotProps = vue.computed(() => ({
        isActive: isActive.value,
        isDirty: props.dirty,
        isFocused: isFocused.value,
        controlRef,
        inputRef,
        focus,
        blur
      }));
      function onClick(e) {
        if (e.target !== document.activeElement) {
          e.preventDefault();
        }
        emit("click:control", e);
      }
      useRender(() => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _i;
        const hasPrependInner = !!(props.prependInnerIcon || slots["prepend-inner"]);
        const hasPrefix = !!(props.prefix || props.prefixIcon || slots.prefix);
        const hasSuffix = !!(props.suffix || props.suffixIcon || slots.suffix);
        const hasClear = !!(props.clearable || slots.clear);
        const hasAppendInner = !!(props.appendInnerIcon || slots["append-inner"]);
        return vue.createVNode("div", {
          "class": ["ve-input-control", {
            "ve-input-control--active": isActive.value,
            "ve-input-control--disabled": props.disabled,
            "ve-input-control--dirty": props.dirty,
            "ve-input-control--focused": isFocused.value,
            "ve-input-control--prepended": hasPrependInner,
            "ve-input-control--prefixed": hasPrefix,
            "ve-input-control--suffixed": hasSuffix,
            "ve-input-control--appended": hasClear || hasAppendInner
          }, colorClasses.value, variantClasses.value, shapeClasses.value],
          "style": colorStyles.value,
          "onClick": onClick
        }, [genOverlays(false, "ve-input-control"), hasPrependInner && vue.createVNode("div", {
          "class": "ve-input-control__prepend-inner"
        }, [(_a = slots["prepend-inner"]) == null ? void 0 : _a.call(slots, slotProps.value), props.prependInnerIcon && vue.createVNode(Icon, {
          "onClick": (e) => emit("click:prepend-inner", e),
          "icon": props.prependInnerIcon
        }, null)]), vue.createVNode("div", {
          "class": "ve-input-control__input"
        }, [hasPrefix && vue.createVNode("span", {
          "class": "ve-input-control__prefix"
        }, [(_c = (_b = slots.prefix) == null ? void 0 : _b.call(slots, slotProps.value)) != null ? _c : props.prefix, props.prefixIcon && vue.createVNode(Icon, {
          "onClick": (e) => emit("click:prefix", e),
          "icon": props.prefixIcon
        }, null)]), (_d = slots.default) == null ? void 0 : _d.call(slots, __spreadProps(__spreadValues({}, slotProps.value), {
          props: {
            class: "ve-native-control"
          }
        })), hasSuffix && vue.createVNode("span", {
          "class": "ve-input-control__suffix"
        }, [props.suffixIcon && vue.createVNode(Icon, {
          "onClick": (e) => emit("click:suffix", e),
          "icon": props.suffixIcon
        }, null), (_f = (_e = slots.suffix) == null ? void 0 : _e.call(slots, slotProps.value)) != null ? _f : props.suffix])]), hasClear && vue.createVNode("div", {
          "class": ["ve-input-control__clearable", {
            "ve-input-control__clearable--has-append-inner": hasAppendInner
          }]
        }, [(_h = (_g = slots.clear) == null ? void 0 : _g.call(slots, slotProps.value)) != null ? _h : vue.createVNode(Button, {
          "icon": props.clearIcon,
          "ripple": false,
          "shape": "circle",
          "size": "1em",
          "onClick": (e) => emit("click:clear", e),
          "variant": "text"
        }, null)]), hasAppendInner && vue.createVNode("div", {
          "class": "ve-input-control__append-inner"
        }, [props.appendInnerIcon && vue.createVNode(Icon, {
          "icon": props.appendInnerIcon,
          "onClick": (e) => emit("click:append-inner", e)
        }, null), (_i = slots["append-inner"]) == null ? void 0 : _i.call(slots, slotProps.value)])]);
      });
      return {
        inputRef,
        controlRef
      };
    }
  });
  function filterInputControlProps(attrs) {
    return pick(attrs, Object.keys(InputControl.props));
  }
  const dirtyTypes = ["color", "file", "time", "date", "datetime-local", "week", "month"];
  const makeInputProps = propsFactory(__spreadValues({
    autofocus: Boolean,
    autoResize: Boolean,
    counter: [Boolean, Number, String],
    counterValue: Function,
    id: String,
    inputAttach: [Boolean, String, Object],
    maxRows: {
      type: [Number, String],
      validator: (v) => !isNaN(parseFloat(v))
    },
    modelValue: null,
    name: String,
    noResize: Boolean,
    persistentCounter: Boolean,
    placeholder: String,
    rows: {
      type: [Number, String],
      default: 5,
      validator: (v) => !isNaN(parseFloat(v))
    },
    type: {
      type: String,
      default: "text"
    },
    width: [String, Number]
  }, makeInputControlProps()));
  const InputEmits = __spreadProps(__spreadValues(__spreadValues({}, FormControlEmits), InputControlEmits), {
    "update:modelValue": (_) => true
  });
  const Input = genericComponent()({
    name: "VeInput",
    directives: {
      Intersect
    },
    props: makeInputProps(),
    emits: InputEmits,
    setup(props, {
      attrs,
      slots,
      emit
    }) {
      const inputControlRef = vue.ref();
      const formControlRef = vue.ref();
      const controlHeight = vue.ref();
      const controlWidth = vue.ref(props.width);
      const model = useProxiedModel(props, "modelValue");
      const id = vue.computed(() => props.id || `ve-input-${getUid()}`);
      const internalDirty = vue.ref(false);
      const isDirty = vue.computed(() => {
        return internalDirty.value || !!model.value || dirtyTypes.includes(props.type);
      });
      const counterValue = vue.computed(() => {
        return typeof props.counterValue === "function" ? props.counterValue(model.value) : (model.value || "").toString().length;
      });
      const max = vue.computed(() => {
        if (attrs.maxlength)
          return attrs.maxlength;
        if (!props.counter || typeof props.counter !== "number" && typeof props.counter !== "string")
          return void 0;
        return props.counter;
      });
      function focus() {
        var _a, _b;
        (_b = (_a = inputControlRef.value) == null ? void 0 : _a.inputRef) == null ? void 0 : _b.focus();
      }
      function blur() {
        var _a, _b;
        (_b = (_a = inputControlRef.value) == null ? void 0 : _a.inputRef) == null ? void 0 : _b.blur();
      }
      function onIntersect(isIntersecting, entries) {
        var _a, _b;
        if (!props.autofocus || !isIntersecting)
          return;
        (_b = (_a = entries[0].target) == null ? void 0 : _a.focus) == null ? void 0 : _b.call(_a);
      }
      const mirrorRef = vue.ref();
      function resize() {
        if (!props.autoResize)
          return;
        vue.nextTick(() => {
          var _a;
          if (!mirrorRef.value)
            return;
          if (props.type === "textarea") {
            const style = getComputedStyle(mirrorRef.value);
            const padding = (parseFloat(style.getPropertyValue("--ve-native-control---padding-top")) || 0) + (parseFloat(style.getPropertyValue("--ve-native-control---padding-bottom")) || 0);
            const lineHeight = parseFloat(style.lineHeight);
            const minHeight = parseFloat(props.rows) * lineHeight + padding;
            const maxHeight = parseFloat(props.maxRows) * lineHeight + padding || Infinity;
            controlHeight.value = Math.min(maxHeight, Math.max(minHeight, mirrorRef.value.scrollHeight));
          } else {
            controlWidth.value = Math.max(parseFloat((_a = props.width) != null ? _a : 100), mirrorRef.value.scrollWidth);
          }
        });
      }
      vue.onMounted(resize);
      vue.watch(model, resize);
      vue.watch(() => props.rows, resize);
      vue.watch(() => props.maxRows, resize);
      let observer;
      vue.watch(mirrorRef, (val) => {
        if (val) {
          observer = new ResizeObserver(resize);
          observer.observe(mirrorRef.value);
        } else {
          observer == null ? void 0 : observer.disconnect();
        }
      });
      vue.onBeforeUnmount(() => {
        observer == null ? void 0 : observer.disconnect();
      });
      function onControlClick(e) {
        focus();
        emit("click:control", e);
      }
      function onClear(e) {
        e.stopPropagation();
        focus();
        vue.nextTick(() => {
          model.value = "";
          emit("click:clear", e);
        });
      }
      useRender(() => {
        const isTextarea = props.type === "textarea";
        const hasCounter = !!(slots.counter || props.counter || props.counterValue);
        const [inputControlProps] = filterInputControlProps(props);
        const [, nativeControlAttrs] = filterInputAttrs(attrs);
        const [formControlSlots] = filterFormControlSlots(slots);
        const [inputControlSlots] = filterInputControlSlots(slots);
        return vue.createVNode(FormControl, {
          "ref": formControlRef,
          "class": ["ve-input", {
            "ve-input--textarea": isTextarea,
            "ve-input--auto-resize": props.autoResize,
            "ve-input--no-resize": props.noResize || props.autoResize
          }],
          "labelId": id.value,
          "style": controlHeight.value ? {
            "--ve-form-control---height": convertToUnit(controlHeight.value)
          } : null,
          "name": props.name,
          "onClick:prepend": (e) => emit("click:prepend", e),
          "onClick:label": (e) => emit("click:label", e),
          "onClick:append": (e) => emit("click:append", e),
          "modelValue": model.value,
          "onUpdate:modelValue": ($event) => model.value = $event,
          "width": controlWidth.value
        }, __spreadProps(__spreadValues({}, formControlSlots), {
          default: ({
            isDisabled,
            isReadonly
          }) => {
            return vue.createVNode(InputControl, vue.mergeProps(inputControlProps, {
              "ref": inputControlRef,
              "onMousedown": (e) => {
                var _a;
                if (e.target === ((_a = inputControlRef.value) == null ? void 0 : _a.inputRef))
                  return;
                e.preventDefault();
              },
              "dirty": !!model.value,
              "active": isDirty.value,
              "onClick:clear": onClear,
              "onClick:prependInner": (e) => emit("click:prepend-inner", e),
              "onClick:prefix": (e) => emit("click:prefix", e),
              "onClick:suffix": (e) => emit("click:suffix", e),
              "onClick:appendInner": (e) => emit("click:append-inner", e),
              "onClick:control": onControlClick,
              "onUpdate:active": (val) => internalDirty.value = val,
              "role": "textbox"
            }), __spreadProps(__spreadValues({}, inputControlSlots), {
              default: (slotProps) => {
                var _a, _b;
                const {
                  inputRef,
                  focus: focus2,
                  blur: blur2,
                  props: nativeControlProps
                } = slotProps;
                if (isTextarea) {
                  return vue.createVNode(vue.Fragment, null, [(_a = slots.default) == null ? void 0 : _a.call(slots, slotProps), IN_BROWSER && vue.createVNode(vue.Teleport, {
                    "disabled": !props.inputAttach,
                    "to": typeof props.inputAttach === "boolean" ? null : props.inputAttach
                  }, {
                    default: () => [vue.withDirectives(vue.createVNode("textarea", vue.mergeProps({
                      "onUpdate:modelValue": ($event) => model.value = $event,
                      "autofocus": props.autofocus,
                      "disabled": isDisabled.value,
                      "id": id.value,
                      "name": props.name,
                      "onFocus": focus2,
                      "onBlur": blur2,
                      "placeholder": props.placeholder,
                      "readonly": isReadonly.value,
                      "ref": inputRef,
                      "rows": props.rows
                    }, nativeControlProps, nativeControlAttrs), null), [[vue.vModelText, model.value], [vue.resolveDirective("intersect"), {
                      handler: onIntersect
                    }, null, {
                      once: true
                    }]]), props.autoResize && vue.withDirectives(vue.createVNode("textarea", vue.mergeProps({
                      "class": "ve-input__textarea-mirror",
                      "onUpdate:modelValue": ($event) => model.value = $event,
                      "ref": mirrorRef,
                      "readonly": true,
                      "aria-hidden": "true"
                    }, nativeControlProps), null), [[vue.vModelText, model.value]])]
                  })]);
                } else {
                  return vue.createVNode(vue.Fragment, null, [(_b = slots.default) == null ? void 0 : _b.call(slots, slotProps), IN_BROWSER && vue.createVNode(vue.Teleport, {
                    "disabled": !props.inputAttach,
                    "to": typeof props.inputAttach === "boolean" ? null : props.inputAttach
                  }, {
                    default: () => [vue.withDirectives(vue.createVNode("input", vue.mergeProps({
                      "onUpdate:modelValue": ($event) => model.value = $event,
                      "onInput": (e) => {
                        if (mirrorRef.value) {
                          mirrorRef.value.textContent = e.target.value;
                          resize();
                        }
                      },
                      "autofocus": props.autofocus,
                      "disabled": isDisabled.value,
                      "id": id.value,
                      "name": props.name,
                      "onFocus": focus2,
                      "onBlur": blur2,
                      "placeholder": props.placeholder,
                      "readonly": isReadonly.value,
                      "ref": inputRef,
                      "type": props.type
                    }, nativeControlProps, nativeControlAttrs), null), [[vue.resolveDirective("intersect"), {
                      handler: onIntersect
                    }, null, {
                      once: true
                    }], [vue.vModelDynamic, model.value]]), props.autoResize && vue.createVNode("span", vue.mergeProps({
                      "class": "ve-input__input-mirror",
                      "ref": mirrorRef,
                      "aria-hidden": "true"
                    }, nativeControlProps), [model.value])]
                  })]);
                }
              }
            }));
          },
          details: hasCounter ? () => {
            return vue.createVNode(vue.Fragment, null, [vue.createVNode("span", null, null), vue.createVNode(Counter, {
              "active": props.persistentCounter || isDirty.value,
              "value": counterValue.value,
              "max": max.value
            }, {
              default: slots.counter
            })]);
          } : formControlSlots == null ? void 0 : formControlSlots.details
        }));
      });
      return {
        formControlRef,
        inputControlRef,
        blur,
        focus
      };
    }
  });
  var menu = "";
  var overlay = "";
  var scrim = "";
  const Scrim = defineComponent({
    name: "VeScrim",
    inheritAttrs: false,
    props: __spreadValues({
      modelValue: Boolean,
      color: String
    }, makeTransitionProps({
      transition: {
        component: FadeTransition
      }
    })),
    setup(props, {
      attrs
    }) {
      const {
        backgroundColorClasses,
        backgroundColorStyles
      } = useBackgroundColor(vue.toRef(props, "color"));
      return () => {
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition,
          "appear": true
        }, {
          default: () => [props.modelValue && vue.createVNode("div", vue.mergeProps({
            "class": ["ve-scrim", backgroundColorClasses.value],
            "style": backgroundColorStyles.value
          }, attrs), null)]
        });
      };
    }
  });
  const makeDelayProps = propsFactory({
    closeDelay: [Number, String],
    openDelay: [Number, String]
  }, "delay");
  function useDelay(props, cb) {
    const delays = {};
    const runDelayFactory = (prop) => () => {
      if (!IN_BROWSER)
        return Promise.resolve(true);
      const active = prop === "openDelay";
      delays.closeDelay && window.clearTimeout(delays.closeDelay);
      delete delays.closeDelay;
      delays.openDelay && window.clearTimeout(delays.openDelay);
      delete delays.openDelay;
      return new Promise((resolve) => {
        var _a;
        delays[prop] = window.setTimeout(() => {
          cb == null ? void 0 : cb(active);
          resolve(active);
        }, Number((_a = props[prop]) != null ? _a : 0));
      });
    };
    return {
      runCloseDelay: runDelayFactory("closeDelay"),
      runOpenDelay: runDelayFactory("openDelay")
    };
  }
  const makeActivatorProps = propsFactory(__spreadValues({
    activator: [String, Object],
    activatorProps: {
      type: Object,
      default: () => ({})
    },
    openOnClick: {
      type: Boolean,
      default: void 0
    },
    openOnHover: Boolean,
    openOnFocus: {
      type: Boolean,
      default: void 0
    }
  }, makeDelayProps()), "activator");
  function useActivator(props, { isActive }) {
    const activatedPosition = vue.ref();
    const activatorEl = vue.ref();
    let isHovered = false;
    let isFocused = false;
    const openOnFocus = vue.computed(() => {
      return props.openOnFocus || props.openOnFocus == null && props.openOnHover;
    });
    const openOnClick = vue.computed(() => {
      return props.openOnClick || props.openOnClick == null && !props.openOnHover && !openOnFocus.value;
    });
    const { runOpenDelay, runCloseDelay } = useDelay(props, (value) => {
      const hovered = props.openOnHover && isHovered;
      const focused = openOnFocus.value && isFocused;
      if (value === (hovered || focused)) {
        isActive.value = value;
      }
    });
    function onEnter(e) {
      activatorEl.value = e.currentTarget || e.target;
      isHovered = true;
      runOpenDelay();
    }
    function onLeave(_) {
      isHovered = false;
      runCloseDelay();
    }
    const availableEvents = {
      click: (e) => {
        e.stopPropagation();
        activatedPosition.value = { left: e.clientX, top: e.clientY };
        activatorEl.value = e.currentTarget || e.target;
        isActive.value = !isActive.value;
      },
      mouseenter: onEnter,
      mouseleave: onLeave,
      touchstartPassive: onEnter,
      touchend: onLeave,
      contextmenu: (e) => e.preventDefault(),
      focus: (e) => {
        if (SUPPORTS_FOCUS_VISIBLE && !e.target.matches(":focus-visible"))
          return;
        e.stopPropagation();
        activatorEl.value = e.currentTarget || e.target;
        isFocused = true;
        runOpenDelay();
      },
      blur: (e) => {
        e.stopPropagation();
        isFocused = false;
        runCloseDelay();
      }
    };
    const activatorEvents = vue.computed(() => {
      const events = {};
      if (openOnClick.value) {
        events.click = availableEvents.click;
      }
      if (props.openOnHover) {
        if (SUPPORTS_TOUCH) {
          events.touchstartPassive = availableEvents.touchstartPassive;
          events.contextmenu = availableEvents.contextmenu;
          events.touchend = availableEvents.touchend;
        } else {
          events.mouseenter = availableEvents.mouseenter;
          events.mouseleave = availableEvents.mouseleave;
        }
      }
      if (openOnFocus.value) {
        events.focus = availableEvents.focus;
        events.blur = availableEvents.blur;
      }
      return events;
    });
    const contentEvents = vue.computed(() => {
      const events = {};
      if (props.openOnHover) {
        if (SUPPORTS_TOUCH) {
          events.touchstartPassive = (_) => isHovered = true;
          events.contextmenu = availableEvents.contextmenu;
          events.touchend = availableEvents.touchend;
        } else {
          events.mouseenter = (_) => isHovered = true;
          events.mouseleave = availableEvents.mouseleave;
        }
      }
      return events;
    });
    const activatorRef = vue.ref();
    vue.watchEffect(() => {
      if (!activatorRef.value)
        return;
      vue.nextTick(() => {
        const activator = activatorRef.value;
        activatorEl.value = isComponentInstance(activator) ? activator.$el : activator;
      });
    });
    const state = {
      activatedPosition,
      activatorEl,
      activatorRef,
      activatorEvents,
      contentEvents
    };
    let scope;
    vue.watch(() => !!props.activator, (val) => {
      if (val && IN_BROWSER) {
        scope = vue.effectScope();
        scope.run(() => useActivatorInScope(props, state));
      } else {
        scope == null ? void 0 : scope.stop();
      }
    }, { flush: "post", immediate: true });
    return state;
  }
  function useActivatorInScope(props, { activatorEl, activatorEvents }) {
    vue.watch(() => props.activator, (val, oldVal) => {
      if (oldVal && val !== oldVal) {
        const activator = getActivator(oldVal);
        activator && unbindActivatorProps(activator);
      }
      if (val) {
        vue.nextTick(() => bindActivatorProps());
      }
    }, { immediate: true });
    vue.watch(() => props.activatorProps, () => bindActivatorProps());
    vue.onScopeDispose(unbindActivatorProps);
    function bindActivatorProps(el = getActivator(), activatorProps = props.activatorProps) {
      if (!el)
        return;
      Object.entries(activatorEvents.value).forEach(([name, cb]) => {
        el.addEventListener(name, cb);
      });
      Object.keys(activatorProps).forEach((k) => {
        if (activatorProps[k] == null) {
          el.removeAttribute(k);
        } else {
          el.setAttribute(k, activatorProps[k]);
        }
      });
    }
    function unbindActivatorProps(el = getActivator(), activatorProps = props.activatorProps) {
      if (!el)
        return;
      Object.entries(activatorEvents.value).forEach(([name, cb]) => {
        el.removeEventListener(name, cb);
      });
      Object.keys(activatorProps).forEach((k) => {
        el.removeAttribute(k);
      });
    }
    const vm = getCurrentInstance("useActivator");
    function getActivator(selector = props.activator) {
      if (selector) {
        activatorEl.value = querySelector(selector, vm);
      }
      return activatorEl.value;
    }
  }
  function staticPositionStrategy() {
  }
  function connectedPositionStrategy(data, props, contentStyles, anchorClasses) {
    if (!data.activatorEl.value)
      return;
    const activatorFixed = isFixedPosition(data.activatorEl.value);
    if (activatorFixed) {
      Object.assign(contentStyles.value, {
        position: "fixed"
      });
    }
    const preferredAnchor = vue.computed(() => parseAnchor(props.anchor));
    const preferredOrigin = vue.computed(() => {
      switch (props.origin) {
        case "overlap":
          return preferredAnchor.value;
        case "auto":
          return oppositeAnchor(preferredAnchor.value);
        default:
          return parseAnchor(props.origin);
      }
    });
    const doesOverlap = vue.computed(() => {
      return preferredAnchor.value.side === preferredOrigin.value.side;
    });
    const configuredMaxHeight = vue.computed(() => {
      const val = parseFloat(String(props.maxHeight));
      return isNaN(val) ? Infinity : val;
    });
    const configuredMinWidth = vue.computed(() => {
      const val = parseFloat(String(props.minWidth));
      return isNaN(val) ? Infinity : val;
    });
    let observe = false;
    const observer = new ResizeObserver(() => {
      if (observe) {
        updatePosition();
      }
    });
    observer.observe(data.activatorEl.value);
    vue.onScopeDispose(() => {
      observer.disconnect();
    });
    vue.watch(() => [preferredAnchor.value, preferredOrigin.value, props.offset], () => updatePosition(), { immediate: !activatorFixed });
    if (activatorFixed)
      vue.nextTick(() => updatePosition());
    requestAnimationFrame(() => {
      if (contentStyles.value.maxHeight) {
        updatePosition();
      }
    });
    function updatePosition() {
      observe = false;
      requestAnimationFrame(() => {
        requestAnimationFrame(() => observe = true);
      });
      const targetBox = data.activatorEl.value.getBoundingClientRect();
      if (props.offset) {
        targetBox.x -= +props.offset;
        targetBox.y -= +props.offset;
        targetBox.width += +props.offset * 2;
        targetBox.height += +props.offset * 2;
      }
      let contentBox;
      {
        const scrollables = /* @__PURE__ */ new Map();
        data.contentEl.value.querySelectorAll("*").forEach((el) => {
          const x2 = el.scrollLeft;
          const y2 = el.scrollTop;
          if (x2 || y2) {
            scrollables.set(el, [x2, y2]);
          }
        });
        const initialMaxWidth = data.contentEl.value.style.maxWidth;
        const initialMaxHeight = data.contentEl.value.style.maxHeight;
        data.contentEl.value.style.removeProperty("max-width");
        data.contentEl.value.style.removeProperty("max-height");
        contentBox = nullifyTransforms(data.contentEl.value);
        contentBox.x -= parseFloat(data.contentEl.value.style.left) || 0;
        contentBox.y -= parseFloat(data.contentEl.value.style.top) || 0;
        data.contentEl.value.style.maxWidth = initialMaxWidth;
        data.contentEl.value.style.maxHeight = initialMaxHeight;
        scrollables.forEach((position, el) => {
          el.scrollTo(...position);
        });
      }
      const maxHeight = configuredMaxHeight.value;
      const contentWidth = Math.max(configuredMinWidth.value, contentBox.width);
      const contentHeight = Math.min(maxHeight, contentBox.height);
      contentBox = new Box(__spreadProps(__spreadValues({}, contentBox), {
        height: Math.min(contentHeight, maxHeight)
      }));
      const scrollParent = getScrollParent(data.contentEl.value);
      const viewportWidth = scrollParent.clientWidth;
      const viewportHeight = Math.min(scrollParent.clientHeight, window.innerHeight);
      const viewportMargin = 12;
      const freeSpace = {
        top: targetBox.top - viewportMargin,
        bottom: viewportHeight - targetBox.bottom - viewportMargin,
        left: targetBox.left - viewportMargin,
        right: viewportWidth - targetBox.right - viewportMargin
      };
      let anchor2 = preferredAnchor.value;
      let origin = preferredOrigin.value;
      {
        const { side } = anchor2;
        const { top, bottom, left, right } = freeSpace;
        if (side === "top" && top < contentHeight && bottom > top || side === "bottom" && bottom < contentHeight && top > bottom || side === "start" && left < contentWidth && right > left || side === "end" && right < contentWidth && left > right) {
          anchor2 = oppositeAnchor(anchor2);
          origin = oppositeAnchor(anchor2);
        }
      }
      const targetPoint = anchorToPoint(anchor2, targetBox);
      const contentPoint = anchorToPoint(origin, contentBox);
      let { x, y } = getOffset(targetPoint, contentPoint);
      let maxWidth = null;
      {
        if (doesOverlap.value || ["center", "top", "bottom"].includes(anchor2.side)) {
          maxWidth = Math.min(viewportWidth, Math.max(targetBox.width, viewportWidth - viewportMargin * 2));
        } else if (anchor2.side === "end") {
          maxWidth = freeSpace.right;
        } else if (anchor2.side === "start") {
          maxWidth = freeSpace.left;
        }
      }
      const minWidth = Math.min(configuredMinWidth.value, maxWidth, targetBox.width);
      if (contentWidth !== Infinity) {
        if (anchor2.side === "top" || anchor2.side === "bottom") {
          const maxX = viewportWidth - Math.min(maxWidth != null ? maxWidth : contentWidth, contentWidth) - viewportMargin;
          if (x > maxX) {
            x = maxX;
            anchor2.align = "end";
            origin = oppositeAnchor(anchor2);
          } else if (x < 0) {
            x = 0;
            anchor2.align = "start";
            origin = oppositeAnchor(anchor2);
          }
        }
      }
      Object.assign(contentStyles.value, {
        "--ve-overlay-anchor-origin": physicalAnchor(anchor2, data.activatorEl.value),
        "transformOrigin": physicalAnchor(origin, data.activatorEl.value),
        "top": convertToUnit(Math.round(y)),
        "left": convertToUnit(Math.round(x)),
        "minWidth": convertToUnit(minWidth),
        "maxWidth": convertToUnit(maxWidth),
        "maxHeight": convertToUnit(maxHeight)
      });
      anchorClasses.value = [
        `ve-overlay--side-${anchor2.side}`,
        `ve-overlay--align-${anchor2.align}`
      ];
    }
    return { updatePosition };
  }
  function pointerPositionStrategy(data, props, contentStyles, _anchorClasses) {
    const updatePosition = (e) => {
      var _a, _b;
      const box = { left: e.clientX, top: e.clientY };
      Object.assign(contentStyles.value, {
        position: "fixed",
        left: convertToUnit(box.left + +((_a = props.offset) != null ? _a : 0)),
        top: convertToUnit(box.top + +((_b = props.offset) != null ? _b : 0))
      });
    };
    document.addEventListener("mousemove", updatePosition);
    vue.onScopeDispose(() => {
      document.removeEventListener("mousemove", updatePosition);
    });
    return {
      updatePosition: void 0
    };
  }
  const POSITION_STRATEGIES = {
    static: staticPositionStrategy,
    connected: connectedPositionStrategy,
    pointer: pointerPositionStrategy
  };
  const makePositionStrategyProps = propsFactory({
    positionStrategy: {
      type: [String, Function],
      default: "static",
      validator: (val) => typeof val === "function" || val in POSITION_STRATEGIES
    },
    anchor: {
      type: String,
      default: "bottom"
    },
    origin: {
      type: String,
      default: "auto"
    },
    offset: [Number, String]
  }, "position-strategy");
  function usePositionStrategy(props, data) {
    const contentStyles = vue.ref({});
    const anchorClasses = vue.ref([]);
    const updatePosition = vue.ref();
    let scope;
    vue.watchEffect(async () => {
      scope == null ? void 0 : scope.stop();
      updatePosition.value = void 0;
      if (!(IN_BROWSER && data.isActive.value && props.positionStrategy))
        return;
      scope = vue.effectScope();
      await vue.nextTick();
      scope.run(() => {
        var _a;
        const strategy = typeof props.positionStrategy === "function" ? props.positionStrategy : POSITION_STRATEGIES[props.positionStrategy];
        updatePosition.value = (_a = strategy(data, props, contentStyles, anchorClasses)) == null ? void 0 : _a.updatePosition;
      });
    });
    IN_BROWSER && window.addEventListener("resize", onResize, { passive: true });
    vue.onScopeDispose(() => {
      IN_BROWSER && window.removeEventListener("resize", onResize);
      updatePosition.value = void 0;
      scope == null ? void 0 : scope.stop();
    });
    function onResize(e) {
      var _a;
      (_a = updatePosition.value) == null ? void 0 : _a.call(updatePosition, e);
    }
    return {
      contentStyles,
      anchorClasses,
      updatePosition
    };
  }
  function bindScroll(el, onScroll) {
    const scrollElements = [document, ...getScrollParents(el)];
    scrollElements.forEach((el2) => {
      el2.addEventListener("scroll", onScroll, { passive: true });
    });
    vue.onScopeDispose(() => {
      scrollElements.forEach((el2) => {
        el2.removeEventListener("scroll", onScroll);
      });
    });
  }
  function closeScrollStrategy(data, _name) {
    var _a;
    function onScroll(_e) {
      data.isActive.value = false;
    }
    bindScroll((_a = data.activatorEl.value) != null ? _a : data.contentEl.value, onScroll);
  }
  function blockScrollStrategy(data, name) {
    var _a;
    const rootParent = (_a = data.root.value) == null ? void 0 : _a.offsetParent;
    const scrollableParent = rootParent && hasScrollbar(rootParent);
    if (scrollableParent) {
      data.root.value.classList.add(`${name}--scroll-blocked`);
    }
    const scrollElements = rootParent ? [] : [.../* @__PURE__ */ new Set([
      ...getScrollParents(data.activatorEl.value),
      ...getScrollParents(data.contentEl.value)
    ])].filter((el) => !el.classList.contains(`${name}-scroll-blocked`));
    scrollElements.forEach((el) => {
      el.style.setProperty("--ve-scrollbar-offset", convertToUnit(getScrollbarWidth(el)));
      el.classList.add(`${name}-scroll-blocked`);
    });
    vue.onScopeDispose(() => {
      if (scrollableParent) {
        data.root.value.classList.remove(`${name}--scroll-blocked`);
      }
      scrollElements.forEach((el) => {
        el.style.removeProperty("--ve-scrollbar-offset");
        el.classList.remove(`${name}-scroll-blocked`);
      });
    });
  }
  function repositionScrollStrategy(data, _name) {
    var _a;
    let slow = false;
    let raf2 = -1;
    function update(e) {
      requestNewFrame(() => {
        var _a2, _b;
        const start = performance.now();
        (_b = (_a2 = data.updatePosition).value) == null ? void 0 : _b.call(_a2, e);
        const time = performance.now() - start;
        slow = time / (1e3 / 60) > 2;
      });
    }
    bindScroll((_a = data.activatorEl.value) != null ? _a : data.contentEl.value, (e) => {
      if (slow) {
        cancelAnimationFrame(raf2);
        raf2 = requestAnimationFrame(() => {
          raf2 = requestAnimationFrame(() => {
            update(e);
          });
        });
      } else {
        update(e);
      }
    });
  }
  const scrollStrategies = {
    none: null,
    close: closeScrollStrategy,
    block: blockScrollStrategy,
    reposition: repositionScrollStrategy
  };
  const makeScrollStrategyProps = propsFactory({
    scrollStrategy: {
      type: [Boolean, String, Function],
      default: "block",
      validator: (val) => typeof val === "function" || typeof val === "boolean" || val in scrollStrategies
    }
  });
  function useScrollStrategy(props, data, name = getCurrentInstanceName()) {
    if (!IN_BROWSER)
      return;
    let scope;
    vue.watchEffect(async () => {
      scope == null ? void 0 : scope.stop();
      if (!data.isActive.value || !props.scrollStrategy || typeof props.scrollStrategy === "boolean")
        return;
      scope = vue.effectScope();
      await vue.nextTick();
      scope.run(() => {
        var _a;
        if (typeof props.scrollStrategy === "function") {
          props.scrollStrategy(data, name);
        } else if (typeof props.scrollStrategy === "string" && props.scrollStrategy in scrollStrategies) {
          (_a = scrollStrategies[props.scrollStrategy]) == null ? void 0 : _a.call(scrollStrategies, data, name);
        }
      });
    });
  }
  function useTeleport(target = false) {
    const teleportTarget = vue.computed(() => {
      const _target = vue.unref(target);
      if (_target === true || !IN_BROWSER)
        return void 0;
      const targetElement = _target === false ? document.body : typeof _target === "string" ? document.querySelector(_target) : _target;
      if (targetElement == null) {
        vue.warn(`Unable to locate target ${_target}`);
        return void 0;
      }
      if (!useTeleport.cache.has(targetElement)) {
        const el = document.createElement("div");
        el.className = "ve-overlay-container";
        targetElement.appendChild(el);
        useTeleport.cache.set(targetElement, el);
      }
      return useTeleport.cache.get(targetElement);
    });
    return { teleportTarget };
  }
  useTeleport.cache = /* @__PURE__ */ new WeakMap();
  const makeLazyProps = propsFactory({
    eager: Boolean
  }, "lazy");
  function useLazy(props, active) {
    const isBooted = vue.ref(false);
    const hasContent = vue.computed(() => isBooted.value || props.eager || active.value);
    vue.watch(active, () => isBooted.value = true);
    function onAfterLeave() {
      if (!props.eager)
        isBooted.value = false;
    }
    return { isBooted, hasContent, onAfterLeave };
  }
  const stack = vue.ref([]);
  function useStack(isActive) {
    const vm = getCurrentInstance("stack");
    let scope;
    vue.watch(isActive, (val) => {
      if (val) {
        scope = vue.effectScope();
        scope.run(() => {
          stack.value.push(vm);
          vue.onScopeDispose(() => {
            stack.value.splice(stack.value.indexOf(vm), 1);
          });
        });
      } else {
        scope == null ? void 0 : scope.stop();
      }
    }, { immediate: true });
    const isTop = vue.computed(() => {
      return vue.toRaw(stack.value[stack.value.length - 1]) === vm;
    });
    return {
      isTop
    };
  }
  const makeOverlayProps = propsFactory(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
    modelValue: Boolean,
    absolute: Boolean,
    attach: [Boolean, String, Object],
    contained: Boolean,
    contentStyle: null,
    contentClass: null,
    noClickAnimation: Boolean,
    persistent: Boolean,
    scrim: {
      type: [String, Boolean],
      default: true
    }
  }, makeActivatorProps()), makeDimensionProps()), makePositionStrategyProps()), makeScrollStrategyProps()), makeThemeProps()), makeTransitionProps({
    transition: {
      component: FadeTransition
    }
  })), makeLazyProps()), "overlay");
  const Overlay = genericComponent()({
    name: "VeOverlay",
    inheritAttrs: false,
    directives: {
      ClickOutside
    },
    props: makeOverlayProps(),
    emits: {
      "click:outside": (_event) => true,
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots,
      attrs,
      emit
    }) {
      const isActive = useProxiedModel(props, "modelValue");
      const isInternalActive = vue.ref(isActive.value);
      const {
        teleportTarget
      } = useTeleport(vue.computed(() => props.attach || props.contained));
      const {
        themeClasses
      } = provideTheme(props);
      const {
        hasContent,
        onAfterLeave: onAfterLeaveByLazy
      } = useLazy(props, isActive);
      const {
        dimensionStyles
      } = useDimension(props);
      const {
        isTop
      } = useStack(isActive);
      const root = vue.ref();
      const contentEl = vue.ref();
      const {
        overlayZIndex
      } = useOverlay(isInternalActive);
      const {
        activatedPosition,
        activatorEl,
        activatorRef,
        activatorEvents,
        contentEvents
      } = useActivator(props, {
        isActive
      });
      const {
        contentStyles,
        anchorClasses,
        updatePosition
      } = usePositionStrategy(props, {
        activatedPosition,
        activatorEl,
        contentEl,
        isActive
      });
      useScrollStrategy(props, {
        root,
        contentEl,
        activatorEl,
        isActive: isInternalActive,
        updatePosition
      });
      const animateClick = () => {
        var _a;
        if (props.noClickAnimation)
          return;
        (_a = contentEl.value) == null ? void 0 : _a.animate([{
          transformOrigin: "center"
        }, {
          transform: "scale(1.03)"
        }, {
          transformOrigin: "center"
        }], {
          duration: 150,
          easing: standardEasing
        });
      };
      const onClickOutside = (e) => {
        emit("click:outside", e);
        if (!props.persistent) {
          isActive.value = false;
        } else {
          animateClick();
        }
      };
      const onKeydown = ({
        key
      }) => {
        if (key === keyValues.esc && isTop.value) {
          if (!props.persistent) {
            isActive.value = false;
          } else {
            animateClick();
          }
        }
      };
      vue.watch(isActive, (val) => {
        if (val)
          isInternalActive.value = true;
        if (IN_BROWSER) {
          if (val) {
            window.addEventListener("keydown", onKeydown);
          } else {
            window.removeEventListener("keydown", onKeydown);
          }
        }
      }, {
        immediate: true
      });
      useBackButton((next) => {
        if (isTop.value && isActive.value) {
          next(false);
          if (!props.persistent) {
            isActive.value = false;
          } else {
            animateClick();
          }
        } else {
          next();
        }
      });
      const top = vue.ref();
      vue.watch(() => {
        return isActive.value && (props.absolute || props.contained) && teleportTarget.value == null;
      }, (val) => {
        if (val) {
          const scrollParent = getScrollParent(root.value);
          if (scrollParent && scrollParent !== document.scrollingElement) {
            top.value = scrollParent.scrollTop;
          }
        }
      });
      const onAfterLeave = () => {
        isInternalActive.value = false;
        onAfterLeaveByLazy();
      };
      const closeConditional = () => {
        return isActive.value && isTop.value;
      };
      const close = () => {
        isActive.value = false;
      };
      useRender(() => {
        var _a;
        const on = vue.toHandlers(activatorEvents.value);
        return vue.createVNode(vue.Fragment, null, [(_a = slots.activator) == null ? void 0 : _a.call(slots, {
          close,
          isActive: isActive.value,
          props: vue.mergeProps({
            ref: activatorRef
          }, on, props.activatorProps),
          on
        }), IN_BROWSER && vue.createVNode(vue.Teleport, {
          "disabled": !teleportTarget.value,
          "to": teleportTarget.value
        }, {
          default: () => [hasContent.value && vue.createVNode("div", vue.mergeProps({
            "class": ["ve-overlay", {
              "ve-overlay--absolute": props.absolute || props.contained,
              "ve-overlay--active": isActive.value,
              "ve-overlay--contained": props.contained
            }, anchorClasses.value, themeClasses.value],
            "ref": root,
            "style": {
              top: convertToUnit(top.value),
              zIndex: overlayZIndex.value
            }
          }, attrs), [vue.createVNode(Scrim, {
            "color": typeof props.scrim === "string" ? props.scrim : void 0,
            "modelValue": isActive.value && !!props.scrim
          }, null), vue.createVNode(MaybeTransition, {
            "appear": true,
            "onAfterLeave": onAfterLeave,
            "persisted": true,
            "transition": props.transition,
            "target": activatorEl.value
          }, {
            default: () => {
              var _a2;
              return [vue.withDirectives(vue.createVNode("div", vue.mergeProps({
                "ref": contentEl,
                "class": ["ve-overlay__wrapper", props.contentClass],
                "style": [props.contentStyle, dimensionStyles.value, contentStyles.value]
              }, vue.toHandlers(contentEvents.value)), [(_a2 = slots.default) == null ? void 0 : _a2.call(slots, {
                close,
                isActive
              })]), [[vue.vShow, isActive.value], [vue.resolveDirective("click-outside"), {
                handler: onClickOutside,
                closeConditional,
                include: () => [activatorEl.value]
              }]])];
            }
          })])]
        })]);
      });
      return {
        animateClick,
        close,
        contentEl,
        activatorEl,
        updatePosition
      };
    }
  });
  function _isSlot$8(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Menu = genericComponent()({
    name: "VeMenu",
    props: __spreadValues({
      modelValue: Boolean,
      id: String
    }, makeTransitionProps({
      transition: {
        component: MenuTransition
      }
    })),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const isActive = useProxiedModel(props, "modelValue");
      const overlayRef = vue.ref();
      const id = vue.computed(() => props.id || `ve-menu-${getUid()}`);
      useRender(() => {
        return vue.createVNode(Overlay, {
          "ref": overlayRef,
          "modelValue": isActive.value,
          "onUpdate:modelValue": ($event) => isActive.value = $event,
          "class": "ve-menu",
          "transition": props.transition,
          "absolute": true,
          "positionStrategy": "connected",
          "scrollStrategy": "reposition",
          "closeDelay": 100,
          "minWidth": 0,
          "offset": 4,
          "scrim": false,
          "activatorProps": {
            "aria-haspopup": "menu",
            "aria-expanded": String(isActive.value),
            "aria-owns": id.value
          }
        }, _isSlot$8(slots) ? slots : {
          default: () => [slots]
        });
      });
      return {
        overlayRef
      };
    }
  });
  var datePickerPanel = "";
  const MAP = {
    year: {
      alias: "Y",
      get: "getFullYear",
      set: "setFullYear",
      startOf: "YYYY-01-01 00:00:00",
      endOf: "YYYY-12-$1 23:59:59.999"
    },
    month: {
      alias: "M",
      get: "getMonth",
      set: "setMonth",
      startOf: "YYYY-MM-01 00:00:00",
      endOf: "YYYY-MM-31 23:59:59.999"
    },
    day: {
      alias: "D",
      get: "getDate",
      set: "setDate",
      startOf: "YYYY-MM-DD 00:00:00",
      endOf: "YYYY-MM-DD 23:59:59.999"
    },
    hour: {
      alias: "H",
      get: "getHours",
      set: "setHours",
      startOf: "YYYY-MM-DD HH:00:00",
      endOf: "YYYY-MM-DD HH:59:59.999"
    },
    minute: {
      alias: "m",
      get: "getMinutes",
      set: "setMinutes",
      startOf: "YYYY-MM-DD HH:mm:00",
      endOf: "YYYY-MM-DD HH:mm:59.999"
    },
    second: {
      alias: "s",
      get: "getSeconds",
      set: "setSeconds",
      startOf: "YYYY-MM-DD HH:mm:ss.000",
      endOf: "YYYY-MM-DD HH:mm:ss.999"
    },
    millisecond: {
      alias: "ms",
      get: "getMilliseconds",
      set: "setMilliseconds",
      startOf: "YYYY-MM-DD HH:mm:ss.000",
      endOf: "YYYY-MM-DD HH:mm:ss.999"
    }
  };
  const defaultDateFormat = "YYYY-MM-DD HH:mm:ss";
  function createDate(options) {
    let date;
    {
      if (!options) {
        date = new Date();
      } else if (typeof options === "string") {
        date = new Date(options.replace(/-/g, "/"));
      } else {
        date = new Date(options);
      }
    }
    function tap(cb1, cb2) {
      const res = cb1();
      cb2(res);
      return res;
    }
    const ctx = {
      add(value, unit) {
        return tap(() => this.clone(), (cloned) => {
          const get = MAP[unit].get;
          const set = MAP[unit].set;
          if (set in cloned && get in cloned) {
            cloned[set](cloned[get]() + value);
          }
        });
      },
      subtract(value, unit) {
        return this.add(-value, unit);
      },
      startOf(unit) {
        return createDate(this.format(MAP[unit].startOf));
      },
      endOf(unit) {
        return createDate(this.format(MAP[unit].endOf));
      },
      format(value = defaultDateFormat) {
        const formatted = this.toObject();
        const { format, counter: counter2 } = value.split("").reduce(({ format: format2, counter: counter22 }, key) => {
          if (key in formatted && format2[format2.length - 1] === key) {
            counter22[key] = counter22[key] || 1;
            counter22[key]++;
          } else {
            format2 += key;
          }
          return { format: format2, counter: counter22 };
        }, { format: "", counter: {} });
        return format.replace(/\w/g, (key) => {
          if (key in formatted) {
            const val = formatted[key];
            if (key in counter2) {
              return padNumber(val, counter2[key]);
            }
            return String(val);
          }
          return String(key);
        });
      },
      clone: () => createDate(date),
      unix() {
        return ~~(date.getTime() / 1e3);
      },
      valueOf() {
        return date.valueOf();
      },
      toDate() {
        return date;
      },
      toObject() {
        return {
          Y: date.getFullYear(),
          M: date.getMonth() + 1,
          D: date.getDate(),
          H: date.getHours(),
          m: date.getMinutes(),
          s: date.getSeconds(),
          ms: date.getMilliseconds(),
          d: date.getDay()
        };
      }
    };
    return new Proxy(ctx, {
      get: (target, prop) => {
        return prop in target ? target[prop] : prop in date ? date[prop].bind(date) : void 0;
      },
      has: (target, prop) => {
        return prop in target || prop in date;
      }
    });
  }
  var dateRangePickerPanel = "";
  const DateRangeKey = Symbol.for("veno-ui:date-range");
  const DateRangePickerPanel = defineComponent({
    name: "VeDateRangePickerPanel",
    props: {
      format: {
        type: [Array, Function],
        default: () => ["YYYY-MM-DD", "YYYY-MM-DD"]
      },
      modelValue: {
        type: Array,
        default: () => []
      }
    },
    emits: {
      "update:modelValue": (_value) => true,
      "preview": (_value) => true
    },
    setup(props, {
      emit
    }) {
      const model = useProxiedModel(props, "modelValue");
      const selected = vue.computed(() => {
        return model.value.map(createDate).sort((a, b) => a.valueOf() - b.valueOf());
      });
      const isPreview = vue.ref(false);
      function formatter(dates) {
        return typeof props.format === "function" ? props.format(dates) : dates.map((date, i) => date.format(props.format[i]));
      }
      function preview(value) {
        isPreview.value = value;
        emit("preview", isPreview.value);
      }
      function select2(value) {
        const length = model.value.length;
        if (length === 1 || isPreview.value && length > 0) {
          if (model.value[1] === value)
            return;
          model.value = formatter([model.value[0], value].map(createDate));
        } else {
          if (model.value[0] === value)
            return;
          model.value = formatter([value].map(createDate));
        }
      }
      function inRange(value) {
        if (selected.value.length < 2)
          return false;
        return selected.value[0].valueOf() <= value && selected.value[1].valueOf() >= value;
      }
      vue.provide(DateRangeKey, {
        selected,
        select: select2,
        inRange,
        preview,
        isPreview
      });
      return () => {
        return vue.createVNode(Card, {
          "class": "ve-date-range-picker-panel"
        }, {
          default: () => [vue.createVNode(DatePickerPanel, {
            "format": defaultDateFormat,
            "modelValue": createDate().startOf("month").format(),
            "max": createDate().startOf("month").format()
          }, null), vue.createVNode(DatePickerPanel, {
            "format": defaultDateFormat,
            "modelValue": createDate().add(1, "month").startOf("month").format(),
            "min": createDate().add(1, "month").startOf("month").format()
          }, null)]
        });
      };
    }
  });
  const ROWS_COUNT = 6;
  const COLS_COUNT = 7;
  const CELLS_COUNT = ROWS_COUNT * COLS_COUNT;
  const WEEKDAYS = ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"];
  const DatePickerPanel = defineComponent({
    name: "VeDatePickerPanel",
    props: {
      activeColor: {
        type: String,
        default: "primary"
      },
      firstDayOfWeek: {
        type: [String, Number],
        default: 0,
        validator: (val) => Number(val) in WEEKDAYS
      },
      format: {
        type: [String, Function],
        default: "YYYY-MM-DD"
      },
      max: String,
      min: String,
      modelValue: String,
      prevDoubleIcon: {
        type: String,
        default: "$prevDouble"
      },
      prevIcon: {
        type: String,
        default: "$prev"
      },
      nextIcon: {
        type: String,
        default: "$next"
      },
      nextDoubleIcon: {
        type: String,
        default: "$nextDouble"
      }
    },
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const firstDayOfWeek = vue.computed(() => Number(props.firstDayOfWeek));
      const max = vue.computed(() => props.max ? createDate(props.max) : void 0);
      const min = vue.computed(() => props.min ? createDate(props.min) : void 0);
      const model = useProxiedModel(props, "modelValue", props.modelValue, (v) => createDate(v), (v) => formatter(v));
      const range = vue.inject(DateRangeKey, null);
      const selected = vue.computed(() => {
        if (range) {
          return range.selected.value.map((v) => valueFormatter(v.startOf("day")));
        }
        return wrapInArray(valueFormatter(model.value.startOf("day")));
      });
      const weekdays = vue.computed(() => createRange(7).map((i) => WEEKDAYS[(i + firstDayOfWeek.value) % 7]));
      const internalModel = vue.ref(model.value.startOf("month"));
      const month = vue.computed(() => internalModel.value.format("M"));
      vue.watch(model, (val) => {
        internalModel.value = val.startOf("month");
      });
      function formatter(date) {
        return typeof props.format === "string" ? date.format(props.format) : props.format(date);
      }
      function valueFormatter(date) {
        return createDate(formatter(date)).valueOf();
      }
      const rows = vue.computed(() => {
        const now = valueFormatter(createDate().startOf("day"));
        const sharedProps = {
          icon: true,
          variant: "text",
          shape: "circle",
          size: "small"
        };
        const cells = [];
        const weekDay = Number(internalModel.value.format("d"));
        const offsetDay = firstDayOfWeek.value - weekDay;
        let date = internalModel.value.add(offsetDay, "day");
        createRange(CELLS_COUNT).forEach((_) => {
          const current = date;
          date = date.add(1, "day");
          const text = formatter(current);
          const value = valueFormatter(current);
          const selectedIndex = selected.value.findIndex((v) => v === value);
          const isActive = selectedIndex > -1;
          const isToday = now == value;
          const variant = isActive ? "contained" : isToday ? "outlined" : "text";
          const color = isActive || isToday ? props.activeColor : void 0;
          function onClick() {
            if (range) {
              range.select(text);
              range.isPreview.value && range.preview(false);
            } else {
              model.value = current;
            }
          }
          cells.push({
            isActive,
            selectedIndex,
            isOtherMonth: current.format("M") !== month.value,
            text,
            value,
            props: __spreadProps(__spreadValues({}, sharedProps), {
              variant,
              color,
              text: current.format("D"),
              onClick
            })
          });
        });
        const rows2 = createRange(ROWS_COUNT).map((_, index2) => {
          return cells.slice(index2 * COLS_COUNT, (index2 + 1) * COLS_COUNT);
        });
        rows2.unshift(weekdays.value.map((text) => ({
          props: __spreadProps(__spreadValues({}, sharedProps), {
            text,
            disabled: true
          })
        })));
        return rows2;
      });
      const controls = vue.computed(() => {
        const sharedProps = {
          variant: "text",
          shape: "circle",
          size: "small"
        };
        const hasPrev = min.value ? internalModel.value.valueOf() > min.value.valueOf() : true;
        const hasNext = max.value ? internalModel.value.valueOf() < max.value.valueOf() : true;
        return {
          prevDouble: __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.prevDoubleIcon,
            onClick: prevYear,
            disabled: !hasPrev
          }),
          prev: __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.prevIcon,
            onClick: prevMonth,
            disabled: !hasPrev
          }),
          date: __spreadProps(__spreadValues({}, sharedProps), {
            shape: "rounded-sm",
            style: {
              fontSize: "14px"
            },
            text: internalModel.value.format("YYYY-MM")
          }),
          next: __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.nextIcon,
            onClick: nextMonth,
            disabled: !hasNext
          }),
          nextDouble: __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.nextDoubleIcon,
            onClick: nextYear,
            disabled: !hasNext
          })
        };
      });
      function prevYear() {
        internalModel.value = internalModel.value.subtract(1, "year");
      }
      function nextYear() {
        internalModel.value = internalModel.value.add(1, "year");
      }
      function prevMonth() {
        internalModel.value = internalModel.value.subtract(1, "month");
      }
      function nextMonth() {
        internalModel.value = internalModel.value.add(1, "month");
      }
      function onMousemove(text) {
        if (!range)
          return;
        if (range.selected.value.length === 1) {
          !range.isPreview.value && range.preview(true);
        }
        if (range.isPreview.value) {
          range.select(text);
        }
      }
      return () => {
        return vue.createVNode(Card, {
          "class": "ve-date-picker-panel",
          "divided": true,
          "onMousedown": (e) => e.preventDefault()
        }, __spreadProps(__spreadValues({}, slots), {
          header: () => vue.createVNode(vue.Fragment, null, [vue.createVNode(Button, controls.value.prevDouble, null), vue.createVNode(Button, controls.value.prev, null), vue.createVNode("div", {
            "class": "ve-date-picker-panel__date"
          }, [vue.createVNode(Button, controls.value.date, null)]), vue.createVNode(Button, controls.value.next, null), vue.createVNode(Button, controls.value.nextDouble, null)]),
          text: () => vue.createVNode(vue.Fragment, null, [rows.value.map((cols) => vue.createVNode("div", {
            "class": "ve-date-picker-panel__row"
          }, [cols.map((col2) => vue.createVNode("div", {
            "key": col2.value,
            "class": ["ve-date-picker-panel__cell", {
              "ve-date-picker-panel__cell--active": col2.isActive,
              "ve-date-picker-panel__cell--other-month": col2.isOtherMonth,
              "ve-date-picker-panel__cell--range-in": col2.value && (range == null ? void 0 : range.inRange(col2.value)),
              "ve-date-picker-panel__cell--range-start": col2.selectedIndex === 0,
              "ve-date-picker-panel__cell--range-end": col2.selectedIndex === 1
            }],
            "onMousemove": () => onMousemove(col2.text)
          }, [vue.createVNode(Button, col2.props, null)]))]))])
        }));
      };
    }
  });
  const DatePicker = genericComponent()({
    name: "VeDatePicker",
    props: {
      appendInnerIcon: {
        type: String,
        default: "$calendar"
      },
      format: [Array, String, Function],
      id: String,
      modelValue: {
        type: [String, Array],
        default: () => []
      },
      openOnClear: Boolean,
      panelProps: Object,
      readonly: Boolean,
      range: Boolean
    },
    emits: {
      "update:modelValue": (_modelValue) => true,
      "change": (_modelValue) => true
    },
    setup(props, {
      slots,
      emit
    }) {
      const activator = vue.ref();
      const inputRef = vue.ref();
      const isActiveMenu = vue.ref(false);
      const id = vue.computed(() => props.id || `ve-date-picker-${getUid()}`);
      const model = useProxiedModel(props, "modelValue", [], (v) => wrapInArray(v), (v) => props.range ? v : v[0]);
      const panelProps = vue.computed(() => {
        const panelProps2 = __spreadValues({}, props.panelProps);
        if (props.format) {
          panelProps2.format = props.format;
        }
        return panelProps2;
      });
      vue.watch(() => inputRef.value, (val) => {
        activator.value = val.$el.querySelector(".ve-input-control");
      });
      function onClear(_e) {
        model.value = [];
        if (props.openOnClear) {
          isActiveMenu.value = true;
        }
      }
      function onKeydown({
        key
      }) {
        if ([keyValues.enter, keyValues.space].includes(key) && !isActiveMenu.value) {
          isActiveMenu.value = true;
        }
        if (key === keyValues.esc && isActiveMenu.value) {
          isActiveMenu.value = false;
        }
      }
      function blur() {
        var _a;
        (_a = inputRef.value) == null ? void 0 : _a.blur();
      }
      function onChange() {
        emit("change", props.range ? model.value : model.value[0]);
      }
      return () => {
        return vue.createVNode(Input, {
          "appendInnerIcon": props.appendInnerIcon,
          "class": ["ve-date-picker", {
            "ve-date-picker--active-menu": isActiveMenu.value
          }],
          "id": id.value,
          "modelValue": model.value.join(" ~ ") || void 0,
          "onClick:clear": onClear,
          "onClick:control": () => {
            if (props.readonly)
              return;
            if (isActiveMenu.value) {
              blur();
            } else {
              isActiveMenu.value = true;
            }
          },
          "onBlur": () => isActiveMenu.value = false,
          "onKeydown": onKeydown,
          "onMousedown": (e) => e.preventDefault(),
          "ref": inputRef,
          "readonly": true
        }, __spreadProps(__spreadValues({}, slots), {
          default: () => vue.createVNode(vue.Fragment, null, [activator.value && vue.createVNode(Menu, {
            "contentClass": "ve-date-picker-menu-wrapper",
            "id": `${id.value}-menu`,
            "modelValue": isActiveMenu.value,
            "onUpdate:modelValue": ($event) => isActiveMenu.value = $event,
            "activator": activator.value,
            "openOnClick": false
          }, {
            default: () => [!props.range && vue.createVNode(DatePickerPanel, vue.mergeProps(panelProps.value, {
              "modelValue": model.value[0],
              "onUpdate:modelValue": (val) => {
                model.value = [val];
                blur();
                onChange();
              }
            }), null), props.range && vue.createVNode(DateRangePickerPanel, vue.mergeProps(panelProps.value, {
              "modelValue": model.value,
              "onUpdate:modelValue": ($event) => model.value = $event,
              "onPreview": (v) => {
                if (!v) {
                  blur();
                  onChange();
                }
              }
            }), null)]
          })])
        }));
      };
    }
  });
  const DefaultsProvider = vue.defineComponent({
    name: "VeDefaultsProvider",
    props: {
      defaults: Object,
      reset: [Number, String],
      root: Boolean,
      scoped: Boolean
    },
    setup(props, {
      slots
    }) {
      const {
        defaults,
        reset,
        root,
        scoped
      } = vue.toRefs(props);
      provideDefaults(defaults, {
        reset,
        root,
        scoped
      });
      return () => {
        var _a;
        return (_a = slots.default) == null ? void 0 : _a.call(slots);
      };
    }
  });
  var device = "";
  const deviceModels = {
    iphonex: {
      width: 375,
      height: 812,
      statusBarHeight: 24
    },
    iphone6plus: {
      width: 414,
      height: 736,
      statusBarHeight: 24
    },
    iphone7plus: {
      width: 414,
      height: 736,
      statusBarHeight: 24
    },
    iphone8plus: {
      width: 414,
      height: 736,
      statusBarHeight: 24
    },
    iphone6: {
      width: 375,
      height: 667,
      statusBarHeight: 24
    },
    iphone7: {
      width: 375,
      height: 667,
      statusBarHeight: 24
    },
    iphone8: {
      width: 375,
      height: 667,
      statusBarHeight: 24
    }
  };
  const makeDeviceProps = propsFactory({
    model: String,
    autoHeight: Boolean
  }, "device");
  function useDevice(props) {
    const deviceModel = vue.computed(() => {
      return props.model && props.model in deviceModels ? deviceModels[props.model] : {
        width: "100%",
        height: "100%",
        statusBarHeight: 0
      };
    });
    const deviceStyles = vue.computed(() => {
      return {
        width: convertToUnit(deviceModel.value.width),
        height: props.autoHeight ? null : convertToUnit(deviceModel.value.height),
        minHeight: props.autoHeight ? convertToUnit(deviceModel.value.height) : null
      };
    });
    return {
      deviceModel,
      deviceStyles
    };
  }
  var deviceStatusBar = "";
  const DeviceStatusBar = genericComponent()({
    name: "VeDeviceStatusBar",
    props: __spreadValues(__spreadValues({
      height: {
        type: Number,
        default: 20
      },
      battery: {
        type: Number,
        default: 100
      },
      operator: {
        type: String,
        default: "Z+"
      }
    }, makeTagProps()), makeColorProps()),
    setup(props) {
      function getClockValue() {
        const now = new Date();
        const hour = now.getHours();
        const minute = now.getMinutes();
        let text = hour >= 12 ? "\u4E0B\u5348" : "\u4E0A\u5348";
        text += `${Math.abs(hour - 12)}:`;
        text += minute > 10 ? minute : `0${minute}`;
        return text;
      }
      const clock = vue.ref(getClockValue());
      const clockTimer = setInterval(() => {
        clock.value = getClockValue();
      }, 1e3);
      vue.onBeforeUnmount(() => {
        clearInterval(clockTimer);
      });
      const {
        colorClasses,
        colorStyles
      } = useColor(vue.computed(() => {
        const {
          textColor,
          color
        } = vue.unref(props);
        return {
          background: color,
          text: textColor
        };
      }));
      return () => {
        return vue.createVNode(props.tag, {
          "class": ["ve-device-status-bar", colorClasses.value],
          "style": [{
            height: convertToUnit(props.height)
          }, colorStyles.value]
        }, {
          default: () => [vue.createVNode("div", {
            "class": "ve-device-status-bar__clock"
          }, [clock.value]), vue.createVNode("div", {
            "class": "ve-device-status-bar__mobile-signal"
          }, [[...Array(4)].map((_) => vue.createVNode("div", null, null))]), vue.createVNode("div", {
            "class": "ve-device-status-bar__mobile-operator"
          }, [props.operator]), vue.createVNode("div", {
            "class": "ve-device-status-bar__wifi-signal"
          }, [[...Array(3)].map((_) => vue.createVNode("div", null, null))]), vue.createVNode("div", {
            "class": "ve-device-status-bar__spacer"
          }, null), vue.createVNode("div", {
            "class": "ve-device-status-bar__battery-percentage"
          }, [props.battery, vue.createTextVNode("%")]), vue.createVNode("div", {
            "class": "ve-device-status-bar__battery"
          }, [vue.createVNode("div", {
            "style": {
              width: `${props.battery}%`
            }
          }, null)])]
        });
      };
    }
  });
  const Device = defineComponent({
    name: "VeDevice",
    props: __spreadValues(__spreadValues(__spreadValues({
      battery: {
        type: Number,
        default: 100
      },
      operator: {
        type: String,
        default: "Z+"
      },
      headerColor: String
    }, makeDeviceProps()), makeTagProps()), makeVariantProps()),
    setup(props, {
      slots
    }) {
      const {
        colorClasses,
        colorStyles,
        variantClasses
      } = useVariant(props);
      const {
        deviceModel,
        deviceStyles
      } = useDevice(props);
      return () => {
        return vue.createVNode(props.tag, {
          "class": ["ve-device", variantClasses.value, colorClasses.value],
          "style": [deviceStyles.value, colorStyles.value]
        }, {
          default: () => {
            var _a, _b;
            return [vue.createVNode("div", {
              "class": "ve-device__app-header",
              "style": {
                backgroundColor: props.headerColor
              }
            }, [deviceModel.value.statusBarHeight > 0 && vue.createVNode(DeviceStatusBar, {
              "height": deviceModel.value.statusBarHeight,
              "battery": props.battery,
              "operator": props.operator
            }, null), slots.header && vue.createVNode("div", {
              "class": "ve-device__app-bar"
            }, [(_a = slots.header) == null ? void 0 : _a.call(slots)])]), vue.createVNode("div", {
              "class": "ve-device__app-main"
            }, [(_b = slots.default) == null ? void 0 : _b.call(slots)]), props.autoHeight && typeof deviceModel.value.height === "number" && vue.createVNode("div", {
              "class": "ve-device__height-tip",
              "style": {
                top: convertToUnit(deviceModel.value.height - 21)
              }
            }, [props.model, vue.createTextVNode("\u9AD8\u5EA6")])];
          }
        });
      };
    }
  });
  var dialog = "";
  const Dialog = genericComponent()({
    name: "VeDialog",
    props: __spreadValues({
      fullscreen: Boolean,
      id: String,
      modelValue: Boolean,
      scrollable: Boolean,
      draggable: Boolean
    }, makeTransitionProps({
      transition: {
        component: DialogTransition
      }
    })),
    emits: {
      "update:modelValue": (_) => true
    },
    setup(props, {
      slots
    }) {
      const isActive = useProxiedModel(props, "modelValue");
      const id = vue.computed(() => props.id || `ve-dialog-${getUid()}`);
      return () => vue.createVNode(Overlay, {
        "aria-role": "dialog",
        "aria-modal": "true",
        "activator-props": {
          "aria-haspopup": "dialog",
          "aria-expanded": String(isActive.value),
          "aria-describedby": id.value
        },
        "class": ["ve-dialog", {
          "ve-dialog--fullscreen": props.fullscreen,
          "ve-dialog--scrollable": props.scrollable
        }],
        "contentClass": "ve-dialog__wrapper",
        "id": id.value,
        "transition": props.transition,
        "modelValue": isActive.value,
        "onUpdate:modelValue": ($event) => isActive.value = $event
      }, __spreadProps(__spreadValues({}, slots), {
        default: slots.default
      }));
    }
  });
  var drawer = "";
  const DisplayKey = Symbol.for("veno-ui:display");
  const defaultDisplayOptions = {
    mobileBreakpoint: "lg",
    thresholds: {
      xs: 0,
      sm: 600,
      md: 960,
      lg: 1280,
      xl: 1920,
      xxl: 2560
    }
  };
  const parseDisplayOptions = (options = defaultDisplayOptions) => {
    return deepMerge(defaultDisplayOptions, options);
  };
  function getClientWidth() {
    return IN_BROWSER ? Math.max(document.documentElement.clientWidth, window.innerWidth) : 0;
  }
  function getClientHeight() {
    return IN_BROWSER ? Math.max(document.documentElement.clientHeight, window.innerHeight) : 0;
  }
  function getPlatform() {
    const userAgent = IN_BROWSER ? window.navigator.userAgent : "ssr";
    function match(regexp) {
      return Boolean(userAgent.match(regexp));
    }
    const android = match(/android/i);
    const ios = match(/iphone|ipad|ipod/i);
    const cordova = match(/cordova/i);
    const electron = match(/electron/i);
    const chrome = match(/chrome/i);
    const edge = match(/edge/i);
    const firefox = match(/firefox/i);
    const opera = match(/opera/i);
    const win = match(/win/i);
    const mac = match(/mac/i);
    const linux = match(/linux/i);
    const ssr = match(/ssr/i);
    return {
      android,
      ios,
      cordova,
      electron,
      chrome,
      edge,
      firefox,
      opera,
      win,
      mac,
      linux,
      touch: SUPPORTS_TOUCH,
      ssr
    };
  }
  function createDisplay(options) {
    const { thresholds, mobileBreakpoint } = parseDisplayOptions(options);
    const height = vue.ref(getClientHeight());
    const platform = getPlatform();
    const state = vue.reactive({});
    const width = vue.ref(getClientWidth());
    function onResize() {
      height.value = getClientHeight();
      width.value = getClientWidth();
    }
    vue.watchEffect(() => {
      const xs = width.value < thresholds.sm;
      const sm = width.value < thresholds.md && !xs;
      const md = width.value < thresholds.lg && !(sm || xs);
      const lg = width.value < thresholds.xl && !(md || sm || xs);
      const xl = width.value < thresholds.xxl && !(lg || md || sm || xs);
      const xxl = width.value >= thresholds.xxl;
      const name = xs ? "xs" : sm ? "sm" : md ? "md" : lg ? "lg" : xl ? "xl" : "xxl";
      const breakpointValue = typeof mobileBreakpoint === "number" ? mobileBreakpoint : thresholds[mobileBreakpoint];
      const mobile = !platform.ssr ? width.value < breakpointValue : platform.android || platform.ios || platform.opera;
      state.xs = xs;
      state.sm = sm;
      state.md = md;
      state.lg = lg;
      state.xl = xl;
      state.xxl = xxl;
      state.smAndUp = !xs;
      state.mdAndUp = !(xs || sm);
      state.lgAndUp = !(xs || sm || md);
      state.xlAndUp = !(xs || sm || md || lg);
      state.smAndDown = !(md || lg || xl || xxl);
      state.mdAndDown = !(lg || xl || xxl);
      state.lgAndDown = !(xl || xxl);
      state.xlAndDown = !xxl;
      state.name = name;
      state.height = height.value;
      state.width = width.value;
      state.mobile = mobile;
      state.mobileBreakpoint = mobileBreakpoint;
      state.platform = platform;
      state.thresholds = thresholds;
    });
    if (IN_BROWSER) {
      window.addEventListener("resize", onResize, { passive: true });
    }
    return vue.toRefs(state);
  }
  function useDisplay() {
    const display = vue.inject(DisplayKey);
    if (!display)
      throw new Error("[VenoUi] Could not find display injection");
    return display;
  }
  const HORIZON = 100;
  const HISTORY = 20;
  function kineticEnergyToVelocity(work) {
    const sqrt2 = 1.41421356237;
    return (work < 0 ? -1 : 1) * Math.sqrt(Math.abs(work)) * sqrt2;
  }
  function calculateImpulseVelocity(samples) {
    if (samples.length < 2) {
      return 0;
    }
    if (samples.length === 2) {
      if (samples[1].t === samples[0].t) {
        return 0;
      }
      return (samples[1].d - samples[0].d) / (samples[1].t - samples[0].t);
    }
    let work = 0;
    for (let i = samples.length - 1; i > 0; i--) {
      if (samples[i].t === samples[i - 1].t) {
        continue;
      }
      const vprev = kineticEnergyToVelocity(work);
      const vcurr = (samples[i].d - samples[i - 1].d) / (samples[i].t - samples[i - 1].t);
      work += (vcurr - vprev) * Math.abs(vcurr);
      if (i === samples.length - 1) {
        work *= 0.5;
      }
    }
    return kineticEnergyToVelocity(work) * 1e3;
  }
  function useVelocity() {
    const touches = {};
    function addMovement(e) {
      Array.from(e.changedTouches).forEach((touch) => {
        var _a;
        const samples = (_a = touches[touch.identifier]) != null ? _a : touches[touch.identifier] = new CircularBuffer(HISTORY);
        samples.push([e.timeStamp, touch]);
      });
    }
    function endTouch(e) {
      Array.from(e.changedTouches).forEach((touch) => {
        delete touches[touch.identifier];
      });
    }
    function getVelocity(id) {
      var _a;
      const samples = (_a = touches[id]) == null ? void 0 : _a.values().reverse();
      if (!samples) {
        throw new Error(`No samples for touch id ${id}`);
      }
      const newest = samples[0];
      const x = [];
      const y = [];
      for (const val of samples) {
        if (newest[0] - val[0] > HORIZON)
          break;
        x.push({ t: val[0], d: val[1].clientX });
        y.push({ t: val[0], d: val[1].clientY });
      }
      return {
        x: calculateImpulseVelocity(x),
        y: calculateImpulseVelocity(y),
        get direction() {
          const { x: x2, y: y2 } = this;
          const [absX, absY] = [Math.abs(x2), Math.abs(y2)];
          return absX > absY && x2 >= 0 ? "right" : absX > absY && x2 <= 0 ? "left" : absY > absX && y2 >= 0 ? "down" : absY > absX && y2 <= 0 ? "up" : oops$1();
        }
      };
    }
    return { addMovement, endTouch, getVelocity };
  }
  function oops$1() {
    throw new Error();
  }
  function useTouch({ isActive, isTemporary, width, touchless, position }) {
    const onTouchmove = throttle((e) => handleTouchmove(e), 69);
    vue.onMounted(() => {
      window.addEventListener("touchstart", onTouchstart, { passive: true });
      window.addEventListener("touchmove", onTouchmove, { passive: false });
      window.addEventListener("touchend", onTouchend, { passive: true });
    });
    vue.onBeforeUnmount(() => {
      window.removeEventListener("touchstart", onTouchstart);
      window.removeEventListener("touchmove", onTouchmove);
      window.removeEventListener("touchend", onTouchend);
    });
    const isHorizontal = vue.computed(() => position.value !== "bottom");
    const { addMovement, endTouch, getVelocity } = useVelocity();
    let maybeDragging = false;
    const isDragging = vue.ref(false);
    const dragProgress = vue.ref(0);
    const offset = vue.ref(0);
    let start;
    function getOffset2(pos, active) {
      return (position.value === "left" ? pos : position.value === "right" ? document.documentElement.clientWidth - pos : position.value === "bottom" ? document.documentElement.clientHeight - pos : oops()) - (active ? width.value : 0);
    }
    function getProgress(pos, limit = true) {
      const progress2 = position.value === "left" ? (pos - offset.value) / width.value : position.value === "right" ? (document.documentElement.clientWidth - pos - offset.value) / width.value : position.value === "bottom" ? (document.documentElement.clientHeight - pos - offset.value) / width.value : oops();
      return limit ? Math.max(0, Math.min(1, progress2)) : progress2;
    }
    function onTouchstart(e) {
      if (touchless.value || !isActive.value)
        return;
      const touchX = e.changedTouches[0].clientX;
      const touchY = e.changedTouches[0].clientY;
      const touchZone = 25;
      const inTouchZone = position.value === "left" ? touchX < touchZone : position.value === "right" ? touchX > document.documentElement.clientWidth - touchZone : position.value === "bottom" ? touchY > document.documentElement.clientHeight - touchZone : position.value === "top" ? touchY < touchZone : oops();
      const inElement = isActive.value && (position.value === "left" ? touchX < width.value : position.value === "right" ? touchX > document.documentElement.clientWidth - width.value : position.value === "bottom" ? touchY > document.documentElement.clientHeight - width.value : position.value === "top" ? touchY < width.value : oops());
      if (inTouchZone || inElement || isActive.value && isTemporary.value) {
        maybeDragging = true;
        start = [touchX, touchY];
        offset.value = getOffset2(isHorizontal.value ? touchX : touchY, isActive.value);
        dragProgress.value = getProgress(isHorizontal.value ? touchX : touchY);
        endTouch(e);
        addMovement(e);
      }
    }
    function handleTouchmove(e) {
      const touchX = e.changedTouches[0].clientX;
      const touchY = e.changedTouches[0].clientY;
      if (maybeDragging) {
        if (!e.cancelable) {
          maybeDragging = false;
          return;
        }
        const dx = Math.abs(touchX - start[0]);
        const dy = Math.abs(touchY - start[1]);
        const thresholdMet = isHorizontal.value ? dx > dy && dx > 3 : dy > dx && dy > 3;
        if (thresholdMet) {
          isDragging.value = true;
          maybeDragging = false;
        } else if ((isHorizontal.value ? dy : dx) > 3) {
          maybeDragging = false;
        }
      }
      if (!isDragging.value)
        return;
      e.preventDefault();
      addMovement(e);
      const progress2 = getProgress(isHorizontal.value ? touchX : touchY, false);
      dragProgress.value = Math.max(0, Math.min(1, progress2));
      if (progress2 > 1) {
        offset.value = getOffset2(isHorizontal.value ? touchX : touchY, true);
      } else if (progress2 < 0) {
        offset.value = getOffset2(isHorizontal.value ? touchX : touchY, false);
      }
    }
    function onTouchend(e) {
      maybeDragging = false;
      if (!isDragging.value)
        return;
      addMovement(e);
      isDragging.value = false;
      const velocity = getVelocity(e.changedTouches[0].identifier);
      const vx = Math.abs(velocity.x);
      const vy = Math.abs(velocity.y);
      const thresholdMet = isHorizontal.value ? vx > vy && vx > 400 : vy > vx && vy > 3;
      if (thresholdMet) {
        isActive.value = velocity.direction === ({
          left: "right",
          right: "left",
          bottom: "up",
          top: "down"
        }[position.value] || oops());
      } else {
        isActive.value = dragProgress.value > 0.5;
      }
    }
    const dragStyles = vue.computed(() => {
      return isDragging.value ? {
        transform: position.value === "left" ? `translateX(calc(-100% + ${dragProgress.value * width.value}px))` : position.value === "right" ? `translateX(calc(100% - ${dragProgress.value * width.value}px))` : position.value === "bottom" ? `translateY(calc(100% - ${dragProgress.value * width.value}px))` : position.value === "top" ? `translateY(calc(-100% + ${dragProgress.value * width.value}px))` : oops(),
        transition: "none"
      } : void 0;
    });
    return {
      isDragging,
      dragProgress,
      dragStyles
    };
  }
  function oops() {
    throw new Error();
  }
  const Drawer = defineComponent({
    name: "VeDrawer",
    props: __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
      disableResizeWatcher: Boolean,
      disableRouteWatcher: Boolean,
      color: String,
      expandOnHover: Boolean,
      permanent: Boolean,
      rail: Boolean,
      railWidth: {
        type: [Number, String],
        default: 52
      },
      showToggler: Boolean,
      temporary: Boolean,
      touchless: Boolean,
      width: {
        type: [Number, String],
        default: 256
      }
    }, makeTagProps({
      tag: "nav"
    })), makeScrollbar()), makeThemeProps()), makeBorderProps()), makeLayoutItemProps({
      position: "fixed",
      anchor: "left",
      modelValue: null
    })),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      attrs,
      slots
    }) {
      const {
        themeClasses
      } = provideTheme(props);
      const {
        borderClasses
      } = useBorder(props);
      const {
        scrollbarClasses
      } = useScrollbar(props);
      const {
        backgroundColorClasses,
        backgroundColorStyles
      } = useBackgroundColor(vue.toRef(props, "color"));
      const {
        mobile,
        platform
      } = useDisplay();
      const router = useRouter();
      const isActive = useProxiedModel(props, "modelValue", null, (v) => !!v);
      const isHovering = vue.ref(false);
      const width = vue.computed(() => {
        return props.rail && props.expandOnHover && isHovering.value ? Number(props.width) : Number(props.rail ? props.railWidth : props.width);
      });
      const isTemporary = vue.computed(() => !props.permanent && !!(mobile.value || props.temporary));
      const hasToggler = vue.computed(() => props.showToggler && !mobile.value);
      vue.watch(isTemporary, (val) => {
        if (!props.disableResizeWatcher && !props.permanent)
          isActive.value = !val;
      });
      if (router) {
        vue.watch(router.currentRoute, () => {
          if (!props.disableRouteWatcher && isTemporary.value)
            isActive.value = false;
        });
      }
      vue.watch(() => props.permanent, (val) => {
        if (val)
          isActive.value = true;
      });
      vue.onBeforeMount(() => {
        if (props.modelValue !== null || isTemporary.value)
          return;
        isActive.value = props.permanent || !mobile.value;
      });
      const {
        isDragging,
        dragProgress,
        dragStyles
      } = useTouch({
        isActive,
        isTemporary,
        width,
        touchless: vue.toRef(props, "touchless"),
        position: vue.toRef(props, "anchor")
      });
      const layoutSize = vue.computed(() => {
        const size = isTemporary.value ? 0 : props.rail && props.expandOnHover ? Number(props.railWidth) : width.value;
        return isDragging.value ? size * dragProgress.value : size;
      });
      const priority = vue.computed(() => isTemporary.value ? parseInt(props.priority, 10) + 1 : props.priority);
      const {
        layoutItemStyles: _layoutItemStyles,
        layoutItemScrimStyles
      } = useLayoutItem(vue.computed(() => ({
        name: props.name,
        position: props.position,
        anchor: props.anchor,
        size: width.value,
        layoutSize: layoutSize.value,
        priority: priority.value,
        active: isActive.value || isDragging.value,
        disableTransition: isDragging.value
      })));
      const layoutItemStyles = vue.computed(() => {
        const styles = _layoutItemStyles.value;
        if (!platform.value.ssr && hasToggler.value && styles.transform) {
          styles.transform = styles.transform.replace("110", "90");
        }
        return styles;
      });
      return () => {
        var _a;
        const slotProps = {
          onClick: () => {
            isActive.value = true;
          }
        };
        return vue.createVNode(vue.Fragment, null, [(_a = slots.activator) == null ? void 0 : _a.call(slots, {
          props: slotProps
        }), vue.createVNode(props.tag, vue.mergeProps({
          "onMouseenter": () => isHovering.value = true,
          "onMouseleave": () => isHovering.value = false,
          "class": ["ve-drawer", {
            "ve-drawer--active": isActive.value,
            "ve-drawer--top": props.anchor === "top",
            "ve-drawer--bottom": props.anchor === "bottom",
            "ve-drawer--start": props.anchor === "left",
            "ve-drawer--end": props.anchor === "right",
            "ve-drawer--expand-on-hover": props.expandOnHover,
            "ve-drawer--rail": props.rail,
            "ve-drawer--is-hovering": isHovering.value,
            "ve-drawer--temporary": isTemporary.value,
            "ve-drawer--has-toggler": hasToggler.value
          }, themeClasses.value, backgroundColorClasses.value, borderClasses.value],
          "style": [layoutItemStyles.value, backgroundColorStyles.value, dragStyles.value]
        }, attrs), {
          default: () => {
            var _a2;
            return [vue.createVNode("div", {
              "class": ["ve-drawer__wrapper", scrollbarClasses.value]
            }, [(_a2 = slots.default) == null ? void 0 : _a2.call(slots)]), hasToggler.value && vue.createVNode(Button, {
              "position": "absolute",
              "class": "ve-drawer__toggler",
              "icon": "$toggler",
              "top": props.anchor === "left" || props.anchor === "right" ? 204 : void 0,
              "left": props.anchor === "bottom" || props.anchor === "top" ? 204 : props.anchor === "right" ? 0 : void 0,
              "right": props.anchor === "left" ? 0 : void 0,
              "bottom": props.anchor === "top" ? 0 : void 0,
              "size": "small",
              "density": "ultra-high",
              "border": true,
              "shape": "circle",
              "onClick": () => {
                isActive.value = !isActive.value;
              }
            }, null)];
          }
        }), vue.createVNode(Scrim, {
          "modelValue": isTemporary.value && !!(isDragging.value || isActive.value),
          "style": [layoutItemScrimStyles.value, isDragging.value ? {
            opacity: dragProgress.value * 0.2,
            transition: "none"
          } : void 0],
          "onClick": () => isActive.value = false
        }, null)]);
      };
    }
  });
  const usePointer = (props = {}) => {
    const isPointerDown = vue.ref(false);
    const isPointerMoving = vue.ref(false);
    const pointerCurrentPosition = vue.ref();
    const pointerDownAt = vue.ref();
    const pointerDownEl = vue.ref();
    const pointerDownPosition = vue.ref();
    const pointerMovement = vue.computed(() => {
      if (!pointerCurrentPosition.value || !pointerDownPosition.value)
        return void 0;
      return {
        left: pointerCurrentPosition.value.left - pointerDownPosition.value.left,
        top: pointerCurrentPosition.value.top - pointerDownPosition.value.top
      };
    });
    const minDelay = vue.computed(() => SUPPORTS_TOUCH ? 5 : 0);
    const maxDelay = vue.computed(() => SUPPORTS_TOUCH ? 50 : 0);
    const unregisterListeners = () => {
      if (SUPPORTS_TOUCH) {
        document.removeEventListener("touchmove", pointerMove);
        document.removeEventListener("touchend", pointerUp);
      } else {
        document.removeEventListener("mousemove", pointerMove);
        document.removeEventListener("mouseup", pointerUp);
      }
    };
    const pointerDown = (e) => {
      if (props.pointerDownStopPropagation)
        e.stopPropagation();
      if (props.pointerDownPreventDefault)
        e.preventDefault();
      pointerDownAt.value = Date.now();
      if (e instanceof MouseEvent) {
        pointerDownEl.value = e.target || e.relatedTarget;
      } else {
        pointerDownEl.value = e.target;
      }
      pointerDownPosition.value = pointerCurrentPosition.value = getPointerPosition(e);
      isPointerDown.value = true;
      if (SUPPORTS_TOUCH) {
        document.addEventListener("touchmove", pointerMove, { passive: !props.pointerMovePreventDefault });
        document.addEventListener("touchend", pointerUp, { passive: true });
      } else {
        document.addEventListener("mousemove", pointerMove);
        document.addEventListener("mouseup", pointerUp);
      }
    };
    function pointerMove(e) {
      if (isPointerMoving.value) {
        if (props.pointerMovePreventDefault && e.cancelable)
          e.preventDefault();
        pointerCurrentPosition.value = getPointerPosition(e);
      } else {
        const time = Date.now() - pointerDownAt.value;
        if (time < minDelay.value)
          ;
        else if (time < maxDelay.value) {
          unregisterListeners();
        } else if (distance(pointerDownPosition.value, getPointerPosition(e)) > 0) {
          isPointerMoving.value = true;
        }
      }
    }
    function pointerUp(e) {
      pointerCurrentPosition.value = getPointerPosition(e);
      pointerDownEl.value = void 0;
      isPointerDown.value = false;
      isPointerMoving.value = false;
      unregisterListeners();
    }
    vue.onScopeDispose(() => {
      unregisterListeners();
    });
    const availableEvents = {
      touchstartPassive: pointerDown,
      touchstart: pointerDown,
      mousedown: pointerDown
    };
    return {
      isPointerDown: vue.readonly(isPointerDown),
      isPointerMoving: vue.readonly(isPointerMoving),
      pointerCurrentPosition: vue.readonly(pointerCurrentPosition),
      pointerDown,
      pointerMove,
      pointerUp,
      pointerDownEl,
      pointerDownPosition: vue.readonly(pointerDownPosition),
      pointerMovement: vue.readonly(pointerMovement),
      pointerEvents: vue.computed(() => {
        const events = {};
        if (SUPPORTS_TOUCH) {
          if (!props.pointerDownPreventDefault) {
            events.touchstartPassive = availableEvents.touchstartPassive;
          } else {
            events.touchstart = availableEvents.touchstart;
          }
        } else {
          events.mousedown = availableEvents.mousedown;
        }
        return events;
      })
    };
  };
  function distance(position1, position2) {
    return Math.sqrt((position2.left - position1.left) ** 2 + (position2.top - position1.top) ** 2);
  }
  function getPointerPosition(e) {
    return e instanceof TouchEvent ? e.touches.length > 0 ? { left: e.touches[0].clientX, top: e.touches[0].clientY } : { left: 0, top: 0 } : { left: e.clientX, top: e.clientY };
  }
  const makeDraggableProps = propsFactory({
    draggable: {
      type: Boolean,
      default: true
    },
    containment: [String, Object],
    disabled: Boolean,
    cursor: {
      type: Boolean,
      default: true
    },
    position: String
  }, "draggable");
  function useDraggable(props = {
    draggable: true,
    disabled: false,
    cursor: true
  }, data) {
    const previous = vue.ref();
    const previousBox = vue.ref();
    const containmentBox = vue.ref();
    const draggableEl = vue.ref();
    const draggableRef = vue.ref();
    const {
      isPointerMoving: isDragging,
      pointerDownEl,
      pointerMovement: draggableMovement,
      pointerEvents
    } = usePointer({
      pointerMovePreventDefault: true
    });
    const vm = getCurrentInstance("useDraggable");
    const updateContainmentBox = () => {
      var _a;
      containmentBox.value = props.containment ? (_a = querySelector(props.containment, vm)) == null ? void 0 : _a.getBoundingClientRect() : void 0;
    };
    vue.watch(isDragging, (val) => {
      var _a;
      if (!val || !props.draggable || props.disabled)
        return;
      previous.value = {
        left: (data == null ? void 0 : data.value.left) || 0,
        top: (data == null ? void 0 : data.value.top) || 0
      };
      previousBox.value = (_a = draggableEl.value) == null ? void 0 : _a.getBoundingClientRect();
      updateContainmentBox();
    }, {
      immediate: true
    });
    vue.watch(draggableMovement, (val) => {
      if (!props.draggable || !isDragging.value || !val || !data || !previous.value || props.disabled)
        return;
      const movement = {
        top: val.top,
        left: val.left
      };
      if (containmentBox.value && previousBox.value) {
        const minLeft = containmentBox.value.left - previousBox.value.left;
        const maxLeft = minLeft + containmentBox.value.width - previousBox.value.width;
        const minTop = containmentBox.value.top - previousBox.value.top;
        const maxTop = minTop + containmentBox.value.height - previousBox.value.height;
        movement.left = Math.min(Math.max(movement.left, minLeft), maxLeft);
        movement.top = Math.min(Math.max(movement.top, minTop), maxTop);
      }
      data.value = {
        top: previous.value.top + movement.top,
        left: previous.value.left + movement.left
      };
    });
    vue.watch(pointerDownEl, (el) => {
      if (el && !draggableEl.value)
        draggableEl.value = el;
    });
    vue.watch(draggableRef, (val) => {
      if (val)
        draggableEl.value = isComponentInstance(val) ? val.$el : val;
    });
    const availableEvents = {
      dragstart: (e) => e.preventDefault(),
      contextmenu: (e) => e.preventDefault()
    };
    const draggableEvents = vue.computed(() => {
      const events = {};
      if (props.draggable) {
        events.dragstart = availableEvents.dragstart;
        if (SUPPORTS_TOUCH) {
          events.contextmenu = availableEvents.contextmenu;
        }
        Object.assign(events, pointerEvents.value);
      }
      return events;
    });
    const draggableStyles = vue.computed(() => {
      if (props.draggable && !props.disabled && props.cursor) {
        return {
          cursor: "move"
        };
      }
      return null;
    });
    const contentStyles = vue.computed(() => {
      if (props.draggable && data) {
        const sharedProps = {
          userSelect: isDragging.value ? "none" : void 0
        };
        if (props.position) {
          return __spreadProps(__spreadValues({}, sharedProps), {
            position: props.position,
            top: convertToUnit(data.value.top),
            left: convertToUnit(data.value.left)
          });
        }
        return __spreadProps(__spreadValues({}, sharedProps), {
          transform: `translate3d(${convertToUnit(data.value.left)}, ${convertToUnit(data.value.top)}, 0)`
        });
      }
      return null;
    });
    return {
      isDragging,
      draggableEl,
      draggableRef,
      draggableEvents,
      draggableMovement,
      draggableStyles,
      contentStyles
    };
  }
  const Draggable = defineComponent({
    name: "VeDraggable",
    inheritAttrs: false,
    props: __spreadValues({
      modelValue: {
        type: Object,
        default: () => ({
          left: 0,
          top: 0
        })
      }
    }, makeDraggableProps()),
    emits: {
      "update:modelValue": (_value) => true
    },
    setup(props, {
      slots
    }) {
      const model = useProxiedModel(props, "modelValue", props.modelValue, (v) => ({
        left: parseFloat((v == null ? void 0 : v.left) || 0),
        top: parseFloat((v == null ? void 0 : v.top) || 0)
      }));
      const {
        draggableEvents,
        draggableStyles,
        contentStyles
      } = useDraggable(props, model);
      return () => {
        var _a;
        const draggable = vue.mergeProps(vue.toHandlers(draggableEvents.value), {
          style: draggableStyles.value
        });
        return (_a = slots.default) == null ? void 0 : _a.call(slots, {
          value: model.value,
          draggable,
          contentStyle: contentStyles.value,
          props: vue.mergeProps(draggable, {
            style: contentStyles.value
          })
        });
      };
    }
  });
  var draggableResizable = "";
  const SUPPORTED_DIRECTIONS = ["top", "top-left", "left", "bottom", "bottom-left", "top-right", "right", "bottom-right"];
  const makeDraggableResizableProps = propsFactory({
    resizable: {
      type: Boolean,
      default: true
    },
    resizableAnchors: {
      type: Array,
      default: SUPPORTED_DIRECTIONS
    },
    showResizableAnchor: Boolean
  }, "draggable-resizable");
  function useDraggableResizable(props, name = getCurrentInstanceName()) {
    const active = vue.ref();
    const isResizing = vue.ref(false);
    const previous = vue.ref({
      left: 0,
      top: 0,
      width: 0,
      height: 0
    });
    const current = vue.ref({
      left: 0,
      top: 0,
      width: 0,
      height: 0
    });
    const resizement = vue.computed(() => ({
      left: current.value.left - previous.value.left,
      top: current.value.top - previous.value.top,
      width: current.value.width - previous.value.width,
      height: current.value.height - previous.value.height
    }));
    const {
      isPointerDown,
      pointerDownEl,
      pointerEvents,
      pointerMovement
    } = usePointer({
      pointerDownPreventDefault: SUPPORTS_TOUCH,
      pointerDownStopPropagation: true,
      pointerMovePreventDefault: true
    });
    const getElAnchor = (el) => {
      return el.dataset.resizableAnchor;
    };
    vue.watch(isPointerDown, (val) => {
      if (val) {
        active.value = getElAnchor(pointerDownEl.value);
      } else {
        active.value = void 0;
        isResizing.value = false;
        previous.value = __spreadValues({}, current.value);
      }
    });
    vue.watch(pointerMovement, (val) => {
      if (!active.value || !val)
        return;
      if (!isResizing.value)
        isResizing.value = true;
      const value = __spreadValues({}, current.value);
      if (active.value.includes("left")) {
        value.left = previous.value.left + val.left;
        value.width = previous.value.width - val.left;
      } else if (active.value.includes("right")) {
        value.width = previous.value.width + val.left;
      }
      if (active.value.includes("top")) {
        value.top = previous.value.top + val.top;
        value.height = previous.value.height - val.top;
      } else if (active.value.includes("bottom")) {
        value.height = previous.value.height + val.top;
      }
      current.value = value;
    });
    return {
      isResizing,
      resizement,
      genResizableAnchors: (anchorProps, hide) => {
        return props.resizableAnchors.map((anchor2) => {
          return vue.createVNode("div", vue.mergeProps(vue.toHandlers(pointerEvents.value), anchorProps, {
            "key": anchor2,
            "data-resizable-anchor": anchor2,
            "class": [`${name}__resizable-anchor`, `${name}__resizable-anchor--${anchor2}`, {
              [`${name}__resizable-anchor--control`]: props.showResizableAnchor,
              [`${name}__resizable-anchor--hide`]: (isResizing.value || (hide == null ? void 0 : hide.value)) && anchor2 !== active.value
            }]
          }), null);
        });
      }
    };
  }
  var tooltip = "";
  const Tooltip = genericComponent()({
    name: "VeTooltip",
    props: __spreadValues({
      id: String,
      text: String,
      arrow: {
        type: Boolean,
        default: true
      }
    }, makeOverlayProps({
      anchor: "top",
      maxWidth: 300,
      minWidth: 0,
      offset: 10,
      openOnClick: false,
      openOnHover: true,
      origin: "auto",
      positionStrategy: "connected",
      scrollStrategy: "reposition",
      transition: {
        component: ScaleTransition
      }
    })),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const isActive = useProxiedModel(props, "modelValue");
      const id = vue.computed(() => props.id || `ve-tooltip-${getUid()}`);
      const anchor2 = vue.computed(() => {
        return props.anchor.split(" ").length > 1 ? props.anchor : `${props.anchor} center`;
      });
      const origin = vue.computed(() => {
        return props.origin === "auto" || props.origin === "overlap" || props.origin.split(" ").length > 1 || props.anchor.split(" ").length > 1 ? props.origin : `${props.origin} center`;
      });
      return () => {
        return vue.createVNode(Overlay, vue.mergeProps(props, {
          "absolute": true,
          "activatorProps": {
            "aria-describedby": id.value
          },
          "anchor": anchor2.value,
          "class": "ve-tooltip",
          "contentClass": "ve-tooltip__wrapper",
          "id": id.value,
          "origin": origin.value,
          "persistent": true,
          "role": "tooltip",
          "scrim": false,
          "modelValue": isActive.value,
          "onUpdate:modelValue": ($event) => isActive.value = $event
        }), {
          default: () => {
            var _a, _b;
            return [(_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text, props.arrow && vue.createVNode("div", {
              "class": "ve-tooltip__arrow"
            }, null)];
          },
          activator: slots.activator
        });
      };
    }
  });
  const DraggableResizable = defineComponent({
    name: "VeDraggableResizable",
    props: __spreadValues(__spreadValues(__spreadValues({
      modelValue: {
        type: Object,
        default: () => ({
          left: 0,
          top: 0
        })
      },
      tooltip: {
        type: Boolean,
        default: true
      }
    }, makeDraggableProps()), makeDraggableResizableProps()), makeTagProps()),
    emits: {
      "update:modelValue": (_value) => true
    },
    setup(props, {
      slots
    }) {
      const rootEl = vue.ref();
      const model = useProxiedModel(props, "modelValue", props.modelValue, (v) => __spreadValues({
        left: (v == null ? void 0 : v.left) ? parseFloat(v == null ? void 0 : v.left) : 0,
        top: (v == null ? void 0 : v.top) ? parseFloat(v == null ? void 0 : v.top) : 0
      }, props.resizable ? {
        width: (v == null ? void 0 : v.width) ? parseFloat(v == null ? void 0 : v.width) : void 0,
        height: (v == null ? void 0 : v.height) ? parseFloat(v == null ? void 0 : v.height) : void 0
      } : void 0));
      const previous = vue.ref(__spreadValues({}, model.value));
      const {
        isDragging,
        draggableEvents,
        draggableMovement
      } = useDraggable(props);
      const {
        isResizing,
        resizement,
        genResizableAnchors
      } = useDraggableResizable(props);
      const styles = vue.computed(() => {
        const sharedProps = {
          width: convertToUnit(model.value.width),
          height: convertToUnit(model.value.height)
        };
        if (props.position) {
          return __spreadProps(__spreadValues({}, sharedProps), {
            position: props.position,
            top: convertToUnit(model.value.top),
            left: convertToUnit(model.value.left)
          });
        }
        return __spreadProps(__spreadValues({}, sharedProps), {
          transform: `translate3d(${convertToUnit(model.value.left)}, ${convertToUnit(model.value.top)}, 0)`
        });
      });
      vue.watch(rootEl, async (el) => {
        if (!el || !props.resizable)
          return;
        await vue.nextTick();
        const box = el.getBoundingClientRect();
        if (!model.value.width)
          previous.value.width = box.width;
        if (!model.value.height)
          previous.value.height = box.height;
        if (!model.value.width || !model.value.height) {
          model.value = __spreadProps(__spreadValues({}, model.value), {
            width: previous.value.width,
            height: previous.value.height
          });
        }
      });
      vue.watch([isDragging, isResizing], ([isDragging2, isResizing2]) => {
        if (props.draggable && !isDragging2 || props.resizable && !isResizing2) {
          previous.value = __spreadValues({}, model.value);
        }
      });
      vue.watch(draggableMovement, (val) => {
        if (!props.draggable || !isDragging.value || !val)
          return;
        model.value = __spreadProps(__spreadValues({}, model.value), {
          top: previous.value.top + val.top,
          left: previous.value.left + val.left
        });
      });
      vue.watch(resizement, (val) => {
        var _a, _b, _c, _d;
        if (!props.resizable || !isResizing.value)
          return;
        model.value = __spreadProps(__spreadValues({}, model.value), {
          top: previous.value.top + val.top,
          left: previous.value.left + val.left,
          width: ((_b = (_a = previous.value) == null ? void 0 : _a.width) != null ? _b : 0) + val.width,
          height: ((_d = (_c = previous.value) == null ? void 0 : _c.height) != null ? _d : 0) + val.height
        });
      });
      return () => {
        const draggable = vue.mergeProps(vue.toHandlers(draggableEvents.value), {
          class: "ve-draggable-resizable__draggable"
        });
        const resizable = {
          style: {
            width: convertToUnit(model.value.width),
            height: convertToUnit(model.value.height)
          }
        };
        return vue.createVNode(props.tag, vue.mergeProps({
          "ref": rootEl,
          "class": ["ve-draggable-resizable", {
            "ve-draggable-resizable--dragging": isDragging.value,
            "ve-draggable-resizable--resizing": isResizing.value
          }],
          "style": styles.value
        }, draggable), {
          default: () => {
            var _a, _b, _c;
            return [slots.default && vue.createVNode("div", {
              "class": "ve-draggable-resizable__wrapper"
            }, [(_a = slots.default) == null ? void 0 : _a.call(slots, {
              value: model.value,
              draggable,
              resizable,
              props: vue.mergeProps(draggable, resizable)
            })]), vue.createVNode(Tooltip, {
              "arrow": false,
              "modelValue": props.tooltip && isResizing.value,
              "openOnHover": false,
              "positionStrategy": "pointer",
              "scrollStrategy": "none",
              "text": `${parseInt((_b = model.value.width) != null ? _b : 0)} x ${parseInt((_c = model.value.height) != null ? _c : 0)}`
            }, {
              activator: props.resizable ? ({
                on: anchorProps
              }) => genResizableAnchors(anchorProps, isDragging) : void 0
            })];
          }
        });
      };
    }
  });
  var draggableSortable = "";
  const DraggableSortableGroupKey = Symbol.for("veno-ui:draggable-sortable-group");
  function createDraggableSortableGroup() {
    const items = /* @__PURE__ */ new Map();
    const swapping = vue.ref(false);
    const find = (targetId, targetEl) => {
      for (const [id, item] of items) {
        if (id !== targetId) {
          const res = item.findContains(targetEl);
          if (res) {
            return [item, id, res.key, res.el];
          }
        }
      }
      return [void 0, void 0, void 0, void 0];
    };
    return {
      register: (id, item) => items.set(id, item),
      unregister: (id) => items.delete(id),
      trySwap: async (from, to) => {
        if (swapping.value)
          return;
        const [toItem, toParentId, toParentKey] = find(from.id, to.el);
        if (from.id === toParentId || !(toItem == null ? void 0 : toItem.group.value))
          return;
        const fromItem = items.get(from.id);
        if (!(fromItem == null ? void 0 : fromItem.group.value) || toItem.group.value !== fromItem.group.value)
          return;
        swapping.value = true;
        const value = fromItem.clone(from.key);
        if (fromItem.put.value && toItem.put.value) {
          await fromItem.leave(from.key);
        }
        if (toItem.put.value) {
          await toItem.enter(toParentKey, value, from);
        }
        swapping.value = false;
      }
    };
  }
  function useDraggableSortableGroupItem(id, item) {
    const group = vue.inject(DraggableSortableGroupKey);
    group == null ? void 0 : group.register(id, item);
    vue.onScopeDispose(() => {
      group == null ? void 0 : group.unregister(id);
    });
    return group;
  }
  const makeDraggableSortableProps = propsFactory({
    clone: Function,
    itemKey: {
      type: [String, Function],
      default: () => (v) => v
    },
    modelValue: {
      type: Array,
      default: () => []
    },
    put: {
      type: Boolean,
      default: true
    },
    group: String
  }, "draggable-sortable");
  function useDraggableSortable(props, name = getCurrentInstanceName()) {
    const model = useProxiedModel(props, "modelValue", props.modelValue);
    const modelEls = /* @__PURE__ */ new Map();
    const modelIndexes = vue.computed(() => {
      const indexes = /* @__PURE__ */ new Map();
      model.value.forEach((value, index2) => indexes.set(typeof props.itemKey === "function" ? props.itemKey(value, index2) : value[props.itemKey], index2));
      return indexes;
    });
    const ghostEl = vue.ref();
    const ghostVNode = vue.ref();
    const active = vue.ref();
    const indexToKey = (index2) => {
      for (const [key, i] of modelIndexes.value) {
        if (index2 === i)
          return key;
      }
      return void 0;
    };
    const keyToIndex = (key) => modelIndexes.value.get(key);
    const keyToValue = (key) => model.value[modelIndexes.value.get(key)];
    const {
      isPointerMoving,
      pointerDown,
      pointerUp,
      pointerDownEl,
      pointerCurrentPosition,
      pointerMovement,
      pointerEvents
    } = usePointer({
      pointerMovePreventDefault: true
    });
    const ghostBox = vue.ref();
    const id = `draggable-sortable-group-item-${getUid()}`;
    const item = {
      findContains: (target) => {
        if (target) {
          for (const [key, el] of modelEls) {
            if (el === target || (el == null ? void 0 : el.contains(target))) {
              return {
                key,
                el
              };
            }
          }
        }
        return void 0;
      },
      put: vue.toRef(props, "put"),
      group: vue.toRef(props, "group"),
      clone: (key) => {
        var _a, _b;
        const value = keyToValue(key);
        return (_b = (_a = props.clone) == null ? void 0 : _a.call(props, value)) != null ? _b : value;
      },
      enter: async (key, value, from) => {
        const index2 = keyToIndex(key);
        model.value.splice(index2, 0, value);
        await vue.nextTick();
        const el = modelEls.get(indexToKey(index2));
        const box = el.getBoundingClientRect();
        pointerDown(new MouseEvent("mousedown", {
          clientY: from.position.top - (from.box.top - box.top),
          clientX: from.position.left - (from.box.left - box.left),
          relatedTarget: el
        }));
      },
      leave: async (key) => {
        model.value.splice(keyToIndex(key), 1);
        if (key === active.value) {
          pointerUp(new MouseEvent("mouseup", {
            clientY: pointerCurrentPosition.value.top,
            clientX: pointerCurrentPosition.value.left
          }));
        }
      }
    };
    const group = useDraggableSortableGroupItem(id, item);
    vue.watch(modelIndexes, () => modelEls.clear());
    vue.watch(pointerDownEl, (targetEl) => {
      var _a;
      ghostBox.value = targetEl ? (_a = item.findContains(targetEl)) == null ? void 0 : _a.el.getBoundingClientRect() : void 0;
    });
    vue.watch(isPointerMoving, (val) => {
      var _a;
      active.value = val ? (_a = item.findContains(pointerDownEl.value)) == null ? void 0 : _a.key : void 0;
    });
    vue.watch(pointerCurrentPosition, (val) => {
      var _a;
      if (!val || !active.value)
        return;
      const targetEl = document.elementFromPoint(val.left, val.top) || void 0;
      const key = (_a = item.findContains(targetEl)) == null ? void 0 : _a.key;
      if (key && active.value !== key) {
        if (item.put.value) {
          const oldIndex = keyToIndex(active.value);
          const newIndex = keyToIndex(key);
          model.value.splice(newIndex, 0, model.value.splice(oldIndex, 1)[0]);
        }
      } else if (!key && item.group.value && targetEl && pointerDownEl.value) {
        group == null ? void 0 : group.trySwap({
          id,
          key: active.value,
          box: ghostEl.value.getBoundingClientRect(),
          position: val
        }, {
          el: targetEl
        });
      }
    });
    return {
      active,
      model,
      modelIndexes,
      modelEls,
      keyToIndex,
      indexToKey,
      keyToValue,
      pointerEvents,
      ghostVNode,
      genGhost: () => {
        var _a, _b, _c, _d;
        return vue.createVNode("div", {
          "ref": ghostEl,
          "class": `${name}__ghost`,
          "style": {
            left: convertToUnit((_a = ghostBox.value) == null ? void 0 : _a.left),
            top: convertToUnit((_b = ghostBox.value) == null ? void 0 : _b.top),
            width: convertToUnit((_c = ghostBox.value) == null ? void 0 : _c.width),
            height: convertToUnit((_d = ghostBox.value) == null ? void 0 : _d.height),
            transform: pointerMovement.value ? `translate3d(${convertToUnit(pointerMovement.value.left)}, ${convertToUnit(pointerMovement.value.top)}, 0px)` : void 0
          }
        }, [ghostVNode.value]);
      }
    };
  }
  const DraggableSortable = defineComponent({
    name: "VeDraggableSortable",
    inheritAttrs: false,
    props: __spreadValues({}, makeDraggableSortableProps()),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const {
        model,
        modelEls,
        active,
        pointerEvents,
        keyToIndex,
        indexToKey,
        ghostVNode,
        genGhost
      } = useDraggableSortable(props);
      const vnodes = vue.computed(() => {
        return model.value.map((value, index2) => {
          var _a;
          const key = indexToKey(index2);
          const draggable = vue.mergeProps(vue.toHandlers(pointerEvents.value), {
            style: {
              cursor: "move"
            }
          });
          const droppable = {
            ref: (v) => {
              modelEls.set(key, isComponentInstance(v) ? v.$el : v);
            }
          };
          const vnode = (_a = slots.item) == null ? void 0 : _a.call(slots, {
            item: value,
            draggable,
            droppable,
            props: vue.mergeProps(draggable, droppable)
          });
          if (vnode && vnode[0]) {
            if (!vnode[0].key)
              vnode[0].key = key;
            vnode[0].props = vue.mergeProps(vnode[0].props || {}, {
              class: {
                "ve-draggable-sortable--active": key === active.value
              }
            });
          }
          return vnode;
        });
      });
      vue.watch(active, (val) => {
        var _a;
        const vnode = (_a = vnodes.value[keyToIndex(val)]) == null ? void 0 : _a[0];
        if (vnode) {
          ghostVNode.value = vue.cloneVNode(vnode);
        } else {
          ghostVNode.value = void 0;
        }
      });
      return () => {
        return vue.createVNode(vue.Fragment, null, [vnodes.value, ghostVNode.value && genGhost()]);
      };
    }
  });
  var form = "";
  function _isSlot$7(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Radio = defineComponent({
    name: "VeRadio",
    props: makeSelectionControlProps({
      type: "radio",
      falseIcon: "$radioOff",
      trueIcon: "$radioOn",
      color: "primary"
    }),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      emit,
      slots
    }) {
      return () => {
        return vue.createVNode(SelectionControl, vue.mergeProps({
          "class": "ve-radio"
        }, props, {
          "onUpdate:modelValue": (val) => emit("update:modelValue", val)
        }), _isSlot$7(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
  const RadioGroup = defineComponent({
    name: "VeRadioGroup",
    props: __spreadValues(__spreadValues(__spreadValues({
      items: Array
    }, makeSelectionGroupControlProps({
      type: "radio",
      trueIcon: "$radioOn",
      falseIcon: "$radioOff"
    })), makeSizeProps()), makeDensityProps()),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const id = vue.computed(() => props.id || `ve-radio-group-${getUid()}`);
      const model = useProxiedModel(props, "modelValue");
      const items = vue.computed(() => {
        var _a;
        return (_a = props.items) == null ? void 0 : _a.map((itemProps) => typeof itemProps === "string" ? {
          value: itemProps
        } : itemProps);
      });
      provideDefaults({
        VeRadio: {
          size: vue.toRef(props, "size"),
          density: vue.toRef(props, "density"),
          readonly: vue.toRef(props, "readonly"),
          disabled: vue.toRef(props, "disabled")
        }
      });
      return () => {
        const _a = props, {
          density,
          size
        } = _a, restProps = __objRest(_a, [
          "density",
          "size"
        ]);
        return vue.createVNode(FormControl, {
          "class": "ve-radio-group",
          "density": density,
          "name": props.name,
          "size": size,
          "modelValue": model.value,
          "onUpdate:modelValue": ($event) => model.value = $event
        }, __spreadProps(__spreadValues({}, slots), {
          default: ({
            isDisabled,
            isReadonly,
            props: controlProps
          }) => vue.createVNode(SelectionGroupControl, vue.mergeProps(restProps, controlProps, {
            "id": id.value,
            "disabled": isDisabled.value,
            "readonly": isReadonly.value,
            "modelValue": model.value,
            "onUpdate:modelValue": ($event) => model.value = $event
          }), {
            default: () => {
              var _a2, _b;
              return [(_a2 = items.value) == null ? void 0 : _a2.map((itemProps) => vue.createVNode(Radio, itemProps, null)), (_b = slots.default) == null ? void 0 : _b.call(slots)];
            }
          })
        }));
      };
    }
  });
  var select = "";
  var list = "";
  const singleOpenStrategy = ({ id, value, opened, parents }) => {
    if (value) {
      const newOpened = /* @__PURE__ */ new Set();
      newOpened.add(id);
      let parent = parents.get(id);
      while (parent != null) {
        newOpened.add(parent);
        parent = parents.get(parent);
      }
      return newOpened;
    } else {
      opened.delete(id);
      return opened;
    }
  };
  const multipleOpenStrategy = ({ id, value, opened, parents }) => {
    if (value) {
      let parent = parents.get(id);
      opened.add(id);
      while (parent != null) {
        opened.add(parent);
        parent = parents.get(parent);
      }
      return opened;
    } else {
      opened.delete(id);
    }
    return opened;
  };
  const classicSelectStrategy = {
    select: ({ id, value, selected, children, parents }) => {
      const items = [id];
      while (items.length) {
        const item = items.shift();
        selected.set(item, value ? "on" : "off");
        if (children.has(item)) {
          items.push(...children.get(item));
        }
      }
      let parent = parents.get(id);
      while (parent) {
        const childrenIds = children.get(parent);
        const everySelected = childrenIds.every((cid) => selected.get(cid) === "on");
        const noneSelected = childrenIds.every((cid) => !selected.has(cid) || selected.get(cid) === "off");
        selected.set(parent, everySelected ? "on" : noneSelected ? "off" : "indeterminate");
        parent = parents.get(parent);
      }
      return selected;
    },
    in: (v, children, parents) => {
      let map = /* @__PURE__ */ new Map();
      for (const id of v || []) {
        map = classicSelectStrategy.select({
          id,
          value: true,
          selected: new Map(map),
          children,
          parents
        });
      }
      return map;
    },
    out: (v, children) => {
      const arr = [];
      for (const [key, value] of v.entries()) {
        if (value === "on" && !children.has(key))
          arr.push(key);
      }
      return arr;
    }
  };
  const independentSelectStrategy = {
    select: ({ id, value, selected }) => {
      selected.set(id, value ? "on" : "off");
      return selected;
    },
    in: (v, children, parents) => {
      let map = /* @__PURE__ */ new Map();
      for (const id of v || []) {
        map = independentSelectStrategy.select({
          id,
          value: true,
          selected: new Map(map),
          children,
          parents
        });
      }
      return map;
    },
    out: (v) => {
      const arr = [];
      for (const [key, value] of v.entries()) {
        if (value === "on")
          arr.push(key);
      }
      return arr;
    }
  };
  const leafSelectStrategy = (single = false) => {
    const strategy = {
      select: ({ id, value, selected, children }) => {
        if (children.has(id))
          return selected;
        if (single)
          return /* @__PURE__ */ new Map([[id, value ? "on" : "off"]]);
        selected.set(id, value ? "on" : "off");
        return selected;
      },
      in: (v, children, parents) => {
        let map = /* @__PURE__ */ new Map();
        for (const id of v != null ? v : []) {
          map = strategy.select({
            id,
            value: true,
            selected: new Map(map),
            children,
            parents
          });
        }
        return map;
      },
      out: independentSelectStrategy.out
    };
    return strategy;
  };
  const classicActiveStrategy = (single) => {
    return ({ id, value, active }) => {
      const newActive = single ? /* @__PURE__ */ new Set() : active;
      if (value) {
        newActive.add(id);
      } else {
        newActive.delete(id);
      }
      return newActive;
    };
  };
  const NestedKey = Symbol.for("veno-ui:nested");
  const emptyNested = {
    id: vue.ref(null),
    root: {
      register: () => null,
      unregister: () => null,
      parents: vue.ref(/* @__PURE__ */ new Map()),
      children: vue.ref(/* @__PURE__ */ new Map()),
      open: () => null,
      select: () => null,
      opened: vue.ref(/* @__PURE__ */ new Set()),
      selected: vue.ref(/* @__PURE__ */ new Map()),
      active: vue.ref(/* @__PURE__ */ new Set()),
      activate: () => null,
      selectedValues: vue.ref([])
    }
  };
  const makeNestedProps = propsFactory({
    selectStrategy: [String, Function],
    openStrategy: [String, Function],
    activeStrategy: [String, Function],
    opened: {
      type: [Boolean, Array],
      default: () => []
    },
    selected: Array,
    active: Array,
    deleteAfterUnmount: {
      type: Boolean,
      default: true
    }
  }, "nested");
  const useNested = (props) => {
    let isUnmounted = false;
    const children = vue.ref(/* @__PURE__ */ new Map());
    const parents = vue.ref(/* @__PURE__ */ new Map());
    const opened = useProxiedModel(props, "opened", props.opened, (v) => typeof v === "boolean" ? new Set(v === true ? [...children.value.keys()] : []) : new Set(v), (v) => [...v.values()]);
    const active = useProxiedModel(props, "active", props.active, (v) => new Set(v), (v) => [...v.values()]);
    const activeStrategy = vue.computed(() => {
      if (typeof props.activeStrategy === "string") {
        switch (props.activeStrategy) {
          case "single":
            return classicActiveStrategy(true);
          case "multiple":
          default:
            return classicActiveStrategy();
        }
      }
      return props.activeStrategy;
    });
    const selectStrategy = vue.computed(() => {
      if (typeof props.selectStrategy === "string") {
        switch (props.selectStrategy) {
          case "single-leaf":
            return leafSelectStrategy(true);
          case "leaf":
            return leafSelectStrategy();
          case "independent":
            return independentSelectStrategy;
          case "classic":
          default:
            return classicSelectStrategy;
        }
      }
      return props.selectStrategy;
    });
    const openStrategy = vue.computed(() => {
      if (typeof props.openStrategy === "string") {
        switch (props.openStrategy) {
          case "single":
            return singleOpenStrategy;
          case "multiple":
          default:
            return multipleOpenStrategy;
        }
      }
      return props.openStrategy;
    });
    const selected = useProxiedModel(props, "selected", props.selected, (v) => selectStrategy.value.in(v, children.value, parents.value), (v) => selectStrategy.value.out(v, children.value, parents.value));
    vue.onBeforeUnmount(() => {
      isUnmounted = true;
    });
    const nested = {
      id: vue.ref(null),
      root: {
        opened,
        selected,
        active,
        selectedValues: vue.computed(() => {
          const arr = [];
          for (const [key, value] of selected.value.entries()) {
            if (value === "on")
              arr.push(key);
          }
          return arr;
        }),
        register: (id, parentId, isGroup) => {
          parentId && parents.value.set(id, parentId);
          isGroup && children.value.set(id, []);
          if (parentId != null) {
            children.value.set(parentId, [...children.value.get(parentId) || [], id]);
          }
        },
        unregister: (id) => {
          var _a;
          if (isUnmounted)
            return;
          children.value.delete(id);
          const parent = parents.value.get(id);
          if (parent) {
            const list2 = (_a = children.value.get(parent)) != null ? _a : [];
            children.value.set(parent, list2.filter((child) => child !== id));
          }
          parents.value.delete(id);
          opened.value.delete(id);
          if (props.deleteAfterUnmount) {
            active.value.delete(id);
            selected.value.delete(id);
          }
        },
        open: (id, value, event) => {
          const newOpened = openStrategy.value({
            id,
            value,
            opened: new Set(opened.value),
            children: children.value,
            parents: parents.value,
            event
          });
          newOpened && (opened.value = newOpened);
        },
        select: (id, value, event) => {
          const newSelected = selectStrategy.value.select({
            id,
            value,
            selected: new Map(selected.value),
            children: children.value,
            parents: parents.value,
            event
          });
          newSelected && (selected.value = newSelected);
        },
        activate: (id, value, event) => {
          const newActive = activeStrategy.value({
            id,
            value,
            active: new Set(active.value),
            children: children.value,
            parents: parents.value,
            event
          });
          newActive && (active.value = newActive);
        },
        children,
        parents
      }
    };
    vue.provide(NestedKey, nested);
    return nested.root;
  };
  const useNestedItem = (id) => {
    const parent = vue.inject(NestedKey, emptyNested);
    const computedId = vue.computed(() => {
      var _a;
      return (_a = id.value) != null ? _a : getUid().toString();
    });
    const item = __spreadProps(__spreadValues({}, parent), {
      id: computedId,
      parent: vue.computed(() => parent.root.parents.value.get(computedId.value)),
      select: (selected, e) => parent.root.select(computedId.value, selected, e),
      isSelected: vue.computed(() => parent.root.selected.value.get(computedId.value) === "on"),
      activate: (activated, e) => parent.root.activate(computedId.value, activated, e),
      isActive: vue.computed(() => parent.root.active.value.has(computedId.value))
    });
    parent.root.register(computedId.value, parent.id.value, false);
    vue.onBeforeUnmount(() => {
      parent.root.unregister(computedId.value);
    });
    return item;
  };
  const useNestedGroup = (props) => {
    const parent = vue.inject(NestedKey, emptyNested);
    const id = vue.computed(() => {
      var _a;
      return (_a = props.value) != null ? _a : getUid().toString();
    });
    const group = __spreadProps(__spreadValues({}, parent), {
      id,
      open: (open, e) => parent.root.open(id.value, open, e),
      isOpen: vue.computed(() => parent.root.opened.value.has(id.value)),
      isSelected: vue.computed(() => parent.root.selected.value.get(id.value) === "on"),
      isIndeterminate: vue.computed(() => parent.root.selected.value.get(id.value) === "indeterminate")
    });
    parent.root.register(id.value, parent.id.value, true);
    vue.onBeforeUnmount(() => {
      parent.root.unregister(id.value);
    });
    vue.provide(NestedKey, group);
    return group;
  };
  const ListKey = Symbol.for("veno-ui:list");
  function provideList() {
    const parent = vue.inject(ListKey, { hasPrepend: vue.ref(false), updateHasPrepend: () => null });
    const data = {
      hasPrepend: vue.ref(false),
      updateHasPrepend: (value) => {
        if (value)
          data.hasPrepend.value = value;
      }
    };
    vue.provide(ListKey, data);
    return parent;
  }
  function useList() {
    return vue.inject(ListKey, null);
  }
  var listGroup = "";
  const ListGroup = genericComponent()({
    name: "VeListGroup",
    props: __spreadValues({
      collapseIcon: {
        type: [String, Object],
        default: "$collapse"
      },
      expandIcon: {
        type: [String, Object],
        default: "$expand"
      },
      value: null
    }, makeTagProps()),
    setup(props, {
      slots
    }) {
      const {
        isOpen,
        open
      } = useNestedGroup(props);
      const list2 = useList();
      const onClick = (e) => {
        open(!isOpen.value, e);
      };
      const activatorProps = vue.computed(() => ({
        onClick,
        appendIcon: isOpen.value ? props.collapseIcon : props.expandIcon,
        class: "ve-list-group__header",
        value: props.value ? `${props.value}_header` : void 0
      }));
      return () => {
        return vue.createVNode(props.tag, {
          "class": ["ve-list-group", {
            "ve-list-group--prepend": list2 == null ? void 0 : list2.hasPrepend.value
          }]
        }, {
          default: () => {
            var _a;
            return [(_a = slots.activator) == null ? void 0 : _a.call(slots, {
              props: activatorProps.value
            }), vue.createVNode(ExpandTransition, null, {
              default: () => {
                var _a2;
                return [vue.withDirectives(vue.createVNode("div", {
                  "class": "ve-list-group__items"
                }, [(_a2 = slots.default) == null ? void 0 : _a2.call(slots)]), [[vue.vShow, isOpen.value]])];
              }
            })];
          }
        });
      };
    }
  });
  var listItem = "";
  var listItemAvatar = "";
  const ListItemAvatar = defineComponent({
    name: "VeListItemAvatar",
    props: makeAvatarProps(),
    setup(props, {
      slots
    }) {
      return () => {
        return vue.createVNode(Avatar, vue.mergeProps({
          "class": ["ve-list-item-avatar", {
            "ve-list-item-avatar--start": props.start,
            "ve-list-item-avatar--end": props.end
          }]
        }, props), slots);
      };
    }
  });
  var listItemHeader = "";
  const ListItemHeader = createSimpleFunctional("ve-list-item-header");
  var listItemTitle = "";
  const ListItemTitle = createSimpleFunctional("ve-list-item-title");
  var listItemSubtitle = "";
  const ListItemSubtitle = createSimpleFunctional("ve-list-item-subtitle");
  const ListItem = genericComponent()({
    name: "VeListItem",
    directives: {
      Ripple
    },
    props: __spreadValues(__spreadValues(__spreadValues({
      active: Boolean,
      activeColor: {
        type: String,
        default: "primary"
      },
      activeClass: String,
      appendAvatar: String,
      appendIcon: [String, Object],
      link: Boolean,
      prependAvatar: String,
      prependIcon: [String, Object],
      ripple: {
        type: Boolean,
        default: true
      },
      subtitle: String,
      text: String,
      title: String,
      value: null
    }, makePaperProps({
      variant: "text",
      size: void 0
    })), makeDisabledProps()), makeRouterProps()),
    setup(props, {
      slots,
      attrs
    }) {
      const link2 = useLink(props, attrs);
      const id = vue.computed(() => {
        var _a;
        return (_a = props.value) != null ? _a : link2.href.value;
      });
      const {
        activate,
        isActive: isNestedActive,
        select: select2,
        isSelected,
        root,
        parent
      } = useNestedItem(id);
      const list2 = useList();
      const isActive = vue.computed(() => {
        var _a;
        return props.active || ((_a = link2.isExactActive) == null ? void 0 : _a.value) || isNestedActive.value;
      });
      const {
        paperClasses,
        paperStyles
      } = usePaper(vue.computed(() => {
        var _a;
        return __spreadProps(__spreadValues({}, props), {
          color: isActive.value ? (_a = props.activeColor) != null ? _a : props.color : props.color
        });
      }));
      const {
        disabledClasses
      } = useDisabled(props);
      vue.onMounted(() => {
        var _a;
        if (((_a = link2.isExactActive) == null ? void 0 : _a.value) && parent.value != null) {
          root.open(parent.value, true);
        }
      });
      vue.watch(() => {
        var _a;
        return (_a = link2.isExactActive) == null ? void 0 : _a.value;
      }, (val) => {
        if (val && parent.value != null) {
          root.open(parent.value, true);
        }
      });
      const slotProps = vue.computed(() => ({
        isActive: isActive.value,
        activate,
        select: select2,
        isSelected: isSelected.value
      }));
      return () => {
        const Tag2 = link2.isLink.value ? "a" : props.tag;
        const hasTitle = slots.title || props.title;
        const hasSubtitle = slots.subtitle || props.subtitle;
        const hasText = slots.text || props.text;
        const hasHeader = !!(hasText || hasTitle || hasSubtitle);
        const hasAppend = !!(slots.append || props.appendAvatar || props.appendIcon);
        const hasPrepend = !!(slots.prepend || props.prependAvatar || props.prependIcon);
        const isClickable = !props.disabled && (link2.isClickable.value || props.link);
        list2 == null ? void 0 : list2.updateHasPrepend(hasPrepend);
        return vue.withDirectives(vue.createVNode(Tag2, {
          "class": ["ve-list-item", {
            "ve-list-item--active": isActive.value,
            "ve-list-item--link": isClickable,
            "ve-list-item--prepend": !hasPrepend && (list2 == null ? void 0 : list2.hasPrepend.value),
            [`${props.activeClass}`]: isActive.value && props.activeClass
          }, paperClasses.value, disabledClasses.value],
          "style": paperStyles.value,
          "href": link2.href.value,
          "tabindex": isClickable ? 0 : void 0,
          "onClick": isClickable && ((e) => {
            var _a;
            (_a = link2.navigate) == null ? void 0 : _a.call(link2, e);
            props.value != null && activate(!isNestedActive.value, e);
          })
        }, {
          default: () => {
            var _a, _b, _c, _d, _e;
            return [genOverlays(isClickable, "ve-list-item"), hasPrepend && ((_b = (_a = slots.prepend) == null ? void 0 : _a.call(slots, slotProps.value)) != null ? _b : vue.createVNode(ListItemAvatar, {
              "start": true,
              "color": "inherit",
              "variant": "text",
              "density": props.density,
              "icon": props.prependIcon,
              "image": props.prependAvatar
            }, null)), hasHeader && vue.createVNode(ListItemHeader, null, {
              default: () => {
                var _a2, _b2;
                return [hasTitle && vue.createVNode(ListItemTitle, null, {
                  default: () => {
                    var _a3, _b3;
                    return [(_b3 = (_a3 = slots.title) == null ? void 0 : _a3.call(slots, {
                      title: props.title
                    })) != null ? _b3 : props.title];
                  }
                }), hasSubtitle && vue.createVNode(ListItemSubtitle, null, {
                  default: () => {
                    var _a3, _b3;
                    return [(_b3 = (_a3 = slots.subtitle) == null ? void 0 : _a3.call(slots, {
                      subtitle: props.subtitle
                    })) != null ? _b3 : props.subtitle];
                  }
                }), hasText && vue.createVNode("div", null, [(_b2 = (_a2 = slots.text) == null ? void 0 : _a2.call(slots, {
                  text: props.text
                })) != null ? _b2 : props.text])];
              }
            }), (_c = slots.default) == null ? void 0 : _c.call(slots, slotProps.value), hasAppend && ((_e = (_d = slots.append) == null ? void 0 : _d.call(slots, slotProps.value)) != null ? _e : vue.createVNode(ListItemAvatar, {
              "end": true,
              "color": "inherit",
              "variant": "text",
              "density": props.density,
              "icon": props.appendIcon,
              "image": props.appendAvatar
            }, null))];
          }
        }), [[vue.resolveDirective("ripple"), isClickable && props.ripple]]);
      };
    }
  });
  var listSubheader = "";
  const ListSubheader = defineComponent({
    name: "VeListSubheader",
    props: __spreadValues({
      color: String,
      inset: Boolean
    }, makeTagProps()),
    setup(props, {
      slots
    }) {
      const {
        textColorClasses,
        textColorStyles
      } = useTextColor(vue.toRef(props, "color"));
      return () => vue.createVNode(props.tag, {
        "class": ["ve-list-subheader", {
          "ve-list-subheader--inset": props.inset
        }, textColorClasses.value],
        "style": {
          textColorStyles
        }
      }, {
        default: () => [slots.default && vue.createVNode("div", {
          "class": "ve-list-subheader__text"
        }, [slots.default()])]
      });
    }
  });
  const ListChildren = genericComponent()({
    name: "VeListChildren",
    props: {
      items: Array
    },
    setup(props, {
      slots
    }) {
      provideList();
      return () => {
        var _a, _b, _c;
        return (_c = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _c : (_b = props.items) == null ? void 0 : _b.map(({
          children,
          props: itemProps,
          type
        }, index2) => {
          var _a2, _b2;
          switch (type) {
            case "divider":
              return vue.createVNode(Divider, itemProps, null);
            case "subheader":
              return vue.createVNode(ListSubheader, itemProps, slots);
            default:
              return children ? vue.createVNode(ListGroup, {
                "value": itemProps == null ? void 0 : itemProps.value
              }, {
                default: () => vue.createVNode(ListChildren, {
                  "items": children
                }, slots),
                activator: ({
                  props: activatorProps
                }) => {
                  var _a3, _b3;
                  return (_b3 = (_a3 = slots.header) == null ? void 0 : _a3.call(slots, {
                    item: itemProps,
                    index: index2,
                    props: activatorProps
                  })) != null ? _b3 : vue.createVNode(ListItem, vue.mergeProps(itemProps, activatorProps), null);
                }
              }) : (_b2 = (_a2 = slots.item) == null ? void 0 : _a2.call(slots, {
                item: itemProps,
                index: index2
              })) != null ? _b2 : vue.createVNode(ListItem, itemProps, slots);
          }
        });
      };
    }
  });
  function _isSlot$6(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  function parseItems$1(items) {
    if (!items)
      return void 0;
    return items.map((item) => {
      if (typeof item === "string")
        return {
          type: "item",
          props: {
            value: item,
            title: item
          }
        };
      const _a = item, {
        $type,
        $children
      } = _a, props = __objRest(_a, [
        "$type",
        "$children"
      ]);
      if ($type === "subheader")
        return {
          type: "subheader",
          props
        };
      if ($type === "divider")
        return {
          type: "divider",
          props
        };
      return {
        type: "item",
        props,
        children: parseItems$1($children)
      };
    });
  }
  const List = genericComponent()({
    name: "VeList",
    props: __spreadValues(__spreadValues(__spreadValues({
      nav: Boolean,
      items: Array
    }, makeNestedProps({
      selectStrategy: "leaf",
      openStrategy: "multiple",
      activeStrategy: "single"
    })), makePaperProps({
      size: void 0
    })), makeDisabledProps()),
    emits: {
      "update:selected": (_selected) => true,
      "update:opened": (_opened) => true,
      "update:active": (_active) => true
    },
    setup(props, {
      slots
    }) {
      const items = vue.computed(() => parseItems$1(props.items));
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const {
        disabledClasses
      } = useDisabled(props);
      const {
        open,
        select: select2,
        activate
      } = useNested(props);
      provideList();
      provideDefaults({
        VeListItem: {
          density: vue.toRef(props, "density")
        }
      });
      useRender(() => {
        return vue.createVNode(props.tag, {
          "class": ["ve-list", {
            "ve-list--nav": props.nav
          }, paperClasses.value, disabledClasses.value],
          "style": paperStyles.value
        }, {
          default: () => {
            var _a, _b;
            return [(_a = slots.prepend) == null ? void 0 : _a.call(slots), vue.createVNode(ListChildren, {
              "items": items.value
            }, _isSlot$6(slots) ? slots : {
              default: () => [slots]
            }), (_b = slots.append) == null ? void 0 : _b.call(slots)];
          }
        });
      });
      return {
        open,
        select: select2,
        activate
      };
    }
  });
  var tag = "";
  var tagGroup = "";
  const TagGroupKey = Symbol.for("veno-ui:chip-group");
  const TagGroup = defineComponent({
    name: "VeTagGroup",
    props: __spreadValues(__spreadValues({
      column: Boolean,
      valueComparator: {
        type: Function,
        default: deepEqual
      }
    }, makeGroupProps({
      selectedClass: "ve-tag--active"
    })), makePaperProps({
      variant: "contained-text"
    })),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const {
        isSelected,
        select: select2,
        next,
        prev,
        selected
      } = useGroup(props, TagGroupKey);
      provideDefaults({
        VeTag: {
          color: vue.toRef(props, "color"),
          size: vue.toRef(props, "size"),
          variant: vue.toRef(props, "variant")
        }
      });
      return () => vue.createVNode(props.tag, {
        "class": ["ve-tag-group", {
          "ve-tag-group--column": props.column
        }, paperClasses.value],
        "style": paperStyles.value
      }, {
        default: () => {
          var _a;
          return [(_a = slots.default) == null ? void 0 : _a.call(slots, {
            isSelected,
            select: select2,
            next,
            prev,
            selected: selected.value
          })];
        }
      });
    }
  });
  const Tag = defineComponent({
    name: "VeTag",
    directives: {
      Ripple
    },
    props: __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
      activeClass: String,
      appendAvatar: String,
      appendIcon: [String, Object],
      closable: Boolean,
      closeIcon: {
        type: [String, Object],
        default: "$close"
      },
      modelValue: {
        type: Boolean,
        default: true
      },
      prependAvatar: String,
      prependIcon: [String, Object],
      ripple: {
        type: Boolean,
        default: true
      },
      text: String,
      link: Boolean
    }, makeLoadingProps()), makeTransitionProps({
      transition: {
        component: FadeInExpandTransition
      }
    })), makePaperProps({
      tag: "span",
      shape: "rounded-sm",
      variant: "contained-text"
    })), makeGroupItemProps()), makeRouterProps()),
    emits: {
      "click:close": (_event) => true,
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      attrs,
      emit,
      slots
    }) {
      const isActive = useProxiedModel(props, "modelValue");
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const {
        loadingClasses
      } = useLoading(props);
      const group = useGroupItem(props, TagGroupKey, false);
      const link2 = useLink(props, attrs);
      function onCloseClick(e) {
        isActive.value = false;
        emit("click:close", e);
      }
      return () => {
        const Tag2 = link2.isLink.value ? "a" : props.tag;
        const hasAppend = !!(slots.append || props.appendIcon || props.appendAvatar);
        const hasClose = !!(props.loading || slots.close || props.closable);
        const hasPrepend = !!(slots.prepend || props.prependIcon || props.prependAvatar);
        const isClickable = !props.disabled && (!!group || link2.isClickable.value || props.link);
        const onClickFunc = props.link ? props.link : group == null ? void 0 : group.toggle;
        return vue.createVNode(MaybeTransition, {
          "transition": props.transition
        }, {
          default: () => [isActive.value && vue.withDirectives(vue.createVNode(Tag2, {
            "class": ["ve-tag", {
              "ve-tag--link": isClickable
            }, paperClasses.value, loadingClasses.value, group == null ? void 0 : group.selectedClass.value],
            "style": paperStyles.value,
            "href": link2.href.value,
            "onClick": isClickable && onClickFunc
          }, {
            default: () => {
              var _a, _b, _c, _d, _e, _f, _g, _h;
              return [genOverlays(isClickable, "ve-tag"), hasPrepend && vue.createVNode("div", {
                "class": ["ve-tag__prepend", {
                  "ve-tag__prepend--avatar": props.prependAvatar
                }]
              }, [(_b = (_a = slots.prepend) == null ? void 0 : _a.call(slots)) != null ? _b : vue.createVNode(Avatar, {
                "color": "inherit",
                "variant": "text",
                "icon": props.prependIcon,
                "image": props.prependAvatar
              }, null)]), (_d = (_c = slots.default) == null ? void 0 : _c.call(slots, {
                isSelected: group == null ? void 0 : group.isSelected.value,
                selectedClass: group == null ? void 0 : group.selectedClass.value,
                select: group == null ? void 0 : group.select,
                toggle: group == null ? void 0 : group.toggle,
                value: group == null ? void 0 : group.value.value,
                disabled: props.disabled
              })) != null ? _d : props.text, hasAppend && vue.createVNode("div", {
                "class": "ve-tag__append"
              }, [(_f = (_e = slots.append) == null ? void 0 : _e.call(slots)) != null ? _f : vue.createVNode(Avatar, {
                "color": "inherit",
                "variant": "text",
                "icon": props.appendIcon,
                "image": props.appendAvatar
              }, null)]), hasClose && vue.createVNode("div", {
                "class": "ve-tag__close"
              }, [(_h = (_g = slots.close) == null ? void 0 : _g.call(slots, {
                props: {
                  onClick: onCloseClick
                }
              })) != null ? _h : vue.createVNode(Button, {
                "variant": "plain",
                "ripple": false,
                "loading": props.loading,
                "icon": props.closeIcon,
                "onClick": onCloseClick
              }, null)])];
            }
          }), [[vue.resolveDirective("ripple"), isClickable && props.ripple, null]])]
        });
      };
    }
  });
  function defaultFilter(value, query, _item) {
    if (value == null || query == null)
      return -1;
    return value.toString().toLocaleLowerCase().indexOf(query.toString().toLocaleLowerCase());
  }
  const Select = genericComponent()({
    name: "VeSelect",
    props: __spreadValues({
      appendInnerIcon: {
        type: String,
        default: "$dropdown"
      },
      deleteAfterUnmount: {
        type: Boolean,
        default: true
      },
      filterable: Boolean,
      id: String,
      items: Array,
      itemText: {
        type: String,
        default: "text"
      },
      itemValue: {
        type: String,
        default: "value"
      },
      loading: Boolean,
      modelValue: {
        type: null,
        default: () => []
      },
      multiple: Boolean,
      noDataText: {
        type: String,
        default: "\u6682\u65E0\u6570\u636E"
      },
      openOnClear: Boolean,
      placeholder: String,
      query: String,
      tags: Boolean,
      readonly: Boolean,
      returnObject: Boolean
    }, makeScrollbar()),
    emits: {
      "click:clear": (_event) => true,
      "update:modelValue": (_modelValue) => true,
      "update:query": (_query) => true
    },
    setup(props, {
      emit,
      slots
    }) {
      const activator = vue.ref();
      const pendingIndex = vue.ref();
      const id = vue.computed(() => props.id || `ve-select-${getUid()}`);
      const inputRef = vue.ref();
      const isActiveMenu = vue.ref(false);
      const listRef = vue.ref();
      const menuRef = vue.ref();
      const mirrorRef = vue.ref();
      const tagInputRef = vue.ref();
      const tagInputWidth = vue.ref();
      const items = vue.computed(() => {
        var _a, _b;
        return (_b = (_a = props.items) == null ? void 0 : _a.map(normalizeItem)) != null ? _b : [];
      });
      const {
        scrollbarClasses
      } = useScrollbar(props);
      const model = useProxiedModel(props, "modelValue", props.modelValue, (v) => wrapInArray(v), (v) => props.multiple ? v : v[0]);
      const query = vue.ref(props.query);
      const active = vue.computed({
        get: () => model.value.map((v) => v && typeof v === "object" ? v[props.itemValue] : v),
        set: (val) => {
          model.value = props.returnObject ? val.map(getItem).filter((v) => v !== void 0) : val;
          if (!props.multiple)
            isActiveMenu.value = false;
        }
      });
      const selections = vue.computed(() => {
        return active.value.map((v) => {
          return items.value.find((i) => i.value === v);
        }).filter((v) => v !== void 0);
      });
      const onUpdateQuery = debounce((v) => {
        if (props.loading)
          return;
        emit("update:query", v);
      }, 300);
      const inputValue = vue.computed({
        get: () => {
          if (props.filterable && isActiveMenu.value)
            return query.value || void 0;
          if (props.tags)
            return void 0;
          return selections.value.map((item) => item.text).join(", ") || void 0;
        },
        set: (val) => {
          query.value = val;
          onUpdateQuery(val);
          if (isActiveMenu.value) {
            vue.nextTick(() => {
              var _a, _b, _c;
              (_c = (_b = (_a = menuRef.value) == null ? void 0 : _a.overlayRef) == null ? void 0 : _b.updatePosition) == null ? void 0 : _c.call(_b);
            });
          }
        }
      });
      const placeholder = vue.computed(() => {
        return props.tags && active.value.length > 0 ? void 0 : props.placeholder;
      });
      const filteredItems = vue.computed(() => items.value.filter((v) => !v.filtered));
      function getItem(v) {
        var _a;
        return (_a = props.items) == null ? void 0 : _a.find((i) => {
          const i1 = typeof i === "object" ? i[props.itemValue] : i;
          const v1 = typeof v === "object" ? v[props.itemValue] : v;
          return i1 === v1;
        });
      }
      function normalizeItem(item) {
        var _a;
        let v;
        if (typeof item === "object") {
          const value = item[props.itemValue];
          const text = String((_a = item[props.itemText]) != null ? _a : value);
          v = {
            text,
            value
          };
        } else {
          v = {
            text: String(item),
            value: item
          };
        }
        if (props.filterable && query.value) {
          v.filtered = defaultFilter(v.text, query.value) === -1;
        }
        return v;
      }
      vue.watch(() => inputRef.value, (val) => {
        activator.value = val.$el.querySelector(".ve-input-control");
      });
      vue.watch(() => props.query, (val) => {
        query.value = val;
      });
      function onBlur() {
        isActiveMenu.value = false;
      }
      function onClear(e) {
        model.value = [];
        if (props.openOnClear) {
          isActiveMenu.value = true;
        } else {
          inputRef.value.blur();
        }
        emit("click:clear", e);
      }
      function onControl() {
        var _a;
        if (props.readonly)
          return;
        if (isActiveMenu.value) {
          (_a = inputRef.value) == null ? void 0 : _a.blur();
        } else {
          isActiveMenu.value = true;
        }
      }
      const onKeydownMove = debounce(({
        key
      }) => {
        var _a;
        const index2 = (_a = pendingIndex.value) != null ? _a : filteredItems.value.findIndex(({
          value
        }) => value === active.value[0]);
        const lastIndex = filteredItems.value.length - 1;
        if (key === keyValues.up) {
          pendingIndex.value = [-1, 0].includes(index2) ? lastIndex : Math.max(0, index2 - 1);
        }
        if (key === keyValues.down) {
          pendingIndex.value = [-1, lastIndex].includes(index2) ? 0 : Math.min(lastIndex, index2 + 1);
        }
        vue.nextTick(() => {
          const el = listRef.value.$el;
          if (!el)
            return;
          const itemEl = el.querySelector(".ve-select__item--pendding");
          if (!itemEl)
            return;
          const itemTop = itemEl.offsetTop;
          if (itemTop <= el.scrollTop) {
            el.scrollTop -= el.scrollTop - itemTop;
          } else {
            const itemBottom = itemEl.offsetTop + itemEl.offsetHeight;
            const scrollBottom = el.scrollTop + el.offsetHeight;
            if (itemBottom >= scrollBottom) {
              el.scrollTop += itemBottom - scrollBottom;
            }
          }
        });
      }, 30);
      const onKeydownEnter = debounce(() => {
        if (!isActiveMenu.value) {
          isActiveMenu.value = true;
        } else if (filteredItems.value.length > 0) {
          const index2 = pendingIndex.value in filteredItems.value ? pendingIndex.value : 0;
          const value = filteredItems.value[index2].value;
          if (props.multiple) {
            active.value = active.value.includes(value) ? active.value.filter((v) => v !== value) : active.value.concat([value]);
          } else {
            active.value = [value];
          }
        }
      }, 60);
      const onKeydownDelete = debounce(() => {
        active.value = active.value.filter((_, i) => i !== active.value.length - 1);
      }, 60);
      function onKeydown(e) {
        const {
          key
        } = e;
        if ([keyValues.up, keyValues.down].includes(key)) {
          e.preventDefault();
          onKeydownMove(e);
        }
        if ([keyValues.enter, keyValues.space, " "].includes(key)) {
          e.preventDefault();
          onKeydownEnter();
        }
        if (key === keyValues.backspace && isActiveMenu.value && props.multiple && props.filterable && props.tags && !query.value && active.value.length > 0) {
          onKeydownDelete();
        }
        if (key === keyValues.esc && isActiveMenu.value) {
          isActiveMenu.value = false;
        }
      }
      function resizeTagInput() {
        tagInputWidth.value = Math.max(0, mirrorRef.value.scrollWidth) + 1;
      }
      let observer;
      vue.watch(mirrorRef, (val) => {
        if (val) {
          observer = new ResizeObserver(resizeTagInput);
          observer.observe(mirrorRef.value);
        } else {
          observer == null ? void 0 : observer.disconnect();
        }
      });
      vue.onBeforeUnmount(() => {
        observer == null ? void 0 : observer.disconnect();
      });
      vue.watch(isActiveMenu, (val) => {
        if (!val)
          pendingIndex.value = void 0;
      });
      return () => {
        const inputProps = props.multiple && !props.tags ? {
          autoResize: true,
          rows: 1,
          type: "textarea"
        } : {};
        const [listSlots, inputSlots] = pick(slots, ["item", "header", "title", "subtitle"]);
        return vue.createVNode(Input, vue.mergeProps(inputProps, {
          "class": ["ve-select", {
            "ve-select--active-menu": isActiveMenu.value
          }],
          "id": id.value,
          "inputAttach": tagInputRef.value,
          "modelValue": inputValue.value,
          "onUpdate:modelValue": ($event) => inputValue.value = $event,
          "onBlur": onBlur,
          "onClick:clear": onClear,
          "onClick:control": onControl,
          "onInput": (e) => {
            if (mirrorRef.value) {
              mirrorRef.value.textContent = e.target.value;
              resizeTagInput();
            }
          },
          "onKeydown": onKeydown,
          "onMousedown": (e) => e.preventDefault(),
          "placeholder": placeholder.value,
          "readonly": !props.filterable,
          "ref": inputRef
        }), __spreadProps(__spreadValues({}, inputSlots), {
          "append-inner": () => vue.createVNode(vue.Fragment, null, [!props.loading && vue.createVNode(Icon, {
            "icon": props.appendInnerIcon
          }, null), props.loading && vue.createVNode(Progress, {
            "size": "14",
            "variant": "circular",
            "stroke-width": "2",
            "indeterminate": true
          }, null)]),
          "default": () => vue.createVNode(vue.Fragment, null, [activator.value && vue.createVNode(Menu, {
            "ref": menuRef,
            "contentClass": "ve-select__menu-wrapper",
            "id": `${id.value}-menu`,
            "modelValue": isActiveMenu.value,
            "onUpdate:modelValue": ($event) => isActiveMenu.value = $event,
            "activator": activator.value,
            "minWidth": void 0,
            "openOnClick": false,
            "eager": true
          }, {
            default: () => [vue.createVNode(List, {
              "ref": listRef,
              "class": scrollbarClasses.value,
              "maxHeight": 250,
              "items": items.value,
              "active": active.value,
              "onUpdate:active": ($event) => active.value = $event,
              "activeStrategy": props.multiple ? "multiple" : "single",
              "deleteAfterUnmount": props.deleteAfterUnmount
            }, __spreadProps(__spreadValues({}, listSlots), {
              item: (itemSlot) => {
                const {
                  item,
                  index: index2
                } = itemSlot;
                const itemSlotProps = {
                  onMousedown: (e) => e.preventDefault(),
                  class: {
                    "ve-select__item--pendding": pendingIndex.value === index2
                  }
                };
                if (slots.item) {
                  return slots.item(__spreadProps(__spreadValues({}, itemSlot), {
                    props: itemSlotProps
                  }));
                }
                return vue.withDirectives(vue.createVNode(ListItem, vue.mergeProps(itemSlotProps, item, {
                  "link": true,
                  "key": item.value
                }), {
                  prepend: props.multiple ? () => vue.createVNode(ListItemAvatar, {
                    "start": true,
                    "color": "inherit",
                    "variant": "text"
                  }, {
                    default: () => [vue.createVNode(Checkbox, {
                      "model-value": active.value.includes(item.value)
                    }, null)]
                  }) : void 0
                }), [[vue.vShow, !item.filtered]]);
              },
              append: () => {
                var _a, _b;
                return vue.createVNode(vue.Fragment, null, [filteredItems.value.length === 0 && ((_b = (_a = slots["no-data"]) == null ? void 0 : _a.call(slots)) != null ? _b : vue.createVNode(ListItem, {
                  "text": props.noDataText
                }, null))]);
              }
            }))]
          }), props.tags && vue.createVNode(TagGroup, {
            "class": "ve-select__selections",
            "size": "x-small"
          }, {
            default: () => [selections.value.map((item) => {
              var _a, _b;
              function close() {
                active.value = active.value.filter((v) => v !== item.value);
              }
              return (_b = (_a = slots.tag) == null ? void 0 : _a.call(slots, {
                item,
                close
              })) != null ? _b : vue.createVNode(Tag, {
                "aria-hidden": "true",
                "tag": "div",
                "key": item.value,
                "closable": true,
                "text": item.text,
                "onClick:close": (e) => {
                  e.stopPropagation();
                  close();
                }
              }, null);
            }), vue.createVNode("div", {
              "class": "ve-select__tag-input",
              "style": {
                width: convertToUnit(selections.value.length > 0 ? tagInputWidth.value : "100%")
              },
              "ref": tagInputRef
            }, [vue.createVNode("span", {
              "class": "ve-select__tag-input-mirror",
              "ref": mirrorRef,
              "aria-hidden": "true"
            }, [query.value])])]
          })])
        }));
      };
    }
  });
  var _switch = "";
  const Switch = defineComponent({
    name: "VeSwitch",
    props: makeSelectionControlProps({
      type: "checkbox",
      color: "primary"
    }),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      emit,
      slots
    }) {
      const control = vue.ref();
      function onClick() {
        var _a, _b;
        (_b = (_a = control.value) == null ? void 0 : _a.inputRef) == null ? void 0 : _b.click();
      }
      return () => {
        return vue.createVNode(SelectionControl, vue.mergeProps({
          "ref": control,
          "class": "ve-switch"
        }, props, {
          "onUpdate:modelValue": (val) => emit("update:modelValue", val)
        }), __spreadProps(__spreadValues({}, slots), {
          default: ({
            textColorClasses,
            textColorStyles
          }) => vue.createVNode("div", {
            "class": ["ve-switch__track", textColorClasses.value],
            "style": [textColorStyles.value],
            "onClick": onClick
          }, null),
          input: () => {
            return vue.createVNode("div", {
              "class": "ve-switch__thumb"
            }, null);
          }
        }));
      };
    }
  });
  const FormChildren = defineComponent({
    name: "VeFormChildren",
    props: {
      items: Array
    },
    setup(props, {
      slots
    }) {
      return () => {
        var _a, _b, _c;
        return (_c = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _c : (_b = props.items) == null ? void 0 : _b.map(({
          type,
          props: itemProps
        }) => {
          switch (type) {
            case "textarea":
              return vue.createVNode(Input, vue.mergeProps({
                "type": "textarea"
              }, itemProps), null);
            case "select":
              return vue.createVNode(Select, itemProps, null);
            case "switch":
              const [controlProps, switchProps] = pick(itemProps || {}, ["label"]);
              return vue.createVNode(FormControl, controlProps, {
                default: () => [vue.createVNode(Switch, switchProps, null)]
              });
            case "date-picker":
              return vue.createVNode(DatePicker, itemProps, null);
            case "checkbox":
              return vue.createVNode(CheckboxGroup, itemProps, null);
            case "radio":
              return vue.createVNode(RadioGroup, itemProps, null);
            case "input":
            default:
              return vue.createVNode(Input, itemProps, null);
          }
        });
      };
    }
  });
  const Form = defineComponent({
    name: "VeForm",
    props: __spreadValues(__spreadValues(__spreadValues(__spreadValues({
      direction: {
        type: String,
        default: "horizontal",
        validator: (v) => ["horizontal", "vertical"].includes(v)
      },
      hideDetails: [Boolean, String],
      inline: Boolean,
      items: Array,
      labelWidth: [Number, String]
    }, makeSizeProps()), makeDensityProps()), makeFormProps()), makeVariantProps()),
    emits: {
      "update:valid": (_valid) => true,
      "update:modelValue": (_modelValue) => true,
      "resetValidation": () => true,
      "reset": (_event) => true,
      "submit": (_value, _event) => true
    },
    setup(props, {
      slots
    }) {
      const form2 = provideForm(props);
      const items = vue.computed(() => {
        var _a;
        return (_a = props.items) == null ? void 0 : _a.map((item) => {
          const _a2 = item, {
            $type: type
          } = _a2, props2 = __objRest(_a2, [
            "$type"
          ]);
          return {
            type,
            props: props2
          };
        });
      });
      const defaults = {
        variant: vue.toRef(props, "variant"),
        size: vue.toRef(props, "size"),
        density: vue.toRef(props, "density"),
        direction: vue.toRef(props, "direction"),
        inline: vue.toRef(props, "inline"),
        labelWidth: vue.toRef(props, "labelWidth"),
        hideDetails: vue.toRef(props, "hideDetails"),
        readonly: vue.toRef(props, "readonly"),
        disabled: vue.toRef(props, "disabled")
      };
      provideDefaults({
        VeInput: defaults,
        VeSelect: defaults,
        VeRadioGroup: defaults,
        VeCheckboxGroup: defaults,
        VeSwitch: defaults,
        VeFormControl: defaults,
        VeButton: {
          density: defaults.density,
          disabled: defaults.disabled
        }
      });
      useRender(() => {
        var _a;
        return vue.createVNode("form", {
          "class": ["ve-form", {
            [`ve-form--${props.direction}`]: !!props.direction,
            "ve-form--inline": props.inline
          }],
          "novalidate": true,
          "onReset": form2.reset,
          "onSubmit": form2.submit
        }, [vue.createVNode(FormChildren, {
          "items": items.value
        }, null), (_a = slots.default) == null ? void 0 : _a.call(slots, form2)]);
      });
      return form2;
    }
  });
  var container = "";
  const Container = defineComponent({
    name: "VeContainer",
    props: __spreadValues({
      fluid: {
        type: Boolean,
        default: false
      }
    }, makeTagProps()),
    setup(props, {
      slots
    }) {
      return () => vue.createVNode(props.tag, {
        "class": ["ve-container", {
          "ve-container--fluid": props.fluid
        }]
      }, slots);
    }
  });
  var col = "";
  function _isSlot$5(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const breakpoints$1 = ["sm", "md", "lg", "xl", "xxl"];
  const breakpointProps = (() => {
    return breakpoints$1.reduce((props, val) => {
      props[val] = {
        type: [Boolean, String, Number],
        default: false
      };
      return props;
    }, {});
  })();
  const offsetProps = (() => {
    return breakpoints$1.reduce((props, val) => {
      props[`offset${vue.capitalize(val)}`] = {
        type: [String, Number],
        default: null
      };
      return props;
    }, {});
  })();
  const orderProps = (() => {
    return breakpoints$1.reduce((props, val) => {
      props[`order${vue.capitalize(val)}`] = {
        type: [String, Number],
        default: null
      };
      return props;
    }, {});
  })();
  const propMap$1 = {
    col: Object.keys(breakpointProps),
    offset: Object.keys(offsetProps),
    order: Object.keys(orderProps)
  };
  function breakpointClass$1(type, prop, val) {
    let className = type;
    if (val == null || val === false) {
      return void 0;
    }
    if (prop) {
      const breakpoint = prop.replace(type, "");
      className += `-${breakpoint}`;
    }
    if (type === "col") {
      className = `ve-${className}`;
    }
    if (type === "col" && (val === "" || val === true)) {
      return className.toLowerCase();
    }
    className += `-${val}`;
    return className.toLowerCase();
  }
  const makeColProps = propsFactory(__spreadProps(__spreadValues(__spreadProps(__spreadValues(__spreadProps(__spreadValues({
    cols: {
      type: [Boolean, String, Number],
      default: false
    }
  }, breakpointProps), {
    offset: {
      type: [String, Number],
      default: null
    }
  }), offsetProps), {
    order: {
      type: [String, Number],
      default: null
    }
  }), orderProps), {
    alignSelf: {
      type: String,
      default: null,
      validator: (str) => ["auto", "start", "end", "center", "baseline", "stretch"].includes(str)
    }
  }), "col");
  const Col = defineComponent({
    name: "VeCol",
    props: __spreadValues(__spreadValues({}, makeTagProps()), makeColProps()),
    setup(props, {
      slots
    }) {
      const classes = vue.computed(() => {
        const classList = [];
        let type;
        for (type in propMap$1) {
          propMap$1[type].forEach((prop) => {
            const value = props[prop];
            const className = breakpointClass$1(type, prop, value);
            if (className)
              classList.push(className);
          });
        }
        const hasColClasses = classList.some((className) => className.startsWith("ve-col-"));
        classList.push({
          "ve-col": !hasColClasses || !props.cols,
          [`ve-col-${props.cols}`]: props.cols,
          [`offset-${props.offset}`]: props.offset,
          [`order-${props.order}`]: props.order,
          [`align-self-${props.alignSelf}`]: props.alignSelf
        });
        return classList;
      });
      return () => vue.createVNode(props.tag, {
        "class": classes.value
      }, _isSlot$5(slots) ? slots : {
        default: () => [slots]
      });
    }
  });
  var row = "";
  function _isSlot$4(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const breakpoints = ["sm", "md", "lg", "xl", "xxl"];
  const alignments = ["start", "end", "center"];
  function makeProps(prefix, def) {
    return breakpoints.reduce((props, val) => {
      props[prefix + vue.capitalize(val)] = def();
      return props;
    }, {});
  }
  const alignValidator = (str) => [...alignments, "baseline", "stretch"].includes(str);
  const alignProps = makeProps("align", () => ({
    type: String,
    default: null,
    validator: alignValidator
  }));
  const justifyValidator = (str) => [...alignments, "space-between", "space-around"].includes(str);
  const justifyProps = makeProps("justify", () => ({
    type: String,
    default: null,
    validator: justifyValidator
  }));
  const alignContentValidator = (str) => [...alignments, "space-between", "space-around", "stretch"].includes(str);
  const alignContentProps = makeProps("alignContent", () => ({
    type: String,
    default: null,
    validator: alignContentValidator
  }));
  const propMap = {
    align: Object.keys(alignProps),
    justify: Object.keys(justifyProps),
    alignContent: Object.keys(alignContentProps)
  };
  const classMap = {
    align: "align",
    justify: "justify",
    alignContent: "align-content"
  };
  function breakpointClass(type, prop, val) {
    let className = classMap[type];
    if (val == null) {
      return void 0;
    }
    if (prop) {
      const breakpoint = prop.replace(type, "");
      className += `-${breakpoint}`;
    }
    className += `-${val}`;
    return className.toLowerCase();
  }
  const GUTTERS = ["xs", "sm", "md", "lg", "xl", "xxl", "x-small", "small", "medium", "large", "x-large", "xx-large"];
  const GUTTERS_ALIASES = {
    "x-small": "xs",
    "small": "sm",
    "medium": "md",
    "large": "lg",
    "x-large": "xl",
    "xx-large": "xxl"
  };
  const makeRowProps = propsFactory(__spreadValues(__spreadProps(__spreadValues(__spreadProps(__spreadValues({
    gutter: {
      type: [Number, String],
      default: "xl"
    },
    align: {
      type: String,
      default: null,
      validator: alignValidator
    }
  }, alignProps), {
    justify: {
      type: String,
      default: null,
      validator: justifyValidator
    }
  }), justifyProps), {
    alignContent: {
      type: String,
      default: null,
      validator: alignContentValidator
    }
  }), alignContentProps), "row");
  const Row = defineComponent({
    name: "VeRow",
    props: __spreadValues(__spreadValues({}, makeTagProps()), makeRowProps()),
    setup(props, {
      slots
    }) {
      const classes = vue.computed(() => {
        const classList = [];
        let type;
        for (type in propMap) {
          propMap[type].forEach((prop) => {
            const value = props[prop];
            const className = breakpointClass(type, prop, value);
            if (className)
              classList.push(className);
          });
        }
        if (GUTTERS.includes(props.gutter)) {
          let gutter = props.gutter;
          if (props.gutter in GUTTERS_ALIASES) {
            gutter = GUTTERS_ALIASES[gutter];
          }
          classList.push(`ve-row--gutter-${gutter}`);
        }
        classList.push({
          [`align-${props.align}`]: props.align,
          [`justify-${props.justify}`]: props.justify,
          [`align-content-${props.alignContent}`]: props.alignContent
        });
        return classList;
      });
      const styles = vue.computed(() => {
        if (GUTTERS.includes(props.gutter))
          return {};
        return {
          "--ve-row-gutter": convertToUnit(props.gutter)
        };
      });
      return () => vue.createVNode(props.tag, {
        "class": ["ve-row", classes.value],
        "style": styles.value
      }, _isSlot$4(slots) ? slots : {
        default: () => [slots]
      });
    }
  });
  var header = "";
  var toolbar = "";
  var toolbarTitle = "";
  const ToolbarTitle = defineComponent({
    name: "VeToolbarTitle",
    props: __spreadValues({
      text: String
    }, makeTagProps()),
    setup(props, {
      slots
    }) {
      return () => {
        const hasText = !!(slots.text || props.text);
        return vue.createVNode(props.tag, {
          "class": "ve-toolbar-title"
        }, {
          default: () => {
            var _a, _b, _c;
            return [hasText && vue.createVNode("div", {
              "class": "ve-toolbar-title__wrapper"
            }, [(_b = (_a = slots.text) == null ? void 0 : _a.call(slots)) != null ? _b : props.text]), (_c = slots.default) == null ? void 0 : _c.call(slots)];
          }
        });
      };
    }
  });
  const makeToolbarProps = propsFactory(__spreadValues({
    title: String
  }, makePaperProps({
    tag: "header",
    height: 64
  })), "toolbar");
  function filterToolbarProps(attrs) {
    return pick(attrs, Object.keys(Toolbar.props));
  }
  const Toolbar = defineComponent({
    name: "VeToolbar",
    props: makeToolbarProps(),
    setup(props, {
      slots
    }) {
      const {
        paperClasses,
        paperStyles
      } = usePaper(vue.computed(() => __spreadProps(__spreadValues({}, props), {
        height: void 0
      })));
      provideDefaults({
        VeButton: {
          variant: "text"
        }
      });
      return () => {
        const hasTitle = !!(props.title || slots.title);
        return vue.createVNode(props.tag, {
          "class": ["ve-toolbar", paperClasses.value],
          "style": paperStyles.value
        }, {
          default: () => {
            var _a, _b, _c;
            return [vue.createVNode("div", {
              "class": "ve-toolbar__wrapper",
              "style": {
                height: convertToUnit(props.height)
              }
            }, [slots.prepend && vue.createVNode("div", {
              "class": "ve-toolbar__prepend"
            }, [(_a = slots.prepend) == null ? void 0 : _a.call(slots)]), hasTitle && vue.createVNode(ToolbarTitle, {
              "text": props.title
            }, {
              text: slots.title
            }), (_b = slots.default) == null ? void 0 : _b.call(slots), slots.append && vue.createVNode("div", {
              "class": "ve-toolbar__append"
            }, [(_c = slots.append) == null ? void 0 : _c.call(slots)])])];
          }
        });
      };
    }
  });
  const ToolbarItems = defineComponent({
    name: "VeToolbarItems",
    props: __spreadValues({}, makeVariantProps({
      variant: "contained-text"
    })),
    setup(props, {
      slots
    }) {
      provideDefaults({
        VeButton: {
          color: vue.toRef(props, "color"),
          textColor: vue.toRef(props, "textColor"),
          variant: vue.toRef(props, "variant")
        }
      });
      return () => {
        var _a;
        return (_a = slots.default) == null ? void 0 : _a.call(slots);
      };
    }
  });
  function _isSlot$3(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Header = defineComponent({
    name: "VeHeader",
    props: __spreadValues(__spreadValues({}, makeToolbarProps()), makeLayoutItemProps({
      position: "fixed",
      anchor: "top"
    })),
    setup(props, {
      slots
    }) {
      const {
        layoutItemStyles
      } = useLayoutItem(vue.computed(() => ({
        position: props.position,
        anchor: props.anchor,
        size: props.height,
        active: props.modelValue,
        priority: props.priority
      })));
      return () => {
        const [toolbarProps] = filterToolbarProps(props);
        return vue.createVNode(Toolbar, vue.mergeProps(toolbarProps, {
          "class": ["ve-header"],
          "style": layoutItemStyles.value
        }), _isSlot$3(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
  const HeaderNavIcon = defineComponent({
    name: "VeHeaderNavIcon",
    props: {
      icon: {
        type: String,
        default: "$menu"
      }
    },
    setup(props, {
      slots
    }) {
      return () => vue.createVNode(Button, {
        "class": "ve-header-nav-icon",
        "icon": props.icon
      }, slots);
    }
  });
  var headerTitle = "";
  const HeaderTitle = defineComponent({
    name: "VeHeaderTitle",
    props: __spreadValues({
      text: String
    }, makeTagProps({
      tag: "header"
    })),
    setup(props, {
      slots
    }) {
      return () => {
        const hasDefault = slots.default || props.text;
        return vue.createVNode(props.tag, {
          "class": "ve-header-title"
        }, {
          default: () => {
            var _a, _b;
            return [hasDefault && vue.createVNode("div", {
              "class": "ve-header-title__wrapper"
            }, [(_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text])];
          }
        });
      };
    }
  });
  const Hover = defineComponent({
    name: "VeHover",
    props: __spreadValues({
      disabled: Boolean,
      modelValue: {
        type: Boolean,
        default: void 0
      }
    }, makeDelayProps()),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const hover = useProxiedModel(props, "modelValue");
      const {
        runOpenDelay,
        runCloseDelay
      } = useDelay(props, (value) => {
        !props.disabled && (hover.value = value);
      });
      return () => {
        var _a;
        return (_a = slots.default) == null ? void 0 : _a.call(slots, {
          hover: hover.value,
          props: {
            onMouseenter: runOpenDelay,
            onMouseleave: runCloseDelay
          }
        });
      };
    }
  });
  var layout = "";
  function _isSlot$2(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Layout = defineComponent({
    name: "VeLayout",
    props: __spreadValues(__spreadValues({}, makeTagProps()), makeLayoutProps()),
    setup(props, {
      slots
    }) {
      const {
        layoutClasses,
        getLayoutItem,
        items
      } = provideLayout(props);
      useRender(() => vue.createVNode(props.tag, {
        "class": ["ve-layout", layoutClasses.value]
      }, _isSlot$2(slots) ? slots : {
        default: () => [slots]
      }));
      return {
        getLayoutItem,
        items
      };
    }
  });
  var layoutItem = "";
  function _isSlot$1(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const LayoutItem = defineComponent({
    name: "VeLayoutItem",
    props: __spreadValues(__spreadValues({
      size: {
        type: [String, Number],
        default: 64
      }
    }, makeTagProps()), makeLayoutItemProps()),
    setup(props, {
      slots
    }) {
      const {
        layoutItemStyles
      } = useLayoutItem(vue.computed(() => ({
        priority: props.priority,
        position: props.position,
        anchor: props.anchor,
        size: props.size,
        active: props.modelValue
      })));
      return () => vue.createVNode(props.tag, {
        "class": ["ve-layout-item"],
        "style": layoutItemStyles.value
      }, _isSlot$1(slots) ? slots : {
        default: () => [slots]
      });
    }
  });
  const Lazy = genericComponent()({
    name: "VeLazy",
    directives: {
      Intersect
    },
    props: __spreadValues(__spreadValues(__spreadValues({
      modelValue: Boolean,
      options: {
        type: Object,
        default: () => ({
          root: void 0,
          rootMargin: void 0,
          threshold: void 0
        })
      }
    }, makeDimensionProps()), makeTagProps()), makeTransitionProps({
      transition: {
        component: FadeTransition
      }
    })),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const {
        dimensionStyles
      } = useDimension(props);
      const isActive = useProxiedModel(props, "modelValue");
      function onIntersect(isIntersecting) {
        if (isActive.value)
          return;
        isActive.value = isIntersecting;
      }
      return () => vue.withDirectives(vue.createVNode(props.tag, {
        "class": "ve-lazy",
        "style": dimensionStyles.value
      }, {
        default: () => [isActive.value && vue.createVNode(MaybeTransition, {
          "transition": props.transition
        }, {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
          }
        })]
      }), [[vue.resolveDirective("intersect"), onIntersect, props.options]]);
    }
  });
  var main = "";
  const Main = defineComponent({
    name: "VeMain",
    props: __spreadValues(__spreadValues({}, makeTagProps({
      tag: "main"
    })), makeColorProps()),
    setup(props, {
      slots
    }) {
      const {
        mainStyles
      } = useLayoutMain();
      const {
        colorClasses,
        colorStyles
      } = useColor(vue.computed(() => {
        const {
          textColor,
          color
        } = vue.unref(props);
        return {
          background: color,
          text: textColor
        };
      }));
      return () => vue.createVNode(props.tag, {
        "class": ["ve-main", colorClasses.value],
        "style": [mainStyles.value, colorStyles.value]
      }, {
        default: () => {
          var _a;
          return [vue.createVNode("div", {
            "class": "ve-main__wrap"
          }, [(_a = slots.default) == null ? void 0 : _a.call(slots)])];
        }
      });
    }
  });
  var messageProvider = "";
  const MessageKey = Symbol.for("veno-ui:message");
  const NotificationKey = Symbol.for("veno-ui:notification");
  const message = createMessage();
  const notification = createMessage();
  function createMessage() {
    const items = vue.ref([]);
    function open(props) {
      return function(text, rest) {
        const id = `ve-message-${getUid()}`;
        const item = __spreadValues(__spreadValues({
          id,
          text,
          modelValue: true,
          variant: "contained",
          elevation: 15,
          duration: 3e3,
          close: () => close(id)
        }, props), rest);
        items.value.push(item);
        if (item.duration > 0) {
          return new Promise((resolve) => {
            setTimeout(() => {
              item.close();
              resolve(item);
            }, item.duration);
          });
        }
        return item.close;
      };
    }
    function close(id) {
      const item = items.value.find((v) => v.id === id);
      if (item) {
        item.modelValue = false;
      }
    }
    function remove(id) {
      items.value.splice(items.value.findIndex((v) => v.id === id), 1);
    }
    return {
      items,
      open,
      info: open({ type: "info" }),
      success: open({ type: "success" }),
      warning: open({ type: "warning" }),
      error: open({ type: "error" }),
      loading: open({ loading: true }),
      close,
      remove
    };
  }
  function provideMessage() {
    const message2 = createMessage();
    vue.provide(MessageKey, message2);
    return message2;
  }
  function useMessage() {
    const message2 = vue.inject(MessageKey);
    if (!message2)
      throw new Error("[VenoUi] Could not find message instance");
    return message2;
  }
  function provideNotification() {
    const notification2 = createMessage();
    vue.provide(NotificationKey, notification2);
    return notification2;
  }
  function useNotification() {
    const notification2 = vue.inject(NotificationKey);
    if (!notification2)
      throw new Error("[VenoUi] Could not find notification instance");
    return notification2;
  }
  const MessageProvider = defineComponent({
    name: "VeMessageProvider",
    register(app2) {
      app2.provide(MessageKey, message);
    },
    props: {
      registered: Boolean
    },
    setup(props, {
      slots
    }) {
      const message2 = !props.registered ? provideMessage() : useMessage();
      const {
        items,
        remove
      } = message2;
      useRender(() => {
        var _a;
        return vue.createVNode(vue.Fragment, null, [(_a = slots.default) == null ? void 0 : _a.call(slots), vue.createVNode(Overlay, {
          "modelValue": items.value.length > 0,
          "scrim": false,
          "scrollStrategy": "none",
          "class": ["ve-message-provider"]
        }, __spreadProps(__spreadValues({}, slots), {
          default: () => vue.createVNode("ul", null, [items.value.map((item) => {
            const [alertProps] = filterAlertProps(item);
            return vue.createVNode(Alert, vue.mergeProps({
              "key": item.id,
              "tag": "li",
              "appear": true,
              "modelValue": item.modelValue,
              "onUpdate:modelValue": ($event) => item.modelValue = $event,
              "on-after-leave": () => remove(item.id)
            }, alertProps), null);
          })])
        }))]);
      });
      return message2;
    }
  });
  var notificationProvider = "";
  const NotificationProvider = defineComponent({
    name: "VeNotificationProvider",
    register(app2) {
      app2.provide(NotificationKey, notification);
    },
    props: {
      registered: Boolean
    },
    setup(props, {
      slots
    }) {
      const notification2 = props.registered ? useNotification() : provideNotification();
      const {
        items,
        remove
      } = notification2;
      useRender(() => {
        var _a;
        return vue.createVNode(vue.Fragment, null, [(_a = slots.default) == null ? void 0 : _a.call(slots), vue.createVNode(Overlay, {
          "modelValue": items.value.length > 0,
          "scrim": false,
          "scrollStrategy": "none",
          "class": ["ve-notification-provider"]
        }, __spreadProps(__spreadValues({}, slots), {
          default: () => vue.createVNode("ul", null, [items.value.map((item) => {
            const [alertProps] = filterAlertProps(item);
            return vue.createVNode(Alert, vue.mergeProps({
              "key": item.id,
              "tag": "li",
              "appear": true,
              "modelValue": item.modelValue,
              "onUpdate:modelValue": ($event) => item.modelValue = $event,
              "on-after-leave": () => remove(item.id),
              "min-width": "300",
              "transition": {
                component: SlideRightFadeInExpandTransition
              }
            }, alertProps), null);
          })])
        }))]);
      });
      return notification2;
    }
  });
  var pagination = "";
  function useRefs() {
    const refs = vue.ref([]);
    vue.onBeforeUpdate(() => refs.value = []);
    function updateRef(e, i) {
      refs.value[i] = e;
    }
    return { refs, updateRef };
  }
  const Pagination = defineComponent({
    name: "VePagination",
    props: __spreadValues({
      activeColor: {
        type: String,
        default: "primary"
      },
      ariaLabel: {
        type: String,
        default: "\u5206\u9875\u5BFC\u822A"
      },
      currentPageAriaLabel: {
        type: String,
        default: "\u5F53\u524D\u9875 {0}"
      },
      disabled: Boolean,
      ellipsis: {
        type: String,
        default: "..."
      },
      firstAriaLabel: {
        type: String,
        default: "\u9996\u9875"
      },
      firstPage: {
        type: [Number, String],
        default: 1
      },
      firstIcon: {
        type: String,
        default: "$first"
      },
      lastAriaLabel: {
        type: String,
        default: "\u6700\u540E\u9875"
      },
      lastIcon: {
        type: String,
        default: "$last"
      },
      modelValue: {
        type: [Number, String],
        default: (props) => props.firstPage,
        validator: (val) => val % 1 === 0
      },
      nextAriaLabel: {
        type: String,
        default: "\u4E0B\u4E00\u9875"
      },
      nextIcon: {
        type: String,
        default: "$next"
      },
      prevIcon: {
        type: String,
        default: "$prev"
      },
      pageAriaLabel: {
        type: String,
        default: "\u8F6C\u5230\u9875\u9762 {0}"
      },
      perPage: {
        type: [Number, String],
        default: 10,
        validator: (val) => val % 1 === 0
      },
      perPageOptions: {
        type: Array,
        default: () => [10, 20, 50, 100]
      },
      previousAriaLabel: {
        type: String,
        default: "\u4E0A\u4E00\u9875"
      },
      showFirstLastPage: Boolean,
      showQuickJumper: Boolean,
      showPerPageSelect: Boolean,
      total: {
        type: [Number, String],
        default: 0,
        validator: (val) => val % 1 === 0
      },
      totalVisible: {
        type: [Number, String],
        validator: (val) => val % 1 === 0
      }
    }, makePaperProps({
      tag: "nav",
      variant: "text",
      shape: "rounded-sm"
    })),
    emits: {
      "update:modelValue": (_modelValue) => true,
      "update:perPage": (_perPage) => true,
      "first": (_value) => true,
      "prev": (_value) => true,
      "next": (_value) => true,
      "last": (_value) => true
    },
    setup(props, {
      slots,
      emit
    }) {
      const internalPage = vue.ref();
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      const page = useProxiedModel(props, "modelValue", props.modelValue, (v) => parseInt(v != null ? v : 1, 10));
      const perPage = useProxiedModel(props, "perPage", props.perPage, (v) => parseInt(v != null ? v : 10, 10));
      const total = vue.computed(() => parseInt(props.total, 10));
      const firstPage = vue.computed(() => parseInt(props.firstPage, 10));
      const lastPage = vue.computed(() => Math.ceil(total.value / perPage.value));
      const maxButtons = vue.ref(-1);
      const {
        resizeRef
      } = useResizeObserver((entries) => {
        if (!entries.length)
          return;
        const {
          target,
          contentRect
        } = entries[0];
        const firstItem = target.querySelector(".ve-pagination__wrapper > *");
        if (!firstItem)
          return;
        let totalWidth = contentRect.width - 96;
        if (props.showPerPageSelect)
          totalWidth -= 100;
        if (props.showQuickJumper)
          totalWidth -= 100;
        const itemWidth = firstItem.getBoundingClientRect().width + 10;
        maxButtons.value = Math.max(0, Math.floor(totalWidth / itemWidth));
      });
      const totalVisible = vue.computed(() => {
        if (props.totalVisible)
          return Math.min(parseInt(props.totalVisible, 10), lastPage.value);
        if (maxButtons.value >= 0)
          return maxButtons.value;
        return Math.min(7, lastPage.value);
      });
      const range = vue.computed(() => {
        if (lastPage.value <= 0)
          return [];
        if (totalVisible.value === 1)
          return [Math.min(Math.max(firstPage.value, page.value), firstPage.value + lastPage.value)];
        if (lastPage.value <= totalVisible.value)
          return createRange(lastPage.value, firstPage.value);
        const middle = Math.ceil(totalVisible.value / 2);
        const left = middle;
        const right = lastPage.value - middle;
        if (page.value < left) {
          return [...createRange(Math.max(1, totalVisible.value - 2), firstPage.value), props.ellipsis, lastPage.value];
        }
        if (page.value > right) {
          const rangeLength2 = totalVisible.value - 2;
          const rangeStart2 = lastPage.value - rangeLength2 + firstPage.value;
          return [firstPage.value, props.ellipsis, ...createRange(rangeLength2, rangeStart2)];
        }
        const rangeLength = Math.max(1, totalVisible.value - 4);
        const rangeStart = rangeLength === 1 ? page.value : page.value - Math.ceil(rangeLength / 2) + firstPage.value;
        return [firstPage.value, props.ellipsis, ...createRange(rangeLength, rangeStart), props.ellipsis, lastPage.value];
      });
      function setValue(e, value, event) {
        e.preventDefault();
        page.value = value;
        event && emit(event, value);
      }
      const {
        refs,
        updateRef
      } = useRefs();
      const items = vue.computed(() => {
        const sharedProps = {
          density: props.density,
          shape: props.shape,
          size: props.size
        };
        return range.value.map((item, index2) => {
          const ref = (e) => updateRef(e, index2);
          if (typeof item === "string") {
            return {
              isActive: false,
              page: item,
              props: __spreadProps(__spreadValues({}, sharedProps), {
                ref,
                ellipsis: true,
                icon: true,
                disabled: true,
                variant: props.variant,
                border: props.border
              })
            };
          } else {
            const isActive = item === page.value;
            return {
              isActive,
              page: item,
              props: __spreadProps(__spreadValues({}, sharedProps), {
                ref,
                ellipsis: false,
                icon: true,
                disabled: props.disabled || lastPage.value < 2,
                elevation: props.elevation,
                variant: isActive ? "outlined" : props.variant,
                border: props.border,
                color: isActive ? props.activeColor : void 0,
                ariaCurrent: isActive,
                ariaLabel: isActive ? props.currentPageAriaLabel : props.pageAriaLabel,
                onClick: (e) => setValue(e, item)
              })
            };
          }
        });
      });
      const controls = vue.computed(() => {
        const sharedProps = {
          color: void 0,
          density: props.density,
          shape: props.shape,
          size: props.size,
          variant: "outlined",
          border: props.border
        };
        const prevDisabled = props.disabled || page.value <= firstPage.value;
        const nextDisabled = props.disabled || page.value >= firstPage.value + lastPage.value - 1;
        return {
          first: props.showFirstLastPage ? __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.firstIcon,
            onClick: (e) => setValue(e, firstPage.value, "first"),
            disabled: prevDisabled,
            ariaLabel: props.firstAriaLabel,
            ariaDisabled: prevDisabled
          }) : void 0,
          prev: __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.prevIcon,
            onClick: (e) => setValue(e, page.value - 1, "prev"),
            disabled: prevDisabled,
            ariaLabel: props.previousAriaLabel,
            ariaDisabled: prevDisabled
          }),
          next: __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.nextIcon,
            onClick: (e) => setValue(e, page.value + 1, "next"),
            disabled: nextDisabled,
            ariaLabel: props.nextAriaLabel,
            ariaDisabled: nextDisabled
          }),
          last: props.showFirstLastPage ? __spreadProps(__spreadValues({}, sharedProps), {
            icon: props.lastIcon,
            onClick: (e) => setValue(e, firstPage.value + lastPage.value - 1, "last"),
            disabled: nextDisabled,
            ariaLabel: props.lastAriaLabel,
            ariaDisabled: nextDisabled
          }) : void 0
        };
      });
      function updateFocus() {
        var _a;
        const currentIndex = page.value - firstPage.value;
        (_a = refs.value[currentIndex]) == null ? void 0 : _a.$el.focus();
      }
      function onKeydown({
        key
      }) {
        if (key === keyValues.left && !props.disabled && page.value > firstPage.value) {
          page.value = page.value - 1;
          vue.nextTick(updateFocus);
        } else if (key === keyValues.right && !props.disabled && page.value < firstPage.value + lastPage.value - 1) {
          page.value = page.value + 1;
          vue.nextTick(updateFocus);
        }
      }
      return () => vue.createVNode(props.tag, {
        "ref": resizeRef,
        "class": ["ve-pagination", paperClasses.value],
        "style": paperStyles.value,
        "role": "navigation",
        "aria-label": props.ariaLabel,
        "onKeydown": onKeydown
      }, {
        default: () => {
          var _a, _b, _c, _d, _e, _f, _g, _h;
          return [vue.createVNode("ul", {
            "class": "ve-pagination__wrapper"
          }, [props.showFirstLastPage && vue.createVNode("li", {
            "class": "ve-pagination__first"
          }, [(_b = (_a = slots.first) == null ? void 0 : _a.call(slots, controls.value.first)) != null ? _b : vue.createVNode(Button, controls.value.first, null)]), vue.createVNode("li", {
            "class": "ve-pagination__prev"
          }, [(_d = (_c = slots.prev) == null ? void 0 : _c.call(slots, controls.value.prev)) != null ? _d : vue.createVNode(Button, controls.value.prev, null)]), items.value.map((item, index2) => {
            var _a2, _b2;
            return vue.createVNode("li", {
              "key": `${index2}_${item.page}`,
              "class": ["ve-pagination__item", {
                "ve-pagination__item--is-active": item.isActive
              }]
            }, [(_b2 = (_a2 = slots.item) == null ? void 0 : _a2.call(slots, item)) != null ? _b2 : vue.createVNode(Button, item.props, {
              default: () => [item.page]
            })]);
          }), vue.createVNode("li", {
            "class": "ve-pagination__next"
          }, [(_f = (_e = slots.next) == null ? void 0 : _e.call(slots, controls.value.next)) != null ? _f : vue.createVNode(Button, controls.value.next, null)]), props.showFirstLastPage && vue.createVNode("li", {
            "class": "ve-pagination__last"
          }, [(_h = (_g = slots.last) == null ? void 0 : _g.call(slots, controls.value.last)) != null ? _h : vue.createVNode(Button, controls.value.last, null)]), props.showPerPageSelect && vue.createVNode("li", {
            "class": "ve-pagination__per-page"
          }, [vue.createVNode(Select, {
            "hide-details": true,
            "width": "95",
            "modelValue": perPage.value,
            "onUpdate:modelValue": ($event) => perPage.value = $event,
            "items": props.perPageOptions.map((v) => ({
              text: `${v} / \u9875`,
              value: parseInt(v, 10)
            }))
          }, null)]), props.showQuickJumper && vue.createVNode("li", {
            "class": "ve-pagination__quick-jumper"
          }, [vue.createVNode(Input, {
            "hide-details": true,
            "width": "60",
            "modelValue": internalPage.value,
            "onUpdate:modelValue": ($event) => internalPage.value = $event,
            "type": "number",
            "onKeydown": ({
              key
            }) => {
              if (key === keyValues.enter && internalPage.value && internalPage.value > 0 && internalPage.value <= lastPage.value) {
                page.value = internalPage.value;
                internalPage.value = void 0;
              }
            },
            "onBlur": () => {
              if (internalPage.value && internalPage.value > 0 && internalPage.value <= lastPage.value) {
                page.value = internalPage.value;
                internalPage.value = void 0;
              }
            }
          }, {
            prepend: () => vue.createVNode("span", null, [vue.createTextVNode("\u8DF3\u81F3")])
          })])])];
        }
      });
    }
  });
  var paper = "";
  const Paper = defineComponent({
    name: "VePaper",
    props: makePaperProps(),
    setup(props, {
      slots
    }) {
      const {
        paperClasses,
        paperStyles
      } = usePaper(props);
      return () => vue.createVNode(props.tag, {
        "class": ["ve-paper", paperClasses.value],
        "style": paperStyles.value
      }, slots);
    }
  });
  var scrollbar = "";
  const Scrollbar = defineComponent({
    name: "VeScrollbar",
    props: __spreadValues(__spreadValues({}, makeTagProps()), makeScrollbar()),
    setup(props, {
      slots
    }) {
      const {
        scrollbarClasses
      } = useScrollbar(props);
      return () => {
        var _a;
        return vue.createVNode("div", {
          "class": ["ve-scrollbar", scrollbarClasses.value]
        }, [(_a = slots.default) == null ? void 0 : _a.call(slots)]);
      };
    }
  });
  var slideGroup = "";
  function bias(val) {
    const c = 0.501;
    const x = Math.abs(val);
    return Math.sign(val) * (x / ((1 / c - 2) * (1 - x) + 1));
  }
  function calculateUpdatedOffset({
    selectedElement,
    containerSize,
    contentSize,
    isRtl,
    currentScrollOffset,
    isHorizontal
  }) {
    const clientSize = isHorizontal ? selectedElement.clientWidth : selectedElement.clientHeight;
    const offsetStart = isHorizontal ? selectedElement.offsetLeft : selectedElement.offsetTop;
    const adjustedOffsetStart = isRtl ? contentSize - offsetStart - clientSize : offsetStart;
    if (isRtl) {
      currentScrollOffset = -currentScrollOffset;
    }
    const totalSize = containerSize + currentScrollOffset;
    const itemOffset = clientSize + adjustedOffsetStart;
    const additionalOffset = clientSize * 0.4;
    if (adjustedOffsetStart <= currentScrollOffset) {
      currentScrollOffset = Math.max(adjustedOffsetStart - additionalOffset, 0);
    } else if (totalSize <= itemOffset) {
      currentScrollOffset = Math.min(currentScrollOffset - (totalSize - itemOffset - additionalOffset), contentSize - containerSize);
    }
    return isRtl ? -currentScrollOffset : currentScrollOffset;
  }
  function calculateCenteredOffset({
    selectedElement,
    containerSize,
    contentSize,
    isRtl,
    isHorizontal
  }) {
    const clientSize = isHorizontal ? selectedElement.clientWidth : selectedElement.clientHeight;
    const offsetStart = isHorizontal ? selectedElement.offsetLeft : selectedElement.offsetTop;
    if (isRtl) {
      const offsetCentered = contentSize - offsetStart - clientSize / 2 - containerSize / 2;
      return -Math.min(contentSize - containerSize, Math.max(0, offsetCentered));
    } else {
      const offsetCentered = offsetStart + clientSize / 2 - containerSize / 2;
      return Math.min(contentSize - containerSize, Math.max(0, offsetCentered));
    }
  }
  const SlideGroupKey = createSymbol("slide-group");
  const SlideGroup = defineComponent({
    name: "VeSlideGroup",
    props: __spreadValues(__spreadValues({
      activeClass: {
        type: String,
        default: "v-slide-item--active"
      },
      centerActive: Boolean,
      direction: {
        type: String,
        default: "horizontal"
      },
      symbol: {
        type: null,
        default: SlideGroupKey
      },
      nextIcon: {
        type: String,
        default: "$next"
      },
      prevIcon: {
        type: String,
        default: "$prev"
      },
      showArrows: {
        type: [Boolean, String],
        validator: (v) => typeof v === "boolean" || ["always", "desktop", "mobile"].includes(v)
      }
    }, makeTagProps()), makeGroupProps()),
    emits: {
      "update:modelValue": (_modelValue) => true
    },
    setup(props, {
      slots
    }) {
      const isRtl = vue.ref(false);
      const {
        mobile
      } = useDisplay();
      const group = useGroup(props, props.symbol);
      const isOverflowing = vue.ref(false);
      const scrollOffset = vue.ref(0);
      const containerSize = vue.ref(0);
      const contentSize = vue.ref(0);
      const isHorizontal = vue.computed(() => props.direction === "horizontal");
      const {
        resizeRef: containerRef,
        contentRect: containerRect
      } = useResizeObserver();
      const {
        resizeRef: contentRef,
        contentRect
      } = useResizeObserver();
      vue.watchEffect(() => {
        if (!containerRect.value || !contentRect.value)
          return;
        const sizeProperty = isHorizontal.value ? "width" : "height";
        containerSize.value = containerRect.value[sizeProperty];
        contentSize.value = contentRect.value[sizeProperty];
        isOverflowing.value = containerSize.value + 1 < contentSize.value;
      });
      vue.watch(group.selected, (selected) => {
        if (!selected.length || !contentRef.value)
          return;
        const index2 = group.items.value.findIndex((item) => item.id === selected[selected.length - 1]);
        const selectedElement = contentRef.value.children[index2];
        if (index2 === 0 || !isOverflowing.value) {
          scrollOffset.value = 0;
        } else if (props.centerActive) {
          scrollOffset.value = calculateCenteredOffset({
            selectedElement,
            containerSize: containerSize.value,
            contentSize: contentSize.value,
            isRtl: isRtl.value,
            isHorizontal: isHorizontal.value
          });
        } else if (isOverflowing.value) {
          scrollOffset.value = calculateUpdatedOffset({
            selectedElement,
            containerSize: containerSize.value,
            contentSize: contentSize.value,
            isRtl: isRtl.value,
            currentScrollOffset: scrollOffset.value,
            isHorizontal: isHorizontal.value
          });
        }
      });
      const disableTransition = vue.ref(false);
      let startTouch = 0;
      let startOffset = 0;
      function onTouchstart(e) {
        const sizeProperty = isHorizontal.value ? "clientX" : "clientY";
        startOffset = scrollOffset.value;
        startTouch = e.touches[0][sizeProperty];
        disableTransition.value = true;
      }
      function onTouchmove(e) {
        if (!isOverflowing.value)
          return;
        const sizeProperty = isHorizontal.value ? "clientX" : "clientY";
        scrollOffset.value = startOffset + startTouch - e.touches[0][sizeProperty];
      }
      function onTouchend(_event) {
        const maxScrollOffset = contentSize.value - containerSize.value;
        if (isRtl.value) {
          if (scrollOffset.value > 0 || !isOverflowing.value) {
            scrollOffset.value = 0;
          } else if (scrollOffset.value <= -maxScrollOffset) {
            scrollOffset.value = -maxScrollOffset;
          }
        } else {
          if (scrollOffset.value < 0 || !isOverflowing.value) {
            scrollOffset.value = 0;
          } else if (scrollOffset.value >= maxScrollOffset) {
            scrollOffset.value = maxScrollOffset;
          }
        }
        disableTransition.value = false;
      }
      function onScroll() {
        containerRef.value && (containerRef.value.scrollLeft = 0);
      }
      const isFocused = vue.ref(false);
      function onFocusin(e) {
        isFocused.value = true;
        if (!isOverflowing.value || !contentRef.value)
          return;
        for (const el of e.composedPath()) {
          for (const item of contentRef.value.children) {
            if (item === el) {
              scrollOffset.value = calculateUpdatedOffset({
                selectedElement: item,
                containerSize: containerSize.value,
                contentSize: contentSize.value,
                isRtl: isRtl.value,
                currentScrollOffset: scrollOffset.value,
                isHorizontal: isHorizontal.value
              });
              return;
            }
          }
        }
      }
      function onFocusout(_e) {
        isFocused.value = false;
      }
      function onFocus(e) {
        var _a;
        if (!isFocused.value && !(e.relatedTarget && ((_a = contentRef.value) == null ? void 0 : _a.contains(e.relatedTarget))))
          focus();
      }
      function onKeydown(e) {
        if (!contentRef.value)
          return;
        if (e.key === (isHorizontal.value ? "ArrowRight" : "ArrowDown")) {
          focus("next");
        } else if (e.key === (isHorizontal.value ? "ArrowLeft" : "ArrowUp")) {
          focus("prev");
        } else if (e.key === "Home") {
          focus("first");
        } else if (e.key === "End") {
          focus("last");
        }
      }
      function focus(location) {
        var _a, _b, _c, _d, _e;
        if (!contentRef.value)
          return;
        if (!location) {
          contentRef.value.querySelector("[tabindex]");
          const focusable = [...contentRef.value.querySelectorAll('button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"])')].filter((el) => !el.hasAttribute("disabled"));
          (_a = focusable[0]) == null ? void 0 : _a.focus();
        } else if (location === "next") {
          const el = (_b = contentRef.value.querySelector(":focus")) == null ? void 0 : _b.nextElementSibling;
          if (el)
            el.focus();
          else
            focus("first");
        } else if (location === "prev") {
          const el = (_c = contentRef.value.querySelector(":focus")) == null ? void 0 : _c.previousElementSibling;
          if (el)
            el.focus();
          else
            focus("last");
        } else if (location === "first") {
          (_d = contentRef.value.firstElementChild) == null ? void 0 : _d.focus();
        } else if (location === "last") {
          (_e = contentRef.value.lastElementChild) == null ? void 0 : _e.focus();
        }
      }
      function scrollTo(location) {
        const sign = isRtl.value ? -1 : 1;
        const newAbosluteOffset = sign * scrollOffset.value + (location === "prev" ? -1 : 1) * containerSize.value;
        scrollOffset.value = sign * clamp(newAbosluteOffset, 0, contentSize.value - containerSize.value);
      }
      const contentStyles = vue.computed(() => {
        const scrollAmount = scrollOffset.value <= 0 ? bias(-scrollOffset.value) : scrollOffset.value > contentSize.value - containerSize.value ? -(contentSize.value - containerSize.value) + bias(contentSize.value - containerSize.value - scrollOffset.value) : -scrollOffset.value;
        return {
          transform: `translate${isHorizontal.value ? "X" : "Y"}(${scrollAmount}px)`,
          transition: disableTransition.value ? "none" : "",
          willChange: disableTransition.value ? "transform" : ""
        };
      });
      const slotProps = vue.computed(() => ({
        next: group.next,
        prev: group.prev,
        select: group.select,
        isSelected: group.isSelected
      }));
      const hasAffixes = vue.computed(() => {
        switch (props.showArrows) {
          case "always":
            return true;
          case "desktop":
            return mobile.value;
          case true:
            return isOverflowing.value || Math.abs(scrollOffset.value) > 0;
          case "mobile":
            return mobile.value || isOverflowing.value || Math.abs(scrollOffset.value) > 0;
          default:
            return !mobile.value && (isOverflowing.value || Math.abs(scrollOffset.value) > 0);
        }
      });
      const hasPrev = vue.computed(() => {
        return hasAffixes.value && scrollOffset.value > 0;
      });
      const hasNext = vue.computed(() => {
        if (!hasAffixes.value)
          return false;
        return contentSize.value > Math.abs(scrollOffset.value) + containerSize.value;
      });
      useRender(() => vue.createVNode(props.tag, {
        "class": ["ve-slide-group", {
          "ve-slide-group--vertical": !isHorizontal.value,
          "ve-slide-group--has-affixes": hasAffixes.value,
          "ve-slide-group--is-overflowing": isOverflowing.value
        }],
        "tabindex": isFocused.value || group.selected.value.length ? -1 : 0,
        "onFocus": onFocus
      }, {
        default: () => {
          var _a, _b, _c, _d, _e;
          return [hasAffixes.value && vue.createVNode("div", {
            "class": ["ve-slide-group__prev", {
              "ve-slide-group__prev--disabled": !hasPrev.value
            }],
            "onClick": () => scrollTo("prev")
          }, [(_b = (_a = slots.prev) == null ? void 0 : _a.call(slots, slotProps.value)) != null ? _b : vue.createVNode(FadeTransition, null, {
            default: () => [vue.createVNode(Icon, {
              "icon": props.prevIcon
            }, null)]
          })]), vue.createVNode("div", {
            "ref": containerRef,
            "class": "ve-slide-group__container",
            "onScroll": onScroll
          }, [vue.createVNode("div", {
            "ref": contentRef,
            "class": "ve-slide-group__content",
            "style": contentStyles.value,
            "onTouchstart": onTouchstart,
            "onTouchmove": onTouchmove,
            "onTouchend": onTouchend,
            "onFocusin": onFocusin,
            "onFocusout": onFocusout,
            "onKeydown": onKeydown
          }, [(_c = slots.default) == null ? void 0 : _c.call(slots, slotProps.value)])]), hasAffixes.value && vue.createVNode("div", {
            "class": ["ve-slide-group__next", {
              "ve-slide-group__next--disabled": !hasNext.value
            }],
            "onClick": () => scrollTo("next")
          }, [(_e = (_d = slots.next) == null ? void 0 : _d.call(slots, slotProps.value)) != null ? _e : vue.createVNode(FadeTransition, null, {
            default: () => [vue.createVNode(Icon, {
              "icon": props.nextIcon
            }, null)]
          })])];
        }
      }));
      return {
        selected: group.selected,
        scrollTo,
        scrollOffset,
        focus
      };
    }
  });
  const SlideGroupItem = defineComponent({
    name: "VeSlideGroupItem",
    props: __spreadValues({}, makeGroupItemProps()),
    setup(props, {
      slots
    }) {
      const group = useGroupItem(props, SlideGroupKey);
      return () => {
        var _a;
        return (_a = slots.default) == null ? void 0 : _a.call(slots, {
          isSelected: group.isSelected.value,
          select: group.select
        });
      };
    }
  });
  var spacer = "";
  function _isSlot(s) {
    return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !vue.isVNode(s);
  }
  const Spacer = defineComponent({
    name: "VeSpacer",
    props: __spreadValues(__spreadValues({}, makeRowProps()), makeColProps({
      cols: "auto"
    })),
    setup(props, {
      slots
    }) {
      return () => {
        var _a, _b;
        let _slot;
        const children = flattenFragments((_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : []);
        if (!children.length) {
          return vue.createVNode("div", {
            "class": "ve-spacer"
          }, null);
        }
        const [rowProps] = pick(props, Object.keys(Row.props));
        const [colProps] = pick(props, Object.keys(Col.props));
        return vue.createVNode(Row, vue.mergeProps(rowProps, {
          "class": "ve-spacer"
        }), _isSlot(_slot = children.map((child, index2) => vue.createVNode(Col, vue.mergeProps(colProps, {
          "key": index2
        }), _isSlot(child) ? child : {
          default: () => [child]
        }))) ? _slot : {
          default: () => [_slot]
        });
      };
    }
  });
  var table = "";
  const defaultPagination = {
    page: 1,
    perPage: 10,
    perPageOptions: [10, 20, 50, 100],
    total: 0,
    totalVisible: 7,
    showQuickJumper: false,
    showPerPageSelect: false
  };
  const makeDataIteratorProps = propsFactory({
    remote: Boolean,
    items: {
      type: Array,
      default: () => []
    },
    mustSort: Boolean,
    multiSort: Boolean,
    sortBy: {
      type: [String, Array],
      default: () => []
    },
    sortDesc: {
      type: [Boolean, Array],
      default: () => []
    },
    customSort: {
      type: Function,
      default: sortItems
    },
    locale: {
      type: String,
      default: "en-US"
    },
    pagination: {
      type: Object,
      defualt: () => __spreadValues({}, defaultPagination)
    }
  }, "data-iterator");
  function toggle(key, oldBy, oldDesc, page, mustSort, multiSort) {
    let by = oldBy.slice();
    let desc = oldDesc.slice();
    const byIndex = by.findIndex((k) => k === key);
    if (byIndex < 0) {
      if (!multiSort) {
        by = [];
        desc = [];
      }
      by.push(key);
      desc.push(false);
    } else if (byIndex >= 0 && !desc[byIndex]) {
      desc[byIndex] = true;
    } else if (!mustSort) {
      by.splice(byIndex, 1);
      desc.splice(byIndex, 1);
    } else {
      desc[byIndex] = false;
    }
    if (!deepEqual(by, oldBy) || !deepEqual(desc, oldDesc)) {
      page = 1;
    }
    return { by, desc, page };
  }
  function useDataIterator(props) {
    const vm = getCurrentInstance("useDataIterator");
    const pagination2 = useProxiedModel(props, "pagination", props.pagination, (val) => {
      var _a;
      const pagination22 = __spreadValues(__spreadValues({}, defaultPagination), val);
      return vue.reactive(__spreadProps(__spreadValues({}, pagination22), {
        page: Number(pagination22.page),
        perPage: Number(pagination22.perPage),
        total: props.remote ? Number((_a = pagination22.total) != null ? _a : props.items.length) : props.items.length
      }));
    });
    const sortBy = useProxiedModel(props, "sortBy");
    const sortDesc = useProxiedModel(props, "sortDesc");
    function updateOptions() {
      vm.emit("update:options", {
        pagination: pagination2.value,
        sortBy: sortBy.value,
        sortDesc: sortDesc.value
      });
    }
    function sortItems2(items2) {
      return props.customSort(items2, wrapInArray(sortBy.value), wrapInArray(sortDesc.value), props.locale);
    }
    function paginateItems(items2) {
      return items2.slice((pagination2.value.page - 1) * pagination2.value.perPage, Math.min(pagination2.value.total, pagination2.value.page * pagination2.value.perPage));
    }
    const items = vue.computed(() => {
      if (props.remote)
        return props.items;
      let items2 = props.items.slice();
      items2 = sortItems2(items2);
      items2 = paginateItems(items2);
      return items2;
    });
    function sort(key) {
      var _a, _b;
      if (Array.isArray(key)) {
        const options = {
          sortBy: key,
          sortDesc: key.map((s) => {
            const i = wrapInArray(sortBy.value).findIndex((k) => k === s);
            return i > -1 ? wrapInArray(sortDesc.value)[i] : false;
          }),
          pagination: __spreadValues({}, pagination2.value)
        };
        sortBy.value = options.sortBy;
        sortDesc.value = options.sortDesc;
        vm.emit("update:options", options);
      } else {
        const { by, desc, page } = toggle(key, wrapInArray(sortBy.value), wrapInArray(sortDesc.value), pagination2.value.page, props.mustSort, props.multiSort);
        const options = {
          sortBy: props.multiSort ? by : (_a = by[0]) != null ? _a : null,
          sortDesc: props.multiSort ? desc : (_b = desc[0]) != null ? _b : null,
          pagination: __spreadProps(__spreadValues({}, pagination2.value), {
            page
          })
        };
        sortBy.value = options.sortBy;
        sortDesc.value = options.sortDesc;
        pagination2.value.page = options.pagination.page;
        vm.emit("update:options", options);
      }
    }
    return {
      items,
      pagination: pagination2,
      sortBy,
      sortDesc,
      sort,
      updateOptions
    };
  }
  var tableTh = "";
  const TableTh = defineComponent({
    name: "VeTableTh",
    props: {
      sortable: Boolean,
      sortDesc: Boolean,
      sortIcon: {
        type: String,
        default: "$sort"
      },
      sortActiveColor: {
        type: String,
        default: "primary"
      },
      filterIcon: {
        type: String,
        default: "$filter"
      },
      filters: {
        type: Array,
        default: () => []
      },
      fixed: [Boolean, String],
      align: {
        type: String,
        default: "start"
      }
    },
    setup(props, {
      slots
    }) {
      return () => {
        var _a;
        return vue.createVNode("th", {
          "class": ["ve-table-th", `text-${props.align}`, {
            "ve-table-th--sortable": props.sortable,
            "ve-table-th--sorted": props.sortDesc !== void 0,
            "ve-table-th--fixed-start": props.fixed === "start",
            "ve-table-th--fixed-end": props.fixed === "end"
          }]
        }, [vue.createVNode("div", {
          "class": "ve-table-th__wrapper"
        }, [(_a = slots.default) == null ? void 0 : _a.call(slots), props.sortable && vue.createVNode(Icon, {
          "class": {
            "ve-table-th__sorter": true,
            "ve-table-th__sorter--desc": props.sortDesc === true
          },
          "icon": props.sortIcon,
          "color": props.sortDesc !== void 0 ? props.sortActiveColor : void 0
        }, null)]), props.filters.length > 0 && vue.createVNode(Button, {
          "class": "ve-table-th__filter",
          "icon": props.filterIcon,
          "variant": "text",
          "onClick": (e) => {
            e.stopPropagation();
          }
        }, null)]);
      };
    }
  });
  function filterTableThProps(attrs) {
    return pick(attrs, Object.keys(TableTh.props));
  }
  var tableNoData = "";
  const TableNoData = defineComponent({
    name: "VeTableNoData",
    props: {
      icon: {
        type: String,
        default: "$nodata"
      },
      text: {
        type: String,
        default: "\u6682\u65E0\u6570\u636E"
      }
    },
    setup(props, {
      slots
    }) {
      return () => {
        var _a, _b;
        return vue.createVNode("div", {
          "class": "ve-table-no-data"
        }, [vue.createVNode(Icon, {
          "icon": props.icon,
          "size": 48,
          "class": "mb-3"
        }, null), vue.createVNode("div", null, [(_b = (_a = slots.default) == null ? void 0 : _a.call(slots)) != null ? _b : props.text])]);
      };
    }
  });
  const Table = defineComponent({
    name: "VeTable",
    props: __spreadValues(__spreadValues(__spreadValues({
      hideBorder: Boolean,
      hideHeader: Boolean,
      fixedHeader: Boolean,
      headers: {
        type: Array,
        default: () => []
      },
      selected: {
        type: Array,
        default: () => []
      },
      sortIcon: {
        type: String,
        default: "$sort"
      },
      sortActiveColor: {
        type: String,
        default: "primary"
      },
      loading: Boolean,
      itemKey: {
        type: String,
        default: "id"
      },
      hidePagination: Boolean
    }, makeDataIteratorProps()), makePaperProps({
      border: true,
      shape: "rounded-sm"
    })), makeScrollbar()),
    emits: {
      "update:pagination": (_) => true,
      "update:sortBy": (_) => true,
      "update:sortDesc": (_) => true,
      "update:options": (_) => true,
      "update:selected": (_) => true
    },
    setup(props, {
      slots
    }) {
      const containerRef = vue.ref();
      const scrollLeft = vue.ref(0);
      const selected = useProxiedModel(props, "selected");
      const isAllSelected = vue.computed(() => {
        return selected.value.map((v) => v[props.itemKey]).sort().join("") === props.items.map((v) => v[props.itemKey]).sort().join("");
      });
      const {
        paperClasses,
        paperStyles
      } = usePaper(props, "ve-table__table");
      const {
        scrollbarClasses
      } = useScrollbar(props);
      const {
        items,
        pagination: pagination2,
        sortBy: rawSortBy,
        sortDesc: rawSortDesc,
        sort,
        updateOptions
      } = useDataIterator(props);
      const headers2 = vue.computed(() => {
        const length = props.headers.length;
        return props.headers.map((header2, index2) => {
          return __spreadProps(__spreadValues({}, header2), {
            fixed: header2.fixed === true ? index2 < (length - 1) / 2 ? "start" : "end" : header2.fixed
          });
        });
      });
      const sortBy = vue.computed(() => wrapInArray(rawSortBy.value));
      const sortDesc = vue.computed(() => wrapInArray(rawSortDesc.value));
      const scrollPositionClasses = vue.computed(() => {
        if (containerRef.value && scrollLeft.value === 0) {
          return "ve-table--scroll-position-start";
        } else if (containerRef.value && scrollLeft.value + containerRef.value.offsetWidth >= containerRef.value.scrollWidth) {
          return "ve-table--scroll-position-end";
        } else {
          return "ve-table--scroll-position-center";
        }
      });
      function handleScroll({
        target
      }) {
        scrollLeft.value = target.scrollLeft;
      }
      function genColProps(header2) {
        var _a, _b;
        const styles = {
          width: convertToUnit(header2.width),
          minWidth: convertToUnit((_a = header2.minWidth) != null ? _a : header2.width),
          maxWidth: convertToUnit((_b = header2.maxWidth) != null ? _b : header2.width)
        };
        return {
          style: styles
        };
      }
      function isSortDesc(header2) {
        return sortDesc.value[sortBy.value.findIndex((v) => v === header2.value)];
      }
      useRender(() => {
        const hasColgroup = !slots.colgroup && props.headers.length > 0;
        const hasThead = !slots.header && !props.hideHeader && props.headers.length > 0;
        const hasTbody = !slots.default;
        const hasPagination = hasTbody && !props.hidePagination;
        return vue.createVNode(props.tag, {
          "class": ["ve-table", {
            "ve-table--fixed-header": props.fixedHeader
          }, scrollPositionClasses.value]
        }, {
          default: () => {
            var _a, _b, _c, _d, _e;
            return [vue.createVNode("div", {
              "ref": containerRef,
              "onScroll": throttle(handleScroll, 128),
              "class": ["ve-table__table", paperClasses.value, scrollbarClasses.value],
              "style": paperStyles.value
            }, [vue.createVNode("table", null, [hasColgroup && vue.createVNode("colgroup", null, [headers2.value.map((header2) => {
              return vue.createVNode("col", genColProps(header2), null);
            })]), (_a = slots.colgroup) == null ? void 0 : _a.call(slots), hasThead && vue.createVNode("thead", null, [props.loading && vue.createVNode("tr", {
              "class": "ve-table__progress"
            }, [vue.createVNode("th", {
              "colspan": props.headers.length
            }, [vue.createVNode(Progress, {
              "color": "primary",
              "indeterminate": true,
              "stroke-width": 3
            }, null)])]), vue.createVNode("tr", null, [headers2.value.map((header2, index2) => {
              return vue.createVNode(TableTh, vue.mergeProps(filterTableThProps(header2)[0], {
                "sort-icon": props.sortIcon,
                "sort-active-color": props.sortActiveColor,
                "sort-desc": isSortDesc(header2),
                "onClick": () => header2.sortable && sort(header2.value)
              }), {
                default: () => {
                  var _a2, _b2, _c2;
                  return [header2.$type === "selection" ? vue.createVNode(Checkbox, {
                    "indeterminate": selected.value.length > 0 && !isAllSelected.value,
                    "onUpdate:indeterminate": (val) => {
                      if (!val) {
                        selected.value = props.items;
                      }
                    },
                    "modelValue": isAllSelected.value,
                    "onUpdate:modelValue": (val) => {
                      if (val) {
                        selected.value = props.items;
                      } else {
                        selected.value = [];
                      }
                    }
                  }, null) : (_c2 = (_b2 = (_a2 = slots[`header.${header2.value}`]) == null ? void 0 : _a2.call(slots, {
                    header: header2,
                    index: index2
                  })) != null ? _b2 : header2.text) != null ? _c2 : header2.value];
                }
              });
            })])]), (_b = slots.header) == null ? void 0 : _b.call(slots), hasTbody && vue.createVNode("tbody", null, [items.value.map((item, index2) => {
              var _a2;
              return vue.createVNode("tr", {
                "key": (_a2 = item[props.itemKey]) != null ? _a2 : index2
              }, [headers2.value.map((header2) => {
                var _a3, _b2;
                return vue.createVNode("td", {
                  "class": ["ve-table-td", {
                    "ve-table-td--sorted": isSortDesc(header2) !== void 0,
                    "ve-table-td--fixed-start": header2.fixed === "start",
                    "ve-table-td--fixed-end": header2.fixed === "end"
                  }]
                }, [header2.$type === "selection" ? vue.createVNode(Checkbox, {
                  "modelValue": selected.value.findIndex((v) => v[props.itemKey] === item[props.itemKey]) > -1,
                  "onUpdate:modelValue": (val) => {
                    if (val) {
                      selected.value.push(item);
                    } else {
                      selected.value = selected.value.filter((v) => v[props.itemKey] !== item[props.itemKey]);
                    }
                  }
                }, null) : (_b2 = (_a3 = slots[`item.${header2.value}`]) == null ? void 0 : _a3.call(slots, {
                  item,
                  index: index2
                })) != null ? _b2 : getObjectValueByPath(item, header2.value)]);
              })]);
            }), !items.value.length && vue.createVNode("tr", null, [vue.createVNode("td", {
              "colspan": props.headers.length
            }, [(_d = (_c = slots.nodata) == null ? void 0 : _c.call(slots)) != null ? _d : vue.createVNode(TableNoData, null, null)])])]), (_e = slots.default) == null ? void 0 : _e.call(slots)])]), hasPagination && vue.createVNode(Pagination, vue.mergeProps({
              "class": "ve-table__pagination"
            }, pagination2.value, {
              "modelValue": pagination2.value.page,
              "onUpdate:modelValue": (v) => {
                pagination2.value.page = v;
                updateOptions();
              },
              "onUpdate:perPage": (v) => {
                pagination2.value.perPage = v;
                updateOptions();
              }
            }), null)];
          }
        });
      });
      return {
        exportCSV(name) {
          downloadCSV(name, props.headers, items.value);
        }
      };
    }
  });
  var tabs = "";
  var tab = "";
  const Tab = defineComponent({
    name: "VeTab",
    props: __spreadValues(__spreadValues(__spreadValues(__spreadValues({
      fixed: Boolean,
      icon: [Boolean, String],
      prependIcon: String,
      appendIcon: String,
      stacked: Boolean,
      title: String,
      ripple: {
        type: Boolean,
        default: true
      },
      color: String,
      sliderColor: String,
      hideSlider: Boolean,
      direction: {
        type: String,
        default: "horizontal"
      }
    }, makeTagProps()), makeRouterProps()), makeGroupItemProps({
      selectedClass: "ve-tab--selected"
    })), makeThemeProps()),
    setup(props, {
      slots,
      attrs
    }) {
      const {
        isSelected,
        select: select2,
        selectedClass
      } = useGroupItem(props, TabsKey);
      const {
        textColorClasses: sliderColorClasses,
        textColorStyles: sliderColorStyles
      } = useTextColor(props, "sliderColor");
      const isHorizontal = vue.computed(() => props.direction === "horizontal");
      provideDefaults({
        VeButton: {
          block: vue.toRef(props, "fixed"),
          color: vue.computed(() => isSelected.value ? props.color : void 0),
          variant: "text"
        }
      }, {
        scoped: true
      });
      const rootEl = vue.ref();
      const sliderEl = vue.ref();
      vue.watch(isSelected, (isSelected2) => {
        var _a, _b;
        if (isSelected2) {
          const prevEl = (_b = (_a = rootEl.value) == null ? void 0 : _a.$el.parentElement) == null ? void 0 : _b.querySelector(".ve-tab--selected .ve-tab__slider");
          const nextEl = sliderEl.value;
          if (!prevEl || !nextEl)
            return;
          const color = getComputedStyle(prevEl).color;
          const prevBox = prevEl.getBoundingClientRect();
          const nextBox = nextEl.getBoundingClientRect();
          const xy = isHorizontal.value ? "x" : "y";
          const XY = isHorizontal.value ? "X" : "Y";
          const rightBottom = isHorizontal.value ? "right" : "bottom";
          const widthHeight = isHorizontal.value ? "width" : "height";
          const prevPos = prevBox[xy];
          const nextPos = nextBox[xy];
          const delta2 = prevPos > nextPos ? prevBox[rightBottom] - nextBox[rightBottom] : prevBox[xy] - nextBox[xy];
          const origin = Math.sign(delta2) > 0 ? isHorizontal.value ? "right" : "bottom" : Math.sign(delta2) < 0 ? isHorizontal.value ? "left" : "top" : "center";
          const size = Math.abs(delta2) + (Math.sign(delta2) < 0 ? prevBox[widthHeight] : nextBox[widthHeight]);
          const scale = size / Math.max(prevBox[widthHeight], nextBox[widthHeight]);
          const initialScale = prevBox[widthHeight] / nextBox[widthHeight];
          const sigma = 1.5;
          nextEl.animate({
            backgroundColor: [color, ""],
            transform: [`translate${XY}(${delta2}px) scale${XY}(${initialScale})`, `translate${XY}(${delta2 / sigma}px) scale${XY}(${(scale - 1) / sigma + 1})`, ""],
            transformOrigin: Array(3).fill(origin)
          }, {
            duration: 225,
            easing: standardEasing
          });
        }
      });
      useRender(() => {
        const [btnProps] = pick(props, ["href", "to", "replace", "icon", "stacked", "prependIcon", "appendIcon", "ripple", "theme", "disabled"]);
        return vue.createVNode(Button, vue.mergeProps({
          "ref": rootEl,
          "class": ["ve-tab", selectedClass.value],
          "tabindex": isSelected.value ? 0 : -1,
          "role": "tab",
          "aria-selected": String(isSelected.value),
          "onClick": () => !props.disabled && select2(!isSelected.value)
        }, btnProps, attrs), {
          default: () => [slots.default ? slots.default() : props.title, !props.hideSlider && vue.createVNode("div", {
            "ref": sliderEl,
            "class": ["ve-tab__slider", sliderColorClasses.value],
            "style": sliderColorStyles.value
          }, null)]
        });
      });
      return {
        isSelected
      };
    }
  });
  function parseItems(items) {
    if (!items)
      return [];
    return items.map((item) => {
      if (typeof item === "string")
        return {
          title: item,
          value: item
        };
      return item;
    });
  }
  const TabsKey = createSymbol("tabs");
  const Tabs = defineComponent({
    name: "VeTabs",
    props: __spreadValues(__spreadValues({
      alignWithTitle: Boolean,
      color: String,
      direction: {
        type: String,
        default: "horizontal"
      },
      fixedTabs: Boolean,
      items: {
        type: Array,
        default: () => []
      },
      stacked: Boolean,
      backgroundColor: String,
      centered: Boolean,
      grow: Boolean,
      height: {
        type: [Number, String],
        default: void 0
      },
      hideSlider: Boolean,
      optional: Boolean,
      right: Boolean,
      sliderColor: String
    }, makeDensityProps()), makeTagProps()),
    setup(props, {
      slots,
      attrs
    }) {
      const parsedItems = vue.computed(() => parseItems(props.items));
      const {
        densityClasses
      } = useDensity(props);
      provideDefaults({
        Tab: {
          color: vue.toRef(props, "color"),
          direction: vue.toRef(props, "direction"),
          stacked: vue.toRef(props, "stacked"),
          fixed: vue.toRef(props, "fixedTabs"),
          sliderColor: vue.toRef(props, "sliderColor"),
          hideSlider: vue.toRef(props, "hideSlider")
        }
      });
      return () => vue.createVNode(SlideGroup, vue.mergeProps({
        "class": ["ve-tabs", `ve-tabs--${props.direction}`, {
          "ve-tabs--align-with-title": props.alignWithTitle,
          "ve-tabs--centered": props.centered,
          "ve-tabs--fixed-tabs": props.fixedTabs,
          "ve-tabs--grow": props.grow,
          "ve-tabs--right": props.right,
          "ve-tabs--stacked": props.stacked
        }, densityClasses.value],
        "role": "tablist",
        "symbol": TabsKey,
        "mandatory": "force",
        "direction": props.direction
      }, attrs), {
        default: () => [slots.default ? slots.default() : parsedItems.value.map((item) => vue.createVNode(Tab, vue.mergeProps(item, {
          "key": item.title
        }), null))]
      });
    }
  });
  const Textarea = genericComponent()({
    name: "Textarea",
    props: makeInputProps({
      type: "textarea"
    }),
    emit: InputEmits,
    setup(props) {
      return () => {
        return vue.createVNode(Input, props, null);
      };
    }
  });
  var themeProvider = "";
  const ThemeProvider = defineComponent({
    name: "VeThemeProvider",
    props: __spreadValues(__spreadValues({}, makeTagProps()), makeThemeProps()),
    setup(props, {
      slots
    }) {
      const {
        themeClasses
      } = provideTheme(props);
      return () => {
        return vue.createVNode(props.tag, {
          "class": ["ve-theme-provider", themeClasses.value]
        }, {
          default: () => {
            var _a;
            return [(_a = slots.default) == null ? void 0 : _a.call(slots)];
          }
        });
      };
    }
  });
  var headers = "";
  const H1 = createSimpleFunctional("ve-h text-h1 my-5", "h1", "VeH1");
  const H2 = createSimpleFunctional("ve-h text-h2 my-4", "h2", "VeH2");
  const H3 = createSimpleFunctional("ve-h text-h3 my-3", "h3", "VeH3");
  const H4 = createSimpleFunctional("ve-h text-h4 my-2", "h4", "VeH4");
  const H5 = createSimpleFunctional("ve-h text-h5 my-1", "h5", "VeH5");
  const H6 = createSimpleFunctional("ve-h text-h6 my-1", "h5", "VeH6");
  var p = "";
  const P = createSimpleFunctional("ve-p", "p");
  var components = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    Alert,
    App,
    Anchor,
    AnchorItem,
    Avatar,
    Badge,
    Breadcrumb,
    BreadcrumbItem,
    Button,
    ButtonGroup,
    ButtonToggle,
    Card,
    CardImage,
    CardAvatar,
    CardHeader,
    CardHeaderText,
    CardTitle,
    CardSubtitle,
    CardActions,
    CardText,
    Carousel,
    CarouselItem,
    Checkbox,
    CheckboxGroup,
    Code,
    Counter,
    DatePicker,
    DatePickerPanel,
    DateRangePickerPanel,
    DefaultsProvider,
    Device,
    DeviceStatusBar,
    Divider,
    Dialog,
    Drawer,
    Draggable,
    DraggableResizable,
    DraggableSortable,
    Form,
    FormControl,
    Container,
    Col,
    Row,
    Header,
    HeaderNavIcon,
    HeaderTitle,
    Hover,
    Icon,
    IconClass,
    IconComponent,
    IconLigature,
    IconSvg,
    Image,
    Input,
    InputControl,
    Label,
    Layout,
    LayoutItem,
    Lazy,
    Link,
    List,
    ListSubheader,
    ListGroup,
    ListItem,
    ListItemAvatar,
    ListItemHeader,
    ListItemTitle,
    ListItemSubtitle,
    Main,
    Menu,
    Messages,
    MessageProvider,
    NotificationProvider,
    Overlay,
    Pagination,
    Paper,
    Progress,
    ProgressLinear,
    ProgressCircular,
    Radio,
    RadioGroup,
    Responsive,
    Scrim,
    Scrollbar,
    SelectionControl,
    SelectionGroupControl,
    SlideGroup,
    SlideGroupItem,
    Select,
    Spacer,
    Switch,
    Table,
    Tabs,
    Tab,
    Tag,
    TagGroup,
    Textarea,
    ThemeProvider,
    Toolbar,
    ToolbarItems,
    ToolbarTitle,
    Tooltip,
    FadeTransition,
    ScaleTransition,
    ExpandTransition,
    ExpandXTransition,
    DialogTransition,
    MenuTransition,
    FadeInExpandTransition,
    SlideRightFadeInExpandTransition,
    H1,
    H2,
    H3,
    H4,
    H5,
    H6,
    P
  }, Symbol.toStringTag, { value: "Module" }));
  var providers = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    MessageProvider,
    NotificationProvider
  }, Symbol.toStringTag, { value: "Module" }));
  function VenoUiResolver(options = {}) {
    const {
      prefix: rawPrefix = "ve"
    } = options;
    const prefix = rawPrefix ? `${toKebabCase(rawPrefix)}-` : "";
    return [
      {
        type: "component",
        resolve: (name) => {
          const kebab = toKebabCase(name);
          if (!kebab.startsWith(prefix))
            return;
          const slice = kebab.slice(prefix.length);
          return {
            name: toPascalCase(slice),
            from: "veno-ui/components"
          };
        }
      }
    ];
  }
  const version = UI_VERSION;
  const createVeno$1 = (options = {}) => {
    const install = (app2) => {
      const {
        componentPrefix = "Ve",
        components: components2 = {},
        directives: directives2 = {}
      } = options;
      for (const key in components2) {
        app2.component(`${componentPrefix}${key}`, components2[key]);
      }
      for (const key in directives2) {
        app2.directive(key, directives2[key]);
      }
      app2.provide(DisplayKey, createDisplay(options.display));
      app2.provide(DefaultsKey, createDefaults(options.defaults));
      app2.provide(DraggableSortableGroupKey, createDraggableSortableGroup());
      app2.provide(ThemeKey, createTheme(app2, options.theme));
      app2.provide(HighlighterKey, createHighlighter(options.highlighter));
      app2.provide(IconsKey, createIcons(options.icons));
      app2.provide(ProvidersKey, createProviders(app2, options.providers));
      function inject(key) {
        var _a, _b, _c;
        const vm = this.$;
        const provides = (_c = (_a = vm.parent) == null ? void 0 : _a.provides) != null ? _c : (_b = vm.vnode.appContext) == null ? void 0 : _b.provides;
        if (provides && key in provides) {
          return provides[key];
        }
      }
      app2.mixin({
        computed: {
          $veno() {
            return vue.reactive({
              display: inject.call(this, DisplayKey),
              theme: inject.call(this, ThemeKey),
              icons: inject.call(this, IconsKey),
              message: inject.call(this, MessageKey),
              notification: inject.call(this, NotificationKey),
              version
            });
          }
        }
      });
    };
    return { install, version };
  };
  const createVeno = (options = {}) => {
    return createVeno$1(__spreadValues({ components, directives, providers }, options));
  };
  exports2.VenoUiResolver = VenoUiResolver;
  exports2.components = components;
  exports2.createDate = createDate;
  exports2.createVeno = createVeno;
  exports2.defaultDateFormat = defaultDateFormat;
  exports2.directives = directives;
  exports2.message = message;
  exports2.providers = providers;
  exports2.useDisplay = useDisplay;
  exports2.useLayout = useLayout;
  exports2.useMessage = useMessage;
  exports2.useTheme = useTheme;
  exports2.utils = index;
  Object.defineProperties(exports2, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
});
//# sourceMappingURL=veno-ui.js.map
